Scriptname DefeatNVNOnHitScr extends ReferenceAlias  

DefeatMCMscr property McmConfig auto
DefeatConfig property RessConfig auto

Actor Property Player Auto
Bool Property IsFemale Auto
Bool Property IsFollower Auto

Float MaxDist = 1000.0
Bool SpamGuard = False

; 2015.07.20 / Add
Float gnSpamGuard
; 2015.07.20 / Add

Function Configure()
	SpamGuard = False
	; 2015.07.20 / Add
	gnSpamGuard  = Utility.GetCurrentRealTime()
	; 2015.07.20 / Add
EndFunction

Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	Actor Aggressor = (akAggressor As Actor)
	
	; 2015.08.01 / Add
	Actor  Victim            = (GetReference() As Actor)
	Bool   canRape           = True
	Bool   isHumanAgg        = Aggressor.HasKeyWordString("ActorTypeNPC")
	Bool   isCreatureAgg     = Aggressor.HasKeyWordString("ActorTypeCreature")
	Bool   isDwarvenAgg      = Aggressor.HasKeyWordString("ActorTypeDwarven")
	Bool   isFollowerAgg     = RessConfig.IsFollower(Aggressor)
	Bool   enableOnHit       = (RessConfig.NVNKDtype <= 2)
	Bool   isPcRaped         = Player.HasKeyWordString("DefeatActive")
	String szVicType         = "NPC"
	Float  nRapeChance       = McmConfig.ChanceOnHitNPC
	Float  nThreshold        = McmConfig.ThresholdNPCvsNPC
	Int    nRapeAttackChance = McmConfig.mnRapePowerAttackChance
	Bool   isRapeAttack      = False
	Float  nCurTime          = Utility.GetCurrentRealTime()
	Bool   isTriggerAttack   = False
	Bool   isFemaleAgg       = False
	; 2015.08.08 / Add
	Bool   enableExplosion   = McmConfig.mEnableRapeAttackExplosion
	; 2015.08.08 / Add
	
	If IsFollower
		szVicType   = "Follower"
		nRapeChance = McmConfig.COHFollower
		nThreshold  = McmConfig.ThresholdFollower
	Endif
	
	If ((nCurTime - gnSpamGuard) > 2.0) && !Victim.HasKeyWordString("DefeatActive")
		SpamGuard   = False
		gnSpamGuard = nCurTime
	Else
		SpamGuard = True
	Endif
		
	If !Aggressor || Aggressor.IsDead()
		canRape = False
	Elseif !Victim || Victim.IsDead()
		canRape = False
	Elseif isFollowerAgg && !McmConfig.AllowCagg
		canRape = False
	Elseif !IsFollower && !CheckGender(Aggressor, isHumanAgg)
		canRape = False
	Elseif !enableOnHit
		canRape = False
	Elseif SpamGuard
		canRape = False
	Elseif Aggressor.HasKeyWordString("DefeatActive")
		canRape = False
	Elseif (Aggressor == Player)
		canRape = False
	Elseif !isHumanAgg && !isCreatureAgg && !isDwarvenAgg
		canRape = False
	Elseif isCreatureAgg && !CheckGender(Aggressor, False)
		canRape = False
	Elseif (Aggressor.GetCombatTarget() != Victim)
		canRape = False
	Elseif (Aggressor.GetDistance(Victim) > MaxDist)
		canRape = False
	Endif
	
	If canRape
		isTriggerAttack = (abPowerAttack || abBashAttack)
		isFemaleAgg     = (SexLabUtil.GetAPI().GetGender(Aggressor) == 1)
		
		If isTriggerAttack && !isFemaleAgg && (Utility.RandomInt(1, 100) <= nRapeAttackChance)
			isRapeAttack = True
			
			RessConfig.mefsRapeAttack.Play(Aggressor, 8.0)
;			RessConfig.mvefRapeAttack.Play(Aggressor)
			; 2015.08.08 / Add
			If enableExplosion
				Aggressor.placeAtMe(RessConfig.mexpRapeAttack)
			Endif
			; 2015.08.08 / Add
			Aggressor.pushActorAway(Victim, 2)
		Endif
		
		canRape = HealthThreshold(Victim, nThreshold, nRapeChance)
	
		If isRapeAttack || canRape
			RessConfig.Knockdown(Victim, Aggressor, 60.0, szVicType)
			
			If !IsFollower || !isPcRaped
				RessConfig.MiscSpells[3].Cast(Aggressor, Victim)
			Endif
		Endif
	Endif
	; 2015.08.01 / Add
	
;	If (Aggressor && !Aggressor.HasKeyWordString("DefeatActive") && (Aggressor != Player))
;		If !SpamGuard
;			SpamGuard = True
;			Actor Victim = (GetReference() As Actor)
;			If Victim
;				If (RessConfig.NVNKDtype <= 2) ; Both or on hit
;					If (IsFollower && (Utility.RandomInt(1, 100) <= McmConfig.COHFollower) || (!IsFollower && (Utility.RandomInt(1, 100) <= McmConfig.ChanceOnHitNPC)))
;						If ((Aggressor.GetCombatTarget() == Victim) && (Aggressor.GetDistance(Victim) <= MaxDist))
;							Bool AggressorHuman = Aggressor.HasKeyWordString("ActorTypeNPC")
;							Bool AggressorCreature = Aggressor.HasKeyWordString("ActorTypeCreature")
;							; 2015.07.19 / Add
;							Bool isDwarvenAgg = Aggressor.HasKeyWordString("ActorTypeDwarven")
;							; 2015.07.19 / Add
;							; 2015.07.19 / Mod / Adding an if condition, isDwarvenAgg
;;							If (AggressorHuman || AggressorCreature)
;							If (AggressorHuman || AggressorCreature || isDwarvenAgg)
;								If (AggressorCreature && !CheckGender(Aggressor, False)) ; Not valid SexLab creatures are not allowed to knock down a npc
;									Return
;								Endif
;								If IsFollower
;									If HealthThreshold(Victim, McmConfig.ThresholdFollower, McmConfig.COHFollower)
;										If !Player.HasKeyWordString("DefeatActive")
;											RessConfig.Knockdown(Victim, Aggressor, 60.0, "Follower")
;											RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;										Else
;											RessConfig.Knockdown(Victim, Aggressor, 60.0, "Follower")
;										Endif
;									Endif
;								Else
;									If RessConfig.IsFollower(Aggressor)
;										If McmConfig.AllowCagg && CheckGender(Aggressor, AggressorHuman)
;											If HealthThreshold(Victim, McmConfig.ThresholdNPCvsNPC, McmConfig.ChanceOnHitNPC)
;												RessConfig.Knockdown(Victim, Aggressor, 60.0, "NPC")
;												RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;											Endif
;										Endif
;									Else
;										If CheckGender(Aggressor, AggressorHuman)
;											If HealthThreshold(Victim, McmConfig.ThresholdNPCvsNPC, McmConfig.ChanceOnHitNPC)
;												RessConfig.Knockdown(Victim, Aggressor, 60.0, "NPC")
;												RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;											Endif
;										Endif
;									Endif
;								Endif
;							Endif
;						Endif
;					Endif
;				Endif
;			Endif
;			Utility.Wait(2.0)
;			SpamGuard = False
;		Endif
;	Endif
EndEvent

Bool Function HealthThreshold(Actor Vic, Float Threshold, Float ChanceOnHit)
	Return ((Utility.RandomInt(1, 100) <= ChanceOnHit) && ((Vic.GetActorValuePercentage("Health") * 100) <= Threshold))
EndFunction

Event OnEnterBleedOut()
	Actor Victim = (GetReference() As Actor)
	Actor Aggressor = Victim.GetCombatTarget()
	
	; 2015.08.01 / Add
	Bool   canRape           = True
	Bool   isHumanAgg        = Aggressor.HasKeyWordString("ActorTypeNPC")
	Bool   isCreatureAgg     = Aggressor.HasKeyWordString("ActorTypeCreature")
	Bool   isDwarvenAgg      = Aggressor.HasKeyWordString("ActorTypeDwarven")
	Bool   isFollowerAgg     = RessConfig.IsFollower(Aggressor)
	Bool   enableBleedout    = (RessConfig.NVNKDtype >= 2)
	Bool   isPcRaped         = Player.HasKeyWordString("DefeatActive")
	String szVicType         = "NPC"
	Float  nRapeChance       = McmConfig.ChanceOnHitNPC
	
	If IsFollower
		szVicType   = "Follower"
		nRapeChance = McmConfig.COHFollower
	Endif
		
	If !Aggressor || Aggressor.IsDead()
		canRape = False
	Elseif !Victim || Victim.IsDead()
		canRape = False
	Elseif isFollowerAgg && !McmConfig.AllowCagg
		canRape = False
	Elseif !IsFollower && !CheckGender(Aggressor, isHumanAgg)
		canRape = False
	Elseif !enableBleedout
		canRape = False
	Elseif Aggressor.HasKeyWordString("DefeatActive")
		canRape = False
	Elseif (Aggressor == Player)
		canRape = False
	Elseif !isHumanAgg && !isCreatureAgg && !isDwarvenAgg
		canRape = False
	Elseif isCreatureAgg && !CheckGender(Aggressor, False)
		canRape = False
	Elseif (Aggressor.GetDistance(Victim) > MaxDist)
		canRape = False
	Elseif (Utility.RandomInt(1, 100) > nRapeChance)
		canRape = False
	Endif
	
	If canRape
		RessConfig.Knockdown(Victim, Aggressor, 60.0, szVicType, IsBleedout = True)
		
		If !IsFollower || !isPcRaped
			RessConfig.MiscSpells[3].Cast(Aggressor, Victim)
		Endif
	Endif
	; 2015.08.01 / Add
	
;	If (Victim && Aggressor && (Aggressor != Player))
;		If (RessConfig.NVNKDtype >= 2) ; Both or bleedout
;			If (IsFollower && (Utility.RandomInt(1, 100) <= McmConfig.COHFollower) || (!IsFollower && (Utility.RandomInt(1, 100) <= McmConfig.ChanceOnHitNPC)))
;				If ((Aggressor.GetDistance(Victim) <= MaxDist) && !Aggressor.HasKeyWordString("DefeatActive"))
;					Bool AggressorHuman = Aggressor.HasKeyWordString("ActorTypeNPC")
;					Bool AggressorCreature = Aggressor.HasKeyWordString("ActorTypeCreature")
;					If (AggressorHuman || AggressorCreature)
;						If (AggressorCreature && !CheckGender(Aggressor, False)) ; Not valid SexLab creatures are not allowed to knock down a npc
;							Return
;						Endif
;						If IsFollower
;							RessConfig.Knockdown(Victim, Aggressor, 60.0, "Follower", IsBleedout = True)
;							If !Player.HasKeyWordString("DefeatActive")
;								RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;							Endif
;						Else
;							If RessConfig.IsFollower(Aggressor) 
;								If (McmConfig.AllowCagg && CheckGender(Aggressor, AggressorHuman))
;									RessConfig.Knockdown(Victim, Aggressor, 60.0, "NPC", IsBleedout = True)
;									RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;								Endif
;							Else
;								If CheckGender(Aggressor, AggressorHuman)
;									RessConfig.Knockdown(Victim, Aggressor, 60.0, "NPC", IsBleedout = True)
;									RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;								Endif
;							Endif
;						Endif
;					Endif
;				Endif
;			Endif
;		Endif
;	Endif
EndEvent

Bool Function CheckGender(Actor Aggressor, Bool Human)
;	DefeatConfig.Log("NVNONHIT CheckGender - Human - "+Human+" / IsFemale - "+IsFemale+" / McmConfig.CreaOnFemale - "+McmConfig.CreaOnFemale+" / McmConfig.CreaOnMale - "+McmConfig.CreaOnMale)
	If !Human
		If (Aggressor.GetFlyingState() < 1)
			If ((IsFemale && McmConfig.CreaOnFemale) || (!IsFemale && McmConfig.CreaOnMale))
				Return RessConfig.SexLab.AllowedCreature(Aggressor.GetLeveledActorBase().GetRace())
			Else
				Return False
			Endif
		Endif
	Elseif !McmConfig.EveryoneNVN
		If IsFemale
			Int Gender = RessConfig.SexLab.GetGender(Aggressor)
			If !McmConfig.SexualityNVN
				Return (((Gender == 0) && McmConfig.MaleOnGal) || ((Gender == 1) && McmConfig.GalOnGal))
			Else
				If (Gender == 0)
					Return (RessConfig.SexLab.Stats.IsStraight(Aggressor) || RessConfig.SexLab.Stats.IsBisexual(Aggressor))
				Elseif (Gender == 1)
					Return (RessConfig.SexLab.Stats.IsGay(Aggressor) || RessConfig.SexLab.Stats.IsBisexual(Aggressor))
				Endif
			Endif
		Else
			Int Gender = RessConfig.SexLab.GetGender(Aggressor)
			If !McmConfig.SexualityNVN
				Return (((Gender == 0) && McmConfig.MaleOnMale) || ((Gender == 1) && McmConfig.GalOnMale))
			Else
				If (Gender == 0)
					Return (RessConfig.SexLab.Stats.IsGay(Aggressor) || RessConfig.SexLab.Stats.IsBisexual(Aggressor))
				Elseif (Gender == 1)
					Return (RessConfig.SexLab.Stats.IsStraight(Aggressor) || RessConfig.SexLab.Stats.IsBisexual(Aggressor))
				Endif
			Endif
		Endif
	Endif	
	Return True
EndFunction
