Scriptname DefeatStateMonitoringEFFscr extends ActiveMagicEffect  

DefeatMCMscr property McmConfig auto
DefeatConfig property RessConfig auto

Import Debug
Import StorageUtil

Actor Victim
Actor Perpetrator
Actor Property Player Auto
Weapon Property Unarmed Auto
String Property StateType Auto
Float Time
Float Confidence
Float Assistance
Float Aggression
Bool WasPartner = False
Bool SpamGuard
; 2015.07.15 / Add
Float gnElapsedTime
Float gnDuration
; 2015.07.15 / Add
; 2015.08.08 / Add
Float gnPoseDuration
; 2015.08.08 / Add

; 2015.07.22 / Add
Int[] Property maRyonaMapIDs Auto Hidden Conditional
; 2015.07.22 / Add

; 2015.07.12 / Add
Function setRyonaEffects(Actor actVictim, Actor actAggressor = None, Bool Enter = true)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int nIdx
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !RessConfig.STTon
		Return
	Endif
	
	;-------------------------------------------------------
	; Add/Remove tattoo
	;-------------------------------------------------------
	; 2015.07.22 / Mod / Using maRyonaMapIDs
	If Enter && McmConfig.mEnableRyona
		; 2015.07.14 / Add
		; Release MapIDs
		RessConfig.releaseRyonaMapIDs(actVictim, maRyonaMapIDs)
		; 2015.07.14 / Add
		
		; Get and add Maps
		maRyonaMapIDs = RessConfig.getRyonaMapID(actVictim, actAggressor)
		
		; 2015.07.13 / Del / Moving to RessConfig.getRyonaMapID()
		; Apply Ryona effects
;		SlaveTats.synchronize_tattoos(actVictim, True)
		; 2015.07.13 / Del / Moving to RessConfig.getRyonaMapID()
	Else
		; 2015.07.13 / Mod / Using RessConfig.releaseRyonaMapIDs()
		; Release MapIDs
		RessConfig.releaseRyonaMapIDs(actVictim, maRyonaMapIDs)
		
		; 2015.07.13 / Mod / Using RessConfig.removeRyonaEffects()
		; Remove Ryona effects
		; 2015.07.14 / Del
;		RessConfig.removeRyonaEffects(actVictim)
		; 2015.07.14 / Del
		
		; Clear MapIDs
		nIdx = maRyonaMapIDs.Length
		
		While (nIdx > 0)
			nIdx -= 1
			
			maRyonaMapIDs[nIdx] = 0
		EndWhile
	Endif
	; 2015.07.22 / Mod / Using maRyonaMapIDs
EndFunction
; 2015.07.12 / Add

Event OnEffectStart(Actor Target, Actor Caster)
	Time = RessConfig.StateDuration
	; 2015.07.15 / Add
	gnElapsedTime = 0.0
	gnDuration    = 5.0
	; 2015.07.15 / Add
	; 2015.08.08 / Add
	gnPoseDuration = 0.0
	; 2015.08.08 / Add
	Victim = Target
	Perpetrator = RessConfig.Perpetrator
	SpamGuard = False
;	DefeatConfig.Log("DefeatStateMonitoringEFFscr Start // Victim - "+Victim+" / StateType - "+StateType+" / Time - "+Time)
	GoToState(StateType)
EndEvent
State Calm
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If Aggressor
			RessConfig.AddCalmList(Aggressor, Victim)
			Victim.StopCombat()
			Victim.StopCombatAlarm()
		Endif
	EndEvent
	Event OnBeginState()
		RegisterForSingleUpdate(Time)
		If Victim.IsPlayerTeammate()
			WasPartner = True
			Victim.SetPlayerTeammate(False, False) 
		Endif
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		If WasPartner
			Victim.SetPlayerTeammate(True, True)
		Endif
		; 2015.07.12 / Add
		RessConfig.RemoveStates(Victim)
		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.12 / Add
	EndEvent
EndState
State Knockdown
	Event OnBeginState()
		RegisterForSingleUpdate(Time)
		RegisterForAnimationEvent(Victim, "staggerStop")
		RegisterForAnimationEvent(Victim, "GetUpEnd")
		RegisterForAnimationEvent(Victim, "BleedoutStop")
	EndEvent
	Event OnUpdate()
		If (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ;|| Victim.HasMagicEffect(RessConfig.NVNAssautEFF)
			; If the player is still in a scene and the knoccked down victim is a follower OR the victim is a NVN victim, extend the knock down state state.
			RegisterForSingleUpdate(Time)
		Else
			Dispel()
		Endif
	EndEvent
	Event OnActivate(ObjectReference akActionRef)
		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
	EndEvent
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		If !SpamGuard
			SpamGuard = True
			Actor Aggressor = (akAggressor As Actor)
			If ((Aggressor == Player) && abBashAttack)
				RessConfig.Knockout(Victim, Aggressor)
			Else
				Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
			Endif
			Utility.Wait(2)
			SpamGuard = False
		Endif
	EndEvent
;	Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
;		Victim.StopCombat()
;		Victim.StopCombatAlarm()
;	EndEvent
	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
;		DefeatConfig.Log("Knockdown OnAnimationEvent")
		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
		RessConfig.DefeatPlayAnimation(Victim, "Bleedout")
;		RessConfig.DefeatPlayAnimation(Victim, "Sit")
;		SetStringValue(Victim, "DefeatStateAnim", "IdleWounded_03")
;		SendAnimationEvent(Victim, "IdleWounded_03")
	EndEvent
	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
		RessConfig.Knockdown(Victim)
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Knockdown(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
	EndEvent
EndState
State Trauma
	Event OnBeginState()
		; 2015.07.15 / Mod
;		RegisterForSingleUpdate(Time)
		RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		RegisterForAnimationEvent(Victim, "staggerStop")
		RegisterForAnimationEvent(Victim, "GetUpEnd")
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = True)
		setRyonaEffects(Victim, Perpetrator, Enter = True)
		; 2015.07.12 / Add
	EndEvent
	Event OnUpdate()
		; 2015.07.15 / Add
		gnElapsedTime += gnDuration
		; 2015.07.15 / Add
		; 2015.08.08 / Add
		gnPoseDuration += gnDuration
		; 2015.08.08 / Add
		
		; 2015.07.15 / Add
		If gnElapsedTime < Time
			RessConfig.setRapedFaceAnimation(Victim, Enter = True)
			RegisterForSingleUpdate(gnDuration)
			
			; 2015.08.08 / Add
			Bool canChangePose = True
			
			If (McmConfig.mnPoseChangeDuration == 0.0)
				canChangePose = False
			Elseif (gnPoseDuration < McmConfig.mnPoseChangeDuration)
				canChangePose = False
			Elseif Victim.HasKeyWordString("SexLabActive")
				canChangePose = False
			Endif
			
			If canChangePose
				RessConfig.DefeatPlayAnimation(Victim, "Trauma Lie")
				gnPoseDuration = 0.0
			Endif
			; 2015.08.08 / Add
		; 2015.07.15 / Add
		; 2015.07.15 / Mod
;		If (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the trauma victim is a follower, extend the state.
;			RegisterForSingleUpdate(Time)
		Elseif (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the trauma victim is a follower, extend the state.
			RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		Else
			Dispel()
		Endif
	EndEvent
	Event OnActivate(ObjectReference akActionRef)
		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
		RessConfig.Trauma(Victim)
	EndEvent
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		If !SpamGuard
			SpamGuard = True
			Actor Aggressor = (akAggressor As Actor)
			If ((Aggressor == Player) && abBashAttack)
				RessConfig.Knockout(Victim, Aggressor)
			Else
				Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
			Endif
			Utility.Wait(2)
			SpamGuard = False
		Endif
	EndEvent
;	Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
;		Victim.StopCombat()
;		Victim.StopCombatAlarm()
;	EndEvent
	; 2015.08.19 / Del
;	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
;		RessConfig.Trauma(Victim)
;	EndEvent
	; 2015.08.19 / Del
	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
		RessConfig.Trauma(Victim)
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Trauma(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = False)
		setRyonaEffects(Victim, Perpetrator, Enter = False)
		; 2015.07.12 / Add
	EndEvent
EndState
State Exhausted
	Event OnBeginState()
		; 2015.07.15 / Mod
;		RegisterForSingleUpdate(Time)
		RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		RegisterForAnimationEvent(Victim, "staggerStop")
		RegisterForAnimationEvent(Victim, "GetUpEnd")
		Victim.DamageActorValue("Stamina", Victim.GetActorValue("Stamina"))
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = True)
		setRyonaEffects(Victim, Perpetrator, Enter = True)
		; 2015.07.12 / Add
	EndEvent
	Event OnUpdate()
		; 2015.07.15 / Add
		gnElapsedTime += gnDuration
		; 2015.07.15 / Add
		; 2015.08.08 / Add
		gnPoseDuration += gnDuration
		; 2015.08.08 / Add
		
		; 2015.07.15 / Add
		If gnElapsedTime < Time
			RessConfig.setRapedFaceAnimation(Victim, Enter = True)
			RegisterForSingleUpdate(gnDuration)
			
			; 2015.08.08 / Add
			Bool canChangePose = True
			
			If (McmConfig.mnPoseChangeDuration == 0.0)
				canChangePose = False
			Elseif (gnPoseDuration < McmConfig.mnPoseChangeDuration)
				canChangePose = False
			Elseif Victim.HasKeyWordString("SexLabActive")
				canChangePose = False
			Endif
			
			If canChangePose
				RessConfig.DefeatPlayAnimation(Victim, "Exhausted Lie")
				gnPoseDuration = 0.0
			Endif
			; 2015.08.08 / Add
		; 2015.07.15 / Add
		; 2015.07.15 / Mod
;		If (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the exausted victim is a follower, extend the state.
;			RegisterForSingleUpdate(Time)
		Elseif (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the exausted victim is a follower, extend the state.
			RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		Else
			Dispel()
		Endif
	EndEvent
	Event OnActivate(ObjectReference akActionRef)
		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
		RessConfig.Exhausted(Victim)
	EndEvent
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		If !SpamGuard
			SpamGuard = True
			Actor Aggressor = (akAggressor As Actor)
			If ((Aggressor == Player) && abBashAttack)
				RessConfig.Knockout(Victim, Aggressor)
			Else
				Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
			Endif
			Utility.Wait(2)
			SpamGuard = False
		Endif
	EndEvent
;	Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
;		Victim.StopCombat()
;		Victim.StopCombatAlarm()
;	EndEvent
	; 2015.08.19 / Del
;	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
;		Victim.Say(RessConfig.TopicToSay[2], Victim) ; Death moan
;		RessConfig.Exhausted(Victim)
;	EndEvent
	; 2015.08.19 / Del
	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
		RessConfig.Exhausted(Victim)
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Exhausted(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = False)
		setRyonaEffects(Victim, Perpetrator, Enter = False)
		; 2015.07.12 / Add
	EndEvent
EndState
State Surrender
	Event OnBeginState()
		Utility.Wait(5.0)
		RessConfig.DefeatPlayAnimation(Victim, "Surrender")
		RegisterForSingleUpdate(2)
	EndEvent
	Event OnUpdate()
		If Victim.HasKeyWordString("DefeatCollateral")
			SendAnimationEvent(Victim, "IdleCowering")
		Elseif !Player.HasKeyWordString("DefeatActive")
			Dispel()
			Return
		Endif
		RegisterForSingleUpdate(5)
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Surrender(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
	EndEvent
EndState
State Yield
	Event OnBeginState()
		RegisterForUpdate(5)
	EndEvent
	Event OnUpdate()
		If (!Player.HasLos(Victim) || Player.IsInCombat() || Player.GetDistance(Victim) > 1000.0)
			Dispel()
		Elseif !Victim.GetAnimationVariableBool("bIsSynced")
			RessConfig.CoverSelf(Victim)
		Endif
	EndEvent
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		If !SpamGuard
			SpamGuard = True
			Actor Aggressor = (akAggressor As Actor)
			If Aggressor
				If ((Aggressor == Player) && abBashAttack)
					RessConfig.Knockdown(Victim)
				Else
					If ((Victim.GetActorValue("Aggression") < 2) || (Victim.GetActorValue("Confidence") < 3))
						Victim.Say(RessConfig.TopicToSay[3], Player) ; Flee
						SendAnimationEvent(Victim, "IdleCowering")
					Else
						Dispel()
					Endif
				Endif
			Endif
			Utility.Wait(2)
			SpamGuard = False
		Endif
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Yield(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
	EndEvent
EndState
State Escape
	Event OnBeginState()
		; 2015.07.15 / Mod
;		RegisterForSingleUpdate(Time)
		RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = True)
		setRyonaEffects(Victim, Perpetrator, Enter = True)
		; 2015.07.12 / Add
	EndEvent
	Event OnUpdate()
		; 2015.07.15 / Add
		gnElapsedTime += gnDuration
		; 2015.07.15 / Add
		
		; 2015.07.15 / Add
		If gnElapsedTime < Time
			RessConfig.setRapedFaceAnimation(Victim, Enter = True)
			RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Add
		; 2015.07.15 / Mod
;		If (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the trauma victim is a follower, extend the state.
;			RegisterForSingleUpdate(Time)
		Elseif (Player.HasKeyWordString("DefeatActive") && Victim.HasKeyWordString("DefeatFollower")) ; If the player is still in a scene and the trauma victim is a follower, extend the state.
			RegisterForSingleUpdate(gnDuration)
		; 2015.07.15 / Mod
		Else
			Dispel()
		Endif
	EndEvent
	Event OnActivate(ObjectReference akActionRef)
		Victim.Say(RessConfig.TopicToSay[3], Victim) ; Flee
	EndEvent
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		If !SpamGuard
			SpamGuard = True
			Actor Aggressor = (akAggressor As Actor)
			If ((Aggressor == Player) && abBashAttack)
				RessConfig.Knockout(Victim, Aggressor)
			Else
				Victim.Say(RessConfig.TopicToSay[3], Victim) ; Flee
			Endif
			Utility.Wait(2)
			SpamGuard = False
		Endif
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		; 2015.07.07 / Mod
		RessConfig.Escape(Victim, Enter = False)
;		RessConfig.RemoveStates(Victim)
;		RessConfig.TieUp(Victim, UnCalm = False, Enter = False)
		; 2015.07.07 / Mod
		; 2015.07.12 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = False)
		setRyonaEffects(Victim, Perpetrator, Enter = False)
		; 2015.07.12 / Add
	EndEvent
EndState
State Weakenings
	Event OnBeginState()
		RegisterForSingleUpdate(Time)
	EndEvent
	Event OnUpdate()
		Dispel()
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		RessConfig.Weakenings(Victim, RemoveSpl = True)
	EndEvent
EndState
State Satisfied
	Event OnBeginState()
		RegisterForSingleUpdate(Time)
	EndEvent
	Event OnUpdate()
		Dispel()
	EndEvent
	Event OnEffectFinish(Actor Target, Actor Caster)
;		DefeatConfig.Log("DefeatStateMonitoringEFFscr End // Victim - "+Victim+" / StateType - "+StateType)
		RessConfig.SetSatisfied(Victim, Satisfied = False)
		If Victim.IsInFaction(RessConfig.DefeatFactions[1]) ; AggFaction
			Victim.SetFactionRank(RessConfig.DefeatFactions[1], 0) ; So the aggressor can be picked as sexual aggressor if a player scene is running
			RessConfig.PlayerScr.Collateral()
		Endif
	EndEvent
EndState