Scriptname DefeatNVNAssaultSPL extends ActiveMagicEffect

DefeatMCMscr Property McmConfig auto
DefeatConfig Property RessConfig auto

Spell Property TheSpell Auto

Import StorageUtil
Import Utility
Import Game
Import Debug

Int NVNSlot
Actor Aggressor
Actor Victim
Actor TheAdd = None
Actor Property Player Auto
Package[] Property NVNAgressorPck Auto
Bool IsFollower
Bool IsHuman
String Outcome
Float MaxDistance
Float KDTime

Event OnEffectStart(Actor Target, Actor Caster)
	Aggressor = Caster
	Victim = Target
	If (Victim && Aggressor)
		; 2015.07.19 / Add
		Bool isEstrusRaped
		Bool isSummonRaped
		
		isSummonRaped = doSummonRape()
		
		If !isSummonRaped
			isEstrusRaped = doEstrusAttack()
		Else
			isEstrusRaped = False
		Endif
		
		If isEstrusRaped
			Return
		Endif
		; 2015.07.19 / Add
		
		If NVNSlot() ; Check is there is free slots.
			DefeatConfig.Log("NVN OnEffectStart - Victim - "+Victim+" // Aggressor - "+Aggressor+" Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())
			IsFollower = RessConfig.IsFollower(Target)
			IsHuman = Aggressor.HasKeyWordString("ActorTypeNPC")
			KDTime = McmConfig.KDTimeNVN
			If Self
				RegisterForSingleUpdate(1.0)
			Endif
		Else
			Dispel()
		Endif
	Endif
EndEvent
Bool Function NVNSlot()
	Int i = 0
	While (i < 10)
		If !RessConfig.VicPair[i].GetReference()
			RessConfig.VicPair[i].ForceRefIfEmpty(Victim)
			RessConfig.AggPair[i].ForceRefIfEmpty(Aggressor)
			NVNSlot = i
;			DefeatConfig.Log("NVN NVNSlot chosen - "+NVNSlot)
			Return True
		Endif
		i += 1
	EndWhile
	Return False
EndFunction
; 2015.07.22 / Add
Bool Function doSummonRape()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor actSummon
	
	;-------------------------------------------------------
	; Summon Raper
	;-------------------------------------------------------
	If Aggressor && Aggressor.HasKeyWordString("ActorTypeDwarven")
		actSummon = RessConfig.summonDwarvenRaper(Aggressor)
	Elseif Aggressor && RessConfig.isSpriggan(Aggressor)
		actSummon = RessConfig.summonSprigganRaper(Aggressor)
	Elseif Aggressor && RessConfig.isAtronachFlame(Aggressor)
		actSummon = RessConfig.summonFlamingRaper(Aggressor)
	Endif
	
	;-------------------------------------------------------
	; Set Effect
	;-------------------------------------------------------
	If actSummon
		Aggressor = actSummon
	Else
		Return False
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return True
EndFunction
; 2015.07.22 / Add
; 2015.07.20 / Add
Bool Function doEstrusAttack()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool   isRaped        = False
	Race   racCreature
	String szRace         = ""
	String szVicType      = "NPC"
	Bool   canUseEstrus   = RessConfig.Estruson
	Bool   canUseTentacle = False
	Int    nRand          = RandomInt(1, 100)
	Float  nInterval      = RandomFloat(0.8, 8.0)
	Int    nRate
	
	;-------------------------------------------------------
	; Check Victim
	;-------------------------------------------------------
	If RessConfig.IsFollower(Victim)
		szVicType = "Follower"
	Endif
	
	;-------------------------------------------------------
	; Do Estrus Attack
	;-------------------------------------------------------
	If Aggressor.HasKeyWordString("ActorTypeDwarven")
		nRate = McmConfig.mnEstrusDwarvenRate
		
		If (nRand <= nRate) && canUseEstrus
			Wait(nInterval)
;			Strip()
;			Wait(0.8)
			isRaped = RessConfig.doDwarvenRape(Aggressor, Victim)
			Strip()
			Wait(0.8)
			
			If isRaped
				WeakeningsState(szVicType)
			Elseif !Aggressor.IsDead() && !Victim.IsDead()
				RessConfig.TieUp(Victim, Aggressor, DoAnimation = False)
			Endif
		Elseif (nRand <= nRate) && !Aggressor.IsDead() && !Victim.IsDead()
			RessConfig.TieUp(Victim, Aggressor, DoAnimation = False)
		Endif
		
		Dispel()
		Return isRaped
	Elseif Aggressor.HasKeyWordString("ActorTypeCreature")
		racCreature = Aggressor.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
		nRate       = McmConfig.mnEstrusTentacleRate
		
		If (StringUtil.Find(szRace, "Lurker") != -1)
			canUseTentacle = True
		Elseif (StringUtil.Find(szRace, "Seeker") != -1)
			canUseTentacle = True
		Elseif (StringUtil.Find(szRace, "Chaurus") != -1)
			canUseTentacle = True
		Endif
		
		If canUseTentacle && (nRand <= nRate) && canUseEstrus
			Wait(nInterval)
;			Strip()
;			Wait(0.8)
			isRaped = RessConfig.doTentacleRape(Aggressor, Victim)
			
			If isRaped
				WeakeningsState(szVicType)
			Endif
			
			Dispel()
			Return isRaped
		Endif
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isRaped
EndFunction
; 2015.07.20 / Add
Event OnUpdate()
;	DefeatConfig.Log("NVN OnUpdate -> Victim - "+Victim+" // Aggressor - "+Aggressor+" // Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())
	If ((GetTimeElapsed() < KDTime) && CheckActors())
		If (!Aggressor.IsInCombat() || !McmConfig.NPCLastEnemy) ; If last enemy is disabled, the aggressor go immediately on the victim, else they will wait for the end of the combat.
;			DefeatConfig.Log("NVN - aggressor out of combat or Last Enemy disabled, begin the assault. // Slot - "+NVNSlot)
			Outcome = SetOutcome()
			If IsFollower
				If Player.HasKeyWordString("DefeatActive") ; Player is down and the victim is a follower, cancel the assault.
					Restored()
					Return
				Endif
			Endif
			
			If (Outcome != "")
				Aggressor.SetFactionRank(RessConfig.DefeatFactions[1], 1)
				MaxDistance = Dist()
				
				; 2015.09.14 / Del
				; 2015.08.03 / Mod
;				If (RandomInt(1, 100) <= McmConfig.mnNpcGangbangChance)
;					TheAdd = FindAdd()
;				Else
;					TheAdd = None
;				Endif
				; 2015.08.03 / Mod
				; 2015.09.14 / Del
				
				If TheAdd
					RessConfig.AggPairAdd[NVNSlot].ForceRefIfEmpty(TheAdd)
					ActorUtil.AddPackageOverride(TheAdd, NVNAgressorPck[NVNSlot], 100, 1)
					Aggressor.EvaluatePackage()
				Endif
				ActorUtil.AddPackageOverride(Aggressor, NVNAgressorPck[NVNSlot], 100, 1)
				Aggressor.EvaluatePackage()
				If (McmConfig.NoNotifications && CheckActors())
					Ressconfig.AssaultNVNMess[NVNSlot].Show()
				Endif
				; 2015.07.11 / Mod / Using McmConfig
				Int i = McmConfig.mnRapeTryNum
				; 2015.07.11 / Mod / Using McmConfig
				While (i > 0)
					i -= 1
					If !CheckActors()
						DefeatConfig.Log("NVN - One of the actor in dead or victim rescued. // Slot - "+NVNSlot)
						Restored()
						Return
;					Elseif (Aggressor.HasMagicEffect(RessConfig.MiscMagicEffects[0]) || Victim.HasMagicEffect(RessConfig.MiscMagicEffects[0])) ; ImmunityEFF
;						DefeatConfig.Log("NVN - victim rescued. // Slot - "+NVNSlot)
;						Restored()
;						Return
					Elseif (Aggressor.GetDistance(Victim) < MaxDistance)
;						DefeatConfig.Log("NVN - Distance reached, Outcome. // Slot - "+NVNSlot)
						GoToState("Outcome")
						Return
					Endif
					Wait(1.0)
				EndWhile
				Restored()
			Else
				Restored()
			Endif
		Else
			If Self
				RegisterForSingleUpdate(5.0)
			Endif
		Endif
	Else
		Restored()
	Endif
EndEvent
String Function SetOutcome()
	; To add : Crime faction, witness etc...
	If IsHuman
		String[] Events = New String[10]
		If IsFollower
			If RessConfig.IsBadRelation(Aggressor, Victim, False)
				If RessConfig.IsSexualAssaulter(Aggressor, Victim, IsFollower = True)
					Return "Raped" ; Prioritize the rape by returning directly
				Endif
				If McmConfig.NVNKillFollower
					If !Victim.IsEssential()
						i = Events.Find("")
						Events[i] = "Kill"
					Endif
				Endif
			Endif
			If McmConfig.NVNRobbedFollower
				i = Events.Find("")
				Events[i] = "Robbed"
			Endif
		Else
			If RessConfig.IsBadRelation(Aggressor, Victim, False)
				If RessConfig.IsSexualAssaulter(Aggressor, Victim, IsFollower = False)
					Return "Raped" ; Prioritize the rape by returning directly
				Endif
				If McmConfig.NVNKill
					If !Victim.IsEssential()
						i = Events.Find("")
						Events[i] = "Kill"
					Endif
				Endif
			Endif
			If McmConfig.NVNRobbed
				i = Events.Find("")
				Events[i] = "Robbed"
			Endif
		Endif
		Int n = -1
		Int i = 0
		While (i < 10)
			If (Events[i] != "")
				n += 1
			Endif
			i += 1
		EndWhile
		If (n != -1) ; Nothing in the array to choose from
			String TheEvent = Events[RandomInt(0, n)] ; Pick an event randomly
;			DefeatConfig.Log("NVN spell Event chosen - "+TheEvent+" // Events array - "+Events)
			If (TheEvent != "")
				Return TheEvent
			Endif
		Else
			Return "Robbed"
		Endif
	Else
		Return "Raped"
	Endif
	Return "Nothing"
EndFunction
State Outcome
	Event OnBeginState()
		If (Outcome != "")
			If (Outcome == "Raped")
				RessConfig.NVNHasBeenRapedBy = RessConfig.HasBeenRapedBy(Victim, Aggressor)
			;	Aggressor.Say(RessConfig.TopicToSay[12], Victim)
				If TheRape()
					RegisterForSingleUpdate(5.0)
				Else
					Restored()
				Endif
			Elseif (Outcome == "Robbed")
				SendAnimationEvent(Aggressor, "DefeatPickUp")
				Int i = Victim.GetNumItems()
				While (i > 0)
					i -= 1
					Form Item = Victim.GetNthForm(i)
					If (Item.GetGoldValue() >= 100.0)
						Victim.RemoveItem(Item, Victim.GetItemCount(Item), True, Aggressor)
					Endif
				EndWhile
				Victim.RemoveItem(GetForm(0x0F), Victim.GetGoldAmount(), akOtherContainer = Aggressor)
				Restored()
				; 2015.07.03 / Add
				Notification(Victim.GetActorBase().GetName()+" is robbed and tied up.")
				Victim.Say(RessConfig.TopicToSay[3], Victim)
				RessConfig.TieUp(Victim, Aggressor, DoAnimation = McmConfig.bTieUpAnim)
				; 2015.07.03 / Add
			Elseif (Outcome == "Kill")
				If !Aggressor.IsWeaponDrawn()
					Aggressor.DrawWeapon()
					Float i = 3.0
					While (!Aggressor.IsWeaponDrawn() && (i > 0.0))
						Wait(0.5)
						i -= 0.5
					EndWhile
				Endif
				Int Attempts
				Bool Succes = False
				Idle TheKillmove
				Int WeaponType = Aggressor.GetEquippedItemType(1)
				If ((WeaponType == 1) || WeaponType == 2) || (WeaponType == 5) 		; Dagger & Sword 1H/2H Bleedout kill
					TheKillmove = RessConfig.Killmoves[5]
				Elseif (WeaponType == 3) || (WeaponType == 4) || (WeaponType == 6) 	; Axe/Mace 1H/2H
					TheKillmove = RessConfig.Killmoves[8] 	; Quick slash
				Else
					TheKillmove = RessConfig.Killmoves[10] 	; Combo 3 punches
				Endif
				While (!Succes && (Attempts < 5))
					If Aggressor.PlayIdleWithTarget(TheKillmove, Victim) ; Bleedout kill
						Succes = True
					Endif
					Attempts += 1
				EndWhile
				If !Succes ; Fail to play an animation or for Sleeping state
					Float HP = Victim.GetActorValue("Health")
					Victim.DamageActorValue("Health", HP - 1.0)
					SendAnimationEvent(Aggressor, "pa_killmove2HM3Slash")
					Wait(3.0)
					While !Victim.IsDead()
						Victim.Kill(Aggressor)
						Wait(0.5)
					EndWhile
				Endif
				Restored()
			Endif
		Else
			Restored()
		Endif
	EndEvent
	Event Onupdate()
		; 2015.07.12 / Del
;		If (!CheckActors() || !Victim.HasKeyWordString("SexLabActive") || !Aggressor.HasKeyWordString("SexLabActive"))
;			Restored()
		; 2015.07.12 / Mod
;		Else
		; 2015.07.12 / Mod
		; 2015.07.12 / Del
			; 2015.07.03 / Add
			Actor Found
			Float nRapeAgainInterval
			; 2015.08.20 / Mod / Not using AgainChance but mnNpcRapeAgainChance
			Int   nRapeAgainRate     = McmConfig.mnNpcRapeAgainChance
			; 2015.07.11 / Mod / Using McmConfig
			Float nMinAgainTime      = McmConfig.mnMinRapeAgainInterval
			Float nMaxAgainTime      = McmConfig.mnMaxRapeAgainInterval
			; 2015.07.25 / Add
			Int     nIdx
			Actor[] aAdds
			; 2015.07.25 / Add
			
			If (nMinAgainTime < nMaxAgainTime)
				nRapeAgainInterval = RandomFloat(nMinAgainTime, nMaxAgainTime)
			Else
				nRapeAgainInterval = nMaxAgainTime
			Endif
			; 2015.07.11 / Mod / Using McmConfig
			
			; 2015.07.28 / Add
			RessConfig.waitSexEnd(Victim)
			; 2015.07.28 / Add
			
			; 2015.07.16 / Add
			If !SexLabUtil.GetConfig().RagdollEnd
				SendAnimationEvent(Victim, GetStringValue(Victim, "DefeatStateAnim"))
			Endif
			; 2015.07.16 / Add
			; 2015.07.21 / Add
			; 2015.08.07 / Mod / Using startWeakenAnimation()
			RessConfig.startWeakenAnimation(Victim)
			RessConfig.forceResetAnimation(Victim)
			; 2015.07.21 / Add
			
			; 2015.07.25 / Add
			aAdds = RessConfig.addAggressor(Aggressor)
			nIdx  = aAdds.Length
			
			While (nIdx > 0)
				nIdx -= 1
				
				If aAdds[nIdx]
					aAdds[nIdx].PathToReference(Victim, 1.0)
				Endif
			EndWhile
			; 2015.07.25 / Add
			
			; 2015.08.20 / Mod / Not using RandomFloat() but RandomInt()
			If (RandomInt(1, 100) < nRapeAgainRate)
				; 2015.07.19 / Add
				Dispel()
				; 2015.07.19 / Add
				; 2015.07.15 / Mod
				Wait(nRapeAgainInterval)
				; 2015.07.15 / Mod
				
				; 2015.07.27 / Mod / Adding the arugument, isRapeAgain = True
				Found = FindAdd(False)
				; 2015.07.04 / Mod / Adding Found == Aggressor.
				If (!Found || Found == Aggressor)
					Found = Aggressor
					Notification(Victim.GetActorBase().GetName()+" will be raped again by the same one.")
				Else
					Notification(Victim.GetActorBase().GetName()+" will be raped again by the other one.")
				Endif
				
				RessConfig.MiscSpells[3].Cast(Found, Victim) ; NVNAssautSPL
				Victim.Say(RessConfig.TopicToSay[3], Victim)
			Else
				Notification(Victim.GetActorBase().GetName()+" avoids being raped again.")
			Endif
			; 2015.07.03 / Add
			
			; 2015.07.12 / Add
			Restored()
			; 2015.07.12 / Add
		; 2015.07.12 / Del
;		Endif
		; 2015.07.12 / Del
	EndEvent
EndState

; 2015.07.28 / Add
Actor[] gaGangbangRapers
; 2015.07.28 / Add
Actor Function FindAdd(Bool isGangbangRape = True)
	; 2015.07.28 / Mod
	gaGangbangRapers = RessConfig.findRapers(Aggressor, Victim, isGangbangRape)
	
	Int nIdx = gaGangbangRapers.Length
	
	While (nIdx > 0)
		nIdx -= 1
		
		If gaGangbangRapers[nIdx]
			Return gaGangbangRapers[nIdx]
		Endif
	EndWhile
	; 2015.07.28 / Mod
	
	Return None
EndFunction
Bool Function TheRape()
	SexLabFramework SexLab = SexLabUtil.GetAPI()
	; 2015.07.28 / Add
	Bool  enableRapeSpell = McmConfig.mEnableReplaceRapeSpell
	Spell splRape         = RessConfig.msplRapeAlt
	; 2015.07.28 / Add
	; 2015.07.06 / Del
;	RegisterForModEvent("AnimationEnd_NVNR", "EndNVNR")
	; 2015.07.06 / Del
	
	; 2015.08.01 / Add
	; 2015.08.07 / Add
	Bool enableRagdoll = McmConfig.mEnableStruggleRagdoll
	; 2015.08.07 / Add
	; 2015.08.20 / Add
	Int  nStruggleChance = McmConfig.mnNpcStruggleChance
	; 2015.08.20 / Add
	; 2015.09.01 / Add
	sslThreadModel      Make
	sslThreadController Thread
	Bool isInvolvePlayer = False
	; 2015.09.01 / Add
	
	; 2015.08.20 / Mod / Using nStruggleChance
	If (RandomInt(1, 100) < nStruggleChance)
		; 2015.08.07 / Mod / Adding the another motion
		If enableRagdoll
			Aggressor.pushActorAway(Victim, 2)
		Else
			RessConfig.startWeakenAnimation(Victim)
		Endif
		
		Wait(2.6)
		RessConfig.StruggleAnim(Victim, Aggressor, Animate = True)
		Wait(8.0)
		; 2015.09.03 / Add
		SendAnimationEvent(Victim, "IdleWounded_02")
		RessConfig.StruggleAnim(Victim, Aggressor, Animate = False)
		; 2015.09.03 / Add
	Endif
	; 2015.08.20 / Mod / Using nStruggleChance
	
;	RessConfig.FollowerHasBeenRapedBy = RessConfig.HasBeenRapedBy(Victim, Aggressor)
;	
;	If (RandomInt(0, 100) <= 44)
;		Aggressor.Say(RessConfig.mtpcAboutVictim, Victim)
;	Endif
	; 2015.08.01 / Add
	
	If IsHuman
		Strip()
		If CheckActors()
			If InvolvePlayer(RessConfig.IsFollower(Aggressor))
				TheAdd = Player
				; 2015.09.01 / Add
				isInvolvePlayer = True
				; 2015.09.01 / Add
			Endif
			Victim.Say(RessConfig.TopicToSay[8], Victim) ; Bleedout
			; 2015.09.01 / Del
;			sslThreadModel Make = SexLab.NewThread()
;			sslBaseAnimation[] Anims
;			Actor[] Positions = sslUtility.MakeActorArray(Victim, Aggressor, TheAdd)
;			Int NumFemales = SexLab.FemaleCount(Positions)
			; 2015.09.01 / Del
			; 2015.08.02 / Add
			SendAnimationEvent(Aggressor, "IdleForceDefaultState")
			; 2015.08.02 / Add
			
			; 2015.07.06 / Add
			If IsFollower && Player.HasKeyWordString("DefeatActive")
				RessConfig.Calm(Victim)
			Elseif IsFollower
				WeakeningsState("Follower")
			Else
				WeakeningsState("NPC")
			Endif
			
			Wait(4.4)

			; 2015.07.11 / Mod / Using McmConfig
			Float nTieupRate = McmConfig.mnTieupRatio
			
			If (RandomFloat(1.0, 100.0) < nTieupRate)
				Notification(Victim.GetActorBase().GetName()+" has been tied up.")
				Victim.Say(RessConfig.TopicToSay[3], Victim)
				RessConfig.TieUp(Victim, Aggressor, DoAnimation = McmConfig.bTieUpAnim)
				; 2015.08.02 / Mod / 1.0 -> 4.4
				Wait(4.4)
				; 2015.07.26 / Add
				Strip()
				; 2015.07.26 / Add
			Endif
			; 2015.07.06 / Add
			; 2015.07.28 / Add
			
			; 2015.09.01 / Add
			Make = RessConfig.setupSexAnimThread(Victim, Aggressor, False, isInvolvePlayer)
			
			If splRape && enableRapeSpell
				Return True
			Elseif Make
				Thread = startSex("NVNR", Make)
			Else
				Thread = None
;				Notification("setupSexAnimThread returns None.")
			Endif
			
			If !Thread
;				Notification("NVN Error: The animation did not start.")
				Return False
			Endif
			; 2015.09.01 / Add
			
			; 2015.09.01 / Del
;			If splRape && enableRapeSpell
;				splRape.Cast(Aggressor, Victim)
;			; 2015.07.28 / Add
;			; 2015.07.28 / Mod / If -> Elseif
;			Elseif TheAdd
;				Positions = SexLab.SortActors(Positions)
;				String Tag = SexLab.MakeAnimationGenderTag(Positions)
;				Anims = SexLab.GetAnimationsByTags(3, Tag)
;				If (Anims.Length == 0)
;					DefeatConfig.Log("NVN, TheRape - No default animations were found because they are probably all disabled (threesome), the script will set default animations.")
;					If (NumFemales == 2) && (SexLab.GetGender(Victim) == 0) ; 2 female aggressors on male
;						Anims = new sslBaseAnimation[2]
;						Anims[0] = SexLab.GetAnimationByName("Arrok Tricycle")
;						Anims[1] = SexLab.GetAnimationByName("Zyn FemDom")
;					Else
;						Anims = new sslBaseAnimation[3]
;						Anims[0] = SexLab.GetAnimationByName("Arrok Devils Threeway")
;						Anims[1] = SexLab.GetAnimationByName("Zyn Double Penetration")
;						Anims[2] = SexLab.GetAnimationByName("DI Forced Threesome")
;					Endif
;				Endif
;				Make.SetAnimations(Anims)
;				Make.AddActors(Positions, Victim)
;				Make.DisableUndressAnimation(Victim)
;				Make.DisableRagdollEnd(Aggressor)
;				Make.DisableRagdollEnd(TheAdd)
;				; 2015.07.22 / Add
;				If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;					bool[] aStripSlots = new bool[33]
;					Make.SetStrip(Aggressor, aStripSlots)
;				Endif
;				If (TheAdd.IsInFaction(RessConfig.mfctDwarven))
;					bool[] aStripSlots = new bool[33]
;					Make.SetStrip(TheAdd, aStripSlots)
;				Endif
;				; 2015.07.22 / Add
;				; 2015.08.01 / Del
;				; 2015.07.27 / Mod
;;				If !McmConfig.mEnableBedUse
;;					Make.DisableBedUse()
;;				Endif
;				; 2015.07.27 / Mod
;				; 2015.08.01 / Del
;				; 2015.07.06 / Del
;;				Make.SetHook("NVNR")
;				; 2015.07.06 / Del
;				; 2015.07.31 / Mod / Using startSex()
;;				sslThreadController Thread = Make.StartThread()
;				sslThreadController Thread = startSex("NVNR", Make)
;				If !Thread
;					DefeatConfig.Log("NVN Error: The animation did not start")
;					Return False
;				Endif
;			Else
;				Bool IsTied = RessConfig.Tied(Victim)
;				If (McmConfig.ReverseR && (NumFemales == 1) && (SexLab.GetGender(Aggressor) == 1))
;					Positions = SexLab.SortActors(Positions)
;					If !IsTied
;						Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
;					Else
;						If RessConfig.Tied(Aggressor)
;							Anims = SexLab.GetAnimationsByTags(2, "SubSub")
;						Else
;							Anims = SexLab.GetAnimationsByTags(2, "DomSub")
;						Endif
;					Endif
;					If (Anims.length == 0)
;						DefeatConfig.Log("NVN, TheRape - No default animations were found because they are probably all disabled or not registered (Cowgirl or Zaz if bound), the script will set default animations.")
;						Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
;						If (Anims.length == 0)
;							Anims = new sslBaseAnimation[1]
;							Anims[0] = SexLab.GetAnimationByName("Arrok Cowgirl")
;						Endif
;					Endif
;				Elseif (McmConfig.ReverseRf && (NumFemales == 2))
;					Positions = SexLab.SortActors(Positions)
;					If !IsTied
;						Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
;					Else
;						If RessConfig.Tied(Aggressor)
;							Anims = SexLab.GetAnimationsByTags(2, "Lesbian,SubSub")
;						Else
;							Anims = SexLab.GetAnimationsByTags(2, "Lesbian,DomSub")
;						Endif
;					Endif
;					If (Anims.length == 0)
;						DefeatConfig.Log("NVN, TheRape - No default animations were found because they are probably all disabled or not registered (Lesbian or Zaz if bound), the script will set default animations.")
;						Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
;						If (Anims.length == 0)
;							Anims = new sslBaseAnimation[1]
;							Anims[0] = SexLab.GetAnimationByName("Arrok Lesbian")
;						Endif
;					Endif
;				Else
;					If !IsTied
;						Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
;					Else
;						If RessConfig.Tied(Aggressor)
;							Anims = SexLab.GetAnimationsByTags(2, "SubSub")
;						Else
;							Anims = SexLab.GetAnimationsByTags(2, "DomSub")
;						Endif
;					Endif
;					If (Anims.length == 0)
;						Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
;					Endif
;				Endif
;				; 2015.08.03 / Mod
;;				Make.SetAnimations(Anims)
;				If !McmConfig.mDisableRapeAnimRestriction
;					Make.SetAnimations(Anims)
;				Endif
;				; 2015.08.03 / Mod
;				Make.AddActors(Positions, Victim)
;				Make.DisableUndressAnimation(Victim)
;				Make.DisableRagdollEnd(Aggressor)
;				; 2015.07.22 / Add
;				If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;					bool[] aStripSlots = new bool[33]
;					Make.SetStrip(Aggressor, aStripSlots)
;				Endif
;				; 2015.07.22 / Add
;				; 2015.08.01 / Del
;				; 2015.07.27 / Mod
;;				If !McmConfig.mEnableBedUse
;;					Make.DisableBedUse()
;;				Endif
;				; 2015.07.27 / Mod
;				; 2015.08.01 / Del
;				; 2015.07.06 / Del
;;				Make.SetHook("NVNR")
;				; 2015.07.06 / Del
;				; 2015.07.31 / Mod / Using startSex()
;;				sslThreadController Thread = Make.StartThread()
;				sslThreadController Thread = startSex("NVNR", Make)
;				If !Thread
;					DefeatConfig.Log("NVN Error: The animation did not start")
;					Return False
;				; 2015.07.06 / Del
;;				Else
;;					RessConfig.RemoveStates(Victim, False)
;				; 2015.07.06 / Del
;				Endif
;			Endif
			; 2015.09.01 / Del
		Else
			Return False
		Endif
	Else
		Strip()
		If CheckActors()
			Victim.Say(RessConfig.TopicToSay[8], Victim) ; Bleedout			
			; 2015.07.06 / Add
			If IsFollower && Player.HasKeyWordString("DefeatActive")
				RessConfig.Calm(Victim)
			Elseif IsFollower
				WeakeningsState("Follower")
			Else
				WeakeningsState("NPC")
			Endif
			
			Wait(1.0)
			; 2015.07.06 / Add
			; 2015.07.26 / Add
			Float nTieupRate = McmConfig.mnTieupRatio
			; 2015.07.30 / Add
			Bool  canTieup   = False
			
			If RessConfig.isSpider(Aggressor) || RessConfig.isTentacleUser(Aggressor)
				canTieup = True
			Endif
			; 2015.07.30 / Add
			
			; 2015.07.30 / Mod / Using canTieup
			If (RandomFloat(1.0, 100.0) < nTieupRate) && canTieup
				Notification(Victim.GetActorBase().GetName()+" has been tied up.")
				Victim.Say(RessConfig.TopicToSay[3], Victim)
				RessConfig.TieUp(Victim, Aggressor)
				Wait(1.0)
			Endif
			; 2015.07.26 / Add
			
			; 2015.07.26 / Add
			Strip()
			; 2015.07.26 / Add
			
			; 2015.09.01 / Add
			Make = RessConfig.setupSexAnimThread(Victim, Aggressor, False, False)
			
			If splRape && enableRapeSpell
				Return True
			Elseif Make
				Thread = startSex("NVNR", Make)
			Else
				Thread = None
;				Notification("setupSexAnimThread returns None.")
			Endif
			
			If !Thread
				Notification("NVN Error: The animation did not start.")
;				Return False
			Endif
			; 2015.09.01 / Add
			
			; 2015.09.01 / Del
;			; 2015.07.26 / Add
;			bool[] aTiedStripSlots = new bool[33]
;			Int    nIdx
;			
;			nIdx = aTiedStripSlots.Length
;			
;			While (nIdx > 0)
;				nIdx -= 1
;				
;				aTiedStripSlots[nIdx] = True
;			EndWhile
;			
;			aTiedStripSlots[61 - 30] = False
;			aTiedStripSlots[48 - 30] = False
;			; 2015.07.26 / Add
;			
;			; 2015.07.28 / Add
;			If splRape && enableRapeSpell
;				splRape.Cast(Aggressor, Victim)
;			; 2015.07.28 / Add
;			; 2015.07.28 / Mod / If -> Elseif
;			Elseif TheAdd
;				sslThreadModel Make = SexLab.NewThread()
;				Make.AddActor(Victim, isVictim = True)
;				Make.AddActor(Aggressor)
;				; 2015.07.28 / Mod
;;				Make.AddActor(TheAdd)
;				Int nRaperIdx = gaGangbangRapers.Length
;				
;				While (nRaperIdx > 0)
;					nRaperIdx -= 1
;					
;					If gaGangbangRapers[nRaperIdx]
;						Make.AddActor(gaGangbangRapers[nRaperIdx])
;					Endif
;				EndWhile
;				; 2015.07.28 / Mod
;				Make.DisableUndressAnimation(Victim)
;				; 2015.07.26 / Add
;				If Victim.IsInFaction(RessConfig.TieUpFaction)
;					Make.SetStrip(Victim, aTiedStripSlots)
;				Endif
;				; 2015.07.26 / Add
;				Make.DisableRagdollEnd(Aggressor)
;				; 2015.07.22 / Add
;				If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;					bool[] aStripSlots = new bool[33]
;					Make.SetStrip(Aggressor, aStripSlots)
;				Endif
;				; 2015.07.28 / Mod
;;				If (TheAdd.IsInFaction(RessConfig.mfctDwarven))
;;					bool[] aStripSlots = new bool[33]
;;					Make.SetStrip(TheAdd, aStripSlots)
;;				Endif
;				nRaperIdx = gaGangbangRapers.Length
;				
;				While (nRaperIdx > 0)
;					nRaperIdx -= 1
;					
;					If gaGangbangRapers[nRaperIdx] && gaGangbangRapers[nRaperIdx].IsInFaction(RessConfig.mfctDwarven)
;						bool[] aStripSlots = new bool[33]
;						Make.SetStrip(gaGangbangRapers[nRaperIdx], aStripSlots)
;					Endif
;				EndWhile
;				; 2015.07.28 / Mod
;				; 2015.07.22 / Add
;				; 2015.08.01 / Del
;				; 2015.07.27 / Mod
;;				If !McmConfig.mEnableBedUse
;;					Make.DisableBedUse()
;;				Endif
;				; 2015.07.27 / Mod
;				; 2015.08.01 / Del
;				; 2015.07.06 / Del
;;				Make.SetHook("NVNR")
;				; 2015.07.06 / Del
;				; 2015.07.31 / Mod / Using startSex()
;;				sslThreadController Thread = Make.StartThread()
;				sslThreadController Thread = startSex("NVNR", Make)
;				If !Thread
;					DefeatConfig.Log("NVN Creatures Error: The animation did not start // Victim - "+Victim+" // Aggressor - "+Aggressor+" // Slot - "+NVNSlot)
;					Return False
;				Endif
;			Else
;				sslThreadModel Make = SexLab.NewThread()
;				Make.AddActor(Victim, isVictim = True)
;				Make.AddActor(Aggressor)
;				Make.DisableUndressAnimation(Victim)
;				; 2015.07.26 / Add
;				If Victim.IsInFaction(RessConfig.TieUpFaction)
;					Make.SetStrip(Victim, aTiedStripSlots)
;				Endif
;				; 2015.07.26 / Add
;				Make.DisableRagdollEnd(Aggressor)
;				; 2015.07.22 / Add
;				If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;					bool[] aStripSlots = new bool[33]
;					Make.SetStrip(Aggressor, aStripSlots)
;				Endif
;				; 2015.07.22 / Add
;				; 2015.08.01 / Del
;				; 2015.07.27 / Mod
;;				If !McmConfig.mEnableBedUse
;;					Make.DisableBedUse()
;;				Endif
;				; 2015.07.27 / Mod
;				; 2015.08.01 / Del
;				; 2015.07.06 / Del
;;				Make.SetHook("NVNR")
;				; 2015.07.06 / Del
;				; 2015.07.31 / Mod / Using startSex()
;;				sslThreadController Thread = Make.StartThread()
;				sslThreadController Thread = startSex("NVNR", Make)
;				If !Thread
;					DefeatConfig.Log("NVN Creatures Error: The animation did not start // Victim - "+Victim+" // Aggressor - "+Aggressor+" // Slot - "+NVNSlot)
;					Return False
;				Endif
;			Endif
			; 2015.09.01 / Del
		Else
			Return False
		Endif
	Endif
	Return True
EndFunction

; 2015.07.31 / Add
sslThreadController Function startSex(String szID, sslThreadModel oModel)
	; Disable BedUse
	If !McmConfig.mEnableBedUse
		oModel.DisableBedUse()
	Endif
	
	; Set Hook
	oModel.SetHook(szID)
	RegisterForModEvent("StageStart_"+szID,  "onStartStage")
	RegisterForModEvent("OrgasmStart_"+szID, "onStartOrgasm")
	
	; Start and Return
	Return oModel.StartThread()
EndFunction

Event onStartStage(string EventName, string argString, float argNum, form sender)
;	Notification("onStartStage")

	sslThreadController oThread   = SexLabUtil.GetAPI().HookController(argString)
	Actor               actVictim = SexLabUtil.GetAPI().HookVictim(argString)
	Actor[]             aActors   = SexLabUtil.GetAPI().HookActors(argString)
	
	RessConfig.randomizeSex(oThread, actVictim, aActors)
EndEvent

Event onStartOrgasm(string EventName, string argString, float argNum, form sender)
;	Notification("onStartOrgasm")

	sslThreadController oThread   = SexLabUtil.GetAPI().HookController(argString)
	Actor               actVictim = SexLabUtil.GetAPI().HookVictim(argString)
	Actor[]             aActors   = SexLabUtil.GetAPI().HookActors(argString)
	
	RessConfig.randomizeSex(oThread, actVictim, aActors)
EndEvent
; 2015.07.31 / Add

Event EndNVNR(string EventName, string argString, float argNum, form sender)
;	DefeatConfig.Log("NVN SexLab event -> Victim - "+Victim+" // Aggressor - "+Aggressor+" // Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())
	; 2015.07.02 / Add
;	If (RandomInt(0, 100) < 80)
;		RessConfig.MiscSpells[3].Cast(Aggressor, Victim) ; NVNAssautSPL
;	Endif
	; 2015.07.02 / Add
	Victim.SetNoBleedoutRecovery(False)
	RessConfig.SetSatisfied(Aggressor, Type = "NPC")
	AdjustIntValue(Aggressor, "RapedBy"+Victim, 1)
	If (TheAdd && (TheAdd != Player))
		RessConfig.SetSatisfied(TheAdd, Type = "NPC")
		AdjustIntValue(TheAdd, "RapedBy"+Victim, 1)
	Endif
	If IsFollower
		RessConfig.Weakenings(Victim, "Follower")
		If Player.HasKeyWordString("DefeatActive") ; Check if the player is being assaulted, in which case the follower uses player victim post assault settings.
			If SexLabUtil.GetConfig().RagdollEnd
				RegisterForAnimationEvent(Victim, "GetUpEnd")
			Else
				Wait(0.5)
				If (McmConfig.bExhaustedPvic && (RandomInt(0, 1) == 0))
					RessConfig.Exhausted(Victim, Aggressor, 60.0)
				Else
					RessConfig.Trauma(Victim, Aggressor, 60.0)
				Endif
				Dispel()
			Endif
		Else
			If SexLabUtil.GetConfig().RagdollEnd
				RegisterForAnimationEvent(Victim, "GetUpEnd")
			Else
				WeakeningsState("Follower")
				Dispel()
			Endif
		Endif
	Else
		RessConfig.Weakenings(Victim, "NPC")
		If SexLabUtil.GetConfig().RagdollEnd
			RegisterForAnimationEvent(Victim, "GetUpEnd")
		Else
			WeakeningsState("NPC")
			Dispel()
		Endif
	Endif
EndEvent
Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	UnregisterForAnimationEvent(Victim, "GetUpEnd")
	If IsFollower
		WeakeningsState("Follower")
	Else
		WeakeningsState("NPC")
	Endif
	Dispel()
EndEvent
Function WeakeningsState(String TheType)
	If !Victim.IsDead()
		String[] Events = New String[3]
		Int i
		Int n = -1
		Float OptionTrauma
		Float OptionExhausted
		If (TheType == "Follower")
			OptionTrauma = McmConfig.NVNTraumaCvic
			OptionExhausted = McmConfig.NVNExhaustedCvic
			If ((McmConfig.EscapeCvic > 0) && !Player.HasKeyWordString("DefeatActive")) ; Don't choose escape if the player is knocked down
				i = Events.Find("")
				Events[i] = "Escape"
				n += 1
			Endif
		Else
			OptionTrauma = McmConfig.NVNTrauma
			OptionExhausted = McmConfig.NVNExhausted
			If (McmConfig.EscapeNPC > 0)
				i = Events.Find("")
				Events[i] = "Escape"
				n += 1
			Endif
		Endif
		; 2015.07.18 / Mod
;		If (OptionTrauma > 0)
		If (OptionTrauma > 0 && !Victim.HasSpell(RessConfig.TraumaSPL))
		; 2015.07.18 / Mod
			i = Events.Find("")
			Events[i] = "Trauma"
			n += 1
		; 2015.07.18 / Add
		Elseif (OptionTrauma > 0 && OptionExhausted == 0)
			i = Events.Find("")
			Events[i] = "Trauma"
			n += 1
		; 2015.07.18 / Add
		Endif
		; 2015.07.18 / Mod
;		If (OptionExhausted > 0)
		If (OptionExhausted > 0 && !Victim.HasSpell(RessConfig.ExhaustedSPL))
		; 2015.07.18 / Mod
			i = Events.Find("")
			Events[i] = "Exhausted"
			n += 1
		; 2015.07.18 / Add
		Elseif (OptionExhausted > 0 && OptionTrauma == 0)
			i = Events.Find("")
			Events[i] = "Exhausted"
			n += 1
		; 2015.07.18 / Add
		Endif
		If (n != -1)
			String TheState = Events[RandomInt(0, n)]
			If (TheState == "Trauma")
				; 2015.07.18 / Mod
;				RessConfig.Trauma(Victim, Player, Type = TheType)
				RessConfig.Trauma(Victim, Aggressor, Type = TheType)
				; 2015.07.18 / Mod
			Elseif (TheState == "Exhausted")
				RessConfig.Exhausted(Victim, Aggressor, Type = TheType)
			Elseif (TheState == "Escape")
				RessConfig.Escape(Victim, Aggressor, Type = TheType)
			Endif
			
			; 2015.07.21 / Add
			; 2015.08.07 / Mod / Using startWeakenAnimation()
			RessConfig.startWeakenAnimation(Victim)
			RessConfig.forceResetAnimation(Victim)
			; 2015.07.21 / Add
		Elseif ((TheType == "Follower") && Player.HasKeyWordString("DefeatActive")) ; If no event chosen, knock down the follower anyway if the player is knocked down
			RessConfig.Trauma(Victim, Player, Type = TheType)
		Else
			RessConfig.Calm(Victim, Enter = False)
		Endif
	Else
		RessConfig.Calm(Victim, Enter = False)
	Endif
EndFunction
Bool Function InvolvePlayer(Bool AggressorFollower)
	If AggressorFollower
		If (McmConfig.NVN3wayAutoFollower > 0.0)
			If (Player.GetDistance(Victim) < McmConfig.NVN3wayAutoFollower)
				Int Button = RessConfig.MiscMessages[2].Show() ; NVN3wayAutoFollowerMess
				If (Button == 1)
					Return True
				Endif
			Endif
		Endif
	Endif
	Return False
EndFunction
Function Strip() ;===== STRIP
	Float zOffset = Aggressor.GetHeadingAngle(Victim)
	Aggressor.SetAngle(0.0, 0.0, Aggressor.GetAngleZ() + zOffset)
	If !PieceToStrip(McmConfig.SSNVNSet[1], Armor.GetMaskForSlot(McmConfig.SSNVN[0] As Int))
		Return
	Endif
	If !PieceToStrip(McmConfig.SSNVNSet[2], Armor.GetMaskForSlot(McmConfig.SSNVN[1] As Int))
		Return
	Endif
	If !PieceToStrip(McmConfig.SSNVNSet[3], Armor.GetMaskForSlot(McmConfig.SSNVN[2] As Int))
		Return
	Endif
	If !PieceToStrip(McmConfig.SSNVNSet[4], Armor.GetMaskForSlot(McmConfig.SSNVN[3] As Int))
		Return
	Endif
	If !PieceToStrip(McmConfig.SSNVNSet[5], Armor.GetMaskForSlot(McmConfig.SSNVN[4] As Int))
		Return
	Endif
	Weapon Equipped = Victim.GetEquippedWeapon()
	If !PieceToStrip(McmConfig.SSNVNSet[0], 0, Equipped)
		Return
	Endif
	Equipped = Victim.GetEquippedWeapon(True)
	If !PieceToStrip(McmConfig.SSNVNSet[0], 0, Equipped)
		Return
	Endif
	Armor Shield = Victim.GetEquippedShield()
	If !PieceToStrip(McmConfig.SSNVNSet[0], 0, Shield)
		Return
	Endif
	Wait(1.0)
EndFunction
Bool Function PieceToStrip(String Way, Int Slot, Form Weapons = None, Float WaitTime = 1.5, String Animation = "DefeatPickUp")
	If CheckActors()
		Form Equipped
		If Weapons
			Equipped = Weapons
		Else
			Equipped = Victim.GetWornForm(Slot)
		Endif
		If (Equipped && (Way != "$Disabled"))
			If !Equipped.HasKeyWordString("SexLabNoStrip")
				If (Slot == 0x00000004)
					Animation = "DefeatStripAnim"
					WaitTime = 2.5
				Endif
;				SendAnimationEvent(Aggressor, Animation)
;				Wait(WaitTime)
				If (Way == "$UNEQUIP")
					Victim.UnequipItem(Equipped, False, True)
				Elseif (Way == "$STRIP")
					Victim.UnequipItem(Equipped, False, True)
					Victim.DropObject(Equipped)
				Elseif ((Way == "$STEAL") && IsHuman)
					Victim.UnequipItem(Equipped, False, True)
					Victim.RemoveItem(Equipped, 1, True, Aggressor)
				Endif
			Endif
		Endif
	Else
		Return False
	Endif
	Return True
EndFunction
Bool Function CheckActors()
	; 2015.07.12 / Mod
;	Return (Victim.HasSpell(RessConfig.KnockDownSPL) && !Aggressor.IsDead() && !Victim.IsDead() && !Aggressor.HasMagicEffect(RessConfig.MiscMagicEffects[0]) && !Victim.HasMagicEffect(RessConfig.MiscMagicEffects[0])) ; ImmunityEFF
	Bool isValidActor = true
	Bool isWeakened   = false
	
	If Victim.HasSpell(RessConfig.KnockDownSPL)
		isWeakened = true
	Elseif Victim.HasSpell(RessConfig.TraumaSPL)
		isWeakened = true
	Elseif Victim.HasSpell(RessConfig.ExhaustedSPL)
		isWeakened = true
	Elseif Victim.HasSpell(RessConfig.SurrenderSPL)
		isWeakened = true
	Elseif Victim.HasSpell(RessConfig.YieldSPL)
		isWeakened = true
	Elseif Victim.IsInFaction(RessConfig.TieUpFaction)
		isWeakened = true
	Endif

	If !isWeakened
		isValidActor = false
	Elseif Aggressor.IsDead()
		isValidActor = false
	Elseif Victim.IsDead()
		isValidActor = false
;	Elseif Aggressor.HasMagicEffect(RessConfig.MiscMagicEffects[0])
;		; ImmunityEFF
;		isValidActor = false
;	Elseif Victim.HasMagicEffect(RessConfig.MiscMagicEffects[0])
;		; ImmunityEFF
;		isValidActor = false
	Endif
	
	Return isValidActor
	; 2015.07.12 / Mod
EndFunction
Event OnDeath(Actor akKiller)
	DefeatConfig.Log("NVN spell OnDeath event - Slot"+NVNSlot+" / Victim - "+Victim+" / Aggressor - "+Aggressor)
	Restored()
EndEvent
Function Restored()
;	If (Outcome == "Raped")
;		DefeatConfig.Log("NVN - Restored "+Victim+" rape."+" // Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())
;	Elseif (Outcome == "Kill")
;		DefeatConfig.Log("NVN - Restored "+Victim+" kill."+" // Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())
;	Elseif (Outcome == "Robbed")
;		DefeatConfig.Log("NVN - Restored "+Victim+" rob."+" // Slot - "+NVNSlot+" // GetTimeElapsed "+GetTimeElapsed())	
;	Endif
	Wait(2.0)
	Dispel()
EndFunction
Event OnEffectFinish(Actor Target, Actor Caster)
	RessConfig.VicPair[NVNSlot].Clear()
	RessConfig.AggPair[NVNSlot].Clear()
	ActorUtil.RemovePackageOverride(Aggressor, NVNAgressorPck[NVNSlot])
	If TheAdd
		RessConfig.AggPairAdd[NVNSlot].Clear()
		ActorUtil.RemovePackageOverride(TheAdd, NVNAgressorPck[NVNSlot])
	Endif
	DefeatConfig.Log("NVN OnEffectFinish - Victim - "+Victim+" // Aggressor - "+Aggressor+" // Slot - "+NVNSlot)
	Target.RemoveSpell(TheSpell)
EndEvent
Float Function Dist()
	; 2015.07.11 / Mod / Using McmConfig.mnRapeDistXXX
	If IsHuman
		Return McmConfig.mnRapeDistHuman
	Else
		If Aggressor.IsAllowedToFly()
			Return McmConfig.mnRapeDistFlyer
		Else
			Return McmConfig.mnRapeDistCreature
		Endif
	Endif
	; 2015.07.11 / Mod / Using McmConfig.mnRapeDistXXX
EndFunction

; ------------------------------------------------------------------------------
; End of Script
; ------------------------------------------------------------------------------
