Scriptname DefeatPAscr Extends Quest

DefeatMCMscr Property McmConfig Auto
DefeatConfig Property Defeat Auto
DefeatPostRscr Property PostRScr Auto Hidden
DefeatPlayer Property PlayerScr Auto

Import Game
Import Utility
Import Debug

Quest[] Property PostAssaultQsts Auto Hidden
Actor Property Player Auto
ImageSpaceModifier Property ISFadeOut Auto
Bool Property Blackout Auto Hidden
FormList Property ForbiddenLocList Auto

Function Install()
	PostAssaultQsts = New Quest[10]
	PostAssaultQsts[0] = (GetFormFromFile(0xC1173, "SexLabDefeat.esp") As Quest) 	; LeftForDeadQST
	PostAssaultQsts[1] = (GetFormFromFile(0xC16D8, "SexLabDefeat.esp") As Quest)	; DefeatedQST
	PostAssaultQsts[2] = (GetFormFromFile(0x10EFF0, "SexLabDefeat.esp") As Quest) 	; SequesteredQST
	PostAssaultQsts[3] = (GetFormFromFile(0xF8B09, "SexLabDefeat.esp") As Quest) 	; FollowerKidnappingQST
EndFunction
Function Configure()
EndFunction

Function Escape()
	If (McmConfig.bEscape == "$Trauma")
		PlayerScr.MiscScenes[1].ForceStart() ; SCEscape
	Else
		Wait(3.0)
		Defeat.DefeatPlayAnimation(Player, "Stand")
		PlayerScr.Restored()
	Endif
EndFunction

Event DARecoverSequence(string eventName, string strArg, float numArg, Form sender)
;	DefeatConfig.Log("DARecoverSequence - Player.HasKeywordString(DefeatActive) - "+Player.HasKeywordString("DefeatActive"))
	If Player.HasKeywordString("DefeatActive")
		PlayerScr.Restored()
	Endif
	UnregisterForModEvent("da_StartRecoverSequence")
EndEvent

Function PickEvent()
	Blackout = True
	If (PlayerScr.ForcedScene == "")
		If (Defeat.LastSceneTheLast && Defeat.LastSceneTheLast.IsDead()) ; Check if the last aggressor is dead in case of double ko or something and then triggers a simple escape
			Escape()
			Return
		Endif
		
		If Defeat.DAon
			If (RandomInt(1, 100) < McmConfig.DAsChance)
				RegisterForModEvent("da_StartRecoverSequence", "DARecoverSequence")
				Int DA = ModEvent.Create("da_ForceBlackout")
				ModEvent.PushString(DA, "ForceBlackout")
				ModEvent.PushString(DA, "None")
				ModEvent.PushFloat(DA, 1.0)
				ModEvent.PushForm(DA, Defeat.LastSceneTheLast)
				If ModEvent.Send(DA)
					RegisterForSingleUpdate(10.0)
					Return
				Endif
			Endif
		Endif

		Quest[] Events = New Quest[10]
		Int n = -1
		Int i

		; vv Check conditions vv
		DefeatConfig.Log("Outcome // Defeat.TheEvilFaction - "+Defeat.TheEvilFaction+" / Raped - "+Defeat.LastSceneRaped+" / Robbed - "+Defeat.LastSceneRobbed)
		; ^^ Check conditions ^^

		String EvilFaction = Defeat.TheEvilFaction
		If ((EvilFaction != "") && (EvilFaction != "Evil"))
			; Register faction events
			If (Defeat.TheEvilFaction == "Guard")
				If McmConfig.PAbEnabled[0] ; Jailed
					Faction CrimeFaction = Defeat.LastSceneTheLast.GetCrimeFaction()
					If CrimeFaction
						If ((CrimeFaction.GetCrimeGold() > 0) || (CrimeFaction.GetCrimeGoldViolent() > 0))
							CrimeFaction.SendPlayerToJail()
							PlayerScr.Restored()
							Defeat.DefeatPlayAnimation(Player, "Stand")
							Return
						Endif
					Endif
				Endif
			Elseif (EvilFaction == "Bandit")
;				If (RandomInt(0, 100) < McmConfig.PAfrequency[2]) ; SequesteredQST
;					If !PostAssaultQsts[2].IsRunning()
;						n += 1
;						i = Events.Find(None)
;						Events[i] = PostAssaultQsts[2]
;					Endif
;				Endif
;				If Defeat.LastSceneFollowers[0] ; Check if there is at least one follower with the player and look for registering follower related events.
;					If (RandomInt(0, 100) < McmConfig.PAfrequency[3]) ; FollowerKidnappingQST
;						If !PostAssaultQsts[3].IsRunning() && !McmConfig.PAbSecondary[0] ; Only as secondary event?
;							n += 1
;							i = Events.Find(None)
;							Events[i] = PostAssaultQsts[3]
;						Endif
;					Endif
;				Endif
			Elseif (EvilFaction == "Forsworn")

			Elseif (EvilFaction == "Silver Hand")

			Elseif (EvilFaction == "Thalmor")

			Elseif (EvilFaction == "Vampire")

			Elseif (EvilFaction == "Warlock")

			Elseif (EvilFaction == "Necromancer")

			Elseif (EvilFaction == "Bloodkin")

			Endif
		Endif
	;	If !ForbiddenLoc(Me.GetCurrentLocation())
		; Register misc events
		If (Chance(0) && OnlyEnemy(0, EvilFaction != "") && OnlyRaped(0, Defeat.LastSceneRaped)) ; LeftForDeadQST
			n += 1
			i = Events.Find(None)
			Events[i] = PostAssaultQsts[0]
		Endif
		If (Chance(1) && OnlyEnemy(1, EvilFaction != "") && OnlyRaped(1, Defeat.LastSceneRaped)) ; DefeatedQST
			n += 1
			i = Events.Find(None)
			Events[i] = PostAssaultQsts[1]
		Endif
		DefeatConfig.Log("Events array // 1 - "+Events[0]+" / 2 - "+Events[1]+" / 3 - "+Events[2]+" / 4 - "+Events[3]+" / 5 - "+Events[4]+" / 6 - "+Events[5]+" / 7 - "+Events[6]+" / 8 - "+Events[7]+" / 9 - "+Events[8]+" / 10 - "+Events[9])
		If (n != -1) ; Nothing in the array to choose from
			TriggerEvent(Events, n)
		Else
			Escape()
		Endif
	Elseif ((PlayerScr.ForcedScene == "Left For Dead")) ; Tamriel
		TriggerEvent(TheEvent = PostAssaultQsts[0])
	Elseif (PlayerScr.ForcedScene == "Defeated")
		TriggerEvent(TheEvent = PostAssaultQsts[1])
	Elseif (PlayerScr.ForcedScene == "End")
		Escape()
	Else
		SendModEvent(PlayerScr.ForcedScene)
	Endif
EndFunction
Function PickSecondEvent() ; Triggers a second event for events that allows it.
	Blackout = False
	Quest[] Events = New Quest[10]
	Int n = -1
	Int i
	String EvilFaction = Defeat.TheEvilFaction
	If ((EvilFaction != "") && (EvilFaction != "Evil"))
		If (Defeat.TheEvilFaction == "Bandit")							; =============== Bandit
;			If Defeat.LastSceneFollowers[0] ; Check if there is at least one follower with the player and look for registering follower related events.
;				If (RandomInt(0, 100) < McmConfig.PAfrequency[2])
;					If !PostAssaultQsts[3].IsRunning()
;						n += 1
;						i = Events.Find(None)
;						Events[i] = PostAssaultQsts[3]
;					Endif
;				Endif
;			Endif
		Elseif (EvilFaction == "Forsworn")

		Elseif (EvilFaction == "Silver Hand")

		Elseif (EvilFaction == "Thalmor")

		Elseif (EvilFaction == "Vampire")

		Elseif (EvilFaction == "Warlock")

		Elseif (EvilFaction == "Necromancer")

		Elseif (EvilFaction == "Bloodkin")

		Endif
	Endif
	DefeatConfig.Log("Second Events array // 1 - "+Events[0]+" / 2 - "+Events[1]+" / 3 - "+Events[2]+" / 4 - "+Events[3]+" / 5 - "+Events[4]+" / 6 - "+Events[5]+" / 7 - "+Events[6]+" / 8 - "+Events[7]+" / 9 - "+Events[8]+" / 10 - "+Events[9])
	If (n != -1) ; Nothing in the array to choose from
		TriggerEvent(Events, n, None, False, False)
	Endif
EndFunction
Bool Function OnlyEvil(Bool TheOption)
	Return (TheOption && (Defeat.TheEvilFaction == ""))
EndFunction

; 2015.09.03 / Mod / Changing default value of Restored, True -> False
Function TriggerEvent(Quest[] Events = None, Int n = 0, Quest TheEvent = None, Bool Blackout = True, Bool Restored = False)
	Bool DoEvent = False
	If (n > 0)
		Int Rand = RandomInt(0, n)
		If Events[Rand].Start()
			TheEvent = Events[Rand]
			DefeatConfig.Log("Post assault / Multiple events, by rand TheEvent - "+TheEvent.GetName())
			DoEvent = True
		Else
			While (0 < n)
				If Events[n].Start()
					DefeatConfig.Log("Post assault / Multiple events, "+Events[Rand].GetName()+" Failed to start, other event found and triggered in the array - "+Events[n].GetName())
					TheEvent = Events[n]
					DoEvent = True
					n = 0
				Endif
				n -= 1
			EndWhile
		Endif
	Else
		If Events[0].Start()
			TheEvent = Events[0]
			DefeatConfig.Log("Post assault / Only one event, TheEvent - "+TheEvent.GetName())
			DoEvent = True
		Endif
	Endif
	If DoEvent
		If Blackout
			BlackOut()
		Endif
		If !Defeat.LastSceneRobbed
			Defeat.GetStrippedItems(Player)
		Endif
	  	PostRScr = (TheEvent As DefeatPostRscr)
		PostRScr.BeginQuest()
		If Restored
			PlayerScr.Restored()
		Endif
	Elseif Blackout ; Make sure to not trigger escape for secondary events.
		DefeatConfig.Log("Post assault / No post assault events, trigger escape event")
		Escape()
	Endif
EndFunction

Bool Function ForbiddenLoc(Location TheLoc)
	If TheLoc
		Int n = TheLoc.GetNumKeywords()
		Int i
		While (i < n)
			If ForbiddenLocList.HasForm(TheLoc.GetNthKeyword(i))
				Return True
			Endif
			i += 1
		Endwhile
	Endif
	Return False
EndFunction

Bool Function Chance(Int Slot)
	Return (RandomInt(0, 100) < McmConfig.PAfrequency[Slot])
EndFunction
Bool Function OnlySecondary(Int Slot)
	Return McmConfig.PAbSecondary[Slot]
EndFunction
Bool Function OnlyEnemy(Int Slot, Bool IsEnemy)
	If !McmConfig.PAbOnlyEnemy[Slot]
		Return True
	Else
		Return IsEnemy
	Endif
EndFunction
Bool Function OnlyRaped(Int Slot, Bool BeenRaped)
	If !McmConfig.PAbOnlyRaped[Slot]
		Return True
	Else
		Return BeenRaped
	Endif
EndFunction
Function BlackOut()
	SendModEvent("DefeatPostAssault", "BlackOutBegin")
	; 2015.09.03 / Del
;	Player.PushActorAway(Player, 0.1)
	; 2015.09.03 / Del
	; 2015.09.03 / Add
	Debug.SendAnimationEvent(Player, "IdleWounded_02")
	; 2015.09.03 / Add
;	ISFadeOut.Apply()
	Wait(1)
	FadeOutGame(True, True, 0, 3) ; Fade out
	Wait(1)
	FadeOutGame(False, True, 6, 3) ; Fade in
EndFunction
Event OnUpdate()
	If Player.HasKeywordString("DefeatActive")
		PlayerScr.Restored()
	Endif
EndEvent