Scriptname DefeatPlayer extends ReferenceAlias

DefeatMCMscr Property McmConfig Auto
DefeatConfig Property RessConfig Auto
DefeatPAscr Property PostAssaultscr Auto
DefeatQTEMeter Property StruggleBar Auto
SexLabFramework SexLab
sslSystemConfig SexLabConfig
Import StorageUtil
Import Utility
Import Game
Import Debug

; 2015.08.06 / Add / DEBUG
;ExAnimationRegister Property ExtAnimSlot Auto
; 2015.08.06 / Add / DEBUG

String Scenario
Bool Raped = False
Bool Robbed = False
Bool IsCreature
Bool ManualStart
Bool IsSurrender
Bool NoTrans = False
Bool SpamGuard = False
Bool SSpamGuard = False
Faction OwnerFaction
Faction CrimeFaction
Int CrimeGold
Int CrimeGoldViolent

Float FarMaxDist = 1200.0
Float Time

Bool IsBar ; Is the resist enabled?
Float DownedTime ; How much time the player will stay downed.
Bool HasFollower ; More difficult to get up is at least one follower is present.

Actor Player
ActorBase PlayerBase
ReferenceAlias Property PlayerFaction Auto
Bool PlayerIsFemale
Bool Tied = False
Bool Stripped = False
Float RobValue
Int TheRobWay

Int StrafeL
Int StrafeR
Bool QTEKeypressed = False
Bool LeftRight = True
Float FillDifficulty = 0.0
Float FillThreshold = 0.0
Int ResistTime = 0

Quest Property Detect Auto
ReferenceAlias[] Property DAggs Auto
ReferenceAlias[] Property DParts Auto
ReferenceAlias[] Property TheAggressors Auto
ReferenceAlias[] Property TheFollowers Auto
Actor[] Aggressors
Actor[] Accomplices
Actor[] Followers
Actor Persuer
Actor TheNext
ReferenceAlias Property AliasTheNext Auto
Actor TheLast
ReferenceAlias Property AliasLastAgg Auto
ReferenceAlias Property AliasLastVic Auto
ReferenceAlias Property CollaAgg Auto
ReferenceAlias Property CollaVic Auto
ReferenceAlias Property SceneCenter Auto
Actor AddOne
Actor AddTwo
Actor AddThree
Bool PotentialAggressor

Int Property NumRapes = 0 Auto Hidden
Int Property NumAgg = 0 Auto Hidden
Actor[] Involved

ObjectReference[] Property MiscReferences Auto Hidden
MiscObject[] Property MiscObjects Auto Hidden
FormList[] Property MiscFormLists Auto Hidden
Scene[] Property MiscScenes Auto Hidden
Message[] Property MiscMessages Auto Hidden

; 2015.07.08 / Add
string gszCurStrugglePose = ""
; 2015.07.08 / Add

; 2015.07.20 / Add
Float gnSpamGuard
Float gnSSpamGuard
; 2015.07.20 / Add

; 2015.08.08 / Add
Actor[] gaCaptiveAgg
Actor[] gaCaptiveVic
; 2015.08.08 / Add

; 2015.09.06 / Add
Bool Property mEnableCellLoadEvents = True Auto
; 2015.09.06 / Add

Event OnDeath(Actor akKiller)
	DefeatConfig.Log("Player as victim OnDeath")
	Clean()
Endevent

; 2015.07.09 / Add
Event OnCellLoad()
	; 2015.08.02 / Add
	Bool isPcCaptiveOK = False
	Bool isRapeClubOK  = False
	
	; 2015.09.06 / Add
	If !mEnableCellLoadEvents
		Return
	Endif
	; 2015.09.06 / Add
	
	; 2015.08.19 / Add
	Detect.Stop()
	; 2015.08.19 / Add
	
	isRapeClubOK = RessConfig.startRapeClub()
	; 2015.08.02 / Add
	
	; 2015.08.02 / Mod
	; 2015.07.25 / Add
	If !isRapeClubOK
		isPcCaptiveOK = startPlayerCaptive("OnCellLoad")
	Endif
	; 2015.07.25 / Add
	; 2015.08.02 / Mod
	
	; 2015.07.25 / Mod
	; 2015.08.02 / Mod
	If !isPcCaptiveOK && !isRapeClubOK
		RessConfig.startCaptive()
	Endif
	; 2015.07.25 / Mod
Endevent
; 2015.07.09 / Add

; 2015.09.12 / Add
Function sayTopic(Actor actFrom, Actor actTo, Int nTopicIdx)
	
	If (actFrom == Player) && McmConfig.mDisablePlayerPoseVoice
		Return
	Endif
	
	If actFrom && RessConfig.maSoundToSay[nTopicIdx]
		RessConfig.maSoundToSay[nTopicIdx].Play(actFrom)
	Elseif actFrom && actTo && RessConfig.TopicToSay[nTopicIdx]
		actFrom.Say(RessConfig.TopicToSay[nTopicIdx], actTo)
	Endif
	
EndFunction
; 2015.09.12 / Add

; 2015.07.25 / Add
Bool Function startPlayerCaptive(String szEvent)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor    actAggressor
	Actor    actFind
	Cell     celCur
	Location locCur
	String[] aPoses
	Float    nMaxSearch   = McmConfig.mnCaptivePcRange
	Int      nSearchCnt   = McmConfig.mnCaptiveAggSearchNum
	Int      nCaptRatio   = McmConfig.mnCaptivePcRatio
	Bool     isFound      = False
	; 2015.08.08 / Add
	Actor    actAgg
	Actor    actVic
	Int      nVicCnt
	; 2015.08.08 / Add
	
	;-------------------------------------------------------
	; Addon check
	;-------------------------------------------------------
	If (RandomInt(1, 100) > nCaptRatio)
		Return False
	; 2015.07.28 / Del
;	Elseif (PlayerBase.GetSex() != 1)
;		Return False
	; 2015.07.28 / Del
	Endif
	
	;-------------------------------------------------------
	; Check location TPO
	;-------------------------------------------------------
	celCur = Player.GetParentCell()
	locCur = Player.GetCurrentLocation()
	
	If !celCur.IsInterior() && (szEvent != "OnSleepStart") && (szEvent != "OnSleepStop")
		Return False
	Elseif celCur.GetFactionOwner() || celCur.GetActorOwner()
		Return False
	; LocTypeHouse [KYWD:0001CB85]
	; LocTypeInn [KYWD:0001CB87]
	Elseif locCur.HasKeyWordString("LocTypeHouse") || locCur.HasKeyWordString("LocTypeInn")
		Return False
	; 2015.07.30 / Add
	Elseif (RessConfig.maNoCaptiveLocations.Find(locCur) >= 0)
;		Notification("Forbidden Place")
		Return False
	; 2015.07.30 / Add
	Endif
	
	;-------------------------------------------------------
	; Search Aggressor Loop
	;-------------------------------------------------------
	While (!isFound && nSearchCnt > 0)
		nSearchCnt -= 1
		
		actFind = FindRandomActorFromRef(Player, nMaxSearch)
		
		If RessConfig.isValidCaptiveAggressor(actFind)
			actAggressor = actFind
			isFound      = True
		Else
			actAggressor = None
		EndIf
	EndWhile
	
	;-------------------------------------------------------
	; Force create Aggressor
	;-------------------------------------------------------
	If !isFound && McmConfig.mEnableCaptiveForceCreateActor
		actAggressor = RessConfig.createCaptiveAggressor()
	EndIf
	
	;-------------------------------------------------------
	; Start "Defeat"
	;-------------------------------------------------------
;	If actAggressor && DefeatTriggerActive(actAggressor)
	If actAggressor
		; 2015.09.12 / Mod / Using sayTopic()
;		Player.Say(RessConfig.TopicToSay[2], Player)
		sayTopic(Player, Player, 2)
		; 2015.09.12 / Mod / Using sayTopic()
		Wait(0.8)
		MessageBox("Someone holds you captive!!")
		
		DisablePlayerControls(1, 1, 1, 0, 1, 1, 0, 0)
		SetPlayerAiDriven()
		
		; 2015.08.08 / Add
		; 2015.09.12 / Add
		If !McmConfig.mDisablePlayerPoseVoice
			SendAnimationEvent(Player, "BleedoutStart")
		Endif
		; 2015.09.12 / Add
		; 2015.08.08 / Add
		
		FadeOutGame(True, True, 0, 17)
		FadeOutGame(False, True, 17, 17)
		
		Player.MoveTo(actAggressor)
		
		Strip(Player, actAggressor)
		
		; 2015.07.26 / Add
		Bool enableWeb    = McmConfig.mEnableTieupWeb
		Bool enableExDev  = McmConfig.mEnableTieupExt
		Bool enableExHood = McmConfig.mEnableTieupHood
		; 2015.07.30 / Add
		Bool enableFuro   = McmConfig.mEnableTieupFuro
		; 2015.07.30 / Add
		
		If RessConfig.isSpider(actAggressor) && enableWeb
			RessConfig.addTieupDevices(Player, "web")
			RessConfig.setTieupPose(Player, "web")
		; 2015.07.30 / Add
		Elseif RessConfig.isTentacleUser(actAggressor) && enableFuro
			RessConfig.setTieupPose(Player, "furo")
		; 2015.07.30 / Add
		Else
			RessConfig.addTieupDevices(Player, "default")
			
			If enableExDev
				If enableExHood
					RessConfig.addTieupDevices(Player, "extend30")
				Endif
				
				RessConfig.addTieupDevices(Player, "extend44")
				RessConfig.addTieupDevices(Player, "extend45")
				RessConfig.addTieupDevices(Player, "extend49")
				RessConfig.addTieupDevices(Player, "extend53")
				RessConfig.addTieupDevices(Player, "extend55")
				RessConfig.addTieupDevices(Player, "extend59")
				RessConfig.addTieupDevices(Player, "extend61")
			Endif
			
			RessConfig.setTieupPose(Player, "default")
		Endif
		; 2015.07.26 / Add
		
		; 2015.08.06 / Add
		; 2015.08.07 / Mod / Adding the if condition, McmConfig.mEnableCaptiveWithFollowers
		; 2015.08.18 / Mod
		If McmConfig.mEnableCaptiveWithFollowers
			startFollowerCaptive(actAggressor)
		Endif
		; 2015.08.06 / Add
		
		If actAggressor.IsDead()
			Restored()
			Return False
		; 2015.08.06 / Del
;		Elseif useRapeSpell(actAggressor, Player)
;			setRapedEffects(Player, Enter = True)
;			RessConfig.waitSexEnd(Player)
;			Restored()
;			Return True
		; 2015.08.06 / Del
		; 2015.09.02 / Add
		Elseif McmConfig.mEnableCaptiveWithFollowers
			; 2015.09.02 / Mod / Adding 4 aggressors
			RessConfig.StartScene(				\
				actAggressor, 					\
				gaCaptiveAgg[0], 				\
				gaCaptiveAgg[1], 				\
				gaCaptiveAgg[2], 				\
				gaCaptiveAgg[3], 				\
				Scenario       = "$Original"	)
		; 2015.09.02 / Add
		Else
			; 2015.08.05 / Mod / Using StartScene()
;			Detect.Start()
;			TheKnockDown(actAggressor, CustomScenario = "$No Transition")
;			Detect.Stop()
			RessConfig.StartScene(				\
				actAggressor, 					\
				Scenario       = "$Original"	)
		Endif
		
		; 2015.09.02 / Add
		If McmConfig.mEnableCaptiveWithFollowers
			nVicCnt = gaCaptiveVic.Length
			
			While (nVicCnt > 0)
				nVicCnt -= 1
				
				actAgg  = gaCaptiveAgg[nVicCnt]
				actVic  = gaCaptiveVic[nVicCnt]
				
				actFind = FindRandomActorFromRef(actAgg, 888.0)
				
				If actAgg && actVic
					actAgg.MoveTo(actFind)
					actVic.MoveTo(actFind)
					RessConfig.Tieup(actVic, actAgg)
					RessConfig.Strip(actVic)
				EndIf
			EndWhile
		Endif
		; 2015.09.02 / Add
		
		; 2015.08.08 / Add
		Wait(26.0)
		
		If McmConfig.mEnableCaptiveWithFollowers
			nVicCnt = gaCaptiveVic.Length
			
			While (nVicCnt > 0)
				nVicCnt -= 1
				
				actAgg  = gaCaptiveAgg[nVicCnt]
				actVic  = gaCaptiveVic[nVicCnt]
				
				If actAgg && actVic
					CollateralRape(actVic, actAgg)
				EndIf
			EndWhile
		Endif
		; 2015.08.08 / Add
		
		; 2015.08.05 / Del / No need for Original Scenario
		; 2015.07.30 / Add
;		Restored()
		; 2015.07.30 / Add
		; 2015.08.05 / Del / No need for Original Scenario
	Else
		Return False
	EndIf
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return True
EndFunction
; 2015.07.25 / Add

; 2015.08.04 / Add
Bool Function startFollowerCaptive(Actor actMain)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor    actFind
	Actor    actAgg
	Actor    actVic
	Actor[]  aAggressors       = new Actor[5]
	Actor[]  aVictims          = new Actor[5]
	Int      nAggIdx           = 0
	Int      nVicIdx           = 0
	Int      nVicCnt
	Int      nSearchCnt
	Float    nMaxSearch        = McmConfig.mnCaptivePcRange
	; 2015.08.08 / Mod
	Bool     isCollateralStart = False
	; 2015.08.08 / Mod
	; 2015.08.18 / Add
	Cell     celCur            = Player.GetParentCell()
	; 2015.08.18 / Add
	; 2015.09.03 / Add
	Float[]  aOffsetX          = new Float[6]
	Float[]  aOffsetY          = new Float[6]
	Float    nOffsetX
	Float    nOffsetY
	; 2015.09.03 / Add
	
	; 2015.09.03 / Add
	;-------------------------------------------------------
	; Init "moveto" offset
	;-------------------------------------------------------
	aOffsetX[0] = 0
	aOffsetY[0] = 8.0
	aOffsetX[1] = 8.0
	aOffsetY[1] = 0
	aOffsetX[2] = 8.0
	aOffsetY[2] = 8.0
	aOffsetX[3] = 0
	aOffsetY[3] = -8.0
	aOffsetX[4] = -8.0
	aOffsetY[4] = 0
	aOffsetX[5] = -8.0
	aOffsetY[5] = -8.0
	; 2015.09.03 / Add
	
	;-------------------------------------------------------
	; Search followers
	;-------------------------------------------------------
	; 2015.08.18 / Mod / Using GetNthRef() to search
;	nSearchCnt = aVictims.Length * 2
	nSearchCnt = celCur.GetNumRefs(62)
	
	While (nVicIdx < aVictims.Length) && (nSearchCnt > 0)
		nSearchCnt -= 1
		
		; 2015.08.18 / Mod / Using GetNthRef() to search
;		actFind = FindRandomActorFromRef(Player, 888.0)
		actFind = celCur.GetNthRef(nSearchCnt, 62) as Actor
		
		If actFind && RessConfig.IsFollower(actFind)
			; 2015.08.18 / Del
;			Wait(0.26)
			; 2015.08.18 / Del
			; 2015.09.03 / Mod / Adding x and y offset
			nOffsetX = aOffsetX[nVicIdx]
			nOffsetY = aOffsetY[nVicIdx]
			actFind.MoveTo(actMain, nOffsetX, nOffsetY)
			aVictims[nVicIdx]  = actFind
			; 2015.09.02 / Add
			Followers[nVicIdx] = actFind
			TheFollowers[nVicIdx].ForceRefTo(actFind)
			; 2015.09.02 / Add
			nVicIdx += 1
		EndIf
	EndWhile
	
	;-------------------------------------------------------
	; Search aggressors
	;-------------------------------------------------------
	nSearchCnt = aVictims.Length
	
	While (nSearchCnt > 0)
		nSearchCnt -= 1
		
		actFind = FindRandomActorFromRef(actMain, nMaxSearch)
		
		If RessConfig.isValidCaptiveAggressor(actFind)
			aAggressors[nAggIdx] = actFind
			; 2015.09.03 / Mod / Adding x and y offset
			nOffsetX = aOffsetX[nAggIdx]
			nOffsetY = aOffsetY[nAggIdx]
			ActFind.MoveTo(actMain, nOffsetX, nOffsetY)
			nAggIdx += 1
		Elseif McmConfig.mEnableCaptiveForceCreateActor
			aAggressors[nAggIdx] = RessConfig.createCaptiveAggressor()
			; 2015.09.03 / Mod / Adding x and y offset
			nOffsetX = aOffsetX[nAggIdx]
			nOffsetY = aOffsetY[nAggIdx]
			ActFind.MoveTo(actMain, nOffsetX, nOffsetY)
			nAggIdx += 1
		EndIf
	EndWhile
	
;	;-------------------------------------------------------
;	; Setup Followers
;	;-------------------------------------------------------
;	nVicCnt = nVicIdx
;	
;	While (nVicCnt > 0)
;		nVicCnt -= 1
;		
;		actAgg  = aAggressors[nVicCnt]
;		actVic  = aVictims[nVicCnt]
;		
;		actFind = FindRandomActorFromRef(actAgg, 888.0)
;		
;		If actAgg && actVic
;			actAgg.MoveTo(actFind)
;			actVic.MoveTo(actFind)
;			; 2015.08.08 / Add
;;			RessConfig.MiscSpells[3].Cast(actAgg, actVic)
;;			actVic.Say(RessConfig.TopicToSay[3], actVic)
;			RessConfig.Tieup(actVic, actAgg)
;			; 2015.09.02 / Mod / Using RessConfig.Strip()
;			RessConfig.Strip(actVic)
;			
;;			If !isCollateralStart
;;				CollateralRape(actVic, actAgg)
;;				isCollateralStart = True
;;			Endif
;			; 2015.08.08 / Add
;		EndIf
;	EndWhile
	
	;-------------------------------------------------------
	; Check victims
	;-------------------------------------------------------
	If (nVicIdx < 1)
		Return False
;	Else
;		RessConfig.doCaptiveDefeat(	\
;			aAggressors,			\
;			aVictims,				\
;			nAggIdx,				\
;			nVicIdx,				\
;			nAggWait = 8.0			)
	EndIf
	
	;-------------------------------------------------------
	; Set arrays of aggressors and victims
	;-------------------------------------------------------
	gaCaptiveAgg = aAggressors
	gaCaptiveVic = aVictims
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return True
EndFunction
; 2015.08.04 / Add

;Event OnEnterBleedOut(Actor akKiller)
;	DefeatConfig.Log("Player as victim OnEnterBleedOut")
;Endevent
Function Clean()
	UnregisterForUpdate()
	Restored()
EndFunction
Function Install()
	SexLab = SexLabUtil.GetAPI()
	SexLabConfig = SexLabUtil.GetConfig()
	Player = (GetReference() As Actor)
	PlayerBase = Player.GetActorBase()
	Aggressors = New Actor[5]
	Accomplices = New Actor[5]
	Followers = New Actor[5]
	MiscObjects = New MiscObject[1]
	MiscObjects[0] = (GetForm(0x0F) As MiscObject) ; Gold
	MiscFormLists = New FormList[4]
	MiscFormLists[0] = (GetFormFromFile(0xDC642, "SexLabDefeat.esp") As FormList) ; MiscStuff
	MiscFormLists[1] = (GetFormFromFile(0xCBDE3, "SexLabDefeat.esp") As FormList) ; StrippedStuff
	MiscFormLists[2] = (GetFormFromFile(0x119C91, "SexLabDefeat.esp") As FormList) ; DefeatMarkerListExt
	MiscFormLists[3] = (GetFormFromFile(0x11A1F4, "SexLabDefeat.esp") As FormList) ; DefeatMarkerListInt
	MiscReferences = New ObjectReference[5]
	MiscMessages = New Message[3]
	MiscMessages[0] = None	; DefeatPAWaitFollowersMess
	MiscMessages[1] = (GetFormFromFile(0xCBDE2, "SexLabDefeat.esp") As Message)	; DefeatQTEAtkMess
	MiscMessages[2] = (GetFormFromFile(0xCB31D, "SexLabDefeat.esp") As Message)	; DefeatQTEStrafeMess
	MiscScenes = New Scene[4]
	MiscScenes[0] = (GetFormFromFile(0xB23F7, "SexLabDefeat.esp") As Scene) ; SCDowned
	MiscScenes[1] = (GetFormFromFile(0xABD69, "SexLabDefeat.esp") As Scene) ; SCEscape
	MiscScenes[2] = (GetFormFromFile(0xBD0C9, "SexLabDefeat.esp") As Scene) ; SCRobbing
	MiscScenes[3] = (GetFormFromFile(0xB54B2, "SexLabDefeat.esp") As Scene) ; SCCollateral
	; 2015.07.20 / Add
	gnSpamGuard  = Utility.GetCurrentRealTime()
	gnSSpamGuard = Utility.GetCurrentRealTime()
	; 2015.07.20 / Add
	; 2015.08.05 / Add
	Detect.Stop()
	; 2015.08.05 / Add
EndFunction
Function Uninstall()
	UnregisterForAllKeys()
	GoToState("Inactive")
EndFunction
Function Configure()
	Hkrefresh()
	; 2015.07.26 / Add
	RegisterForSleep()
	; 2015.07.26 / Add
	GoToState("Running")
EndFunction
Function Hkrefresh()
	UnregisterForAllKeys()
	RegisterForKey(RessConfig.HotKeyInts[3]) ; Surrender key
	; 2015.07.17 / Add / Regist,Unregist Captive List
	RegisterForKey(RessConfig.HotKeyInts[4])
	; 2015.07.17 / Add / Regist,Unregist Captive List
	; 2015.09.06 / Del
	; 2015.08.24 / Add
;	RegisterForKey(RessConfig.HotKeyInts[5])
	; 2015.08.24 / Add
	; 2015.09.06 / Del
EndFunction
State Inactive
	; DEBUG
;	Event OnBeginState()
;		Notification("State Inactive starts.")
;	EndEvent
	; DEBUG
	; 2015.07.20 / Add
	Event OnKeyDown(Int KeyCode)
		If (KeyCode == RessConfig.HotKeyInts[4])
			RessConfig.onClickHotKeyCaptiveList()
		; 2015.09.06 / Del
		; 2015.08.24 / Add
;		Elseif (KeyCode == RessConfig.HotKeyInts[5])
;			RessConfig.onClickHotKeyCleanupSelected()
		; 2015.08.24 / Add
		; 2015.09.06 / Del
		Endif
	EndEvent
	; 2015.07.20 / Add
EndState

String Property ForcedScene = "" Auto Hidden
Bool CustomAllowStaydown
Bool CustomAllowResist
Bool CustomAllowRob
Bool CustomAllowRelation
Bool CustomAllowWitness
Bool CustomAllowCommentary
Function CustomScene(String Option, Bool OnOff = True, String IsForcedScene = "")
	ManualStart = True
	If Option == "ForcedScene"
		ForcedScene = IsForcedScene
	Elseif Option == "AllowStaydown"
		CustomAllowStaydown = OnOff
	Elseif Option == "AllowResist"
		CustomAllowResist = OnOff
	Elseif Option == "AllowRob"
		CustomAllowRob = OnOff
	Elseif Option == "AllowRelation"
		CustomAllowRelation = OnOff
	Elseif Option == "AllowWitness"
		CustomAllowWitness = OnOff
	Elseif Option == "AllowCommentary"
		CustomAllowCommentary = OnOff
	Endif
EndFunction

State Running
	; DEBUG
	Event OnBeginState()
RessConfig.saveDebugStr("State Running starts.")
	EndEvent
	; DEBUG
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If Aggressor
			; 2015.08.01 / Add
			Float nCurTime = Utility.GetCurrentRealTime()
			
			If ((nCurTime - gnSpamGuard) > 2.0) && !Player.HasKeyWordString("DefeatActive")
				SpamGuard   = False
				gnSpamGuard = nCurTime
			Else
				SpamGuard = True
			Endif
			; 2015.08.01 / Add
			
			If !SpamGuard
				SpamGuard = True
				If (IsAggressorValid(Aggressor) && IsPlayerValid())
					If CheckAggressor(Aggressor)
						; 2015.08.01 / Add
						Int  nRapeAttackChance = McmConfig.mnRapePowerAttackChance
						Bool isRapeAttack      = False
						Bool isTriggerAttack   = (abPowerAttack || abBashAttack)
						Bool isFemaleAgg       = (SexLab.GetGender(Aggressor) == 1)
						; 2015.08.08 / Add
						Bool   enableExplosion   = McmConfig.mEnableRapeAttackExplosion
						; 2015.08.08 / Add
						
						If isTriggerAttack && !isFemaleAgg && (Utility.RandomInt(1, 100) <= nRapeAttackChance)
							isRapeAttack = True
							
							RessConfig.mefsRapeAttack.Play(Aggressor, 8.0)
;							RessConfig.mvefRapeAttack.Play(Aggressor)
							; 2015.08.08 / Add
							If enableExplosion
								Aggressor.placeAtMe(RessConfig.mexpRapeAttack)
							Endif
							; 2015.08.08 / Add
						Endif
						; 2015.08.01 / Add
						
						; 2015.08.01 / Mod / Adding the condition, isRapeAttack
						If KDWay(Aggressor, abPowerAttack, akSrc) || isRapeAttack
							; 2015.08.06 / Add
							If useRapeSpell(Aggressor, Player)
								setRapedEffects(Player, Enter = True)
							Else
							; 2015.08.06 / Add
								Detect.Start()
								TheKnockDown(Aggressor)
								Detect.Stop()
							; 2015.08.06 / Add
							Endif
							; 2015.08.06 / Add
							Return
						Endif
					Endif
				Endif
				Wait(2.0)
				SpamGuard = False
			; 2015.07.20 / Add
;			Else
;				Notification("SpamGuard is "+(SpamGuard as String))
			; 2015.07.20 / Add
			Endif
		Endif
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If (KeyCode == RessConfig.HotKeyInts[3]) ; Surrender key
			; 2015.07.20 / Add
			Float nCurTime = Utility.GetCurrentRealTime()
			
			; 2015.08.01 / Mod / Adding the condition, !Player.HasKeyWordString("DefeatActive")
			If ((nCurTime - gnSSpamGuard) > 2.0) && !Player.HasKeyWordString("DefeatActive")
				SSpamGuard   = False
				gnSSpamGuard = nCurTime
			Else
				SSpamGuard = True
			Endif
			; 2015.07.20 / Add
			
			If !SSpamGuard
				SSpamGuard = True
				If (!IsInMenuMode() && !Player.HasKeyWordString("DefeatActive") && !Player.HasKeywordString("ActorTypeCreature"))
					If Player.IsInCombat()
						Surrender()
	;				Elseif !Player.HasKeyWordString("SexLabActive")
	;					Actor Target = (GetCurrentCrosshairRef() as Actor)
	;					If Target
	;						; dialogues?
	;					Endif
					; 2015.09.05 / Add
					Else
						Actor actFind = RessConfig.getActorSelected(	\
							enableConsole    = False,					\
							enableNearPlayer = False					\
						)
						
						If actFind && (actFind != Player) && RessConfig.isNaked(Player)
							; Rape me
							RessConfig.StartScene(				\
								actFind, 						\
								Scenario       = "$Original"	)
						Else
							RessConfig.doDebugTest()
						Endif
					; 2015.09.05 / Add
					Endif
				Endif
			Endif
			Wait(2.0)
			SSpamGuard = False
		; 2015.07.17 / Add / Regist,Unregist Captive Internal List
		Elseif (KeyCode == RessConfig.HotKeyInts[4])
			RessConfig.onClickHotKeyCaptiveList()
		; 2015.07.17 / Add
		; 2015.09.06 / Del
		; 2015.08.24 / Add
;		Elseif (KeyCode == RessConfig.HotKeyInts[5])
;			RessConfig.onClickHotKeyCleanupSelected()
		; 2015.08.24 / Add
		; 2015.09.06 / Del
		Endif
	EndEvent
	
	; 2015.07.25 / Add
	Event OnSleepStop(bool abInterrupted)
;		Notification("DefeatPlayer.OnSleepStop")
		startPlayerCaptive("OnSleepStop")
	Endevent
	; 2015.07.25 / Add
	
	; 2015.08.01 / Add
	Event OnEnterBleedOut()
		Actor  Victim       = Player
		Actor  Aggressor    = Victim.GetCombatTarget()
		Bool   canRape      = True
		Float  nRapeChance  = McmConfig.ChanceOnHitPvic
		
		If !Aggressor || Aggressor.IsDead()
			canRape = False
		Elseif !Victim || Victim.IsDead()
			canRape = False
		Elseif !IsPlayerValid()
			canRape = False
		Elseif Aggressor.HasKeyWordString("DefeatActive")
			canRape = False
		Elseif !IsAggressorValid(Aggressor)
			canRape = False
		Elseif (Aggressor.GetDistance(Victim) > FarMaxDist)
			canRape = False
		Elseif (Utility.RandomInt(1, 100) > nRapeChance)
			canRape = False
		Endif
		
		; 2015.08.06 / Add
		If canRape && useRapeSpell(Aggressor, Player)
			setRapedEffects(Player, Enter = True)
		; 2015.08.06 / Add
		; 2015.08.06 / Mod / If -> Elseif
		Elseif canRape
			Detect.Start()
			TheKnockDown(Aggressor)
			Detect.Stop()
		Endif
	EndEvent
	; 2015.08.01 / Add
EndState
; | Death Alternative trigger
Bool Function DefeatTriggerActive(Actor Aggressor)
	Return ((RessConfig.OnOffPlayerVictim) && !Player.HasKeywordString("DefeatActive") && !Player.HasMagicEffect(RessConfig.MiscMagicEffects[0]) && CheckAggressor(Aggressor) && !RessConfig.MiscQuests[6].IsRunning() && IsAggressorValid(Aggressor)) ; PlayerVicOnOff && DGIntimidateQuest && ImmunityEFF
EndFunction
Function DefeatTrigger(Actor Aggressor)
	Detect.Start()
	TheKnockDown(Aggressor)
	Detect.Stop()
Endfunction
Function Surrender()
	IsSurrender = True
	Detect.Start()
	SetAggressors()
	TheNext = Aggressors[0]
	If TheNext
		If IsThereGuard()
			; 2015.09.12 / Mod / Using sayTopic()
;			Player.Say(RessConfig.TopicToSay[3], Player) ; Flee
			sayTopic(Player, Player, 3)
			; 2015.09.12 / Mod / Using sayTopic()
			Player.SheatheWeapon()
			Player.StopCombatAlarm()
			Restored()
			Return
		Endif
		TheNext.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction / Run toward the victim
		TheNext.EvaluatePackage()
		IsCreature = TheNext.HasKeywordString("ActorTypeCreature")
		If !IsCreature ; TheNext.HasKeywordString("ActorTypeNPC")
			ForceThirdPerson()
			PlayerFaction.ForceRefTo(Player)
			RessConfig.AddCalmList(TheNext, Player)
			DisablePlayerControls(1, 1, 1, 0, 1, 1, 0, 0) ;	(abMovement, abFighting, abCamSwitch, abLooking, abSneaking, abMenu, abActivate, abJournalTabs)
;			Player.EnableAI(False)
			SetPlayerAiDriven()
			Player.SetAnimationVariableBool("bSprintOK", False)
			; 2015.09.12 / Mod / Using sayTopic()
;			Player.Say(RessConfig.TopicToSay[3], Player) ; Flee
			sayTopic(Player, Player, 3)
			; 2015.09.12 / Mod / Using sayTopic()
			; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
;			PlayerIsFemale = (SexLab.GetGender(Player) == 1)
			PlayerIsFemale = (PlayerBase.GetSex() == 1)
			; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
			SetScenario()
			SetFollowers()
			SetAlertOff()
			RessConfig.LastSceneAggressors = Aggressors
			RessConfig.LastSceneAccomplices = Accomplices
			RessConfig.LastSceneFollowers = Followers
			NumAgg = RessConfig.HowMany("Aggressors")
			Player.SheatheWeapon()
			Float i = 4.0
			While (Player.IsWeaponDrawn() && (i > 0.0))
				Wait(0.5)
				i -= 0.5
			EndWhile
			RessConfig.DefeatPlayAnimation(Player, "Surrender")
			GoToState("Downed")
			EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; To display the hud
		Elseif (IsCreature && RessConfig.SexCombination(TheNext, Player, True))
			ForceThirdPerson()
			PlayerFaction.ForceRefTo(Player)
			RessConfig.AddCalmList(TheNext, Player)
			DisablePlayerControls(1, 1, 1, 0, 1, 1, 0, 0)
;			Player.EnableAI(False)
			SetPlayerAiDriven()
			Player.SetAnimationVariableBool("bSprintOK", False)
			; 2015.09.12 / Mod / Using sayTopic()
;			Player.Say(RessConfig.TopicToSay[3], Player) ; Flee
			sayTopic(Player, Player, 3)
			; 2015.09.12 / Mod / Using sayTopic()
			; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
;			PlayerIsFemale = (SexLab.GetGender(Player) == 1)
			PlayerIsFemale = (PlayerBase.GetSex() == 1)
			; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
			SetScenario()
			SetFollowers()
			SetAlertOff()
			RessConfig.LastSceneAggressors = Aggressors
			RessConfig.LastSceneAccomplices = Accomplices
			RessConfig.LastSceneFollowers = Followers
			NumAgg = RessConfig.HowMany("Aggressors")
			Player.SheatheWeapon()
			float i = 4.0
			While (Player.IsWeaponDrawn() && (i > 0.0))
				Wait(0.5)
				i -= 0.5
			EndWhile
			If Input.IsKeyPressed(RessConfig.HotKeyInts[3]) ; Surrender key
				RessConfig.DefeatPlayAnimation(Player, "Submission")
				ManualStart = True
				CustomAllowStaydown = McmConfig.StayDown
				CustomAllowResist = False
				CustomAllowRob = Robbed
				CustomAllowRelation = True
				CustomAllowWitness = McmConfig.WitnessPvic
				CustomAllowCommentary = (McmConfig.DialoguesPvic && !IsCreature)
				Wait(1.0)
				GoToState("Downed")
			Else
				SendAnimationEvent(Player, "IdleCowering")
				GoToState("Downed")
			Endif
			EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; To display the hud
		Else
			Notification("$You can't surrender to this enemy.")	
		Endif
	Else
		Restored()
	Endif
	; 2015.07.07 / Add / For the surrender detection stop bug
	Detect.Stop()
	; 2015.07.07 / Add / For the surrender detection stop bug
Endfunction
Function SetSurrenderSpeaker(Actor Aggressor)
	TheNext = Aggressor
	AliasLastAgg.ForceRefTo(TheNext)
	TheNext.SetFactionRank(RessConfig.DefeatFactions[1], 1) ; AggFaction
	TheNext.EvaluatePackage()
EndFunction
State ForceGreetWait																			;===== ForceGreetWait
	Event OnBeginState()
		Time = -1.0
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		Time += 1
		If TheNext.IsInDialogueWithPlayer()
			Return
		Elseif (Time > 10.0)
			Restored()
			Return
		Endif
		TheNext.EvaluatePackage()
		RegisterForSingleUpdate(2.0)
	EndEvent
EndState

; 2015.07.20 / Add
Bool Function doEstrusAttack(Actor Aggressor, Actor Victim)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool   isRaped        = False
	Race   racCreature
	String szRace         = ""
	Bool   canUseEstrus   = RessConfig.Estruson
	Bool   canUseTentacle = False
	Int    nRand          = RandomInt(1, 100)
	Float  nInterval      = RandomFloat(0.8, 8.0)
	Int    nRate
	
	;-------------------------------------------------------
	; Estrus Attack
	;-------------------------------------------------------
	If Aggressor.HasKeyWordString("ActorTypeDwarven")
		nRate = McmConfig.mnEstrusDwarvenRate
		
		If (nRand <= nRate) && canUseEstrus
			SendAnimationEvent(Victim, "BleedoutStart")
			Wait(nInterval)
			SendAnimationEvent(Victim, "BleedoutStop")
;			Strip(Player, Aggressor)
;			Wait(0.8)
			isRaped = RessConfig.doDwarvenRape(Aggressor, Victim)
			
			If isRaped
				setRyonaEffects(Victim, Aggressor, Enter = True)
				RessConfig.setRapedFaceAnimation(Victim)
				RessConfig.DefeatPlayAnimation(Victim, "Lie")
			Endif
		Endif
	Elseif Aggressor.HasKeyWordString("ActorTypeCreature")
		racCreature = Aggressor.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
		nRate       = McmConfig.mnEstrusTentacleRate
		
		If (StringUtil.Find(szRace, "Lurker") != -1)
			canUseTentacle = True
		Elseif (StringUtil.Find(szRace, "Seeker") != -1)
			canUseTentacle = True
		Elseif (StringUtil.Find(szRace, "Chaurus") != -1)
			canUseTentacle = True
		Endif
		
		If canUseTentacle && (nRand <= nRate) && canUseEstrus
			SendAnimationEvent(Victim, "BleedoutStart")
			Wait(nInterval)
			SendAnimationEvent(Victim, "BleedoutStop")
;			Strip(Player, Aggressor)
;			Wait(0.8)
			isRaped = RessConfig.doTentacleRape(Aggressor, Victim)
			
			If isRaped
				setRyonaEffects(Victim, Aggressor, Enter = True)
				RessConfig.setRapedFaceAnimation(Victim)
				RessConfig.DefeatPlayAnimation(Victim, "Lie")
			Endif
		Endif
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
;	Notification("doEstrusAttack::isRaped is "+(isRaped as String))
	Return isRaped
EndFunction
; 2015.07.20 / Add

; 2015.07.25 / Add
Actor Function doSummonRape(Actor Aggressor)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor actSummon = None
	
	;-------------------------------------------------------
	; Summon Raper
	;-------------------------------------------------------
	If Aggressor && Aggressor.HasKeyWordString("ActorTypeDwarven")
		actSummon = RessConfig.summonDwarvenRaper(Aggressor)
	Elseif Aggressor && RessConfig.isSpriggan(Aggressor)
		actSummon = RessConfig.summonSprigganRaper(Aggressor)
	Elseif Aggressor && RessConfig.isAtronachFlame(Aggressor)
		actSummon = RessConfig.summonFlamingRaper(Aggressor)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actSummon
EndFunction
; 2015.07.25 / Add

Function TheKnockDown(Actor Aggressor, String CustomScenario = "")
	; 2015.07.22 / Add
	; 2015.07.25 / Mod / Using doSummonRape()
	Actor actSummon = doSummonRape(Aggressor)
	
	If actSummon
		Aggressor      = actSummon
		CustomScenario = "$No Transition"
	Elseif doEstrusAttack(Aggressor, Player)
		Wait(2.0)
		SpamGuard = False
		; 2015.07.23 / Add
		Detect.Stop()
		; 2015.07.23 / Add
		; 2015.08.01 / Add
		Restored()
		; 2015.08.01 / Add
		Return
	Endif
	; 2015.07.22 / Add
;	PlayerBase.SetInvulnerable(True)
	ForceThirdPerson()
	PlayerFaction.ForceRefTo(Player)
	CrimeHandle()
	RessConfig.AddCalmList(Aggressor, Player)
	; 2015.09.12 / Mod
	If !McmConfig.mDisablePlayerPoseVoice
		RessConfig.DefeatPlayAnimation(Player, "Bleedout")
	Endif
	; 2015.09.12 / Mod
	DisablePlayerControls(1, 1, 1, 0, 1, 1, 0, 0) ;	(abMovement, abFighting, abCamSwitch, abLooking, abSneaking, abMenu, abActivate, abJournalTabs)
	SetPlayerAiDriven()
	Player.SetAnimationVariableBool("bSprintOK", False)
	; 2015.09.12 / Mod / Using sayTopic()
;	Player.Say(RessConfig.TopicToSay[2], Player) ; Death
	sayTopic(Player, Player, 2)
	; 2015.09.12 / Mod / Using sayTopic()
	; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
;	PlayerIsFemale = (SexLab.GetGender(Player) == 1)
	PlayerIsFemale = (PlayerBase.GetSex() == 1)
	; 2015.07.25 / Mod / SexLab.GetGender(Player) returns 0, when player is female
	SetScenario(CustomScenario)
	IsSurrender = False
	TheNext = None
	If (Scenario == "$No Transition")
		; 2015.07.26 / Add
		Aggressor.PathToReference(Player, 1.0)
		; 2015.07.26 / Add
		; 2015.07.26 / Mod / 0.5 -> 8.0
		; 2015.09.13 / Mod / Adding the if condition
		If actSummon
			Wait(8.0)
		Endif
		; 2015.09.13 / Mod / Adding the if condition
		; 2015.07.26 / Mod / 0.5 -> 8.0
		NoTrans = True
		; 2015.08.01 / Add
		If Aggressor.IsDead()
			SpamGuard = False
			Detect.Stop()
			Return
		; 2015.08.01 / Add
		; 2015.08.01 / Mod / If -> Elseif
		Elseif TheRape(Player, Aggressor, None, None, None)
			RessConfig.Weakenings(Player, RemoveSpl = True)
			Player.AddSpell(RessConfig.MiscSpells[1], False) ; DebuffConsSPL
			Raped = True
			Wait(2.0)
			EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; For the HUD to appear after SexLab triggered a sex scene, the player should still be ai driven and unable to move
		; 2015.08.01 / Add
		Else
			SpamGuard = False
			Detect.Stop()
			Restored()
			Return
		; 2015.08.01 / Add
		Endif
	Else
		SetAggressors(Aggressor)
		SetFollowers()
		SetAlertOff()
		RessConfig.LastSceneAggressors = Aggressors
		RessConfig.LastSceneAccomplices = Accomplices
		RessConfig.LastSceneFollowers = Followers
		NumAgg = RessConfig.HowMany("Aggressors")
		If Player.HasKeywordString("ActorTypeCreature")
			; 2015.09.12 / Mod
			If !McmConfig.mDisablePlayerPoseVoice
				SendAnimationEvent(Player, "BleedoutStart")
			Endif
			; 2015.09.12 / Mod
			If RessConfig.MiscQuests[7].IsRunning() ; WerewolfQst
				RessConfig.MiscQuests[7].SetStage(100); as PlayerWerewolfChangeScript).ShiftBack()
				float i = 5.0
				While (Player.GetAnimationVariableBool("bIsSynced") && (i > 0.0))
					Wait(0.2)
					i -= 0.2
				EndWhile
				; 2015.09.12 / Mod / Using sayTopic()
;				Player.Say(RessConfig.TopicToSay[2], Player) ; Death
				sayTopic(Player, Player, 2)
				; 2015.09.12 / Mod / Using sayTopic()
				; 2015.09.12 / Mod
				If !McmConfig.mDisablePlayerPoseVoice
					SendAnimationEvent(Player, "BleedoutStart")
				Endif
				; 2015.09.12 / Mod
			Elseif RessConfig.DawnguardOn
				If RessConfig.MiscQuests[8].IsRunning() ; VampireLordQst
					RessConfig.MiscQuests[8].SetStage(100); as dlc1playervampirechangescript).ShiftBack()
					float i = 5.0
					While (Player.GetAnimationVariableBool("bIsSynced") && (i > 0.0))
						Wait(0.2)
						i -= 0.2
					EndWhile
					; 2015.09.12 / Mod / Using sayTopic()
;					Player.Say(RessConfig.TopicToSay[2], Player) ; Death
					sayTopic(Player, Player, 2)
					; 2015.09.12 / Mod / Using sayTopic()
					; 2015.09.12 / Mod
					If !McmConfig.mDisablePlayerPoseVoice
						SendAnimationEvent(Player, "BleedoutStart")
					Endif
					; 2015.09.12 / Mod
				Endif
			Endif
		Endif
		GoToState("Downed")
		EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; To display the hud
	Endif
	UpdatePackages()
EndFunction
Bool Function KDAllowed(Actor Aggressor)
	Return (!Player.IsInKillMove() && !Player.HasMagicEffect(RessConfig.MiscMagicEffects[0]) && !Player.HasKeywordString("DefeatActive") && !RessConfig.MiscQuests[6].IsRunning()) ; ImmunityEFF && DGIntimidateQuest
EndFunction
Bool Function KDWay(Actor Aggressor, Bool PowerAttack, Form HitSource)
	If KDAllowed(Aggressor)
		If (Aggressor.GetDistance(Player) < FarMaxDist)
			If McmConfig.KDWayThreshold ; Wound
				Float PlayerHealth = (Player.GetActorValuePercentage("Health") * 100)  
				If ((RandomInt(1, 100) <= McmConfig.ChanceOnHitPvic) && (PlayerHealth <= McmConfig.ThresholdPvic) && (PlayerHealth >= McmConfig.ThresholdPvicMin))
					Return True
				Endif
			Endif
			If McmConfig.KDWayStamina ; Exhaustion
				Float PlayerStamina = (Player.GetActorValuePercentage("Stamina") * 100)
				If OnlyBack(McmConfig.KDWayStaminaOB, Aggressor)
					If ((RandomInt(1, 100) <= McmConfig.ChanceOnHitPvicS) && (PlayerStamina <= McmConfig.ExhaustionPvic))
						Return True
					Endif
				Endif
			Endif
			If PowerAttack
				If McmConfig.KDWayPowerAtk ; Stun
					Weapon TheSource = (HitSource as weapon)
					If TheSource
						If ((RandomInt(1, 100) <= McmConfig.KDWayPowerAtkCOH) && ((TheSource.GetStagger() * 100) >= McmConfig.PowerAtkStagger))
							Return True
						Endif
					Endif
				Endif
			Endif
		Endif
	Endif
	Return False
EndFunction
Bool Function OnlyBack(Bool TheOption, Actor Aggressor)
	If TheOption
		Float Fangle = (Player.GetHeadingAngle(Aggressor))
		If ((Fangle < 110) && (Fangle > -110)) ; Returns FALSE for a hit in the back
			Return False
		Else
			Return True
		Endif
	Endif
	Return True
EndFunction
Bool Function CheckActor(Actor Target = None)
	If (Target && (Target.IsDead() || Target.IsCommandedActor()))
		Int i = Aggressors.Find(Target)
		If (i != -1)
			Aggressors[i] = None
			TheAggressors[i].Clear()
			NumAgg -= 1
			Return False
		Endif
		i = Accomplices.Find(Target)
		If (i != -1)
			Accomplices[i] = None
			TheAggressors[i + 5].Clear()
			Return False
		Endif
	Endif
	Return True
EndFunction
Bool Function CheckAggressor(Actor Aggressor)
	If (IsSurrender || McmConfig.EveryonePvic)
		Return True
	Else
		Return RessConfig.SexCombination(Aggressor, Player, True)
	Endif
EndFunction
Bool Function IsAggressorValid(Actor Aggressor)
	If Aggressor.HasKeywordString("ActorTypeNPC")
		IsCreature = False
		Return True
	Elseif Aggressor.HasKeywordString("ActorTypeCreature")
		IsCreature = True
		Return True
	; 2015.07.20 / Add
	Elseif Aggressor.HasKeywordString("ActorTypeDwarven")
		Return True
	; 2015.07.20 / Add
	Endif
	Return False
EndFunction
Bool Function IsPlayerValid()
	If ((Player.HasKeywordString("ActorTypeCreature") && !McmConfig.BeastImmunity) || Player.IsOnMount())
		Return False
	EndIf
	Return True
EndFunction
Function SetScenario(String CustomScenario = "")
	If (CustomScenario != "")
		Scenario = CustomScenario
	Elseif IsCreature
		Scenario = McmConfig.CrScenario
	Else
		Scenario = McmConfig.KDScenario
	Endif
EndFunction
Bool Function AllowStaydown()
	If ManualStart
		Return (Tied || CustomAllowStaydown)
	Else
		Return (Tied || McmConfig.StayDown)
	Endif
EndFunction
Bool Function AllowResist()
	If ManualStart
		Return CustomAllowResist
	Else
		Return McmConfig.bResistQTE
	Endif
EndFunction
Bool Function AllowRob()
	If ManualStart
		Return CustomAllowRob
	Else
		Return Robbed
	Endif
EndFunction
Bool Function AllowRelation()
	If ManualStart
		Return CustomAllowRelation
	Else
		Return True
	Endif
EndFunction
Function SetSexualAssault(Bool Set)
	PotentialAggressor = Set
EndFunction
Bool Function AllowWitness()
	If ManualStart
		Return CustomAllowWitness
	Else
		Return McmConfig.WitnessPvic
	Endif
EndFunction
Bool Function AllowCommentaries()
	If ManualStart
		Return (CustomAllowCommentary && !IsCreature)
	Else
		Return (McmConfig.DialoguesPvic && !IsCreature)
	Endif
EndFunction
;=============================================================================================================================== NPCS HANDLING
Function SetAggressors(Actor Agg = None)
	Int i
	While (i < 10)
		Actor Reference = (DAggs[i].GetReference() As Actor)
		
		; 2015.08.08 / Add
;		If !Reference && gaCaptiveAgg[i]
;			Reference = gaCaptiveAgg[i]
;		Endif
		; 2015.08.08 / Add
		
		If Reference
			If !Reference.IsInFaction(RessConfig.DefeatFactions[1]) ; AggFaction
				Int Slot = Aggressors.Find(None)
				If (RessConfig.SexCombination(Reference, Player, True) && (Slot != -1))
					Aggressors[Slot] = Reference
					TheAggressors[Slot].ForceRefTo(Reference)
					DefeatConfig.Log("SetAggressors Aggressor / Slot filled - "+Slot+" // Aggressor -> "+Aggressors[Slot])
					Reference.EvaluatePackage()
				Else
					Slot = Accomplices.Find(None)
					If (Slot != -1)
						Accomplices[Slot] = Reference
						TheAggressors[Slot + 5].ForceRefTo(Reference)
						DefeatConfig.Log("SetAggressors Accomplices / Slot filled - "+Slot+" // Accomplice -> "+Accomplices[Slot])
						Reference.EvaluatePackage()
					Endif
				Endif
			Endif
		Endif
		i += 1
	EndWhile
	DefeatConfig.Log("SetAggressors / Aggressors slots - "+Aggressors)
	DefeatConfig.Log("SetAggressors / Accomplices slots - "+Accomplices)
EndFunction
Function SetFollowers()
	Int i
	While (i < 5)
		Actor Reference = (DParts[i].GetReference() As Actor)
		
		; 2015.08.08 / Add
;		If !Reference && gaCaptiveVic[i]
;			Reference = gaCaptiveVic[i]
;		Endif
		; 2015.08.08 / Add
		
		If Reference
			Followers[i] = Reference
			TheFollowers[i].ForceRefTo(Reference)
			DefeatConfig.Log("SetFollowers / Slot filled - "+i+" // Follower - "+Followers[i])
			String TheState = RessConfig.VictimState(Reference)
			If (TheState == "") ; The follower is doing well
				If (IsSurrender && McmConfig.FollowerSurrender)
					RessConfig.Surrender(Followers[i])
				Elseif (Scenario == "$All Down") || IsSurrender ; Make aggressor attack remaining followers in case of all down of surrender with FollowerSurrender disabled
					Int n
					While (n < 5)
						If (Aggressors[n] && CheckActor(Aggressors[n]))
;							DefeatConfig.Log(Aggressors[n]+" attacks "+Reference)
							Aggressors[n].StartCombat(Reference)
							Reference.StartCombat(Aggressors[n])
						Endif
						If (Accomplices[n] && CheckActor(Accomplices[n]))
							Accomplices[n].StartCombat(Reference)
							Reference.StartCombat(Accomplices[n])
						Endif
						n += 1
					EndWhile
				Else ; "Original" scenario, every follower gets knocked down
					; 2015.06.27 / Mod
;					RessConfig.Knockdown(Reference, Duration = 60.0, Type = "Player Victim")
					RessConfig.Surrender(Followers[i])
					; 2015.06.27 / Mod
				Endif
			Else
				If (TheState == "BleedOut")
					RessConfig.Knockdown(Reference, Duration = 60.0, Type = "Player Victim")
				Endif
			Endif
		Endif
		i += 1
	EndWhile
	DefeatConfig.Log("SetFollowers / Scenario - "+Scenario+" // Followers slots - "+Followers)
EndFunction
;=============================================================================================================================== NPCS HANDLING
Bool Function StillFighting()
	Int i
	While (i < 5)
		If (Aggressors[i] && Aggressors[i].IsInCombat())
			Return True
		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 5)
		If (Accomplices[i] && Accomplices[i].IsInCombat())
			Return True
		Endif
		i += 1
	EndWhile
	Return False
EndFunction
Actor Function IsThereGuard()
	Int i
	While (i < 5)
		If (Aggressors[i] && Aggressors[i].IsGuard())
			Return Aggressors[i]
		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 5)
		If (Accomplices[i] && Accomplices[i].IsGuard())
			Return Accomplices[i]
		Endif
		i += 1
	EndWhile
	Return None
EndFunction
Function CrimeHandle()
	Actor Guard = IsThereGuard()
	If Guard
;		DefeatConfig.Log("CrimeHandle yes")
		CrimeFaction = Guard.GetCrimeFaction()
		CrimeGold = CrimeFaction.GetCrimeGold()
		CrimeGoldViolent = CrimeFaction.GetCrimeGoldViolent()
;		DefeatConfig.Log("CrimeGold before - "+CrimeGold)
;		DefeatConfig.Log("CrimeGoldViolent before - "+CrimeGoldViolent)
		CrimeFaction.SetCrimeGold(0)
		CrimeFaction.SetCrimeGoldViolent(0)
;		DefeatConfig.Log("CrimeGold after - "+CrimeGold)
;		DefeatConfig.Log("CrimeGoldViolent after - "+CrimeGoldViolent)
	Endif
;	If Player.IsTrespassing()
;		OwnerFaction = Player.GetParentCell().GetFactionOwner()
;		If OwnerFaction
;			Player.AddToFaction(OwnerFaction)
;		Endif
;	Endif
EndFunction
Function SetAlertOff()
	Int i
	While (i < 5)
		If (Aggressors[i] && Aggressors[i].IsAlerted())
			Aggressors[i].SetAlert(False)
		Endif
		If (Accomplices[i] && Accomplices[i].IsAlerted())
			Accomplices[i].SetAlert(False)
		Endif
		i += 1
	EndWhile
EndFunction

State Downed																					;===== STATE DOWNED
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State Downed starts.")
; DEBUG
		; 2015.08.29 / Add
		Time = 0.0
		; 2015.08.29 / Add
		DownedTime = 15.0
		If StillFighting() ; Check if there is an aggressor is still in combat for some reason (because of a follower for most cases) and if so make the script loop to give a chance to the player to get up.
			If IsSurrender
				FillThreshold = 0.05
				StruggleBar()
			Else
				MiscScenes[0].Start() ; Downed scene
				IsBar = AllowResist()
				HasFollower = (Followers[0] && (RessConfig.VictimState(Followers[0]) == ""))
				If HasFollower
					DownedTime = 30.0
				Endif
				If IsBar
					If HasFollower
						FillThreshold = 0.005
					Else
						FillThreshold = 0.008
					Endif
					StruggleBar()
	;				EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; For the HUD to appear or else the bar will not be displayed, the player should be ai driven and not be able to move
				Endif
			Endif
			; 2015.08.29 / Del
;			Time = 0.0
			; 2015.08.29 / Del
			RegisterForSingleUpdate(1.0)
		Else
			If IsSurrender
				If !IsCreature
					SetSurrenderSpeaker(TheNext)
					RessConfig.SurrenderData(Player, TheNext)
					RessConfig.QSTStage = 10
					GoTostate("ForceGreetWait")
				Else
					GoToState("MightRecover")
				Endif
			Else
				GoToState("MightRecover")
			Endif
		Endif
	EndEvent
	Event OnUpdate() ; Loop to check the situation every 1 second.
		Time += 1.0
		If StillFighting()
			If IsSurrender
				If (StruggleBar.Percent >= 1.0) || TheNext.IsDead() ; Bar filled, player get up, only if resist bar is enabled.
					StruggleBar(False)
					Restored()
					Return
				Endif
			Else
				If IsBar
					If (StruggleBar.Percent >= 1.0) ; Bar filled, player get up, only if resist bar is enabled.
						StruggleBar(False)
						Restored()
						Return
					Endif
				Else
					If (Time > DownedTime) ; DownedTime passed, player get up, only if resist bar is disabled.
						Restored()
						Return
					Endif
				Endif
			Endif
		Else
			If IsSurrender
				StruggleBar(False)
				If !IsCreature
					SetSurrenderSpeaker(TheNext)
					RessConfig.SurrenderData(Player, TheNext)
					RessConfig.QSTStage = 10
					GoToState("ForceGreetWait")
				Else
					GoToState("MightRecover")
				Endif
			Else
				GoToState("MightRecover")
			Endif
			Return
		Endif
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StrafeL) && LeftRight)
			LeftRight = False
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Elseif ((KeyCode == StrafeR) && !LeftRight)
			LeftRight = True
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Elseif (KeyCode == RessConfig.HotKeyInts[3]) ; Surrender key
			If IsSurrender  ; Ask the follower to surrender too if they are still fighting
				Int i
				While (i < 5)
					If Followers[i]
						String TheState = RessConfig.VictimState(Followers[i])
						If (TheState == "")
							RessConfig.Surrender(Followers[i])
						Endif
					Endif
					i += 1
				EndWhile
			Endif
		Endif
	EndEvent
EndState
State MightRecover																			    ;===== STATE MIGHT RECOVER
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State MightRecover starts.")
; DEBUG
		Tied = RessConfig.Tied(Player) ; Check if the player is tied
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		Time += 1.0
;		DefeatConfig.Log("MightRecover / Time -> "+Time+" / DownedTime - "+DownedTime+" / TheNext -> "+TheNext)
		If (!Aggressors[0] && Accomplices[0]) ; No aggressors but accomplices, wait for the first one to get out of combat
			If (IsBar && (StruggleBar.Percent >= 1.0)) ; Bar filled, player get up, only if resist bar is enabled.
				StruggleBar(False)
				Restored()
				Return
			Elseif ((Time >= 1.0) && !Accomplices[0].IsInCombat())
				StruggleBar(False)
				TheLast = Accomplices[0]
				GotoState("AssaultMode")
				Return
			Else
				If (Time > DownedTime) ; The next aggressor did not reach the player in time for whatever reason, the player gets up.
					Restored()
					Return
				Endif
			Endif
		Elseif SetNextAgg()
			If (IsBar && (StruggleBar.Percent >= 1.0)) ; Bar filled, player get up, only if resist bar is enabled.
				StruggleBar(False)
				Restored()
				Return
			; 2015.08.30 / Mod / Deleting conditions, TheNext.GetDistance(Player) and !TheNext.IsInCombat()
;			Elseif ((Time >= 1.0) && (TheNext.GetDistance(Player) < Dist(TheNext)) && !TheNext.IsInCombat())
			Elseif (Time >= 1.0)
				StruggleBar(False)
				GotoState("AssaultMode")
				Return
			Else
				If (Time > DownedTime) ; The next aggressor did not reach the player in time for whatever reason, the player gets up.
					Restored()
					Return
				Endif
			Endif
		Else
			If IsBar
				StruggleBar(False)
			Endif
			Restored()
			Return
		Endif
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StrafeL) && LeftRight)
			LeftRight = False
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Elseif ((KeyCode == StrafeR) && !LeftRight)
			LeftRight = True
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Endif
	EndEvent	
EndState
State Escape																					;===== STATE ESCAPE
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State Escape starts.")
; DEBUG
		FillThreshold = 0.060	
		StruggleBar()
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		If (StruggleBar.Percent >= 1.0)
			RegisterForSingleUpdate(10.0)
			StruggleBar(False)
			; 2015.07.15 / Mod
;			RessConfig.DefeatPlayAnimation(Player, "Stand")
			RessConfig.DefeatPlayAnimation(Player, "Trauma Stand")
			; 2015.07.15 / Mod
			SetPlayerAiDriven(False)
			; 2015.07.14 / Add
			setRapedEffects(Player, Enter = False)
			; 2015.07.14 / Add
			GoToState("Flee")
			Return
		Endif
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StrafeL) && LeftRight)
			LeftRight = False
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Elseif ((KeyCode == StrafeR) && !LeftRight)
			LeftRight = True
			FillDifficulty += FillThreshold
			StruggleBar.Percent = (FillDifficulty)
		Endif
	EndEvent
EndState
State Flee
	Event OnUpdate()
		MiscScenes[1].Stop() ; SCEscape
	EndEvent
EndState
State AssaultMode 																				;===== STATE ASSAULT MODE
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State AssaultMode starts.")
; DEBUG
		RegisterForSingleUpdate(0.50)
	EndEvent
	Event OnUpdate()
		If (!SetNextAgg()) ; No more available aggressors
			Wait(0.5)
			RessConfig.DefeatPlayAnimation(Player, "Sit")
			
			If (!Aggressors[0] && Accomplices[0])
				NumAgg = RessConfig.HowMany("Accomplices")
			Endif
			Collateral() ; Maybe the player has been knocked down by NPC who don't want them, let's check if they are interested by the followers.
			If StillBusy() ; Check if one aggressor or follower is still busy
				GoToState("FollowerWait")
			Else
				If (AllowedToBeRobbed() && CheckActor(TheLast))
					StartRobbingScene(Player, TheLast, McmConfig.RobbingWay, McmConfig.vRobbing)
				Else
; DEBUG
RessConfig.saveDebugStr("Return 1 at AssaultMode.")
; DEBUG
					PostAssault()
				Endif
			Endif
		Else
			If Raped
				If !AllowStaydown()
					SetPlayerAiDriven()
					SendAnimationEvent(TheNext, "IdlePrisonerBeat")
					RessConfig.SoundToPlay[8].Play(Player) ; Rescue
					RessConfig.DefeatPlayAnimation(Player, "Bleedout")
				Endif
			Endif
			DefeatConfig.Log("Player victim, Assault - Aggressor "+TheNext+", Persuer (Should be the same) -> "+Persuer+" // Raped - "+Raped+" // NumRapes - "+NumRapes+" // NumAgg - "+NumAgg)
			RessConfig.LastSceneRaped = Raped
			If !IsCreature ; Creature don't care about you
				AliasLastAgg.ForceRefTo(TheNext)
				RessConfig.HasBeenRapedBy = RessConfig.HasBeenRapedBy(Player, TheNext)					; For dialogues
				RessConfig.InSceneRapesHowManyBy = GetIntValue(TheNext, "RapedByInScene"+Player)		; 
				RessConfig.TheEvilFaction = RessConfig.IsEvilFaction(TheNext)
				RessConfig.AllowedFaction = ((RessConfig.TheEvilFaction != "") && (RessConfig.TheEvilFaction != "Guard"))
				DefeatConfig.Log("NPC - "+TheNext+" / HasBeenRapedBy - "+RessConfig.HasBeenRapedBy+" / InSceneRapesHowManyBy - "+RessConfig.InSceneRapesHowManyBy+" / AllowedFaction - "+RessConfig.AllowedFaction+" / TheEvilFaction - "+RessConfig.TheEvilFaction)
				If AllowRelation() && !RessConfig.IsBadRelation(TheNext, Player, True)
					DefeatConfig.Log(TheNext+" has good relation with the player, forgive topic")
					TheNext.Say(RessConfig.TopicToSay[18], Player) ; Forgive topic
					Int i = Aggressors.Find(TheNext)
					Aggressors[i] = None
					TheAggressors[i].Clear()
					TheLast = TheNext
					TheNext.EvaluatePackage()
					TheNext = None
					Wait(2.0)
					GoToState("AssaultMode")
				Else
					GetWitness()
					DefeatConfig.Log(TheNext+" wants to have a piece of ass / IsBadRelation")
					If AllowCommentaries()
						TheNext.Say(RessConfig.TopicToSay[17], Player) ; Comment topic
						Wait(1.5)
					Endif
					; 2015.08.30 / Add
					Bool isAggFriend    = False
					Bool isDefeatActive = False
					Bool isSexActive    = False
					
					If RessConfig.AWitness
						isAggFriend    = (TheNext.getFactionReaction(RessConfig.AWitness) > 1)
						isDefeatActive = RessConfig.AWitness.HasKeyWordString("DefeatActive")
						isSexActive    = RessConfig.AWitness.HasKeyWordString("SexLabActive")
					Endif
					; 2015.08.30 / Add
					; 2015.08.30 / Mod / Adding conditions, !isEnemy && !isDefeatActive && !isSexActive
;					If RessConfig.AWitness
					If RessConfig.AWitness && !isAggFriend && !isDefeatActive && !isSexActive
						RessConfig.AWitness.Say(RessConfig.TopicToSay[19], Player) ; Witness comment
						Wait(2.0)
						RessConfig.MiscSpells[5].Cast(RessConfig.AWitness, Player) ; ImmunitySPL
; DEBUG
RessConfig.saveDebugStr("Return 2 at AssaultMode.")
RessConfig.saveDebugStr("Witness is "+RessConfig.AWitness.GetLeveledActorBase().GetName())
; DEBUG
						PostAssault()
						Return
					Else
						If (AllowResist() && !Tied)
							GoToState("QTE")
						Else
							PreDownRape()
						Endif
					Endif
				Endif
			Else
				If (McmConfig.HuntCrea && SexLab.AllowedCreature(TheNext.GetLeveledActorBase().GetRace()))
					If (AllowResist() && !Tied)
						GoToState("QTE")
					Else
						PreDownRape()
					Endif
				Else
					DefeatConfig.Log(TheNext+" creature not a potential aggressor, remove from aggressors.")
					Int i = Aggressors.Find(TheNext)
					Aggressors[i] = None
					TheAggressors[i].Clear()
					TheLast = TheNext
					TheNext.EvaluatePackage()
					TheNext = None
					GoToState("AssaultMode")
				Endif
			Endif
		Endif
		TheLast = TheNext
	EndEvent
EndState
State Pursuit
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State Pursuit starts.")
; DEBUG
		Time = -1.0
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		Time += 1.0
		
		; 2015.08.30 / Mod / Deleting conditions, Persuer.GetDistance(Player) and !Persuer.IsInCombat()
;		If (Time >= 2.0) && (Persuer.GetDistance(Player) < (Dist(Persuer) + 50) && !Persuer.IsInCombat())
		If (Time >= 2.0)
			SetPlayerAiDriven() ; set ai driven if we had to renable this if the player had to get up from a ragdoll
			GoToState("AssaultMode")
			Return
		Elseif ((Time > 15.0) || (Player.GetDistance(Persuer) > 1700.0)) ; Player succeed escaping or the next aggressor didn't reach the player in time for whatever reason
			If AllowStaydown()
				; 2015.07.15 / Mod
;				RessConfig.DefeatPlayAnimation(Player, "Stand")
				RessConfig.DefeatPlayAnimation(Player, "Trauma Stand")
				; 2015.07.15 / Mod
			Endif
			Restored()
			Return
		Elseif !AllowStaydown() ; If the player is trying to run away
			If (RandomInt(1, 100) <= 10) ; 10% every 1 second that the player staggers
				SendAnimationEvent(Player, "staggerStart")
			Endif
		Endif
		RegisterForSingleUpdate(1.0)
	EndEvent
EndState
Function PostAssault()
;	Player.Say(RessConfig.TopicToSay[3], Player) ; Flee
;	sayTopic(Player, Player, 3)
	Player.SetAnimationVariableBool("bSprintOK", True)
	RessConfig.DefeatPlayAnimation(Player, "Sit")
	If !Player.HasMagicEffect(RessConfig.MiscMagicEffects[0]) ; ImmunityEFF Check if a NPC has rescued the player or has been hit
		ObjectReference Marker
		If Player.IsInInterior()
			Marker = FindClosestReferenceOfAnyTypeInListFromRef(MiscFormLists[3], Player, 50000.0) ; DefeatMarkerListInt
			If Marker
				DefeatConfig.Log("PostAssault Marker Found - "+Marker+" / BaseObject "+Marker.GetBaseObject())
				SceneCenter.ForceRefTo(Marker)
			Endif
		Else
			Marker = FindClosestReferenceOfAnyTypeInListFromRef(MiscFormLists[2], Player, 50000.0) ; DefeatMarkerListExt
			If Marker
				DefeatConfig.Log("PostAssault Marker Found - "+Marker+" / BaseObject "+Marker.GetBaseObject())
				SceneCenter.ForceRefTo(Marker)
			Endif
		Endif
		SetSceneData() ; Set data for the scene.
		Int i
		While (i < 5) ; Set aggressors to not follow the player when and if teleported.
			If Aggressors[i]
				Aggressors[i].SetFactionRank(RessConfig.DefeatFactions[1], 5) ; AggFaction
				Aggressors[i].EvaluatePackage()
				If McmConfig.InsatiablePvic
					RessConfig.SetSatisfied(Aggressors[i], Satisfied = False)
				Endif
			Endif
			If Accomplices[i]
				Accomplices[i].SetFactionRank(RessConfig.DefeatFactions[1], 5) ; AggFaction
				Accomplices[i].EvaluatePackage()
				If McmConfig.InsatiablePvic
					RessConfig.SetSatisfied(Accomplices[i], Satisfied = False)
				Endif
			Endif
			i += 1
		EndWhile
		If (CrimeGold > 0)
			CrimeFaction.SetCrimeGold(CrimeGold)
		Endif
		If (CrimeGoldViolent > 0)
			CrimeFaction.SetCrimeGoldViolent(CrimeGoldViolent)
		Endif
		Wait(1.0)
		
		; 2015.09.06 / Add
		mEnableCellLoadEvents = False
		; 2015.09.06 / Add
		
		PostAssaultscr.PickEvent()
	Else
		PostAssaultscr.Escape()
	Endif
EndFunction
Function PreDownRape()
	If !Stripped
		Stripped = True
		Strip(Player, TheNext)
	Endif
	; 2015.09.12 / Mod / Using sayTopic()
;	Player.Say(RessConfig.TopicToSay[3], Player) ; Flee
	sayTopic(Player, Player, 3)
	; 2015.09.12 / Mod / Using sayTopic()
	If TheRape(Player, TheNext, AddOne, AddTwo, AddThree)
		NumRapes += 1
		RessConfig.Weakenings(Player, RemoveSpl = True)
		Player.AddSpell(RessConfig.MiscSpells[1], False) ; DebuffConsSPL
		Raped = True
		UpdatePackages()
		Collateral()
		Wait(2.0)
		EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0) ; For the HUD to appear after SexLab triggered a sex scene, the player should still be ai driven and unable to move
	Else
		Restored()
	Endif
Endfunction
Bool Function AllowedToBeRobbed()
	If (!IsCreature && !RessConfig.MiscQuests[5].IsRunning() && RessConfig.AllowedFaction) ; RobberQst
		If (RandomInt(1, 100) < McmConfig.fRobbing)
			Return True
		Endif
		MiscScenes[2].Stop() ; SCRobbing
	Endif
	Return False
EndFunction
Function StartRobbingScene(Actor Victim, Actor Aggressor, String RobWay = "", Float TheValue = -1.0)
	If RobWay == "Value"
		TheRobWay = 1
	Elseif RobWay == "Gold"
		TheRobWay = 2
	Elseif (McmConfig.RobbingWay == "$Value")
		TheRobWay = 1
	Elseif (McmConfig.RobbingWay == "$Only Gold")
		TheRobWay = 2
	Endif
	IF (TheValue != -1)
		RobValue = TheValue
	Else
		RobValue = McmConfig.vRobbing
	ENdif
	AliasLastAgg.ForceRefTo(Aggressor)
	AliasLastVic.ForceRefTo(Victim)
	MiscScenes[2].ForceStart() ; SCRobbing
Endfunction
Function RobValuable(Actor Victim, Actor Aggressor)
	SendModEvent("DefeatPostAssault", "RobBegin")
;	DefeatConfig.Log("START Robbing")
	RecoverStuff(Aggressor)
	If (TheRobWay == 1)
		Int i = Victim.GetNumItems()
		While (i > 0)
			i -= 1
			Form Item = Victim.GetNthForm(i)
			If ((Item.GetGoldValue() > RobValue) && !Item.HasKeyWordString("SexLabNoStrip"))
				Victim.RemoveItem(Item, Victim.GetItemCount(Item), True, Aggressor)
	;		Elseif (Item.GetType() == 41) ; Weapon
	;			Victim.RemoveItem(Item, Victim.GetItemCount(Item), True, Aggressor)
			Endif
		EndWhile
		Victim.RemoveItem(MiscObjects[0], Victim.GetGoldAmount(), akOtherContainer = Aggressor) ; Gold
	Else
		Victim.RemoveItem(MiscObjects[0], Victim.GetGoldAmount(), akOtherContainer = Aggressor) ; Gold
	Endif
	Robbed = True
;	DefeatConfig.Log("ENDS Robbing")
EndFunction
Float Function Dist(Actor Agg)
	; 2015.07.11 / Mod / Using McmConfig.mnRapeDistXXX
	If !IsCreature
		Return McmConfig.mnRapeDistHuman
	Else
		If Agg.IsAllowedToFly()
			Return McmConfig.mnRapeDistFlyer
		Else
			Return McmConfig.mnRapeDistCreature
		Endif
	Endif
	; 2015.07.11 / Mod / Using McmConfig.mnRapeDistXXX
EndFunction
Function UpdatePackages()
	Int i
	While (i < 5)
		If Aggressors[i]
			Aggressors[i].EvaluatePackage()
		Endif
		If Accomplices[i]
			Accomplices[i].EvaluatePackage()
		Endif		
		i += 1
	EndWhile
EndFunction
Bool Function SetNextAgg()
	Bool Enough = (NumRapes >= (NumAgg * McmConfig.mnRapeNumPerAgg))
	If !Enough
		If !TheNext
			Return PickAnAggressor()
		Else
			If !CheckActor(TheNext) ; TheNext actor exists, Check if he is still alive and if not return another aggressor
				Return PickAnAggressor()
			Else 	; TheNext actor exists and is alive, evaluate package
				TheNext.EvaluatePackage()
			Endif
		Endif
	Else
		Return False
	Endif
	Return True
EndFunction
Actor Function PickAnAggressor()
	Int i
	While (i < 5)
		If Aggressors[i] 
			Int FactionRank = Aggressors[i].GetFactionRank(RessConfig.DefeatFactions[1]); AggFaction
			If ((RessConfig.VictimState(Aggressors[i]) == "") && RessConfig.SexInterest(Aggressors[i], True, False) && (FactionRank == 0))
				TheNext = Aggressors[i]
				Persuer = Aggressors[i]
				TheNext.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction / Run toward the victim
				TheNext.EvaluatePackage()
				IsCreature = TheNext.HasKeywordString("ActorTypeCreature")
				DefeatConfig.Log("TheNext set - "+TheNext)
				Return TheNext
			Endif
		Endif
		i += 1
	EndWhile
	Return None
EndFunction
Function SetAdds()
	If !IsCreature
		If McmConfig.ThreesomeChance > 0.0
			If (RandomInt(0, 100) < McmConfig.ThreesomeChance)
				Int i								
				While (i < 5)
					If (Aggressors[i] && (Aggressors[i] != TheNext) && !Aggressors[i].HasKeywordString("ActorTypeCreature") && !Aggressors[i].HasKeywordString("SexLabActive"))
						If (CheckActor(Aggressors[i]) && (Aggressors[i].GetFactionRank(RessConfig.DefeatFactions[1]) < 1) && (Aggressors[i].GetDistance(Player) < FarMaxDist)) ; AggFaction
							If RessConfig.IsSexualAssaulter(Aggressors[i], Player, True) ; Make sure to not pick a creature if there is one in the array.
								AddOne = Aggressors[i]
								AddOne.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction
								AddOne.EvaluatePackage()
								DefeatConfig.Log("Threesome second aggressor Set -> "+AddOne+", Aggressor list -> "+Aggressors)
								Return
							Endif				
						Endif
					Endif
					i += 1
				EndWhile
			Endif
		Endif
	Else
		If (McmConfig.GbCrChancePvic > 0.0)
			If (RandomInt(0, 100) < McmConfig.GbCrChancePvic)
				VoiceType AggressorRace = TheNext.GetVoiceType()
				Int IsValidRace = RessConfig.MiscVoicetypes.Find(AggressorRace)
				If (IsValidRace != -1)
					Int i
					While (i < 5)
						If (Aggressors[i] && (Aggressors[i] != TheNext) && !Aggressors[i].HasKeywordString("ActorTypeNPC") && !Aggressors[i].HasKeywordString("SexLabActive"))
							If (CheckActor(Aggressors[i]) && (AggressorRace == Aggressors[i].GetVoiceType()) && (Aggressors[i].GetFactionRank(RessConfig.DefeatFactions[1]) < 1) && (Aggressors[i].GetDistance(Player) < FarMaxDist)) ; AggFaction
								If RessConfig.IsSexualAssaulter(Aggressors[i], Player, True)
									If (IsValidRace > 2)
										If !AddOne
											AddOne = Aggressors[i]
											AddOne.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction
											AddOne.EvaluatePackage()
											DefeatConfig.Log("Multiple 1 set -> "+AddOne)
											Return
										Endif
									Elseif (IsValidRace < 3)
										If !AddOne
											AddOne = Aggressors[i]
											AddOne.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction
											AddOne.EvaluatePackage()
											DefeatConfig.Log("Multiple 1 set -> "+AddOne)
										Elseif !AddTwo
											AddTwo = Aggressors[i]
											AddTwo.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction
											AddTwo.EvaluatePackage()
											DefeatConfig.Log("Multiple 2 set -> "+AddTwo)
										Elseif !AddThree
											AddThree = Aggressors[i]
											AddThree.SetFactionRank(RessConfig.DefeatFactions[1], 2) ; AggFaction
											AddThree.EvaluatePackage()
											DefeatConfig.Log("Multiple 3 set -> "+AddThree)
											Return
										Endif
									Endif
								Endif
							Endif
						Endif
						i += 1
					EndWhile
				Endif
			Endif
		Endif
	Endif
EndFunction
Bool Function Collateral(Actor Aggressor = None, Actor Victim = None)
	If (McmConfig.CollateralAssault && !MiscScenes[3].IsPlaying() && Followers[0] && !(NumRapes >= (NumAgg * McmConfig.mnRapeNumPerAgg))) ; SCCollateral / Is there at least one follower, is a collateral scene isn't playing already or is there enough rapes in the scene already.
		Actor[] CollateralActors = New Actor[2]
		If (Aggressor && Victim)
			CollateralActors[0] = Aggressor
			CollateralActors[1] = Victim
		Else
			CollateralActors = CollateralGetActors(CollateralActors)
		Endif
		If (CollateralActors[0] && CollateralActors[1])
			CollateralActors[0].SetFactionRank(RessConfig.DefeatFactions[1], 3) ; AggFaction / Set the aggressor as collateral aggressor
			CollateralActors[1].SetFactionRank(RessConfig.DefeatFactions[0], 3) ; DefeatFaction / Set follower as collateral victim
			RessConfig.FollowerHasBeenRapedBy = RessConfig.HasBeenRapedBy(CollateralActors[1], CollateralActors[0])
			CollateralStart(CollateralActors[0], CollateralActors[1])
			Return True
		Endif
	Endif
	Return False
EndFunction
Actor[] Function CollateralGetActors(Actor[] CollaActors)
	Int i
	Int n
	While (i < 5)
		If Followers[i]
			If (!Followers[i].HasKeywordString("SexLabActive") && (Followers[i].GetFactionRank(RessConfig.DefeatFactions[0]) == 0))
				n = 0
				While (n < 5)
					If Accomplices[n]
						If ((Accomplices[n] != TheNext) && (Accomplices[n].GetDistance(Followers[i]) < FarMaxDist) && (Accomplices[n].GetFactionRank(RessConfig.DefeatFactions[1]) == 0) && \
							!Accomplices[n].HasKeywordString("SexLabActive") && !Accomplices[n].HasSpell(RessConfig.SatisfiedSPL) && RessConfig.SexCombination(Accomplices[n], Followers[i], False))
							CollaActors[0] = Accomplices[n]
							CollaActors[1] = Followers[i]
							DefeatConfig.Log("Collateral accomplice set - "+Accomplices[n])
							DefeatConfig.Log("Collateral Victim set - "+Followers[i])
							Return CollaActors
						Endif
					Endif
					n += 1
				EndWhile
				n = 0
				While (n < 5)
					If Aggressors[n]
						If ((Aggressors[n] != TheNext) && (Aggressors[n].GetDistance(Followers[i]) < FarMaxDist) && (Aggressors[n].GetFactionRank(RessConfig.DefeatFactions[1]) == 0) && \
							!Aggressors[n].HasKeywordString("SexLabActive") && !Aggressors[n].HasSpell(RessConfig.SatisfiedSPL) && RessConfig.SexCombination(Aggressors[n], Followers[i], False))
							CollaActors[0] = Aggressors[n]
							CollaActors[1] = Followers[i]
							DefeatConfig.Log("Collateral Aggressor set - "+Aggressors[n])
							DefeatConfig.Log("Collateral Victim set - "+Followers[i])
							Return CollaActors
						Endif
					Endif
					n += 1
				EndWhile
			Endif
		Endif
		i += 1
	EndWhile
	Return CollaActors
EndFunction
Function CollateralStart(Actor Aggressor, Actor Victim) ; Start a sexual aggression between the two given NPCs.
	CollaAgg.ForceRefTo(Aggressor)
	CollaVic.ForceRefTo(Victim)
	MiscScenes[3].Start() ; SCCollateral
	DefeatConfig.Log("Aggressor GetFactionRank(RessConfig.DefeatFactions[1]) - "+Aggressor.GetFactionRank(RessConfig.DefeatFactions[1]))
	DefeatConfig.Log("Victim GetFactionRank(RessConfig.DefeatFactions[1]) - "+Victim.GetFactionRank(RessConfig.DefeatFactions[0]))
	DefeatConfig.Log("Collateral start - "+Aggressor+" on "+Victim)
EndFunction
Function AnotherCollateral()
	If !(NumRapes >= (NumAgg * McmConfig.mnRapeNumPerAgg))
		MiscScenes[3].Stop() ; SCCollateral
		Wait(0.5)
		Collateral()
	Endif
EndFunction
Bool Function TheRape(Actor Victim, Actor Next, Actor AOne = None, Actor ATwo = None, Actor AThree = None)
	; 2015.07.28 / Add
;	If useRapeSpell(Next, Victim)
;		setRapedEffects(Player, Enter = True)
;		
;		Involved    = new Actor[5]
;		Involved[0] = Victim
;		Involved[1] = Next
;		Involved[2] = AOne
;		Involved[3] = ATwo
;		Involved[4] = AThree
;		
;		RessConfig.waitSexEnd(Victim)
;		
;		onFinishPlayerRape()
;		
;		Return True
;	Endif
	; 2015.07.28 / Add
	
	; 2015.08.08 / Add
	setRyonaEffects(Victim, Next, Enter = True)
	RessConfig.setRapedFaceAnimation(Victim)
	; 2015.08.08 / Add
	
	RegisterForModEvent("AnimationEnd_DefeatPvic", "EndPr")
	
	; 2015.09.01 / Add
	sslThreadModel      Make
	sslThreadController Thread
	
	Make = RessConfig.setupSexAnimThread(Victim, Next, True, False)
	
	If Make
		Thread = startSex("DefeatPvic", Make)
	Else
		Thread = None
; DEBUG
RessConfig.saveDebugStr("setupSexAnimThread() returns None.")
; DEBUG
	Endif
	; 2015.09.01 / Add
	
	; 2015.09.06 / Add
	If !Thread
; DEBUG
RessConfig.saveDebugStr("startSex() returns None.")
; DEBUG
		Return False
	Endif
	; 2015.09.06 / Add
	
;	DefeatConfig.Log("TheRape Function -> Victim - "+Victim+" / Next - "+Next+" / AOne - "+AOne+" / ATwo - "+ATwo+" / AThree - "+AThree+" / IsCreature - "+IsCreature)
;	If !IsCreature
;		sslThreadModel Make = SexLab.NewThread()
;		sslBaseAnimation[] Anims
;		Actor[] Positions = sslUtility.MakeActorArray(Victim, Next, AOne)
;		Int NumFemales = SexLab.FemaleCount(Positions)
;		If (AOne && CheckActor(Next) && CheckActor(AOne)) 						; If there is 2 human aggressors
;			Positions = SexLab.SortActors(Positions)
;			String Tag = SexLab.MakeAnimationGenderTag(Positions)
;			Anims = SexLab.GetAnimationsByTags(3, Tag)
;			If (Anims.Length == 0)
;				DefeatConfig.Log("Player as vicim, TheRape - No default animations were found because they are probably all disabled (threesomPlayer), the script will set default animations.")
;				If (NumFemales == 2) && !PlayerIsFemale ; 2 female aggressors on male player
;					Anims = new sslBaseAnimation[2]
;					Anims[0] = SexLab.GetAnimationByName("Arrok Tricycle")
;					Anims[1] = SexLab.GetAnimationByName("Zyn FemDom")
;				Else
;					Anims = new sslBaseAnimation[3]
;					Anims[0] = SexLab.GetAnimationByName("Arrok Devils Threeway")
;					Anims[1] = SexLab.GetAnimationByName("Zyn Double Penetration")
;					Anims[2] = SexLab.GetAnimationByName("DI Forced Threesome")
;				Endif
;			Endif
;			; 2015.08.03 / Mod
;;			Make.SetAnimations(Anims)
;			If !McmConfig.mDisableRapeAnimRestriction
;				Make.SetAnimations(Anims)
;			Endif
;			; 2015.08.03 / Mod
;			Make.AddActors(Positions, Victim)
;			Make.DisableUndressAnimation(Victim)
;			; 2015.07.17 / Add
;			; 2015.07.18 / Mod / Adding an if clause
;			If SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
;				Make.DisableRagdollEnd(Victim)
;			Endif
;			; 2015.07.17 / Add
;			Make.DisableRagdollEnd(Next)
;			Make.DisableRagdollEnd(AOne)
;			; 2015.07.22 / Add
;			If (Next.IsInFaction(RessConfig.mfctDwarven))
;				bool[] aStripSlots = new bool[33]
;				Make.SetStrip(Next, aStripSlots)
;			Endif
;			If (AOne.IsInFaction(RessConfig.mfctDwarven))
;				bool[] aStripSlots = new bool[33]
;				Make.SetStrip(AOne, aStripSlots)
;			Endif
;			; 2015.07.22 / Add
;			; 2015.08.01 / Del
;			; 2015.07.27 / Mod
;;			If !McmConfig.mEnableBedUse
;;				Make.DisableBedUse()
;;			Endif
;			; 2015.07.27 / Mod
;			; 2015.08.01 / Del
;			; 2015.08.01 / Mod / Using startSex()
;;			Make.SetHook("DefeatPvic")
;;			sslThreadController Thread = Make.StartThread()
;			sslThreadController Thread = startSex("DefeatPvic", Make)
;			
;			If !Thread
;				DefeatConfig.Log("Error: Human Threesome, Animation did not start / Aggressor - "+Next.GetLeveledActorBase().GetName()+" / "+Next+" & Add - "+AOne.GetLeveledActorBase().GetName()+" / "+Aone)
;				Return False
;			; 2015.08.08 / Del
;			; 2015.07.15 / Add
;;			Else
;;				setRyonaEffects(Victim, Next, Enter = True)
;;				RessConfig.setRapedFaceAnimation(Victim)
;			; 2015.07.15 / Add
;			; 2015.08.08 / Del
;			Endif
;		Elseif CheckActor(Next) 												; 1 human aggressor
;			If (McmConfig.ReverseR && (NumFemales == 1) && (SexLab.GetGender(Next) == 1))
;				Positions = SexLab.SortActors(Positions)
;				If !Tied
;					Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
;				Else
;					If RessConfig.Tied(TheNext)
;						Anims = SexLab.GetAnimationsByTags(2, "SubSub")
;					Else
;						Anims = SexLab.GetAnimationsByTags(2, "DomSub")
;					Endif
;				Endif
;				If (Anims.length == 0)
;					DefeatConfig.Log("Player as vicim, TheRape - No default animations were found because they are probably all disabled or not registered (Cowgirl or Zaz if bound), the script will set default animations.")
;					Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
;					If (Anims.length == 0)
;						Anims = new sslBaseAnimation[1]
;						Anims[0] = SexLab.GetAnimationByName("Arrok Cowgirl")
;					Endif
;				Endif
;			Elseif (McmConfig.ReverseRf && (NumFemales == 2))
;				Positions = SexLab.SortActors(Positions)
;				If !Tied
;					Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
;				Else
;					If RessConfig.Tied(TheNext)
;						Anims = SexLab.GetAnimationsByTags(2, "Lesbian,SubSub")
;					Else
;						Anims = SexLab.GetAnimationsByTags(2, "Lesbian,DomSub")
;					Endif
;				Endif
;				If (Anims.length == 0)
;					DefeatConfig.Log("Player as vicim, TheRape - No default animations were found because they are probably all disabled or not registered (Lesbian or Zaz if bound), the script will set default animations.")
;					Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
;					If (Anims.length == 0)
;						Anims = new sslBaseAnimation[1]
;						Anims[0] = SexLab.GetAnimationByName("Arrok Lesbian")
;					Endif
;				Endif
;			Else
;				If !Tied
;					Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
;				Else
;					If RessConfig.Tied(TheNext)
;						Anims = SexLab.GetAnimationsByTags(2, "SubSub")
;					Else
;						Anims = SexLab.GetAnimationsByTags(2, "DomSub")
;					Endif
;				Endif
;				If (Anims.length == 0)
;					Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
;				Endif
;			Endif
;			; 2015.08.03 / Mod
;;			Make.SetAnimations(Anims)
;			If !McmConfig.mDisableRapeAnimRestriction
;				Make.SetAnimations(Anims)
;			Endif
;			; 2015.08.03 / Mod
;			Make.AddActors(Positions, Victim)
;			Make.DisableUndressAnimation(Victim)
;			; 2015.07.17 / Add
;			; 2015.07.18 / Mod / Adding an if clause
;			If SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
;				Make.DisableRagdollEnd(Victim)
;			Endif
;			; 2015.07.17 / Add
;			Make.DisableRagdollEnd(Next)
;			; 2015.07.22 / Add
;			If (Next.IsInFaction(RessConfig.mfctDwarven))
;				bool[] aStripSlots = new bool[33]
;				Make.SetStrip(Next, aStripSlots)
;			Endif
;			; 2015.07.22 / Add
;			; 2015.08.01 / Del
;			; 2015.07.27 / Mod
;;			If !McmConfig.mEnableBedUse
;;				Make.DisableBedUse()
;;			Endif
;			; 2015.07.27 / Mod
;			; 2015.08.01 / Del
;			; 2015.08.01 / Mod / Using startSex()
;;			Make.SetHook("DefeatPvic")
;;			sslThreadController Thread = Make.StartThread()
;			sslThreadController Thread = startSex("DefeatPvic", Make)
;			
;			If !Thread
;				DefeatConfig.Log("Error: Human, Animation did not start / Aggressor - "+Next.GetLeveledActorBase().GetName()+" / "+Next)
;				Return False
;			; 2015.08.08 / Del
;			; 2015.07.15 / Add
;;			Else
;;				setRyonaEffects(Victim, Next, Enter = True)
;;				RessConfig.setRapedFaceAnimation(Victim)
;			; 2015.07.15 / Add
;			; 2015.08.08 / Del
;			Endif
;		Endif
;	Else
;		sslThreadModel Make = SexLab.NewThread()
;		sslBaseAnimation[] Anims
;		Actor[] Positions = sslUtility.MakeActorArray(Victim, Next, AOne, ATwo, AThree)
;		Positions = SexLab.SortActors(Positions)
;		String Tag = SexLab.MakeAnimationGenderTag(Positions)
;		; 2015.08.03 / Mod
;;		Make.SetAnimations(Anims)
;		If !McmConfig.mDisableRapeAnimRestriction
;			Make.SetAnimations(Anims)
;		Endif
;		; 2015.08.03 / Mod
;		Make.AddActors(Positions, Victim)
;		Make.DisableUndressAnimation(Victim)
;		; 2015.07.17 / 
;		; 2015.07.18 / Mod / Adding an if clause
;		If SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
;			Make.DisableRagdollEnd(Victim)
;		Endif
;		; 2015.07.17 / Add
;		; 2015.08.01 / Del
;		; 2015.07.27 / Mod
;;		If !McmConfig.mEnableBedUse
;;			Make.DisableBedUse()
;;		Endif
;		; 2015.07.27 / Mod
;		; 2015.08.01 / Del
;		; 2015.08.01 / Mod / Using startSex()
;;		Make.SetHook("DefeatPvic")
;;		sslThreadController Thread = Make.StartThread()
;		sslThreadController Thread = startSex("DefeatPvic", Make)
;		
;		If !Thread
;			DefeatConfig.Log("Error: Creature, Animation did not start / Aggressor - "+Next.GetLeveledActorBase().GetName()+" / "+Next)
;			Return False
;		; 2015.08.08 / Del
;		; 2015.07.15 / Add
;;		Else
;;			setRyonaEffects(Victim, Next, Enter = True)
;;			RessConfig.setRapedFaceAnimation(Victim)
;		; 2015.07.15 / Add
;		; 2015.08.08 / Del
;		Endif
;	Endif
	
	; 2015.07.25 / Add
	; 2015.07.28 / Mod
	RessConfig.waitSexEnd(Player)
	; 2015.07.28 / Mod
	
	; 2015.08.03 / Add
	SendAnimationEvent(Player, "BleedoutStop")
	Wait(0.8)
	; 2015.08.03 / Add
	setRapedEffects(Player, Enter = True)
	; 2015.07.25 / Add
	
	Return True
EndFunction

; 2015.07.28 / Add
Function onFinishPlayerRape()
	If TheNext.IsDead()
		Restored()
		Return
	Endif
	
	Int i = Involved.Length
	While (i > 0)
		i -= 1
		If (Involved[i] && (Involved[i] != Player))
;			DefeatConfig.Log("SetSatisfied & DefeatFactions[1] 0 on - "+Involved[i]) ; AggFaction
			RessConfig.SetSatisfied(Involved[i], Type = "Player Victim")
			Involved[i].SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
			AdjustIntValue(Involved[i], "RapedBy"+Player, 1)
			AdjustIntValue(Involved[i], "RapedByInScene"+Player, 1)
			ShiftLast(Involved[i])
		Endif
	EndWhile
	; 2015.07.25 / Add
	Actor   actAggressor = GetLastAggressor()
	Actor[] aAdds        = RessConfig.addAggressor(actAggressor)
	Int     nIdx         = aAdds.Length
	
	While (nIdx > 0)
		nIdx -= 1
		
		If aAdds[nIdx]
			aAdds[nIdx].PathToReference(Player, 1.0)
		Endif
	EndWhile
	; 2015.07.25 / Add
	
	; 2015.08.03 / Add
;	If !SexLabConfig.RagdollEnd || McmConfig.mEnablePcRapedAnimation
;		SendAnimationEvent(Player, "BleedoutStop")
;		Wait(0.8)
;		setRapedEffects(Player, Enter = True)
;	Endif
	
	Float nRapeAgainMin      = McmConfig.mnMinRapeAgainInterval
	Float nRapeAgainMax      = McmConfig.mnMaxRapeAgainInterval
	Float nRapeAgainInterval = RandomFloat(nRapeAgainMin, nRapeAgainMax)
	Wait(nRapeAgainInterval)
	; 2015.08.03 / Add
	
	Player.RemoveSpell(RessConfig.MiscSpells[1]) ; DebuffConsSPL
	RessConfig.Weakenings(Player, "Player Victim")
	If !Player.HasMagicEffect(RessConfig.MiscMagicEffects[0]) ; ImmunityEFF Check if a NPC has rescued the player or has been hit
		If NoTrans ; If setting is set to "No Transition"
			; 2015.07.18 / Mod / Add an if condition, !McmConfig.mEnablePcRapedAnimation
			If SexLabConfig.RagdollEnd && !McmConfig.mEnablePcRapedAnimation
				SetPlayerAiDriven(False) ; For the player to get up properly
				RegisterForAnimationEvent(Player, "GetUpEnd")
			Else
				If !RessConfig.IsClothed(Player)
					RessConfig.CoverSelf(Player)
				Endif
				NoTrans = False
				Restored()
			Endif
			UnregisterForModEvent("AnimationEnd_DefeatPvic")
			; 2015.08.01 / Add
			stopSex("DefeatPvic")
			; 2015.08.01 / Add
			Return
		Endif
		AnotherTurn(Player)
		TheNext = None
		AddOne = None
		AddTwo = None
		AddThree = None
		DisablePlayerControls(0, 1, 1, 0, 1, 1, 0, 0) ; Re-disable some commands after SexLab, at this point the player should still be ai driven
		; 2015.07.15 / Add
;		setRapedEffects(Player, Enter = False)
		; 2015.07.15 / Add
		; 2015.07.17 / Mod
		; 2015.07.18 / Mod / Add an if condition, !McmConfig.mEnablePcRapedAnimation
		If SexLabConfig.RagdollEnd && !McmConfig.mEnablePcRapedAnimation
			SetPlayerAiDriven(False) ; For the player to get up properly
			RegisterForAnimationEvent(Player, "GetUpEnd")
		Else
			Transition()
		Endif
		; 2015.07.17 / Mod
		UpdatePackages()
	Else
		; 2015.07.18 / Mod / Add an if condition, !McmConfig.mEnablePcRapedAnimation
		If SexLabConfig.RagdollEnd && !McmConfig.mEnablePcRapedAnimation
			Wait(4.0)
			Restored()
		Else
			Restored()
		Endif
	Endif
	UnregisterForModEvent("AnimationEnd_DefeatPvic")
	; 2015.08.01 / Add
	stopSex("DefeatPvic")
	; 2015.08.01 / Add
EndFunction
; 2015.07.28 / Add

Event EndPr(string EventName, string argString, Float argNum, form sender)					;===== END EVENTS
	If TheNext.IsDead()
		Restored()
		Return
	Endif
	
	Involved = SexLab.HookActors(argString)
	
	onFinishPlayerRape()
EndEvent
Function Consensual(Actor Victim, Actor Aggressor)
	RegisterForModEvent("AnimationEnd_DefeatPvic", "EndConsensual")
	
	; 2015.09.01 / Add
	sslThreadModel      Make
	sslThreadController Thread
	
	Make = RessConfig.setupSexAnimThread(Victim, Aggressor, True, False, "Consensual")
	
	If Make
		Thread = startSex("DefeatPvic", Make)
	Else
		Thread = None
; DEBUG
RessConfig.saveDebugStr("setupSexAnimThread() returns None.")
; DEBUG
	Endif
	; 2015.09.01 / Add
	
;	sslThreadModel Make = SexLab.NewThread()
;	Actor[] Positions = sslUtility.MakeActorArray(Victim, Aggressor)
;	Positions = SexLab.SortActors(Positions)
;	Make.AddActors(Positions)
;	Make.DisableRagdollEnd(Aggressor)
;	; 2015.07.22 / Add
;	If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;		bool[] aStripSlots = new bool[33]
;		Make.SetStrip(Aggressor, aStripSlots)
;	Endif
;	; 2015.07.22 / Add
;	; 2015.07.17 / Add
;	; 2015.07.18 / Mod / Adding an if clause
;	If SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
;		Make.DisableRagdollEnd(Victim)
;	Endif
;	; 2015.07.17 / Add
;	; 2015.08.01 / Mod / Using startSex()
;;	Make.SetHook("DefeatPvic")
;;	sslThreadController Thread = Make.StartThread()
;	sslThreadController Thread = startSex("DefeatPvic", Make)
	
	; 2015.07.25 / Add
	; 2015.08.01 / Mod / Using waitSexEnd()
	RessConfig.waitSexEnd(Victim)
	
	; 2015.08.03 / Add
	SendAnimationEvent(Player, "BleedoutStop")
	Wait(0.8)
	; 2015.08.03 / Add
	setRapedEffects(Player, Enter = True)
	; 2015.07.25 / Add
EndFunction
Event EndConsensual(string EventName, string argString, Float argNum, form sender)
	; 2015.08.03 / Add
;	If !SexLabConfig.RagdollEnd || McmConfig.mEnablePcRapedAnimation
;		SendAnimationEvent(Player, "BleedoutStop")
;		setRapedEffects(Player, Enter = True)
;	Endif
	; 2015.08.03 / Add
	RessConfig.SetSatisfied(TheNext, Type = "Player Victim")
	TheNext.SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
;	AdjustIntValue(TheNext, "RapedBy"+Player, 1)
	AdjustIntValue(TheNext, "RapedByInScene"+Player, 1)
	ShiftLast(TheNext)
	RessConfig.Weakenings(Player, "Player Victim")
	AnotherTurn(Player)
	TheNext = None
	DisablePlayerControls(0, 1, 1, 0, 1, 1, 0, 0) ; Re-disable some commands after SexLab, at this point the player should still be ai driven
	; 2015.07.15 / Add
;	setRapedEffects(Player, Enter = False)
	; 2015.07.15 / Add
	; 2015.07.17 / Mod
	; 2015.07.18 / Mod / Add an if condition, !McmConfig.mEnablePcRapedAnimation
	If SexLabConfig.RagdollEnd && !McmConfig.mEnablePcRapedAnimation
		SetPlayerAiDriven(False) ; For the player to get up properly
		RegisterForAnimationEvent(Player, "GetUpEnd")
	Else
		Transition()
	Endif
	; 2015.07.17 / Mod
	UnregisterForModEvent("AnimationEnd_DefeatPvic")
	; 2015.08.01 / Add
	stopSex("DefeatPvic")
	; 2015.08.01 / Add
EndEvent
Function BlowJob(Actor Victim, Actor Aggressor)
	RegisterForModEvent("AnimationEnd_DefeatPvic", "EndBJ")
	
	; 2015.09.01 / Add
	sslThreadModel      Make
	sslThreadController Thread
	
	Make = RessConfig.setupSexAnimThread(Victim, Aggressor, True, False, "Blowjob")
	
	If Make
		Thread = startSex("DefeatPvic", Make)
	Else
		Thread = None
; DEBUG
RessConfig.saveDebugStr("setupSexAnimThread() returns None.")
; DEBUG
	Endif
	; 2015.09.01 / Add
	
;	sslThreadModel Make = SexLab.NewThread()
;	Actor[] Positions = sslUtility.MakeActorArray(Victim, Aggressor)
;	Positions = SexLab.SortActors(Positions)
;	sslBaseAnimation[] Anims = (SexLab.GetAnimationsByTags(2, "Blowjob,MF", "Vaginal,Anal,69"))
;	If (Anims.length == 0)
;		Anims = new sslBaseAnimation[2]
;		Anims[0] = SexLab.GetAnimationByName("Arrok Blowjob")
;		Anims[1] = SexLab.GetAnimationByName("DI Blowjob")
;	Endif
;	; 2015.08.03 / Mod
;;	Make.SetAnimations(Anims)
;	If !McmConfig.mDisableRapeAnimRestriction
;		Make.SetAnimations(Anims)
;	Endif
;	; 2015.08.03 / Mod
;	Make.AddActors(Positions)
;	Make.DisableRagdollEnd(Aggressor)
;	; 2015.07.22 / Add
;	If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;		bool[] aStripSlots = new bool[33]
;		Make.SetStrip(Aggressor, aStripSlots)
;	Endif
;	; 2015.07.22 / Add
;	Make.DisableUndressAnimation(Victim, True)
;	; 2015.07.17 / Add
;	; 2015.07.18 / Mod / Adding an if clause
;	If SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
;		Make.DisableRagdollEnd(Victim)
;	Endif
;	; 2015.07.17 / Add
;	; 2015.08.01 / Del
;	; 2015.07.27 / Mod
;;	If !McmConfig.mEnableBedUse
;;		Make.DisableBedUse()
;;	Endif
;	; 2015.07.27 / Mod
;	; 2015.08.01 / Del
;	; 2015.08.01 / Mod / Using startSex()
;;	Make.SetHook("DefeatPvic")
;;	sslThreadModel Thread = Make.StartThread()
;	sslThreadController Thread = startSex("DefeatPvic", Make)
	
	; 2015.07.25 / Add
	; 2015.08.01 / Mod / Using waitSexEnd()
	RessConfig.waitSexEnd(Victim)
	
	; 2015.08.03 / Add
	SendAnimationEvent(Player, "BleedoutStop")
	Wait(0.8)
	; 2015.08.03 / Add
	setRapedEffects(Player, Enter = True)
	; 2015.07.25 / Add
EndFunction
Event EndBJ(string EventName, string argString, Float argNum, form sender)
	; 2015.08.03 / Add
;	If !SexLabConfig.RagdollEnd || McmConfig.mEnablePcRapedAnimation
;		SendAnimationEvent(Player, "BleedoutStop")
;		setRapedEffects(Player, Enter = True)
;	Endif
	; 2015.08.03 / Add
	RessConfig.SetSatisfied(TheNext, Type = "Player Victim")
	TheNext.SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
;	AdjustIntValue(TheNext, "RapedBy"+Player, 1)
	AdjustIntValue(TheNext, "RapedByInScene"+Player, 1)
	ShiftLast(TheNext)
;	RessConfig.Weakenings(Player, "Player Victim")
	AnotherTurn(Player)
	TheNext = None
	DisablePlayerControls(0, 1, 1, 0, 1, 1, 0, 0) ; Re-disable some commands after SexLab, at this point the player should still be ai driven
	; 2015.07.15 / Add
;	setRapedEffects(Player, Enter = False)
	; 2015.07.15 / Add
	; 2015.07.17 / Mod
	; 2015.07.18 / Mod / Add an if condition, !McmConfig.mEnablePcRapedAnimation
	If SexLabConfig.RagdollEnd && !McmConfig.mEnablePcRapedAnimation
		SetPlayerAiDriven(False) ; For the player to get up properly
		RegisterForAnimationEvent(Player, "GetUpEnd")
	Else
		Transition()
	Endif
	; 2015.07.17 / Mod
	UnregisterForModEvent("AnimationEnd_DefeatPvic")
	; 2015.08.01 / Add
	stopSex("DefeatPvic")
	; 2015.08.01 / Add
EndEvent
Function CollateralRape(Actor Victim, Actor Aggressor)
	; 2015.07.17 / Add
	If Victim != Player
		; 2015.08.01 / Add
		; 2015.08.07 / Add
		Bool enableRagdoll = McmConfig.mEnableStruggleRagdoll
		; 2015.08.07 / Add
		; 2015.08.20 / Add
		Int  nStruggleChance = McmConfig.mnNpcStruggleChance
		; 2015.08.20 / Add
		
		; 2015.08.20 / Mod / Using nStruggleChance
		If (RandomInt(1, 100) < nStruggleChance)
			; 2015.08.07 / Mod / Adding the another motion
			If enableRagdoll
				Aggressor.pushActorAway(Victim, 2)
			Else
				RessConfig.startWeakenAnimation(Victim)
			Endif
			
			Wait(2.6)
			RessConfig.StruggleAnim(Victim, Aggressor, Animate = True)
			Wait(8.0)
			SendAnimationEvent(Aggressor, "IdleForceDefaultState")
			; 2015.09.03 / Add
			SendAnimationEvent(Victim, "IdleWounded_02")
			RessConfig.StruggleAnim(Victim, Aggressor, Animate = False)
			; 2015.09.03 / Add
			; 2015.08.01 / Add
		Endif
		; 2015.08.20 / Mod / Using nStruggleChance
		
		; 2015.07.18 / Add
		If (Victim.HasSpell(RessConfig.ExhaustedSPL))
			RessConfig.Trauma(Victim, Type = "Follower")
		Elseif (McmConfig.bExhaustedPvic && Victim.HasSpell(RessConfig.TraumaSPL))
			RessConfig.Exhausted(Victim, Type = "Follower")
		; 2015.07.18 / Add
		; 2015.07.18 / Mod / If -> Elseif
		Elseif (McmConfig.bExhaustedPvic && (RandomInt(0, 1) == 0))
			RessConfig.Exhausted(Victim, Type = "Follower")
		Else
			RessConfig.Trauma(Victim, Type = "Follower")
		Endif
		
		; 2015.08.08 / Add
		RessConfig.setRapedFaceAnimation(Victim, Enter = True)
		; 2015.08.08 / Add
	Endif
	; 2015.07.17 / Add
	; 2015.07.28 / Add
;	If useRapeSpell(Aggressor, Victim)
;		Involved    = new Actor[2]
;		Involved[0] = Aggressor
;		Involved[1] = Victim
;		
;		RessConfig.RemoveStates(Victim, False)
;		NumRapes += 1
;		AnotherCollateral()
;		
;		RessConfig.waitSexEnd(Victim)
;		
;		onFinishCollateralRape(Victim)
;		
;		Return
;	Endif
	; 2015.07.28 / Add
	RegisterForModEvent("AnimationEnd_Collateral", "CollaEnd")
;	sslThreadModel Make = SexLab.NewThread()
;	sslBaseAnimation[] Anims
;	
;	Actor[] Positions = sslUtility.MakeActorArray(Victim, Aggressor)
;	Positions = SexLab.SortActors(Positions)
;	Bool IsTied = RessConfig.Tied(Victim)
;	If !IsTied
;		Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
;	Else
;		Anims = SexLab.GetAnimationsByTags(2, "Aggressive,Bound")
;	Endif
;	Int NumFemales = SexLab.FemaleCount(Positions)
;	DefeatConfig.Log("CollateralRape ReverseR - "+McmConfig.ReverseR+" / NumFemales - "+NumFemales+" / SexLab.GetGender(Aggressor) == 1 - "+(SexLab.GetGender(Aggressor) == 1)+" / Positions - "+Positions)
;	If (McmConfig.ReverseR && (NumFemales == 1) && (SexLab.GetGender(Aggressor) == 1))
;		If !IsTied
;			Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
;		Else
;			If RessConfig.Tied(Aggressor)
;				Anims = SexLab.GetAnimationsByTags(2, "SubSub")
;			Else
;				Anims = SexLab.GetAnimationsByTags(2, "DomSub")
;			Endif
;		Endif
;		If (Anims.length == 0)
;			Anims = new sslBaseAnimation[1]
;			Anims[0] = SexLab.GetAnimationByName("Arrok Cowgirl")
;		Endif
;	Elseif (McmConfig.ReverseRf && (NumFemales == 2))
;		If !IsTied
;			Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
;		Else
;			Anims = SexLab.GetAnimationsByTags(2, "Lesbian,Bound")
;		Endif
;		If (Anims.length == 0)
;			Anims = new sslBaseAnimation[1]
;			Anims[0] = SexLab.GetAnimationByName("Arrok Lesbian")
;		Endif
;	Endif
;	; 2015.08.06 / Add / DEBUG
;;	Anims = new sslBaseAnimation[1]
;;	Anims[0] = ExtAnimSlot.GetAnimationByName("Necro Missionary")
;	; 2015.08.06 / Add / DEBUG
;	; 2015.08.03 / Add
;	If !McmConfig.mDisableRapeAnimRestriction
;;		Make.AddActor(Victim, isVictim = True)
;;		Make.AddActor(Aggressor)
;;		
;;		Actor[] aRapers = RessConfig.findRapers(Aggressor, Victim, True)
;;		Int nRaperIdx   = aRapers.Length
;;		
;;		While (nRaperIdx > 0)
;;			nRaperIdx -= 1
;;			
;;			If aRapers[nRaperIdx]
;;				Make.AddActor(aRapers[nRaperIdx])
;;			Endif
;;		EndWhile
;;		
;		Make.SetAnimations(Anims)
;;	Else
;;		Make.AddActors(Positions, Victim)
;	Endif
;	; 2015.08.03 / Add
;	Make.AddActors(Positions, Victim)
;	Make.DisableUndressAnimation(Victim)
;	Make.DisableRagdollEnd(Aggressor)
;	; 2015.07.22 / Add
;	If (Aggressor.IsInFaction(RessConfig.mfctDwarven))
;		bool[] aStripSlots = new bool[33]
;		Make.SetStrip(Aggressor, aStripSlots)
;	Endif
	; 2015.07.22 / Add
	; 2015.08.01 / Del
	; 2015.07.27 / Mod
;	If !McmConfig.mEnableBedUse
;		Make.DisableBedUse()
;	Endif
	; 2015.07.27 / Mod
	; 2015.08.01 / Del
	; 2015.08.01 / Mod / Using startSex()
;	Make.SetHook("Collateral")
;	sslThreadController Thread = Make.StartThread()
;	sslThreadController Thread = startSex("Collateral", Make)

	; 2015.09.01 / Add
	sslThreadModel      Make
	sslThreadController Thread
	
	Make = RessConfig.setupSexAnimThread(Victim, Aggressor, True, False)
	
	If Make
		Thread = startSex("Collateral", Make)
	Else
		Thread = None
;		Notification("setupSexAnimThread returns None.")
	Endif
	; 2015.09.01 / Add
	
	If !Thread
		Aggressor.SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
		Victim.SetFactionRank(RessConfig.DefeatFactions[0], 0) ; DefeatFaction
		DefeatConfig.Log("Error: Collateral, Animation did not start / Aggressor - "+Aggressor.GetLeveledActorBase().GetName()+" / "+Aggressor)
; DEBUG
RessConfig.saveDebugStr("Error: Collateral, Animation did not starts.")
; DEBUG
	Else
		RessConfig.RemoveStates(Victim, False)
		NumRapes += 1
		AnotherCollateral()
	Endif
EndFunction

; 2015.08.01 / Add
sslThreadController Function startSex(String szID, sslThreadModel oModel)
	; Disable BedUse
	If !McmConfig.mEnableBedUse
		oModel.DisableBedUse()
	Endif
	
	; Set Hook
	oModel.SetHook(szID)
	RegisterForModEvent("StageStart_"+szID,  "onStartStage")
	RegisterForModEvent("OrgasmStart_"+szID, "onStartOrgasm")
	
	; Start and Return
	Return oModel.StartThread()
EndFunction

Function stopSex(String szID)
	; Unregister
	UnregisterForModEvent("StageStart_"+szID)
	UnregisterForModEvent("OrgasmStart_"+szID)
	
	; Stop
	Return
EndFunction

Event onStartStage(string EventName, string argString, float argNum, form sender)
;	Notification("onStartStage")

	sslThreadController oThread   = SexLabUtil.GetAPI().HookController(argString)
	Actor               actVictim = SexLabUtil.GetAPI().HookVictim(argString)
	Actor[]             aActors   = SexLabUtil.GetAPI().HookActors(argString)
	
	RessConfig.randomizeSex(oThread, actVictim, aActors)
EndEvent

Event onStartOrgasm(string EventName, string argString, float argNum, form sender)
;	Notification("onStartOrgasm")

	sslThreadController oThread   = SexLabUtil.GetAPI().HookController(argString)
	Actor               actVictim = SexLabUtil.GetAPI().HookVictim(argString)
	Actor[]             aActors   = SexLabUtil.GetAPI().HookActors(argString)
	
	RessConfig.randomizeSex(oThread, actVictim, aActors)
EndEvent
; 2015.08.01 / Add

; 2015.07.28 / Add
Bool Function useRapeSpell(Actor actAggressor, Actor actVictim)
	Bool  isUsed          = False
	Bool  enableRapeSpell = McmConfig.mEnableReplaceRapeSpell
	Spell splRape         = RessConfig.msplRapeAlt
	
	If splRape && enableRapeSpell
		splRape.Cast(actAggressor, actVictim)
		isUsed = True
	Endif
	
	Return isUsed
EndFunction

Function onFinishCollateralRape(Actor TheVic)
	; 2015.07.07 / Add
	Actor Aggressor
	; 2015.07.07 / Add
	If (GetState() == "FollowerWait")
		Collateral() ; Start another collateral before the player get out of the waiting state
	Endif
	Int i = Involved.Length
	While (i > 0)
		i -= 1
		If (Involved[i] && (Involved[i] != TheVic))
			; 2015.07.07 / Add
			Aggressor = Involved[i]
			; 2015.07.07 / Add
;			DefeatConfig.Log("CollaEnd SetSatisfied & DefeatFactions[1] 0 on - "+Involved[i]) ; AggFaction
			RessConfig.SetSatisfied(Involved[i], Type = "Player Victim")
			Involved[i].SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
			AdjustIntValue(Involved[i], "RapedBy"+TheVic, 1)
		Endif
	EndWhile
	TheVic.SetFactionRank(RessConfig.DefeatFactions[0], 0)
	AnotherTurn(TheVic)
	If SexLabConfig.RagdollEnd
		RegisterForAnimationEvent(TheVic, "GetUpEnd")
	Else
		; 2015.07.21 / Add
		; 2015.08.07 / Mod / Using startWeakenAnimation()
		RessConfig.startWeakenAnimation(TheVic)
		; 2015.07.21 / Add
		; 2015.07.16 / Mod
		; 2015.07.18 / Add
		If (TheVic.HasSpell(RessConfig.ExhaustedSPL))
			RessConfig.Trauma(TheVic, Type = "Follower")
		Elseif (McmConfig.bExhaustedPvic && TheVic.HasSpell(RessConfig.TraumaSPL))
			RessConfig.Exhausted(TheVic, Type = "Follower")
		; 2015.07.18 / Add
		; 2015.07.18 / Mod / If -> Elseif
		Elseif (McmConfig.bExhaustedPvic && (RandomInt(0, 1) == 0))
;			RessConfig.Exhausted(TheVic, Duration = 60.0, Type = "Player Victim")
			RessConfig.Exhausted(TheVic, Type = "Follower")
		Else
;			RessConfig.Trauma(TheVic, Duration = 60.0, Type = "Player Victim")
			RessConfig.Trauma(TheVic, Type = "Follower")
		Endif
		; 2015.07.16 / Mod
		; 2015.07.07 / Add
		Wait(1.0)

		If (RandomFloat(1.0, 100.0) < McmConfig.mnTieupRatio && Aggressor && Aggressor.HasKeyWordString("ActorTypeNPC"))
			Notification(TheVic.GetActorBase().GetName()+" has been tied up.")
			TheVic.Say(RessConfig.TopicToSay[3], TheVic)
			RessConfig.TieUp(TheVic, Aggressor, DoAnimation = McmConfig.bTieUpAnim)
			; 2015.08.31 / Add
			RessConfig.Strip(TheVic)
			; 2015.08.31 / Add
		Endif
		
		; 2015.07.21 / Add
		RessConfig.forceResetAnimation(TheVic)
		; 2015.07.21 / Add
		
		Wait(1.0)
		; 2015.07.07 / Add
		TheVic.EvaluatePackage()
		; 2015.07.02 / Del
;		RessConfig.Weakenings(TheVic, "Follower")
		; 2015.07.02 / Del
		If IsSurrender
			If (GetState() == "StruggleFree")
				TheNext = None
				If SetNextAgg()
					SetAdds()
					GoToState("Pursuit")
				Endif
			Endif
		Elseif (GetState() != "FollowerWait")
			Collateral() ; another aggressor up?
		Endif
	Endif
	UpdatePackages()
EndFunction
; 2015.07.28 / Add
Event CollaEnd(string EventName, string argString, Float argNum, form sender)
	Actor TheVic = SexLab.HookVictim(argString)
	Involved     = SexLab.HookActors(argString)
	
	; 2015.07.28 / Mod
	onFinishCollateralRape(TheVic)
	; 2015.07.28 / Mod
EndEvent

; 2015.07.22 / Add
Int[] Property maRyonaMapIDs Auto Hidden Conditional
; 2015.07.22 / Add

; 2015.07.14 / Add
Function setRyonaEffects(Actor actVictim, Actor actAggressor = None, Bool Enter = true)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int nIdx
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !RessConfig.STTon
		Return
	Endif
	
	;-------------------------------------------------------
	; Add/Remove tattoo
	;-------------------------------------------------------
	; 2015.07.22 / Mod / Using maRyonaMapIDs
	If Enter && McmConfig.mEnableRyona
		; Release MapIDs
		RessConfig.releaseRyonaMapIDs(actVictim, maRyonaMapIDs)
		
		; Get and add Maps
		maRyonaMapIDs = RessConfig.getRyonaMapID(actVictim, actAggressor)
	Else
		; Release MapIDs
		RessConfig.releaseRyonaMapIDs(actVictim, maRyonaMapIDs)
		
		; Remove Ryona effects
;		RessConfig.removeRyonaEffects(actVictim)
		
		; Clear MapIDs
		nIdx = maRyonaMapIDs.Length
		
		While (nIdx > 0)
			nIdx -= 1
			
			maRyonaMapIDs[nIdx] = 0
		EndWhile
	Endif
	; 2015.07.22 / Mod / Using maRyonaMapIDs
EndFunction
; 2015.07.14 / Add

Event OnAnimationEvent(ObjectReference akSource, string asEventNaPlayer)
	; 2015.07.08 / Add
	Actor Aggressor
	Int   nIdx       = Involved.Length
	; 2015.07.11 / Mod / Using McmConfig
	
	; 2015.07.15 / Mod / Using GetLastAggressor()
	Aggressor = GetLastAggressor()
	; 2015.07.08 / Add
	If (akSource == Player)
		UnregisterForAnimationEvent(Player, "GetUpEnd")
		If Raped
			If NoTrans
				NoTrans = False
				; 2015.07.08 / Mod
;				RessConfig.DefeatPlayAnimation(Player, "Stand")
				RessConfig.DefeatPlayAnimation(Player, "Trauma Stand")
				; 2015.07.08 / Mod
				; 2015.07.14 / Add
				setRyonaEffects(Player, Aggressor, Enter = True)
				RessConfig.setRapedFaceAnimation(Player)
				; 2015.07.14 / Add
				If McmConfig.SlowDown
					RessConfig.MiscSpells[2].Cast(Player) ; DebuffSpeedSPL
				Endif
				Restored()
			Else
				; 2015.07.25 / Del
				; 2015.07.17 / Add
;				setRapedEffects(Player, Enter = True)
				; 2015.07.17 / Add
				; 2015.07.25 / Del
				Transition()
			Endif
		Else
			If AllowStaydown()
				; 2015.07.08 / Mod
;				RessConfig.DefeatPlayAnimation(Player, "Stand")
				RessConfig.DefeatPlayAnimation(Player, "Trauma Stand")
				; 2015.07.08 / Mod
			Endif
			Restored()
		Endif
	Else
		Actor TheVic = (akSource as Actor)
		UnregisterForAnimationEvent(TheVic, "GetUpEnd")
		; 2015.07.21 / Add
		; 2015.08.07 / Mod / Using startWeakenAnimation()
		RessConfig.startWeakenAnimation(TheVic)
		; 2015.07.21 / Add
		; 2015.07.17 / Mod
		; 2015.07.18 / Add
		If (TheVic.HasSpell(RessConfig.ExhaustedSPL))
			RessConfig.Trauma(TheVic, Type = "Follower")
		Elseif (McmConfig.bExhaustedPvic && TheVic.HasSpell(RessConfig.TraumaSPL))
			RessConfig.Exhausted(TheVic, Type = "Follower")
		; 2015.07.18 / Add
		; 2015.07.18 / Mod / If -> Elseif
		Elseif (McmConfig.bExhaustedPvic && (RandomInt(0, 1) == 0))
;			RessConfig.Exhausted(TheVic, Duration = 60.0)
			RessConfig.Exhausted(TheVic, Type = "Follower")
		Else
;			RessConfig.Trauma(TheVic, Duration = 60.0)
			RessConfig.Trauma(TheVic, Type = "Follower")
		Endif
		; 2015.07.17 / Mod
		; 2015.07.07 / Add
		Wait(1.0)

		If (RandomFloat(1.0, 100.0) < McmConfig.mnTieupRatio) && Aggressor && Aggressor.HasKeyWordString("ActorTypeNPC")
			Notification(TheVic.GetActorBase().GetName()+" has been tied up.")
			TheVic.Say(RessConfig.TopicToSay[3], TheVic)
			RessConfig.TieUp(TheVic, Aggressor, DoAnimation = McmConfig.bTieUpAnim)
		Endif
		
		; 2015.07.21 / Add
		RessConfig.forceResetAnimation(TheVic)
		; 2015.07.21 / Add
		
		Wait(1.0)
		; 2015.07.07 / Add
		TheVic.EvaluatePackage()
		; 2015.07.07 / Del
;		RessConfig.Weakenings(TheVic, "Follower")
		; 2015.07.07 / Del
		AnotherTurn(TheVic)
		If IsSurrender
			If (GetState() == "StruggleFree")
				TheNext = None
				If SetNextAgg()
					SetAdds()
					GoToState("Pursuit")
				Endif
			Endif
		Else
			Collateral() ; another client for the follower?
		Endif
	Endif
EndEvent
Function AnotherTurn(Actor Victim)
	If (McmConfig.AgainChance > 0)
		Int i
		Int n = Involved.Length
		While (i < n)
			If (Involved[i] && (Involved[i] != Victim))
				If (RandomInt(0, 100) < McmConfig.AgainChance)
					RessConfig.SetSatisfied(Involved[i], Satisfied = False)
					Involved[i].SetFactionRank(RessConfig.DefeatFactions[1], 0) ; AggFaction
					ShiftLast(Involved[i])
				Endif
			Endif
			i += 1
		EndWhile
	Endif
EndFunction
Function ShiftLast(Actor Agg)
	Int i
	If (Accomplices.Find(Agg) != -1)
		While (i < 5)
			If Accomplices[i + 1]
				Accomplices[i] = Accomplices[i + 1]
			Else
				Accomplices[i] = Agg
				Return
			Endif
			i += 1
		EndWhile
	Else
		While (i < 5)
			If Aggressors[i + 1]
				Aggressors[i] = Aggressors[i + 1]
			Else
				Aggressors[i] = Agg
				Return
			Endif
			i += 1
		EndWhile
	Endif
EndFunction
Function Transition()
	If McmConfig.DamageStamina
		Player.DamageActorValue("Stamina", Player.GetActorValue("Stamina"))
	Endif
	; 2015.07.14 / Add
;	If !SexLabConfig.RagdollEnd
		; 2015.07.18 / Del
;		Wait(4.4)
		; 2015.07.18 / Del
		; 2015.07.25 / Del
;		setRapedEffects(Player, Enter = True)
		; 2015.07.25 / Del
;	EndIf
	; 2015.07.14 / Add
	If SetNextAgg()
		If AllowStaydown()
			SetPlayerAiDriven()
			RessConfig.DefeatPlayAnimation(Player, "Lie")
		Else
			; 2015.07.14 / Add
			setRapedEffects(Player, Enter = False)
			; 2015.07.14 / Add
			SetPlayerAiDriven(False)	; Allow the player to run away
			If !RessConfig.IsClothed(Player)
				RessConfig.CoverSelf(Player)
			Endif
		Endif
		Collateral()
		SetAdds()
		GoToState("Pursuit")
	Else
		SetPlayerAiDriven()
		Persuer = TheLast
		GoToState("AssaultMode")
	Endif
	UnregisterForModEvent("AnimationEnd_DefeatPvic")
	; 2015.08.01 / Add
	stopSex("DefeatPvic")
	; 2015.08.01 / Add
EndFunction
;===== STRIPPING =====
Function Strip(Actor Vic, Actor Agg)
	Agg.SetAngle(0.0, 0.0, Agg.GetAngleZ() + Agg.GetHeadingAngle(Vic))
	If (Player.GetItemCount(MiscFormLists[0].GetAt(0) As Form) > 0) ; MiscStuff/Sack
		RessConfig.ActionQst.OptionOutOfBag(Player, True)
	Endif
	If !NoTrans
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[1], Armor.GetMaskForSlot(McmConfig.SSPvic[0] As Int))
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[2], Armor.GetMaskForSlot(McmConfig.SSPvic[1] As Int))
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[3], Armor.GetMaskForSlot(McmConfig.SSPvic[2] As Int))
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[4], Armor.GetMaskForSlot(McmConfig.SSPvic[3] As Int))
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[5], Armor.GetMaskForSlot(McmConfig.SSPvic[4] As Int))
		Weapon Equipped = Vic.GetEquippedWeapon()
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[0], 0, Equipped)
		Equipped = Vic.GetEquippedWeapon(True)
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[0], 0, Equipped)
		Armor Shield = Vic.GetEquippedShield()
		PieceToStrip(Vic, Agg, McmConfig.SSPvicSet[0], 0, Shield)
	Endif
EndFunction
Function StripColla(Actor Vic, Actor Agg)
	Agg.SetAngle(0.0, 0.0, Agg.GetAngleZ() + Agg.GetHeadingAngle(Vic))
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[1], Armor.GetMaskForSlot(McmConfig.SSNVN[0] As Int))
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[2], Armor.GetMaskForSlot(McmConfig.SSNVN[1] As Int))
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[3], Armor.GetMaskForSlot(McmConfig.SSNVN[2] As Int))
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[4], Armor.GetMaskForSlot(McmConfig.SSNVN[3] As Int))
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[5], Armor.GetMaskForSlot(McmConfig.SSNVN[4] As Int))	
	Weapon Equipped = Vic.GetEquippedWeapon()
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[0], 0, Equipped)
	Equipped = Vic.GetEquippedWeapon(True)
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[0], 0, Equipped)
	Armor Shield = Vic.GetEquippedShield()
	PieceToStrip(Vic, Agg, McmConfig.SSNVNSet[0], 0, Shield)
EndFunction
Function PieceToStrip(Actor Vic, Actor Agg, String Way, Int Slot, Form Weapons = None, Float WaitTime = 1.5, String Animation = "DefeatPickUp")
	Form Equipped
	If Weapons
		Equipped = Weapons
	Else
		Equipped = Vic.GetWornForm(Slot)
	Endif
	If (Equipped && (Way != "$Disabled"))
		If !Equipped.HasKeyWordString("SexLabNoStrip")
			If (Slot == 0x00000004)
				Animation = "DefeatStripAnim"
				WaitTime = 2.5
			Endif
			SendAnimationEvent(Agg, Animation)
			Wait(WaitTime)
			If (Way == "$UNEQUIP")
				Vic.UnequipItem(Equipped, False, True)
			Elseif ((Way == "$STEAL") && !IsCreature)
				Vic.RemoveItem(Equipped, 1, True, Agg)
			Else
				MiscFormLists[1].AddForm(Equipped) ; StrippedStuff
				Vic.UnequipItem(Equipped, False, True)
				Vic.DropObject(Equipped)
			Endif
		Endif
	Endif
EndFunction	
Function RecoverStuff(Actor Target)
	Cell c = Target.GetParentCell()
	Int NumRefs = c.GetNumRefs(26) ; 41 Weapon ; Armor = 26
	; 2015.09.03 / Add
	Bool isDroppedArm
	Bool isDroppedWpn
	; 2015.09.03 / Add
	
	While NumRefs 
		NumRefs -= 1
		Form TheArmor = (c.GetNthRef(NumRefs, 26))
		; 2015.09.03 / Mod / Changing the condition because Find() returns integer.
		isDroppedArm = (MiscFormLists[1].Find(TheArmor) >= 0)
		
		If isDroppedArm ; StrippedStuff
 			Target.AddItem(TheArmor, abSilent = True)
		Endif
	EndWhile
	NumRefs = c.GetNumRefs(41)
	While NumRefs 
		NumRefs -= 1
		Form TheWeapon = (c.GetNthRef(NumRefs, 41))
		; 2015.09.03 / Mod / Changing the condition because Find() returns integer.
		isDroppedWpn = (MiscFormLists[1].Find(TheWeapon) >= 0)
		
		If isDroppedWpn ; StrippedStuff
 			Target.AddItem(TheWeapon, abSilent = True)
		Endif
	EndWhile
EndFunction
State FollowerWait
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State FollowerWait starts.")
; DEBUG
		FillDifficulty = 0.008
		StruggleBar()
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		If (StruggleBar.Percent >= 1.0)
			Restored()
			; 2015.07.15 / Mod
;			RessConfig.DefeatPlayAnimation(Player, "Stand")
			RessConfig.DefeatPlayAnimation(Player, "Trauma Stand")
			; 2015.07.15 / Mod
			Return
		Endif
		If !StillBusy()
			Wait(4.0)
			GoToState("AssaultMode")
			Return
		Elseif Supervisor()
			If Input.IsKeyPressed(StrafeL) || Input.IsKeyPressed(StrafeR)
				Notification("$An aggressor watches you.")
				StruggleBar.Percent -= 0.2
				If (StruggleBar.Percent < 0)
					StruggleBar.Percent = 0
				Endif
			Endif
		Endif
		RegisterForSingleUpdate(2.0)
	EndEvent
	Event OnEndState()
		StruggleBar(False)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StrafeL) && LeftRight)
			LeftRight = False
			StruggleBar.Percent += FillDifficulty
		Elseif ((KeyCode == StrafeR) && !LeftRight)
			LeftRight = True
			StruggleBar.Percent += FillDifficulty
		Endif
	EndEvent
EndState
Actor Function Supervisor()
	Int i
	While (i < 5)
		If (Aggressors[i] && CheckActor(Aggressors[i]) && Aggressors[i].HasLOS(Player))
			If (!Aggressors[i].HasKeywordString("SexLabActive") || !Aggressors[i].HasKeywordString("DefeatCollateral"))
				Return Aggressors[i]
			Endif
		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 5)
		If (Accomplices[i] && CheckActor(Accomplices[i]) && Accomplices[i].HasLOS(Player))
			If (!Accomplices[i].HasKeywordString("SexLabActive") || !Accomplices[i].HasKeywordString("DefeatCollateral"))
				Return Accomplices[i]
			Endif
		Endif
		i += 1
	EndWhile
	Return None
EndFunction
Bool Function StillBusy()
	Int i
	While (i < 5)
		If (Accomplices[i] && CheckActor(Accomplices[i]))
			Int FactionRank = Accomplices[i].GetFactionRank(RessConfig.DefeatFactions[1]) ; AggFaction
			DefeatConfig.Log("StillBusy Accomplices[i] - "+Accomplices[i]+" / FactionRank AggFaction - "+FactionRank+" / HasKeywordString SexLabActive - "+Accomplices[i].HasKeywordString("SexLabActive")+" / HasKeywordString DefeatCollateral - "+Accomplices[i].HasKeywordString("DefeatCollateral"))
			If (FactionRank == 3 || Accomplices[i].HasKeywordString("SexLabActive") || Accomplices[i].HasKeywordString("DefeatCollateral"))
				Return True
			Endif
		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 5)
		If (Aggressors[i] && CheckActor(Aggressors[i]))
			Int FactionRank = Aggressors[i].GetFactionRank(RessConfig.DefeatFactions[1]) ; AggFaction
			DefeatConfig.Log("StillBusy Aggressors[i] - "+Aggressors[i]+" / FactionRank AggFaction - "+FactionRank+" / HasKeywordString SexLabActive - "+Aggressors[i].HasKeywordString("SexLabActive")+" / HasKeywordString DefeatCollateral - "+Aggressors[i].HasKeywordString("DefeatCollateral"))
			If (FactionRank == 3 || Aggressors[i].HasKeywordString("SexLabActive") || Aggressors[i].HasKeywordString("DefeatCollateral"))
				Return True
			Endif
		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 5)
		If (Followers[i] && CheckActor(Followers[i]))
			DefeatConfig.Log("StillBusy Followers[i] HasKeywordString SexLabActive - "+Followers[i].HasKeywordString("SexLabActive"))
			If Followers[i].HasKeywordString("SexLabActive")
				Return True
			Endif
		Endif
		i += 1
	EndWhile
	Return False
EndFunction
State StruggleFree
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State StruggleFree starts.")
; DEBUG
		FillDifficulty = 0.01
		FillThreshold = 0.0
		If !IsMovementControlsEnabled()
			SetPlayerAiDriven()
			EnablePlayerControls(1, 0, 0, 0, 0, 0, 0, 0)
		Endif
		
		; 2015.07.08 / Add
		; 2015.07.11 / Mod / Using McmConfig
		If !Stripped && McmConfig.mIsTieupStrip
			Actor Aggressor = CollaAgg.GetReference() As Actor
			
			Stripped = True
			Strip(Player, Aggressor)
			Wait(1.0)
		Endif
		; 2015.07.08 / Add
		
		; 2015.07.26 / Mod
		Bool enableExDev  = McmConfig.mEnableTieupExt
		Bool enableExHood = McmConfig.mEnableTieupHood
		
		RessConfig.addTieupDevices(Player, "default")
		
		If enableExDev
			If enableExHood
				RessConfig.addTieupDevices(Player, "extend30")
			Endif
			
			RessConfig.addTieupDevices(Player, "extend44")
			RessConfig.addTieupDevices(Player, "extend45")
			RessConfig.addTieupDevices(Player, "extend49")
			RessConfig.addTieupDevices(Player, "extend53")
			RessConfig.addTieupDevices(Player, "extend55")
			RessConfig.addTieupDevices(Player, "extend59")
			RessConfig.addTieupDevices(Player, "extend61")
		Endif
		
		RessConfig.setTieupPose(Player, "default")
		; 2015.07.26 / Mod
		
		Wait(2.0)
		StruggleBar()
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		If (StruggleBar.Percent > FillThreshold)
			; 2015.07.08 / Mod
;			SendAnimationEvent(Player, "DefeatZapWriStruggle06")
			SendAnimationEvent(Player, gszCurStrugglePose)
			; 2015.07.08 / Mod
		; 2015.07.08 / Del
;		Else
;			SendAnimationEvent(Player, "DefeatTieUpIdle")
		; 2015.07.08 / Del
		Endif
		If (StruggleBar.Percent >= 1.0)
			SendAnimationEvent(Player, "DefeatTieUpExit")
			; 2015.07.26 / Mod
			RessConfig.removeTieupDevices(Player)
			; 2015.07.26 / Mod
			
			; 2015.07.20 / Mod
			Wait(2)
			Restored()
		Endif
		FillThreshold = StruggleBar.Percent
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnEndState()
		StruggleBar(False)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StrafeL) && LeftRight)
			LeftRight = False
			StruggleBar.Percent += FillDifficulty
		Elseif ((KeyCode == StrafeR) && !LeftRight)
			LeftRight = True
			StruggleBar.Percent += FillDifficulty
		Endif
	EndEvent
EndState
State QTE 																	;===== STATE QTE : RESIST Function
	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
		Actor Aggressor = (akAggressor As Actor)
		If (Aggressor && (Aggressors.Find(Aggressor) != -1) && (Accomplices.Find(Aggressor) != -1))
			RessConfig.AddCalmList(Aggressor, Player)
		Endif
	EndEvent
	Event OnBeginState()
; DEBUG
RessConfig.saveDebugStr("State QTE starts.")
; DEBUG
		If ((McmConfig.QTEHKType == "$Attack") || UsingGamepad())
			StrafeL = Input.GetMappedKey("Left Attack/Block")
			StrafeR = Input.GetMappedKey("Right Attack/Block")
			If McmConfig.bQTEmess
				MiscMessages[1].ShowAsHelpMessage("QTEAtk", 2, 1, 1)
			Endif
		Else
			StrafeL = Input.GetMappedKey("Strafe Left")
			StrafeR = Input.GetMappedKey("Strafe Right")
			If McmConfig.bQTEmess
				MiscMessages[2].ShowAsHelpMessage("QTEStrafe", 2, 1, 1)
			Endif
		Endif
		RegisterForKey(StrafeL)
		RegisterForKey(StrafeR)
		RegisterForSingleUpdate(2.0)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If UsingGamepad()
			If !QTEKeypressed
				If (KeyCode == StrafeL) || (KeyCode == StrafeR)
					QTEKeypressed = True
				Endif
			Endif
		Endif
	EndEvent
	Event OnKeyUp(Int KeyCode, Float HoldTime)
		If UsingGamepad()
			If QTEKeypressed
				If (KeyCode == StrafeL) || (KeyCode == StrafeR)
					QTEKeypressed = False
				Endif
			Endif
		Endif
	EndEvent
	Event OnUpdate()
		If (Input.IsKeyPressed(StrafeL) || Input.IsKeyPressed(StrafeR) || QTEKeypressed)
			UnregisterForKey(StrafeL)
			UnregisterForKey(StrafeR)
			QTEKeypressed = False
			RessConfig.SoundToPlay[8].Play(Player) ; Rescue
			UnregisterForUpdate()
			RessConfig.StruggleSceneTrigger(TheNext, Player, "Player Victim")
;			GoToState("Resist")
		Else
			UnregisterForKey(StrafeL)
			UnregisterForKey(StrafeR)
			UnregisterForUpdate()
			GotoState("")
			PreDownRape()
		Endif
	EndEvent
EndState
Function StruggleBar(Bool Display = True)
	If Display
		If ((McmConfig.QTEHKType == "$Attack") || UsingGamepad())
			StrafeL = Input.GetMappedKey("Left Attack/Block")
			StrafeR = Input.GetMappedKey("Right Attack/Block")
		Else
			StrafeL = Input.GetMappedKey("Strafe Left")
			StrafeR = Input.GetMappedKey("Strafe Right")
		Endif
		RegisterForKey(StrafeL)
		RegisterForKey(StrafeR)
		StruggleBar.Alpha = 100.0
	Else
		StruggleBar.Alpha = 0.0
		StruggleBar.Percent = 0.0
		FillDifficulty = 0.0
		UnregisterForKey(StrafeL)
		UnregisterForKey(StrafeR)
	EndIf
EndFunction
; 2015.07.15 / Add
Function setRapedEffects(Actor actVictim, Bool Enter = True)
	If Enter && McmConfig.mEnablePcRapedAnimation
		Int   nPoseRand    = RandomInt(0, 3)
		Actor actAggressor = GetLastAggressor()
		Bool  isTied       = (RandomFloat(1.0, 100.0) < McmConfig.mnTieupRatio)
		Bool  enableWeb    = McmConfig.mEnableTieupWeb
		Bool  enableFuro   = McmConfig.mEnableTieupFuro
		
		If isTied && actAggressor && actAggressor.HasKeyWordString("ActorTypeNPC")
			; 2015.07.26 / Mod
			Bool enableExDev  = McmConfig.mEnableTieupExt
			Bool enableExHood = McmConfig.mEnableTieupHood
			
			RessConfig.addTieupDevices(Player, "default")
			
			If enableExDev
				If enableExHood
					RessConfig.addTieupDevices(Player, "extend30")
				Endif
				
				RessConfig.addTieupDevices(Player, "extend44")
				RessConfig.addTieupDevices(Player, "extend45")
				RessConfig.addTieupDevices(Player, "extend49")
				RessConfig.addTieupDevices(Player, "extend53")
				RessConfig.addTieupDevices(Player, "extend55")
				RessConfig.addTieupDevices(Player, "extend59")
				RessConfig.addTieupDevices(Player, "extend61")
			Endif
			
			RessConfig.setTieupPose(Player, "default")
			; 2015.07.26 / Mod
		; 2015.07.26 / Add
		Elseif isTied && RessConfig.isSpider(actAggressor) && enableWeb
			RessConfig.addTieupDevices(Player, "web")
			RessConfig.setTieupPose(Player, "web")
		; 2015.07.26 / Add
		; 2015.07.30 / Add
		Elseif isTied && RessConfig.isTentacleUser(actAggressor) && enableFuro
			RessConfig.setTieupPose(Player, "furo")
		; 2015.07.30 / Add
		Elseif nPoseRand <= 0
			RessConfig.DefeatPlayAnimation(actVictim, "Trauma Lie")
		Elseif nPoseRand <= 1
			RessConfig.DefeatPlayAnimation(actVictim, "Exhausted Lie")
		Elseif nPoseRand <= 2
			RessConfig.DefeatPlayAnimation(actVictim, "Lie")
		Else
			RessConfig.DefeatPlayAnimation(actVictim, "Sit")
		Endif
		
		; 2015.07.21 / Add
		RessConfig.forceResetAnimation(actVictim)
		; 2015.07.21 / Add
		
		setRyonaEffects(actVictim, actAggressor, Enter = True)
		RessConfig.setRapedFaceAnimation(actVictim)
	Elseif Enter
		Actor actAggressor = GetLastAggressor()
		
		setRyonaEffects(actVictim, actAggressor, Enter = True)
		RessConfig.setRapedFaceAnimation(actVictim)
	Else
		; 2015.07.26 / Mod
		RessConfig.removeTieupDevices(actVictim)
		; 2015.07.26 / Mod
		
		; 2015.09.06 / Add
		setRyonaEffects(actVictim, Enter = False)
		RessConfig.setRapedFaceAnimation(actVictim, Enter = False)
		; 2015.09.06 / Add
		
		RessConfig.DefeatPlayAnimation(actVictim, "Trauma Stand")
	Endif
EndFunction
; 2015.07.15 / Add
Function Restored()																		;===== RESTORED
	RessConfig.MiscSpells[5].Cast(Player, Player) ; ImmunitySPL
	If Player.HasSpell(RessConfig.MiscSpells[1]) ; DebuffConsSPL
		Player.RemoveSpell(RessConfig.MiscSpells[1]) ; DebuffConsSPL
	Endif
	; 2015.09.12 / Add
	; DebuffSPL
	If Player.HasSpell(RessConfig.MiscSpells[0])
		Player.RemoveSpell(RessConfig.MiscSpells[0])
	Endif
	; DebuffSpeedSPL
	If Player.HasSpell(RessConfig.MiscSpells[2])
		Player.RemoveSpell(RessConfig.MiscSpells[2])
	Endif
	; 2015.09.12 / Add
	; 2015.07.14 / Add
	setRapedEffects(Player, Enter = False)
	; 2015.07.14 / Add
	; 2015.07.25 / Add
	SendAnimationEvent(Player, "IdleForceDefaultState")
	; 2015.07.25 / Add
	SendAnimationEvent(Player, "BleedoutStop")
	Int i
	While (i < 10)
		TheAggressors[i].Clear()
		If (i < 5)
			If Aggressors[i]
				SetIntValue(Aggressors[i], "RapedByInScene"+Player, 0) ; Reset rape count for this scene
			Endif
			Aggressors[i] = None
			Followers[i] = None
 			TheFollowers[i].Clear()
			; 2015.08.08 / Add
;			gaCaptiveAgg[i] = None
;			gaCaptiveVic[i] = None
			; 2015.08.08 / Add
 		Endif
		i += 1
	EndWhile
	i = 0
	While (i < 4)
		MiscScenes[i].Stop()
		i += 1
	EndWhile
	Message.ResetHelpMessage("QTEStrafe")
	Message.ResetHelpMessage("QTEAtk")
	SceneCenter.Clear()
	AliasLastAgg.Clear()
	AliasTheNext.Clear()
	AliasLastVic.Clear()
	CollaVic.Clear()
	CollaAgg.Clear()
	SpamGuard = False
	SSpamGuard = False
	RessConfig.AWitness = None
	TheLast = None
	TheNext = None
	AddOne = None
	AddTwo = None
	AddThree = None
	Stripped = False
	Raped = False
	Robbed = False
	ManualStart = False
	NumRapes = 0
	ForcedScene = ""
	MiscFormLists[0].Revert() ; StrippedStuff
	If (StruggleBar.Alpha > 0.0)
		StruggleBar(False)
	Endif
;	If OwnerFaction
;		Player.RemoveFromFaction(OwnerFaction)
;		OwnerFaction = None
;	Endif
	CrimeGold = 0
	CrimeGoldViolent = 0
	PlayerFaction.Clear()
	SetPlayerAiDriven(False)
	; 2015.07.17 / Add
	DisablePlayerControls(0, 0, 0, 0, 0, 0, 0, 0)
	; 2015.07.17 / Add
;	PlayerBase.SetInvulnerable(False)
	EnablePlayerControls()
	Player.SetAnimationVariableBool("bSprintOK", True)
;	Player.EnableAI()
	
	; 2015.09.06 / Add
	mEnableCellLoadEvents = True
	; 2015.09.06 / Add
	
	; 2015.09.06 / Add
	Detect.Stop()
	; 2015.09.06 / Add
	
	RessConfig.QSTStage = 0
	GoToState("Running")
	DefeatConfig.Log("Player victim - End scene, Restored.")
EndFunction 
Function SetSceneData()
	RessConfig.LastSceneAggressors = Aggressors
	RessConfig.LastSceneAccomplices = Accomplices
	RessConfig.LastSceneFollowers = Followers
	RessConfig.LastSceneTheLast = TheLast
	RessConfig.LastSceneRaped = Raped
	RessConfig.LastSceneRobbed = Robbed
EndFunction
Actor[] Function GetAggressors()
	Return Aggressors
EndFunction
Actor[] Function GetAccomplices()
	Return Accomplices
EndFunction
Actor[] Function GetFollowers()
	Return Followers
EndFunction
Actor Function GetLastAggressor()
	Return TheLast
EndFunction
Actor Function GetTheNext()
	Return TheNext
EndFunction
Function SetTheNext(Actor Aggressor)
	TheNext = Aggressor
EndFunction
Bool Function HasBeenRaped()
	Return Raped
EndFunction
Bool Function HasBeenRobbed()
	Return Robbed
EndFunction
Int Function GetScenecrimegold()
	Return CrimeGold
EndFunction
Actor Function GetWitness()
	If AllowWitness()
		RessConfig.DefeatRape.SendStoryEvent(None, Player, TheNext)
	; 2015.08.29 / Add
	Else
		RessConfig.AWitness = None
	; 2015.08.29 / Add
	Endif
	Wait(1)
	Return RessConfig.AWitness
EndFunction

; ------------------------------------------------------------------------------
; End of Script
; ------------------------------------------------------------------------------
