scriptname DefeatConfig extends Quest Conditional

Import StorageUtil
Import Debug
Import Game
Import Utility

Bool Function IsThereDefeat() Global ; Check if Defeat is enabled on the current play.
	Return GetDefeat()
EndFunction

DefeatConfig Function GetDefeat() Global ; Get Defeat scripts.
	Return (GetFormFromFile(0x4B8D1, "SexLabDefeat.esp") As DefeatConfig)
EndFunction

Bool Function IsDefeatActive(Actor Target) ; Check if the target is affected by Defeat stuff.
	Return Target.HasMagicEffectWithKeyword(DefeatActive) || Target.HasKeyWordString("DefeatActive")
EndFunction

DefeatMCMscr Property McmConfig Auto
DefeatPlayer Property PlayerScr Auto
DefeatQTEMeter Property StruggleBar Auto
DefeatPAscr Property PostAssaultscr Auto
DefeatActionScr Property ActionQst Auto
DefeatNPCsScr Property NPCsRefreshQstScr Auto
Defeathkactiontarget Property HKActionTargetScr Auto

Bool Property OnOffPlayerAggressor Auto Hidden Conditional
Bool Property OnOffPlayerVictim Auto Hidden Conditional
Bool Property OnOffNVN Auto Hidden Conditional
Bool Property OnOffPerk Auto Hidden Conditional
Bool Property OnOffNecro Auto Hidden Conditional

KeyWord Property DefeatActive Auto
KeyWord Property DefeatRape Auto
Actor Property Player Auto
DefeatNVNInActionScr[] Property PlayerSLMonitor Auto
Package Property DoNothing Auto
ReferenceAlias Property BurlapSackVictim Auto
Perk Property DefeatAssaultPRK Auto

DefeatNVNOnHitScr[] Property NVNOnHitScr Auto
DefeatNVNInActionScr[] Property NVNActionScr Auto
Int Property NVNKDtype = 1 Auto Hidden Conditional
Bool Property NVNAllowVic = True Auto Hidden Conditional
Bool Property NVNAllowFollowerVic = True Auto Hidden Conditional
ReferenceAlias[] Property VicPair Auto
ReferenceAlias[] Property AggPair Auto
ReferenceAlias[] Property AggPairAdd Auto
Message[] Property AssaultNVNMess Auto Hidden

Quest[] Property MiscQuests Auto Hidden
FormList[] Property MiscFormLists Auto Hidden
Topic[] Property TopicToSay Auto Hidden
Sound[] Property SoundToPlay Auto Hidden
Spell[] Property ResistSpells Auto Hidden
Spell[] Property MiscSpells Auto Hidden
MagicEffect[] Property MiscMagicEffects Auto Hidden
Package[] Property MiscPackages Auto Hidden
ObjectReference[] Property MiscReferences Auto Hidden
GlobalVariable[] Property MiscGlobals Auto Hidden
Message[] Property MiscMessages Auto Hidden
Idle[] Property Killmoves Auto Hidden
Idle[] Property MiscIdles Auto Hidden
Int[] Property HotKeyInts Auto Hidden
VoiceType[] Property MiscVoicetypes Auto Hidden
Faction[] Property DefeatFactions Auto Hidden
Faction[] Property FollowerFactions Auto Hidden
; 2015.07.09 / Add
Faction[] Property CaptiveFactions Auto Hidden
Faction[] Property NonCaptiveFactions Auto Hidden
; 2015.07.09 / Add
; 2015.07.25 / Add
ActorBase[] Property maCaptiveBandits Auto Hidden
ActorBase[] Property maCaptiveThieves Auto Hidden
ActorBase[] Property maCaptiveForsworns Auto Hidden
ActorBase[] Property maCaptiveThalmors Auto Hidden
ActorBase[] Property maCaptiveVampires Auto Hidden
ActorBase[] Property maCaptiveWarlocks Auto Hidden
ActorBase[] Property maCaptiveDraugrs Auto Hidden
ActorBase[] Property maCaptiveUndeads Auto Hidden
ActorBase[] Property maCaptiveFalmers Auto Hidden
ActorBase[] Property maCaptiveDwarvens Auto Hidden
ActorBase[] Property maCaptiveAnimals Auto Hidden
ActorBase[] Property maCaptiveWerewolves Auto Hidden
ActorBase[] Property maCaptiveGiants Auto Hidden
ActorBase[] Property maCaptiveOrcs Auto Hidden
; 2015.07.25 / Add
; 2015.07.18 / Add
ActorBase[] Property maCaptiveVictims Auto Hidden
VoiceType[] Property maCaptiveExcludeVoices Auto Hidden
; 2015.07.18 / Add
; 2015.07.12 / Add
Quest[] Property maFGTripWandererQuests Auto Hidden
Quest Property mqstAFTweakFollowerQuest Auto Hidden
; 2015.07.12 / Add
; 2015.07.14 / Add
Quest Property mqstEFFrameworkFollowerQuest Auto Hidden
Quest Property mqstFLPackageFollowerQuest Auto Hidden
; 2015.07.14 / Add
; 2015.07.11 / Add
Actor Property PreCaptiveVictim Auto
; 2015.07.11 / Add
; 2015.07.15 / Add
Quest Property mqstJbNPCMapQuest Auto Hidden
Actor[] Property maInternalNpcList Auto Hidden
; 2015.07.15 / Add

; 2015.07.20 / Add
Miscobject Property moEstrusToken Auto Hidden
Keyword Property mkwEstrusEffect Auto Hidden
; 2015.07.20 / Add

; 2015.07.22 / Add
Armor[] Property maDwarvenArmors Auto Hidden
VoiceType Property mvocDwarven Auto Hidden
Faction Property mfctDwarven Auto Hidden
Activator Property mactvSummonFX Auto Hidden
ActorBase Property mabDwarvenRaper Auto Hidden
; 2015.07.22 / Add
; 2015.09.06 / Add
ActorBase[] Property maSicDwarvenRapers Auto Hidden
; 2015.09.06 / Add

; 2015.07.25 / Add
Faction Property mfctSpriggan Auto Hidden
; 2015.07.25 / Add

; 2015.07.26 / Add
Faction Property mfctDaedra Auto Hidden
; 2015.07.26 / Add
Spell Property msplGhostNew Auto Hidden
Spell Property msplFireWolf Auto Hidden
ActorBase[] Property maFlamingRapers Auto Hidden
; 2015.07.26 / Add

; 2015.07.26 / Add
Armor[] Property maTieupDevices Auto Hidden
Armor[] Property maTieupYokes Auto Hidden
Armor[] Property maTieupArmBinders Auto Hidden
Armor[] Property maTieupSlot30 Auto Hidden
Armor[] Property maTieupSlot44 Auto Hidden
Armor[] Property maTieupSlot45 Auto Hidden
Armor[] Property maTieupSlot49 Auto Hidden
Armor[] Property maTieupSlot53 Auto Hidden
Armor[] Property maTieupSlot55 Auto Hidden
Armor[] Property maTieupSlot59 Auto Hidden
Armor[] Property maTieupSlot61 Auto Hidden
; 2015.07.26 / Add

; 2015.07.28 / Add
Spell Property msplRapeAlt Auto Hidden
; 2015.07.28 / Add

; 2015.07.30 / Add
Location[] Property maNoCaptiveLocations Auto Hidden
; 2015.07.30 / Add

; 2015.08.01 / Add
EffectShader property mefsRapeAttack auto
VisualEffect property mvefRapeAttack auto
; 2015.08.01 / Add

; 2015.08.08 / Add
Explosion property mexpRapeAttack auto
; 2015.08.08 / Add

; 2015.08.02 / Add
Topic property mtpcAboutVictim auto
Actor[] Property maRapeClubMembers Auto Hidden
Armor Property marmRapeClubHood Auto Hidden
; 2015.08.01 / Add

; 2015.08.05 / Add
VoiceType[] Property maRapeClubExcludeVoices Auto Hidden
; 2015.08.05 / Add

; 2015.08.07 / Add
Armor[] Property maTongues Auto Hidden
; 2015.08.07 / Add

; 2015.09.06 / Add
Int[]   Property maLeftForDeadCells Auto Hidden
Float[] Property maLeftForDeadPosX  Auto Hidden
Float[] Property maLeftForDeadPosY  Auto Hidden
Float[] Property maLeftForDeadPosZ  Auto Hidden
; 2015.09.06 / Add

; 2015.09.12 / Add
Sound[] Property maSoundToSay Auto Hidden
; 2015.09.12 / Add


; SL Controller menu
String[] ControllerOptions
String[] ControllerTags

Function Log(String TheTrace) Global
	Trace("Defeat: "+TheTrace)
EndFunction

SexLabFramework Property SexLab Auto Hidden 					; SexLab
sslSystemConfig Property SexLabConfig Auto Hidden 				;
Bool Property DAon = False Auto Hidden Conditional 				; Death Alternative
Bool Property Zazon = False Auto Hidden Conditional 			; Zaz
Bool Property DDon = False Auto Hidden Conditional 				; Devous Devices
Bool Property DawnguardOn = False Auto Hidden Conditional		; Dawnguard
Bool Property DragonbornOn = False Auto Hidden Conditional 		; Dragonborn
Bool Property EFFon = False Auto Hidden Conditional 			; Extensible Follower Framework
Bool Property UIEon = False Auto Hidden Conditional 			; UIExtensions
Bool Property PAHon = False Auto Hidden Conditional 			; Paradise Halls
;Bool Property SARon = False Auto Hidden Conditional 			; SexLab Aroused
; 2015.07.09 / Add
Bool Property FGTon = False Auto Hidden Conditional 			; Follower Goes on a Trip
; 2015.07.09 / Add
; 2015.07.11 / Add
Bool Property ZazRon = False Auto Hidden Conditional 			; Zaz Resources
; 2015.07.11 / Add
; 2015.07.12 / Add
Bool Property AFTon = False Auto Hidden Conditional 			; Amazing Follower Tweaks
Bool Property STTon = False Auto Hidden Conditional 			; SlaveTats
; 2015.07.12 / Add
; 2015.07.14 / Add
Bool Property FLPon = False Auto Hidden Conditional 			; FollowerLivePackage
; 2015.07.14 / Add
; 2015.07.15 / Add
Bool Property jbNPCMapon = False Auto Hidden Conditional		; jbNPCMap
; 2015.07.15 / Add
; 2015.07.16 / Add
Bool Property Haloson = False Auto Hidden Conditional			; Halos Poser
; 2015.07.16 / Add
; 2015.07.19 / Add
Bool Property Estruson = False Auto Hidden Conditional			; Estrus
; 2015.07.19 / Add
; 2015.07.28 / Add
Bool Property SRSon = False Auto Hidden Conditional				; Sexlab RapeSpell
; 2015.07.28 / Add
Bool Property EQTONGUESCRon = False Auto Hidden Conditional		; Equipable Tongues
Bool Property EQTONGUEon    = False Auto Hidden Conditional		; Equipable Tongues
Bool Property HTOOLSon      = False Auto Hidden Conditional		; HTools
; 2015.08.07 / Add
; 2015.09.06 / Add
Bool Property SICon      	= False Auto Hidden Conditional		; Skyrim Immersive Creatures
; 2015.09.06 / Add


Function CheckForMods()
	Int i
	While (i < GetModCount())
		String ModName = GetModName(i)
		If (ModName == "Dawnguard.esm")
			DawnguardOn = True
			MiscQuests[8] = (GetFormFromFile(0x71d0, "Dawnguard.esm") As Quest)
			McmConfig.AModList[0] = "Dawnguard : ON"
			Log("Dawwnguard detected.")
		Elseif (ModName == "Dragonborn.esm")
			DragonbornOn = True
			MiscFormLists[1].Revert()
			MiscFormLists[1].AddForm(GetFormFromFile(0x21749, "Dragonborn.esm")) ; DLC2DarkElfBed01
			MiscFormLists[1].AddForm(GetFormFromFile(0x35038, "Dragonborn.esm")) ; DLC2DarkElfBed01L
			MiscFormLists[1].AddForm(GetFormFromFile(0x35037, "Dragonborn.esm")) ; DLC2DarkElfBed01R
			MiscFormLists[1].AddForm(GetFormFromFile(0x32802, "Dragonborn.esm")) ; DLC2DarkElfBedDouble01
			MiscFormLists[1].AddForm(GetFormFromFile(0x36797, "Dragonborn.esm")) ; DLC2DarkElfBedDouble01L
			MiscFormLists[1].AddForm(GetFormFromFile(0x36796, "Dragonborn.esm")) ; DLC2DarkElfBedDouble01R
			MiscVoicetypes[3] = (GetFormFromFile(0x208DC, "Dragonborn.esm") As VoiceType) ; Riekling Voice Type
			McmConfig.AModList[1] = "Dragonborn : ON"
			Log("Dragonborn detected.")
		Elseif (ModName == "ZaZAnimationPack.esm")
			Zazon = True
			McmConfig.AModList[2] = "ZaZ Animation Pack : ON"
			Log("ZaZ Animation Pack detected.")
		Elseif (ModName == "Devious Devices - Integration.esm")
			DDon = True
			DefeatFactions[2] = (GetFormFromFile(0x29567, "Devious Devices - Integration.esm") As Faction)
			McmConfig.AModList[3] = "Devious Devices : ON"
			Log("Devious Devices detected.")
		Elseif (ModName == "daymoyl.esm")
			DAon = True
			McmConfig.AModList[4] = "Death Alternative : ON"
			McmConfig.Grayout("daymoyl", True)
			Log("Death Alternative detected.")
		Elseif (ModName == "UIExtensions.esp")
			UIEon = True
			McmConfig.AModList[5] = "UIExtensions : ON"
			Log("UIExtension detected.")
		Elseif (ModName == "paradise_halls.esm")
			PAHon = True
			McmConfig.AModList[6] = "Paradise Halls : ON"
			Log("Paradise Halls detected.")
;		Elseif (ModName == "EFFCore.esm")
;			EFFon = True
;			McmConfig.AModList[5] = "Extensible Follower Framework : ON"
;			Log("Extensible Follower Framework detected.")
;		Elseif (ModName == "SexLabAroused.esm")
;			SARon = True
;			McmConfig.AModList[7] = "SexLab Aroused Redux : ON"
;			McmConfig.Grayout("SAR", True)
;			Log("SexLab Aroused detected.")
		; 2015.07.09 / Add
		Elseif (ModName == "FGT.esp")
			FGTon = True
			; 2015.07.12 / Add
			maFGTripWandererQuests = getQuestsFromAddon("FGTWandererQuest")
			; 2015.07.12 / Add
			McmConfig.AModList[7] = "Follower Goes on a Trip : ON"
			Log("Follower Goes on a Trip detected.")
;			Notification("Follower Goes on a Trip detected.")
		; 2015.07.09 / Add
		; 2015.07.11 / Add
		Elseif (ModName == "ZazResources.esp")
			ZazRon = True
			McmConfig.AModList[8] = "Zaz Resources : ON"
			Log("Zaz Resources detected.")
		; 2015.07.11 / Add
		; 2015.07.12 / Add
		Elseif (ModName == "AmazingFollowerTweaks.esp")
			AFTon = True
			mqstAFTweakFollowerQuest = GetFormFromFile(0x12CE, ModName) as Quest
			McmConfig.AModList[9] = "Amazing Follower Tweaks : ON"
			Log("Amazing Follower Tweaks detected.")
		Elseif (ModName == "SlaveTats.esp")
			STTon = True
			McmConfig.AModList[10] = "SlaveTats : ON"
			Log("SlaveTats detected.")
		; 2015.07.12 / Add
		; 2015.07.14 / Add
		Elseif (ModName == "EFFCore.esm")
			EFFon = True
			mqstEFFrameworkFollowerQuest = GetFormFromFile(0xEFF, ModName) as Quest
			McmConfig.AModList[11] = "Extensible Follower Framework : ON"
			Log("Extensible Follower Framework detected.")
		Elseif (ModName == "FollowerLivePackage.esp")
			FLPon = True
			mqstFLPackageFollowerQuest = GetFormFromFile(0x980D62, ModName) as Quest
			McmConfig.AModList[12] = "FollowerLivePackage : ON"
			Log("FollowerLivePackage detected.")
		; 2015.07.14 / Add
		; 2015.07.15 / Add
		Elseif (ModName == "Merged Patch 01.esp")
			; My environment only because jbNPCMap is merged
			jbNPCMapon = True
			mqstJbNPCMapQuest = GetFormFromFile(0x9801, ModName) as Quest
			McmConfig.AModList[13] = "jbNPCMap : ON"
			Log("jbNPCMap detected.")
			
			Haloson = True
			McmConfig.AModList[14] = "Halo's Poser : ON"
			Log("Halo's Poser detected.")
		Elseif (ModName == "jbNPCMap.esp")
			jbNPCMapon = True
			mqstJbNPCMapQuest = GetFormFromFile(0xD62, ModName) as Quest
			McmConfig.AModList[13] = "jbNPCMap : ON"
			Log("jbNPCMap detected.")
		; 2015.07.15 / Add
		; 2015.07.16 / Add
		Elseif (ModName == "Halo's Poser.esp")
			Haloson = True
			McmConfig.AModList[14] = "Halo's Poser : ON"
			Log("Halo's Poser detected.")
		; 2015.07.16 / Add
		; 2015.07.19 / Add
		Elseif (ModName == "zzEstrus.esp")
			Estruson = True
			McmConfig.AModList[15] = "Estrus : ON"
			Log("Estrus detected.")
		; 2015.07.19 / Add
		; 2015.07.28 / Add
		Elseif (ModName == "SexLabRapeSpell.esp")
			SRSon = True
			; SexLabRapeSpellTarget [SPEL:020012C5]
			msplRapeAlt = GetFormFromFile(0x12C5, ModName) As Spell
			McmConfig.AModList[16] = "SexLab RapeSpell : ON"
			Log("SexLab RapeSpell detected.")
		; 2015.07.28 / Add
		; 2015.08.07 / Add
		Elseif (ModName == "Tongueswcript.esp")
			EQTONGUESCRon = True
			McmConfig.AModList[17] = "Equipable Tongues with script : ON"
			Log("Equipable Tongues with script detected.")
		Elseif (ModName == "Tongues.esp")
			EQTONGUEon = True
			McmConfig.AModList[18] = "Equipable Tongues without script : ON"
			Log("Equipable Tongues without script detected.")
		Elseif (ModName == "HTools.esp")
			HTOOLSon = True
			McmConfig.AModList[19] = "Halo's HTools : ON"
			Log("Halo's HTools detected.")
		; 2015.08.07 / Add
		; 2015.09.06 / Add
		Elseif (ModName == "Skyrim Immersive Creatures.esp")
			SICon = True
			; _00EncDwemerArchitect_lvl10 [NPC_:0309C4E8]
			; _00EncDwemerEngineer_lvl15 [NPC_:031B9AF0]
			; _00EncDwemerGuard_lvl10 [NPC_:0309C4E5]
			; _00EncDwemerMage_lvl10 [NPC_:031B9AEB]
			; _00EncDwemerTinker_lvl10 [NPC_:030F382F]
			maSicDwarvenRapers    = new ActorBase[5]
			maSicDwarvenRapers[0] = GetFormFromFile(0x09C4E8, ModName) As ActorBase
			maSicDwarvenRapers[1] = GetFormFromFile(0x1B9AF0, ModName) As ActorBase
			maSicDwarvenRapers[2] = GetFormFromFile(0x09C4E5, ModName) As ActorBase
			maSicDwarvenRapers[3] = GetFormFromFile(0x1B9AEB, ModName) As ActorBase
			maSicDwarvenRapers[4] = GetFormFromFile(0x0F382F, ModName) As ActorBase
			McmConfig.AModList[20] = "Skyrim Immersive Creatures : ON"
			Log("Skyrim Immersive Creatures detected.")
		; 2015.09.06 / Add
		Endif
		i += 1
	EndWhile
	
	; 2015.07.11 / Add
	McmConfig.mEnableAddonZAP = Zazon
	McmConfig.mEnableAddonFGT = FGTon
	; 2015.07.11 / Add
	; 2015.07.12 / Add
	McmConfig.mEnableAddonAFT = AFTon
	McmConfig.mEnableAddonSTT = STTon
	; 2015.07.12 / Add
	; 2015.07.19 / Add
	McmConfig.mEnableAddonEstrus = Estruson
	; 2015.07.19 / Add
EndFunction

Function Maintenance(Bool Updated = False, Int Vers = 0)
	If !Updated
		If (McmConfig.ModStatus == "$Enabled")
			RegisterForKey(HotKeyInts[0]) ; Option key
			RegisterForModEvent("AnimationStart", "RapeScene")
			RegisterForModEvent("AnimationEnd", "EndRapeScene")
			If (McmConfig.OnOffPagg == "$Enabled")
				ActionQst.Configure()
				HKActionTargetScr.Configure()
			Endif	
			If (McmConfig.OnOffPvic == "$Enabled")
				PlayerScr.Configure()
				PostAssaultscr.Configure()
			; 2015.07.20
			Else
				PlayerScr.Configure()
				PlayerScr.GoToState("Inactive")
			; 2015.07.20
			Endif
			; Check if compatible mods are still loaded.
			If DawnguardOn
				If !GetFormFromFile(0x71d0, "Dawnguard.esm")
					MiscQuests[8] = None
					McmConfig.AModList[0] = "Dawnguard : OFF"
					DawnguardOn = False
				Endif
			Endif
			If DragonbornOn
				If !GetFormFromFile(0x208DC, "Dragonborn.esm") 
					MiscFormLists[1].Revert()
					MiscVoicetypes[3] = None ; Rikeling voicetype
					McmConfig.AModList[1] = "Dragonborn : OFF"
					DragonbornOn = False
				Endif
			Endif
			If Zazon
				If !GetFormFromFile(0x137E6, "ZaZAnimationPack.esm")
					McmConfig.AModList[2] = "ZaZ Animation Pack : OFF"
					Zazon = False
				Endif
			Endif
			; 2015.07.11 / Add
			McmConfig.mEnableAddonZAP = Zazon
			; 2015.07.11 / Add
			If DDon
				If !GetFormFromFile(0x29567, "Devious Devices - Integration.esm")
					DefeatFactions[2] = None
					McmConfig.AModList[3] = "Devious Devices : OFF"
					DDon = False
				Endif
			Endif
			If DAon
				If !GetFormFromFile(0xD62, "daymoyl.esm")
					McmConfig.Grayout("daymoyl")
					McmConfig.AModList[4] = "Death Alternative : OFF"
					DAon = False
				Endif
			Endif
			If UIEon
				If !GetFormFromFile(0xE05, "UIExtensions.esp") ; list menu
					McmConfig.AModList[5] = "UIExtensions : OFF"
					UIEon = False
				Endif
			Endif
			If PAHon
				If !GetFormFromFile(0x1FAEF, "paradise_halls.esm")
					McmConfig.AModList[6] = "Paradise Halls : OFF"
					PAHon = False
				Endif
			Endif
;			If EFFon
;				If !GetFormFromFile(0xEFF, "EFFCore.esm")
;					McmConfig.AModList[5] = "Extensible Follower Framework : OFF"
;					EFFon = False
;				Endif
;			Endif
;			If SARon
;				If !GetFormFromFile(0x4290F, "SexLabAroused.esm")
;					McmConfig.Grayout("SAR")
;					McmConfig.AModList[7] = "SexLab Aroused Redux : OFF"
;					SARon = False
;				Endif
;			Endif
			; 2015.07.11 / Add
			Int nIdx = 6
			; 2015.07.11 / Add
			; 2015.07.10 / Add
			nIdx += 1
			If FGTon
				If !GetFormFromFile(0x3321, "FGT.esp")
					McmConfig.AModList[nIdx] = "Follower Goes on a Trip : OFF"
					FGTon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonFGT = FGTon
			; 2015.07.10 / Add
			; 2015.07.11 / Add
			nIdx += 1
			If ZazRon
				If !GetFormFromFile(0x6E8C, "ZazResources.esp")
					McmConfig.AModList[nIdx] = "Zaz Resources : OFF"
					ZazRon = False
				Endif
			Endif
			; 2015.07.11 / Add
			; 2015.07.12 / Add
			nIdx += 1
			If AFTon
				If !GetFormFromFile(0x12CE, "AmazingFollowerTweaks.esp")
					McmConfig.AModList[nIdx] = "Amazing Follower Tweaks : OFF"
					AFTon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonAFT = AFTon
			
			nIdx += 1
			If STTon
				If !GetFormFromFile(0x800, "SlaveTats.esp")
					McmConfig.AModList[nIdx] = "SlaveTats : OFF"
					STTon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonSTT = STTon
			; 2015.07.12 / Add
			; 2015.07.14 / Add
			nIdx += 1
			If EFFon
				If !GetFormFromFile(0xEFF, "EFFCore.esm")
					McmConfig.AModList[nIdx] = "Extensible Follower Framework : OFF"
					EFFon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonEFF = EFFon
			
			nIdx += 1
			If FLPon
				If !GetFormFromFile(0x980D62, "FollowerLivePackage.esp")
					McmConfig.AModList[nIdx] = "FollowerLivePackage : OFF"
					FLPon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonFLP = FLPon
			; 2015.07.14 / Add
			; 2015.07.15 / Add
			nIdx += 1
			If jbNPCMapon
				If !GetFormFromFile(0xD62, "jbNPCMap.esp") && !GetFormFromFile(0x9801, "Merged Patch 01.esp")
					McmConfig.AModList[nIdx] = "jbNPCMap : OFF"
					jbNPCMapon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonJbNPCMap = jbNPCMapon
			; 2015.07.15 / Add
			; 2015.07.16 / Add
			nIdx += 1
			If Haloson
				If !GetFormFromFile(0x121886, "Halo's Poser.esp") && !GetFormFromFile(0x9801, "Merged Patch 01.esp")
					McmConfig.AModList[nIdx] = "Halo's Poser : OFF"
					Haloson = False
				Endif
			Endif
			
			McmConfig.mEnableAddonHalosPoser = Haloson
			; 2015.07.16 / Add
			; 2015.07.20 / Add
			nIdx += 1
			If Estruson
				If !GetFormFromFile(0x8AF, "zzEstrus.esp")
					McmConfig.AModList[nIdx] = "Estrus : OFF"
					Estruson = False
				Endif
			Endif
			
			McmConfig.mEnableAddonEstrus = Estruson
			; 2015.07.20 / Add
			; 2015.07.28 / Add
			nIdx += 1
			If SRSon
				If !GetFormFromFile(0x12C5, "SexLabRapeSpell.esp")
					McmConfig.AModList[nIdx] = "SexLab RapeSpell : OFF"
					SRSon = False
				Endif
			Endif
			
			McmConfig.mEnableAddonRapeSpell = SRSon
			; 2015.07.28 / Add
			; 2015.08.07 / Add
			nIdx += 1
			If EQTONGUESCRon
				; linga1armor "Tongue 1" [ARMO:01003DE6]
				If !GetFormFromFile(0x3DE6, "Tongueswcript.esp")
					McmConfig.AModList[nIdx] = "Equipable Tongues with script : OFF"
					EQTONGUESCRon = False
				Endif
			Endif
			
			McmConfig.mEnableEqTongueScr = EQTONGUESCRon
			
			nIdx += 1
			If EQTONGUEon
				; linga1armor "Tongue 1" [ARMO:01003DE6]
				If !GetFormFromFile(0xD6C, "Tongues.esp")
					McmConfig.AModList[nIdx] = "Equipable Tongues without script : OFF"
					EQTONGUEon = False
				Endif
			Endif
			
			McmConfig.mEnableEqTongue = EQTONGUEon
			
			nIdx += 1
			If HTOOLSon
				; TongueA1 "Tongue A1" [ARMO:01003902]
				If !GetFormFromFile(0x3902, "HTools.esp")
					McmConfig.AModList[nIdx] = "Halo's HTools : OFF"
					HTOOLSon = False
				Endif
			Endif
			
			McmConfig.mEnableHaloHTools = HTOOLSon
			; 2015.08.07 / Add
			; 2015.09.06 / Add
			nIdx += 1
			If SICon
				; _00EncDwemerArchitect_lvl10 [NPC_:0309C4E8]
				If !GetFormFromFile(0x09C4E8, "Skyrim Immersive Creatures.esp")
					McmConfig.AModList[nIdx] = "Skyrim Immersive Creatures : OFF"
					SICon = False
				Endif
			Endif
			; 2015.09.06 / Add
		Endif
	Else
		Update(Vers)
	Endif
EndFunction

State Inactive
EndState

Function Update(Int Vers = 0)
	; 2015.07.10 / Mod / Vers 60 - v5.1.0 with patch v2.0
	; 2015.07.13 / Mod / Vers 61 - v5.1.0 with patch v2.1
	; 2015.07.14 / Mod / Vers 62 - v5.1.0 with patch v2.2
	; 2015.07.14 / Mod / Vers 63 - v5.1.0 with patch v2.3
	; 2015.07.18 / Mod / Vers 64 - v5.1.0 with patch v2.4
	; 2015.07.19 / Mod / Vers 65 - v5.1.0 with patch v2.5
	; 2015.07.22 / Mod / Vers 66 - v5.1.0 with patch v2.6
	; 2015.07.22 / Mod / Vers 67 - v5.1.0 with patch v2.7
	; 2015.07.26 / Mod / Vers 68 - v5.1.0 with patch v3.0
	; 2015.07.27 / Mod / Vers 69 - v5.1.0 with patch v3.1
	; 2015.07.28 / Mod / Vers 70 - v5.1.0 with patch v3.2
	; 2015.07.30 / Mod / Vers 71 - v5.1.0 with patch v3.3
	; 2015.08.01 / Mod / Vers 72 - v5.1.0 with patch v3.4
	; 2015.08.02 / Mod / Vers 73 - v5.1.0 with patch v4.0
	; 2015.08.02 / Mod / Vers 74 - v5.1.0 with patch v4.1
	; 2015.08.04 / Mod / Vers 75 - v5.1.0 with patch v4.2
	; 2015.08.06 / Mod / Vers 76 - v5.1.0 with patch v4.3
	; 2015.08.06 / Mod / Vers 77 - v5.1.0 with patch v4.4
	; 2015.08.18 / Mod / Vers 78 - v5.1.0 with patch v4.5
	; 2015.08.20 / Mod / Vers 79 - v5.1.0 with patch v4.6
	; 2015.09.02 / Mod / Vers 80 - v5.1.0 with patch v4.7
	; 2015.09.03 / Mod / Vers 81 - v5.1.0 with patch v4.8
	; 2015.09.06 / Mod / Vers 82 - v5.1.0 with patch v5.0
	; 2015.09.12 / Mod / Vers 83 - v5.1.0 with patch v5.1
	; 2015.09.15 / Mod / Vers 84 - v5.1.0 with patch v5.2
	If (Vers == 84) ; 5.1.0-patch-5.2
		; 2015.07.20 / Mod / 15 -> 16
		; 2015.08.07 / Mod / 17 -> 20
		; 2015.09.06 / Mod / 20 -> 21
		String[] AModListOld = New String[21]
		AModListOld[0] = McmConfig.AModList[0]
		AModListOld[1] = McmConfig.AModList[1]
		AModListOld[2] = McmConfig.AModList[2]
		AModListOld[3] = McmConfig.AModList[3]
		AModListOld[4] = McmConfig.AModList[4]
		AModListOld[5] = McmConfig.AModList[5]
		AModListOld[6] = "Paradise Halls : OFF"
		; 2015.07.11 / Add
		Int nIdx = 6
		; 2015.07.11 / Add
		; 2015.07.10 / Add
		nIdx += 1
		AModListOld[nIdx] = "Follower Goes on a Trip : OFF"
		; 2015.07.10 / Add
		; 2015.07.11 / Add
		nIdx += 1
		AModListOld[nIdx] = "Zaz Resources : OFF"
		; 2015.07.11 / Add
		; 2015.07.12 / Add
		nIdx += 1
		AModListOld[nIdx] = "Amazing Follower Tweaks : OFF"
		nIdx += 1
		AModListOld[nIdx] = "SlaveTats : OFF"
		; 2015.07.12 / Add
		; 2015.07.14 / Add
		nIdx += 1
		AModListOld[nIdx] = "Extensible Follower Framework : OFF"
		nIdx += 1
		AModListOld[nIdx] = "FollowerLivePackage : OFF"
		nIdx += 1
		AModListOld[nIdx] = "jbNPCMap : OFF"
		nIdx += 1
		AModListOld[nIdx] = "Halo's Poser : OFF"
		; 2015.07.14 / Add
		; 2015.07.20 / Add
		nIdx += 1
		AModListOld[nIdx] = "Estrus : OFF"
		; 2015.07.20 / Add
		; 2015.07.28 / Add
		nIdx += 1
		AModListOld[nIdx] = "SexLab RapeSpell : OFF"
		; 2015.07.28 / Add
		; 2015.08.07 / Add
		nIdx += 1
		AModListOld[nIdx] = "Equipable Tongues with script : OFF"
		nIdx += 1
		AModListOld[nIdx] = "Equipable Tongues without script : OFF"
		nIdx += 1
		AModListOld[nIdx] = "Halo's HTools : OFF"
		; 2015.08.07 / Add
		; 2015.09.06 / Add
		nIdx += 1
		AModListOld[nIdx] = "Skyrim Immersive Creatures : OFF"
		; 2015.09.06 / Add
		; 2015.07.28 / Mod / 16 -> 17
		; 2015.08.07 / Mod / 17 -> 20
		; 2015.09.06 / Mod / 20 -> 21
		McmConfig.AModList = New String[21]
		McmConfig.AModList = AModListOld
		; 2015.08.29 / Del
;		OnOffFeature("PlayerVic")
		; 2015.08.29 / Del
		OnOffFeature("PlayerVic", True)
	Endif
	Install(True)
	
	; 2015.07.10 / Mod / Vers 60 - v5.1.0 with patch v2.0
	; 2015.07.13 / Mod / Vers 61 - v5.1.0 with patch v2.1
	; 2015.07.14 / Mod / Vers 62 - v5.1.0 with patch v2.2
	; 2015.07.14 / Mod / Vers 63 - v5.1.0 with patch v2.3
	; 2015.07.18 / Mod / Vers 64 - v5.1.0 with patch v2.4
	; 2015.07.19 / Mod / Vers 65 - v5.1.0 with patch v2.5
	; 2015.07.22 / Mod / Vers 66 - v5.1.0 with patch v2.6
	; 2015.07.22 / Mod / Vers 67 - v5.1.0 with patch v2.7
	; 2015.07.26 / Mod / Vers 68 - v5.1.0 with patch v3.0
	; 2015.07.27 / Mod / Vers 69 - v5.1.0 with patch v3.1
	; 2015.07.28 / Mod / Vers 70 - v5.1.0 with patch v3.2
	; 2015.07.30 / Mod / Vers 71 - v5.1.0 with patch v3.3
	; 2015.08.01 / Mod / Vers 72 - v5.1.0 with patch v3.4
	; 2015.08.02 / Mod / Vers 73 - v5.1.0 with patch v4.0
	; 2015.08.02 / Mod / Vers 74 - v5.1.0 with patch v4.1
	; 2015.08.04 / Mod / Vers 75 - v5.1.0 with patch v4.2
	; 2015.08.06 / Mod / Vers 76 - v5.1.0 with patch v4.3
	; 2015.08.06 / Mod / Vers 77 - v5.1.0 with patch v4.4
	; 2015.08.18 / Mod / Vers 78 - v5.1.0 with patch v4.5
	; 2015.08.20 / Mod / Vers 79 - v5.1.0 with patch v4.6
	; 2015.09.02 / Mod / Vers 80 - v5.1.0 with patch v4.7
	; 2015.09.03 / Mod / Vers 81 - v5.1.0 with patch v4.8
	; 2015.09.06 / Mod / Vers 82 - v5.1.0 with patch v5.0
	; 2015.09.12 / Mod / Vers 83 - v5.1.0 with patch v5.1
	; 2015.09.15 / Mod / Vers 84 - v5.1.0 with patch v5.2
	Notification("Defeat updated to version V5.1.0 patch v5.2")
	Log("Defeat updated to version V5.1.0 patch v5.2")
EndFunction

Function Uninstall(Int loop = 0)
	If !Player.HasKeywordString("DefeatActive")
		PlayerScr.Uninstall()
		ActionQst.Uninstall()
		GoToState("Inactive")
		If OnOffPlayerAggressor
			If (ActionQst.GetState() == "Carrying")
				ActionQst.OptionOutOfBag(Player)
			Endif
			OnOffFeature("PlayerAgg")
		Endif
		If OnOffPlayerVictim
			OnOffFeature("PlayerVic")
		Endif
		If OnOffNVN
			OnOffFeature("")
		Endif
		Cell PlayerCell = Player.GetParentCell()
		Int i
		While (i < 50)
			If TieUpSlots[i]
				TieUp(TieUpSlots[i], Enter = False)
			Endif
			If TieUpSlotsAliases[i].GetReference()
				TieUp((TieUpSlotsAliases[i].GetReference() As Actor), Enter = False)
			Endif
			i += 1
		EndWhile
		i = 30
		While (i < 30)
			If KnockoutSlots[i]
				Knockout(KnockoutSlots[i], Enter = False)
			Endif
			If KnockoutSlotsAliases[i].GetReference()
				Knockout((KnockoutSlotsAliases[i].GetReference() As Actor), Enter = False)
			Endif
			i += 1
		EndWhile
		Notification("$Defeat: Uninstalled")
		McmConfig.ModStatus = "$Disabled"
	Else
		MessageBox("$You are currently defeated, you need to wait for the scene to end or use Clean up function before you can disable this feature.")
	Endif
	Stop()
Endfunction

Function Install(Bool Reconfigure = False)
	If !Reconfigure
		Start()
		McmConfig.Install()
		McmConfig.ModStatus = "$Enabled"
	Endif

	SexLab = SexLabUtil.GetAPI()
	SexLabConfig = SexLabUtil.GetConfig()

	TieUpSlots = New Actor[50]
	KnockoutSlots = New Actor[30]

	MiscQuests = New Quest[9]
	MiscQuests[0] = (GetFormFromFile(0xD62, "SexLabDefeat.esp") As Quest)	; PlayerQST
	MiscQuests[1] = (GetFormFromFile(0xBD631, "SexLabDefeat.esp") As Quest)	; PAQst
	MiscQuests[2] = (GetFormFromFile(0x36014, "SexLabDefeat.esp") As Quest)	; PlayerActionQst
	MiscQuests[3] = (GetFormFromFile(0x6E968, "SexLabDefeat.esp") As Quest)	; NPCsQst
	MiscQuests[4] = (GetFormFromFile(0x6E96C, "SexLabDefeat.esp") As Quest)	; NPCsRefreshQst
	MiscQuests[5] = (GetFormFromFile(0xC16D7, "SexLabDefeat.esp") As Quest)	; Robber
	MiscQuests[6] = (GetForm(0x47AE6) As Quest)								; DGIntimidateQuest
	MiscQuests[7] = (GetForm(0x2BA16) As Quest)								; WerewolfQst
	MiscQuests[8] = None													; VampireLordQst
	MiscFormLists = New FormList[2]
	MiscFormLists[0] = (GetFormFromFile(0xDC642, "SexLabDefeat.esp") As FormList) 	; MiscStuff
	MiscFormLists[1] = (GetFormFromFile(0x11B22E, "SexLabDefeat.esp") As FormList) 	; DBBedList
;	MiscGlobals = New GlobalVariable[0]
	Killmoves = New Idle[12] ; Paired anims / Killmoves
	Killmoves[0] = (GetFormFromFile(0xED3DF, "SexLabDefeat.esp") As Idle) ; Defeat Sleeper 			PA
	Killmoves[1] = (GetForm(0xF465A) As Idle) ; BackStab 1H 										PA
	Killmoves[2] = (GetForm(0xF4679) As Idle) ; Slit throat 										PA
	Killmoves[3] = (GetFormFromFile(0x81E, "Update.esm") As Idle) ; BackStab 2H 					PA
	Killmoves[4] = (GetFormFromFile(0x815, "Update.esm") As Idle) ; Neck Break 						PA
	Killmoves[5] = (GetForm(0xF469E) As Idle) ; Bleedout kill 										PA
	Killmoves[6] = (GetForm(0xF469A) As Idle) ; ShortA Slash down high 								PA
	Killmoves[7] = (GetForm(0xF469B) As Idle) ; ShortB sword in belly								PA
	Killmoves[8] = (GetForm(0xF469C) As Idle) ; ShortC Quick slash 									PA
	Killmoves[9] = (GetForm(0xF469D) As Idle) ; ShortD Sword to throat 								PA
	Killmoves[10] = (GetForm(0xF9958) As Idle) ; Combo 3 punches									PA
	Killmoves[11] = (GetForm(0x108A45) As Idle) ; ShortJ Push ground stomp head 					PA
	MiscIdles = New Idle[2]
	MiscIdles[0] = (GetForm(0x13ECC) As Idle) 	; BleedoutStart
	MiscIdles[1] = (GetForm(0x13ECE) As Idle) 	; BleedoutStop
	TopicToSay = New Topic[21]
	TopicToSay[0] = (GetForm(0x13EBB) As Topic) ; Hit
	TopicToSay[1] = (GetForm(0x13EE3) As Topic) ; Attack
	TopicToSay[2] = (GetForm(0x13EE4) As Topic) ; Death
	TopicToSay[3] = (GetForm(0x13F30) As Topic) ; Flee
	TopicToSay[4] = (GetForm(0x2A459) As Topic) ; Assault
	TopicToSay[5] = (GetForm(0x46648) As Topic) ; Taunt
	TopicToSay[6] = (GetForm(0x3F500) As Topic) ; AcceptYield
	TopicToSay[7] = (GetForm(0x3F500) As Topic) ; MurderNC
	TopicToSay[8] = (GetForm(0x39B95) As Topic) ; BleedOut
	TopicToSay[9] = (GetForm(0x13EBA) As Topic) ; PowerAttack
	TopicToSay[10] = (GetForm(0x39C2C) As Topic) ; PickPocketNC
	TopicToSay[11] = (GetForm(0x2A45A) As Topic) ; PickPocketCombat				
	TopicToSay[12] = (GetForm(0x21405) As Topic) ; DialogueGenericPoisonCoughBranchTopic (Cough)
	TopicToSay[13] = (GetForm(0x2A45B) As Topic) ; Steal
	TopicToSay[14] = (GetForm(0x26EC9) As Topic) ; Follower Agree
	TopicToSay[15] = (GetForm(0x26EC3) As Topic) ; Follower Refuse
	TopicToSay[16] = (GetForm(0x26E7D) As Topic) ; Follower MoralRefusal
	TopicToSay[17] = (GetFormFromFile(0x31057DB, "SexLabDefeat.esp") As Topic)  ; Player victim commentaries
	TopicToSay[18] = (GetFormFromFile(0x31057DD, "SexLabDefeat.esp") As Topic)  ; Forgive
	TopicToSay[19] = (GetFormFromFile(0x311C7C2, "SexLabDefeat.esp") As Topic)  ; Witness comment
	TopicToSay[20] = (GetFormFromFile(0x3108301, "SexLabDefeat.esp") As Topic)  ; Can I join comment
	SoundToPlay = New Sound[9]
	SoundToPlay[0] = (GetForm(0x1E68D) As Sound) ; Sand throwing		 AMBDustDropImpactSD
	SoundToPlay[1] = (GetForm(0x2A4A1) As Sound) ; Bow					 WPNBowFireSD
	SoundToPlay[2] = (GetForm(0x36515) As Sound) ; Bottle break		 	 MAGIcicleImpactBreak
	SoundToPlay[3] = (GetForm(0x53A60) As Sound) ; Telekinesis push		 MAGAlterationTelekinesisThrow
	SoundToPlay[4] = (GetForm(0x183FA) As Sound) ; Bash shield			 WPNBashShield
	SoundToPlay[5] = (GetForm(0x183F8) As Sound) ; Bash weapon			 WPNBashBlade
	SoundToPlay[6] = (GetForm(0x334A9) As Sound) ; Undress				 ITMClothingDown
	SoundToPlay[7] = (GetForm(0x22472) As Sound) ; Fail					 MAGFail
	SoundToPlay[8] = (GetForm(0x5228C) As Sound) ; Rescue (hit)			 NPCKillMelee
	ResistSpells = New Spell[10]
	ResistSpells[0] = (GetFormFromFile(0x55522, "SexLabDefeat.esp") As Spell) ; ResistArcherySpell
	ResistSpells[1] = (GetFormFromFile(0x55525, "SexLabDefeat.esp") As Spell) ; ResistDestructionFireSpell
	ResistSpells[2] = (GetFormFromFile(0x55534, "SexLabDefeat.esp") As Spell) ; ResistDestructionFrostSpell
	ResistSpells[3] = (GetFormFromFile(0x55537, "SexLabDefeat.esp") As Spell) ; ResistDestructionShockSpell
	ResistSpells[4] = (GetFormFromFile(0x5552B, "SexLabDefeat.esp") As Spell) ; ResistConjurationFireSpell
	ResistSpells[5] = (GetFormFromFile(0x5702C, "SexLabDefeat.esp") As Spell) ; ResistConjurationFrostSpell
	ResistSpells[6] = (GetFormFromFile(0x5702E, "SexLabDefeat.esp") As Spell) ; ResistConjurationShockSpell
	ResistSpells[7] = (GetFormFromFile(0x55531, "SexLabDefeat.esp") As Spell) ; ResistAlterationSpell
	ResistSpells[8] = (GetFormFromFile(0x55FFD, "SexLabDefeat.esp") As Spell) ; ResistSneakSpell
	ResistSpells[9] = (GetFormFromFile(0x55528, "SexLabDefeat.esp") As Spell) ; ResistAlchemySpell
	MiscReferences = New ObjectReference[5]
	MiscReferences[0] = (GetFormFromFile(0xE9336, "SexLabDefeat.esp") As ObjectReference)	; PosRef
	MiscReferences[1] = (GetFormFromFile(0x96F96, "SexLabDefeat.esp") As ObjectReference)	; NecroChest
	MiscReferences[2] = (GetFormFromFile(0x103CE6, "SexLabDefeat.esp") As ObjectReference)	; BurlapSackMarker
	MiscReferences[3] = (GetFormFromFile(0x105274, "SexLabDefeat.esp") As ObjectReference)	; BurlapSackWorldMarker
	MiscReferences[4] = None 																; BurlapSackWorldForm
	MiscMessages = New Message[3]
	MiscMessages[0] = (GetFormFromFile(0x6B8E5, "SexLabDefeat.esp") As Message)		; DefeatOptionMess
	MiscMessages[1] = (GetFormFromFile(0x11510A, "SexLabDefeat.esp") As Message)	; DefeatOptionCleanMess
	MiscMessages[2] = (GetFormFromFile(0x129F5D, "SexLabDefeat.esp") As Message)	; DefeatNVNAuto3WayFollowerMess
	AssaultNVNMess = New Message[10]
	AssaultNVNMess[0] = (GetFormFromFile(0x7BA6B, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess
	AssaultNVNMess[1] = (GetFormFromFile(0x7BA6C, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess000
	AssaultNVNMess[2] = (GetFormFromFile(0x7BA6D, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess001
	AssaultNVNMess[3] = (GetFormFromFile(0x7BA6E, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess002
	AssaultNVNMess[4] = (GetFormFromFile(0x7BA6F, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess003
	AssaultNVNMess[5] = (GetFormFromFile(0x86C40, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess004
	AssaultNVNMess[6] = (GetFormFromFile(0x86C41, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess005
	AssaultNVNMess[7] = (GetFormFromFile(0x86C42, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess006
	AssaultNVNMess[8] =	(GetFormFromFile(0x86C43, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess007
	AssaultNVNMess[9] = (GetFormFromFile(0x86C44, "SexLabDefeat.esp") As Message) ; DefeatAssaultNPCMess008
	; 2015.08.01 / Mod / 4 -> 5
	MiscVoicetypes = New VoiceType[5]
	MiscVoicetypes[0] = (GetForm(0x1F1CD) As VoiceType)	; DraugrV CrDraugrVoice
	MiscVoicetypes[1] = (GetForm(0x1F1D2) As VoiceType)	; FalmerV CrFalmerVoice
	MiscVoicetypes[2] = (GetForm(0x1F21D) As VoiceType)	; SpiderV CrFrostbiteSpiderVoice
	MiscVoicetypes[3] = None 							; Riekling
	; 00_CrZombieVoice [VTYP:0200B4A9]
	MiscVoicetypes[4] = (GetFormFromFile(0xB4A9, "zombie.esp") As VoiceType)	; Zombie
	; 2015.07.17 / Mod
	HotKeyInts = New Int[6]
	; 2015.07.17 / Mod
	HotKeyInts[0] = 11	; Option key
	HotKeyInts[1] = 42	; Modifier key
	HotKeyInts[2] = 34	; Action key
	HotKeyInts[3] = 37	; Surrender key
	; 2015.07.17 / Add
	; Regist/Unregist Captive Internal NPC List
	HotKeyInts[4] = 12
	; 2015.07.17 / Add
	; 2015.08.24 / Add
	HotKeyInts[5] = 10
	; 2015.08.24 / Add
	DefeatFactions
	DefeatFactions = New Faction[3]
	DefeatFactions[0] = (GetFormFromFile(0x1D92, "SexLabDefeat.esp") As Faction)	; DefeatFaction
	DefeatFactions[1] = (GetFormFromFile(0x8C862, "SexLabDefeat.esp") As Faction) 	; AggFaction
	DefeatFactions[2] = None 														; ZadAnimatingFaction
	FollowerFactions = New Faction[2]
	FollowerFactions[0] = (GetForm(0x5C84E) As Faction) ; CurrentFollowerFaction
	FollowerFactions[1] = (GetForm(0xBD738) As Faction) ; CurrentHireling
	MiscSpells = New Spell[6]
	MiscSpells[0] = (GetFormFromFile(0x12C7, "SexLabDefeat.esp") As Spell)		; DebuffSPL
	MiscSpells[1] = (GetFormFromFile(0x1D90, "SexLabDefeat.esp") As Spell)		; DebuffConsSPL
	MiscSpells[2] = (GetFormFromFile(0x79F1D, "SexLabDefeat.esp") As Spell) 	; DebuffSpeedSPL
	MiscSpells[3] = (GetFormFromFile(0x6E96A, "SexLabDefeat.esp") As Spell)		; NVNAssautSPL
	MiscSpells[4] = (GetFormFromFile(0x107D99, "SexLabDefeat.esp") As Spell)	; SexCrimeSPL
	MiscSpells[5] = (GetFormFromFile(0xD44D0, "SexLabDefeat.esp") As Spell)		; ImmunitySPL
	MiscMagicEffects = New MagicEffect[5]
	MiscMagicEffects[0] = (GetFormFromFile(0xD44CF, "SexLabDefeat.esp") As MagicEffect) ; ImmunityEFF
	MiscMagicEffects[1] = (GetFormFromFile(0x4DE88, "SexLabDefeat.esp") As MagicEffect) ; HKActionEFF
	MiscMagicEffects[2] = (GetFormFromFile(0x59B45, "SexLabDefeat.esp") As MagicEffect) ; HKFollowerActionEFF
	MiscMagicEffects[3] = (GetFormFromFile(0x107D97, "SexLabDefeat.esp") As MagicEffect) ; SexCrimeEFF
	MiscMagicEffects[4] = (GetFormFromFile(0x6E969, "SexLabDefeat.esp") As MagicEffect) ; NVNAssaultEFF
	MiscPackages = New Package[11]
	MiscPackages[0] = (GetFormFromFile(0xE9899, "SexLabDefeat.esp") As Package) ; DoNothing
	MiscPackages[1] = (GetFormFromFile(0x73575, "SexLabDefeat.esp") As Package) ; NVNAgressorPck01
	MiscPackages[2] = (GetFormFromFile(0x73AD8, "SexLabDefeat.esp") As Package) ; NVNAgressorPck02
	MiscPackages[3] = (GetFormFromFile(0x73ADC, "SexLabDefeat.esp") As Package) ; NVNAgressorPck03
	MiscPackages[4] = (GetFormFromFile(0x73ADD, "SexLabDefeat.esp") As Package) ; NVNAgressorPck04
	MiscPackages[5] = (GetFormFromFile(0x73ADE, "SexLabDefeat.esp") As Package) ; NVNAgressorPck05
	MiscPackages[6] = (GetFormFromFile(0x86C3E, "SexLabDefeat.esp") As Package) ; NVNAgressorPck06
	MiscPackages[7] = (GetFormFromFile(0x86C3F, "SexLabDefeat.esp") As Package) ; NVNAgressorPck07
	MiscPackages[8] = (GetFormFromFile(0x86C3B, "SexLabDefeat.esp") As Package) ; NVNAgressorPck08
	MiscPackages[9] = (GetFormFromFile(0x86C3C, "SexLabDefeat.esp") As Package) ; NVNAgressorPck09
	MiscPackages[10] = (GetFormFromFile(0x86C3D, "SexLabDefeat.esp") As Package) ; NVNAgressorPck10

	; SL controllermenu
	ControllerOptions = New String[5]
	ControllerOptions[0] = "$Animation stage - Forward"
	ControllerOptions[1] = "$Animation stage - Backward"
	ControllerOptions[2] = "$Disable current animation"
	ControllerOptions[3] = "Coitus interruptus"
	ControllerOptions[4] = "$Change current scene tag"
	ControllerTags = New String[24]
	ControllerTags[0] = "Foreplay"
	ControllerTags[1] = "Kissing"
	ControllerTags[2] = "Hugging"
	ControllerTags[3] = "Sex"
	ControllerTags[4] = "Vaginal"
	ControllerTags[5] = "Anal"
	ControllerTags[6] = "Oral"
	ControllerTags[7] = "Aggressive"
	ControllerTags[8] = "Straight"
	ControllerTags[9] = "Lesbian"
	ControllerTags[10] = "Missionary"
	ControllerTags[11] = "Cowgirl"
	ControllerTags[12] = "Doggy,Doggy Style,DoggyStyle"
	ControllerTags[13] = "Blowjob"
	ControllerTags[14] = "Boobjob"
	ControllerTags[15] = "Handjob"
	ControllerTags[16] = "Footjob"
	ControllerTags[17] = "Standing"
	ControllerTags[18] = "Laying"
	ControllerTags[19] = "Sideways"
	ControllerTags[20] = "Arrok"
	ControllerTags[21] = "AP"
	ControllerTags[22] = "Bleagh"
	ControllerTags[23] = "Zyn"
	
	; 2015.07.09 / Add
	CaptiveFactions = New Faction[11]
	; BanditFaction
	CaptiveFactions[0] = (GetFormFromFile(0x1BCC0, "Skyrim.esm") As Faction)
	; ForswornFaction
	CaptiveFactions[1] = (GetFormFromFile(0x43599, "Skyrim.esm") As Faction)
	; SilverHandFaction
	CaptiveFactions[2] = (GetFormFromFile(0xAA0A4, "Skyrim.esm") As Faction)
	; 2015.07.09 / Add
	; 2015.07.18 / Add
	; BanditFriendFaction
	CaptiveFactions[3] = (GetFormFromFile(0x44EF6, "Skyrim.esm") As Faction)
	; BanditAllyFaction
	CaptiveFactions[4] = (GetFormFromFile(0xE0CD9, "Skyrim.esm") As Faction)
	; SilverHandFactionPacified
	CaptiveFactions[5] = (GetFormFromFile(0xA6F88, "Skyrim.esm") As Faction)
	; ThalmorFaction [FACT:00039F26]
	CaptiveFactions[6] = (GetFormFromFile(0x39F26, "Skyrim.esm") As Faction)
	; ThievesGuildFaction [FACT:00029DA9]
	CaptiveFactions[7] = (GetFormFromFile(0x29DA9, "Skyrim.esm") As Faction)
	; VampireFaction [FACT:00027242]
	CaptiveFactions[8] = (GetFormFromFile(0x27242, "Skyrim.esm") As Faction)
	; VampireThrallFaction [FACT:0002EB13]
	CaptiveFactions[9] = (GetFormFromFile(0x2EB13, "Skyrim.esm") As Faction)
	; 2015.07.18 / Add
	; 2015.07.24 / Add
	; MS09NorthwatchFaction [FACT:000C0637]
	CaptiveFactions[10] = (GetFormFromFile(0xC0637, "Skyrim.esm") As Faction)
	; 2015.07.24 / Add
	
	NonCaptiveFactions = New Faction[3]
	; 2015.07.24 / Del
	; DwarvenAutomatonFaction
;	NonCaptiveFactions[0] = (GetFormFromFile(0x43598, "Skyrim.esm") As Faction)
	; 2015.07.24 / Del
	; DogFaction
	NonCaptiveFactions[0] = (GetFormFromFile(0x43596, "Skyrim.esm") As Faction)
	; FarmAnimalsFaction "FarmAnimalsFaction" [FACT:0004E849]
	NonCaptiveFactions[1] = (GetFormFromFile(0x4E849, "Skyrim.esm") As Faction)
	; SprigganPreyFaction "Spriggan Prey Faction" [FACT:0003E095]
	NonCaptiveFactions[2] = (GetFormFromFile(0x3E095, "Skyrim.esm") As Faction)
	; 2015.07.09 / Add
	; 2015.07.18 / Add
	; AtronachFlameFaction
;	NonCaptiveFactions[1] = (GetFormFromFile(0x44CCD, "Skyrim.esm") As Faction)
	; 2015.07.18 / Add
	
	; 2015.07.18 / Add
	maCaptiveBandits     = New ActorBase[35]
	; BanditBossM
	maCaptiveBandits[0]  = (GetFormFromFile(0x3DEDF, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[1]  = (GetFormFromFile(0x3DEE1, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[2]  = (GetFormFromFile(0x3DEE3, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[3]  = (GetFormFromFile(0x3DEE4, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[4]  = (GetFormFromFile(0x3DEE5, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[5]  = (GetFormFromFile(0x3DEE6, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[6]  = (GetFormFromFile(0x3DEE8, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[7]  = (GetFormFromFile(0x3DEEA, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[8]  = (GetFormFromFile(0x3DEEC, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[9]  = (GetFormFromFile(0x3DEED, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[10] = (GetFormFromFile(0x3DEEE, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[11] = (GetFormFromFile(0x3DEEF, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[12] = (GetFormFromFile(0x3DEF0, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[13] = (GetFormFromFile(0x3DEF1, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[14] = (GetFormFromFile(0x3DEF3, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[15] = (GetFormFromFile(0x3DEF5, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[16] = (GetFormFromFile(0x3DEF7, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[17] = (GetFormFromFile(0x3DEF8, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[18] = (GetFormFromFile(0x3DEF9, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[19] = (GetFormFromFile(0x3DEFA, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[20] = (GetFormFromFile(0x3DEFB, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[21] = (GetFormFromFile(0x3DEFD, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[22] = (GetFormFromFile(0x3DEFF, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[23] = (GetFormFromFile(0x3DF01, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[24] = (GetFormFromFile(0x3DF02, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[25] = (GetFormFromFile(0x3DF03, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[26] = (GetFormFromFile(0x3DF04, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[27] = (GetFormFromFile(0x3DF05, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[28] = (GetFormFromFile(0x3DF07, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[29] = (GetFormFromFile(0x3DF09, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[30] = (GetFormFromFile(0x3DF0B, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[31] = (GetFormFromFile(0x3DF0C, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[32] = (GetFormFromFile(0x3DF0D, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[33] = (GetFormFromFile(0x3DF0E, "Skyrim.esm") As ActorBase)
	maCaptiveBandits[34] = (GetFormFromFile(0x3DF0F, "Skyrim.esm") As ActorBase)
	
	maCaptiveThieves     = New ActorBase[1]
	; WIThief "Thief" [NPC_:00023EE8]
	maCaptiveThieves[0]  = (GetFormFromFile(0x23EE8, "Skyrim.esm") As ActorBase)
	
	maCaptiveForsworns     = New ActorBase[2]
	; EncForsworn01Melee1HBretonM01 [NPC_:00043BDD]
	maCaptiveForsworns[0]  = (GetFormFromFile(0x43BDD, "Skyrim.esm") As ActorBase)
	; EncForsworn01MissileBretonM01 [NPC_:00043BE7]
	maCaptiveForsworns[1]  = (GetFormFromFile(0x43BE7, "Skyrim.esm") As ActorBase)
	
	maCaptiveThalmors      = New ActorBase[1]
	; EncThalmor01MagicM [NPC_:0002B125]
	maCaptiveThalmors[0]   = (GetFormFromFile(0x2B125, "Skyrim.esm") As ActorBase)
	
	maCaptiveVampires      = New ActorBase[5]
	; EncVampire02BossBretonM [NPC_:0002E1DC]
	maCaptiveVampires[0] = (GetFormFromFile(0x2E1DC, "Skyrim.esm") As ActorBase)
	; EncVampire02BossDarkElfM [NPC_:0002E1DD]
	maCaptiveVampires[1] = (GetFormFromFile(0x2E1DD, "Skyrim.esm") As ActorBase)
	; EncVampire02BossHighElfM [NPC_:0002E1E1]
	maCaptiveVampires[2] = (GetFormFromFile(0x2E1E1, "Skyrim.esm") As ActorBase)
	; EncVampire02BossImperialM [NPC_:0003377B]
	maCaptiveVampires[3] = (GetFormFromFile(0x3377B, "Skyrim.esm") As ActorBase)
	; EncVampire02BossNordM [NPC_:0002E1E2]
	maCaptiveVampires[4] = (GetFormFromFile(0x2E1E2, "Skyrim.esm") As ActorBase)
	
	maCaptiveWarlocks    = New ActorBase[5]
	; EncWarlockAtro01BretonM [NPC_:0006D235]
	maCaptiveWarlocks[0] = (GetFormFromFile(0x6D235, "Skyrim.esm") As ActorBase)
	; EncWarlockFire01DarkElfM [NPC_:00044CE1]
	maCaptiveWarlocks[1] = (GetFormFromFile(0x44CE1, "Skyrim.esm") As ActorBase)
	; EncWarlockIce01NordM [NPC_:00045C76]
	maCaptiveWarlocks[2] = (GetFormFromFile(0x45C76, "Skyrim.esm") As ActorBase)
	; EncWarlockNecro02HighElfM [NPC_:000551BD]
	maCaptiveWarlocks[3] = (GetFormFromFile(0x551BD, "Skyrim.esm") As ActorBase)
	; EncWarlockStorm03ImperialM [NPC_:00045C96]
	maCaptiveWarlocks[4] = (GetFormFromFile(0x45C96, "Skyrim.esm") As ActorBase)
	
	maCaptiveDraugrs     = New ActorBase[3]
	; EncDraugr01Melee1HHeadM00 [NPC_:0005593B]
	maCaptiveDraugrs[0]  = (GetFormFromFile(0x5593B, "Skyrim.esm") As ActorBase)
	; EncDraugr02MissileHeadM00 [NPC_:00022400]
	maCaptiveDraugrs[1]  = (GetFormFromFile(0x22400, "Skyrim.esm") As ActorBase)
	; EncDraugr01Melee2HHeadM00 [NPC_:0001FB8F]
	maCaptiveDraugrs[2]  = (GetFormFromFile(0x1FB8F, "Skyrim.esm") As ActorBase)
	
	maCaptiveUndeads     = New ActorBase[1]
	; EncSkeleton01Melee1H "Skeleton" [NPC_:0002D1DE]
	maCaptiveUndeads[0]  = (GetFormFromFile(0x2D1DE, "Skyrim.esm") As ActorBase)
	
	maCaptiveFalmers     = New ActorBase[3]
	; EncFalmer01Template "Falmer" [NPC_:0003B54C]
	maCaptiveFalmers[0]  = (GetFormFromFile(0x3B54C, "Skyrim.esm") As ActorBase)
	; EncFalmer04Template "Falmer Nightprowler" [NPC_:0003B54E]
	maCaptiveFalmers[1]  = (GetFormFromFile(0x3B54E, "Skyrim.esm") As ActorBase)
	; EncChaurus "Chaurus" [NPC_:000A5600]
	maCaptiveFalmers[2]  = (GetFormFromFile(0xA5600, "Skyrim.esm") As ActorBase)
	
	maCaptiveDwarvens    = New ActorBase[2]
	; EncDwarvenSpider02 "Dwarven Spider" [NPC_:00023A98]
	maCaptiveDwarvens[0] = (GetFormFromFile(0x23A98, "Skyrim.esm") As ActorBase)
	; EncDwarvenSphere01 "Dwarven Sphere" [NPC_:0010EC89]
	maCaptiveDwarvens[1] = (GetFormFromFile(0x10EC89, "Skyrim.esm") As ActorBase)
	
	maCaptiveAnimals     = New ActorBase[5]
	; EncTroll "Troll" [NPC_:00023ABA]
	maCaptiveAnimals[0]  = (GetFormFromFile(0x23ABA, "Skyrim.esm") As ActorBase)
	; EncTrollFrost "Frost Troll" [NPC_:00023ABB]
	maCaptiveAnimals[1]  = (GetFormFromFile(0x23ABB, "Skyrim.esm") As ActorBase)
	; EncBear "Bear" [NPC_:00023A8A]
	maCaptiveAnimals[2]  = (GetFormFromFile(0x23A8A, "Skyrim.esm") As ActorBase)
	; 2015.07.26 / Add
	; EncWolf "Wolf" [NPC_:00023ABE]
	maCaptiveAnimals[3]  = (GetForm(0x23ABE) as ActorBase)
	; EncSabreCat "Sabre Cat" [NPC_:00023AB5]
	maCaptiveAnimals[4]  = (GetForm(0x23AB5) as ActorBase)
	; 2015.07.26 / Add
	
	maCaptiveWerewolves    = New ActorBase[1]
	; EncWerewolf01 "Werewolf" [NPC_:00023ABC]
	maCaptiveWerewolves[0] = (GetFormFromFile(0x23ABC, "Skyrim.esm") As ActorBase)
	
	maCaptiveGiants     = New ActorBase[1]
	; EncGiant01 "Giant" [NPC_:00023AAE]
	maCaptiveGiants[0]  = (GetFormFromFile(0x23AAE, "Skyrim.esm") As ActorBase)
	
	maCaptiveOrcs     = New ActorBase[1]
	; WEAdventurerBrawlerOrcM "Orc" [NPC_:00109A7E]
	maCaptiveOrcs[0]  = (GetFormFromFile(0x109A7E, "Skyrim.esm") As ActorBase)
	
	maCaptiveVictims        = New ActorBase[8]
	; WEFarmerFemale "Farmer" [NPC_:001034E6]
	maCaptiveVictims[0]     = (GetFormFromFile(0x1034E6, "Skyrim.esm") As ActorBase)
	; WEAdventurerWarriorNordF "Nord" [NPC_:00103503]
	maCaptiveVictims[1]     = (GetFormFromFile(0x103503, "Skyrim.esm") As ActorBase)
	; EncGuardSonsF01FemaleNord "Stormcloak Soldier" [NPC_:000AA922]
	maCaptiveVictims[2]     = (GetFormFromFile(0xAA922, "Skyrim.esm") As ActorBase)
	; WEAdventurerBrawlerOrcF "Orc" [NPC_:00105562]
	maCaptiveVictims[3]     = (GetFormFromFile(0x105562, "Skyrim.esm") As ActorBase)
	; Urwa "Hunter" [NPC_:0002FFEB]
	maCaptiveVictims[4]     = (GetFormFromFile(0x2FFEB, "Skyrim.esm") As ActorBase)
	; WEAdventurerDualPoisonerImperialF "Imperial" [NPC_:00103501]
	maCaptiveVictims[5]     = (GetFormFromFile(0x103501, "Skyrim.esm") As ActorBase)
	; WEAdventurerRangedConjurerWoodElfF "Wood Elf" [NPC_:0010554F]
	maCaptiveVictims[6]     = (GetFormFromFile(0x10554F, "Skyrim.esm") As ActorBase)
	; WERoad02NobleF "Noble" [NPC_:00102D63]
	maCaptiveVictims[7]     = (GetFormFromFile(0x102D63, "Skyrim.esm") As ActorBase)
	
	maCaptiveExcludeVoices    = New VoiceType[2]
	; FemaleOldKindly [VTYP:00013AE1]
	maCaptiveExcludeVoices[0] = (GetFormFromFile(0x13AE1, "Skyrim.esm") As VoiceType)
	; 2015.07.18 / Add
	; 2015.07.24 / Add
	; FemaleOldGrumpy [VTYP:00013AE2]
	maCaptiveExcludeVoices[1] = (GetFormFromFile(0x13AE2, "Skyrim.esm") As VoiceType)
	; 2015.07.24 / Add
	
	; 2015.08.05 / Add
	maRapeClubExcludeVoices    = New VoiceType[2]
	; MaleChild [VTYP:00013AE8]
	maRapeClubExcludeVoices[0] = GetForm(0x13AE8) as VoiceType
	; MaleUniqueAventusAretino [VTYP:00047496]
	maRapeClubExcludeVoices[1] = GetForm(0x47496) as VoiceType
	; 2015.08.05 / Add
	
	; 2015.07.20 / Add
	; zzEstrusToken2 "zzEstrusToken2" [MISC:01012B95]
	moEstrusToken = (GetFormFromFile(0x12B95, "zzEstrus.esp") as Miscobject)
	; zzEstrusEffect [KYWD:01005E4F]
	mkwEstrusEffect = (GetFormFromFile(0x5E4F, "zzEstrus.esp") as Keyword)
	; 2015.07.20 / Add
	
	; 2015.07.22 / Add
	; ArmorDwarvenHelmet "Dwarven Helmet" [ARMO:0001394F]
	; ArmorDwarvenCuirass "Dwarven Armor" [ARMO:0001394D]
	; ArmorDwarvenGauntlets "Dwarven Gauntlets" [ARMO:0001394E]
	; ArmorDwarvenBoots "Dwarven Boots" [ARMO:0001394C]
	maDwarvenArmors    = new Armor[4]
	maDwarvenArmors[0] = GetForm(0x1394F) as Armor
	maDwarvenArmors[1] = GetForm(0x1394D) as Armor
	maDwarvenArmors[2] = GetForm(0x1394E) as Armor
	maDwarvenArmors[3] = GetForm(0x1394C) as Armor
	
	; CrDwarvenCenturionVoice [VTYP:0001F1CF]
	mvocDwarven = GetForm(0x1F1CF) as VoiceType
	
	; DwarvenAutomatonFaction
	mfctDwarven = GetForm(0x43598) as Faction
	
	; SummonTargetFXActivator [ACTI:0007CD55]
	mactvSummonFX = GetForm(0x7CD55) as Activator
	
	; LvlBanditGhostMelee1HMale "Ghost" [NPC_:000B1F96]
	; EncBandit01Melee1HTankNordM [NPC_:0003DE8A]
	; dunNorthwatchPrisoner01 "Northwatch Prisoner" [NPC_:000C1A9E]
	; WEDL03ImpBodyguard "Bodyguard" [NPC_:000B91A6]
	; MQ101Prisoner "Lokir" [NPC_:0004679A]
	mabDwarvenRaper = GetForm(0xB1F96) as ActorBase
	; 2015.07.22 / Add
	
	; 2015.07.25 / Add
	; SprigganFaction
	mfctSpriggan = GetForm(0x3E094) as Faction
	; 2015.07.25 / Add
	
	; 2015.07.26 / Add
	; AbGhostNew "Ghost Visuals" [MGEF:000D2053]
	msplGhostNew = GetForm(0xD2053) as Spell
	; DaedraFaction "Daedra" [FACT:0002B0E5]
	mfctDaedra   = GetForm(0x2B0E5) as Faction
	; GhostAbilityFireNoAlpha "Ghost Ability" [SPEL:0010F5A7]
	msplFireWolf = GetForm(0x10F5A7) as Spell
	
	maFlamingRapers    = new ActorBase[2]
	; SummonFlamingThrall "Flaming Thrall" [NPC_:0009CE28]
;	maFlamingRapers[0] = GetForm(0x9CE28) as ActorBase
	; EncWolf "Wolf" [NPC_:00023ABE]
	maFlamingRapers[0]  = (GetForm(0x23ABE) as ActorBase)
	; EncSkeleton01Melee1H "Skeleton" [NPC_:0002D1DE]
	maFlamingRapers[1]  = (GetForm(0x2D1DE) as ActorBase)
	; 2015.07.26 / Add
	
	; 2015.07.26 / Add
	maTieupYokes    = new Armor[6]
	maTieupYokes[0] = MiscFormLists[0].GetAt(3) as Armor
	
	maTieupArmBinders    = new Armor[2]
	maTieupArmBinders[0] = MiscFormLists[0].GetAt(4) as Armor
	
	maTieupSlot30        = new Armor[20]
	maTieupSlot44        = new Armor[20]
	maTieupSlot45        = new Armor[20]
	maTieupSlot49        = new Armor[20]
	maTieupSlot53        = new Armor[20]
	maTieupSlot55        = new Armor[20]
	maTieupSlot59        = new Armor[20]
	maTieupSlot61        = new Armor[20]
	; 2015.07.26 / Add
	
	; 2015.07.30 / Add
	maNoCaptiveLocations    = new Location[2]
	; SRMChangeRaceLocation [LCTN:01002BCE]
	maNoCaptiveLocations[0] = GetFormFromFile(0x2BCE, "ShowRaceMenuAlternative.esp") as Location
	; 2015.07.30 / Add
	; 2015.08.02 / Add
	maNoCaptiveLocations[1] = GetFormFromFile(0xD70, "HavenBag.esp") as Location
	; 2015.08.02 / Add
	
	; 2015.08.01 / Add
	; DragonPowerAbsorbFXS [EFSH:000280C0]
	; BerserkerFXS [EFSH:000FD7D9]
	; DarkElfAncestorsWrathFXShader [EFSH:0010F56C]
	; IllusionNegativeFXS [EFSH:00074799]
	mefsRapeAttack = GetForm(0x74799) as EffectShader
	; MAGDragonPowerAbsorbManEffect [RFCT:0002E6AD]
	mvefRapeAttack = GetForm(0x2E6AD) as VisualEffect
	; 2015.08.01 / Add
	; 2015.08.08 / Add
	; ExplosionIllusionDark01 [EXPL:0004046D]
	mexpRapeAttack = GetForm(0x4046D) as Explosion
	; 2015.08.08 / Add
	
	; 2015.08.02 / Add
	; [DIAL:030B54B4]
	; [INFO:030D5502] About female vampires
	mtpcAboutVictim = GetFormFromFile(0xB54B4, "SexLabDefeat.esp") As Topic
	; 2015.08.02 / Add
	
	; 2015.07.15 / Add
	If maInternalNpcList.Length != 40
		maInternalNpcList = New Actor[40]
	Endif
	; 2015.07.15 / Add
	
	; 2015.08.02 / Add
	If maRapeClubMembers.Length != 40
		maRapeClubMembers = New Actor[40]
	Endif
	
	; ExecutionHoodDB "Execution Hood" [ARMO:0005A9E3]
	marmRapeClubHood = GetForm(0x5A9E3) as Armor
	; 2015.08.02 / Add
	
	; 2015.09.12 / Add
	maSoundToSay    = new Sound[4]
	; 2015.09.12 / Add
	maSoundToSay[2] = GetFormFromFile(0x080801, "SexLabDefeat.esp") as Sound
	maSoundToSay[3] = GetFormFromFile(0x080802, "SexLabDefeat.esp") as Sound
	; 2015.09.12 / Add
	
	CheckForMods()
;	If (McmConfig.OnOffPagg == "$Disabled")
		OnOffFeature("PlayerAgg", True)
;	Endif
;	If (McmConfig.OnOffPvic == "$Disabled")
		OnOffFeature("PlayerVic", True)
;	Endif
;	If (McmConfig.OnOffNVN == "$Disabled")
		OnOffFeature("", True)
;	Endif
	Maintenance()
	
	; 2015.08.07 / Add
	setTieupDeviceForms()
	setTonguesForms()
	; 2015.08.07 / Add
	
	; 2015.09.06 / Add
	setLeftForDeadLocations()
	Hkrefresh()
	; 2015.09.06 / Add
	
	GoToState("")
	Notification("$Defeat: Installed")
Endfunction

; 2015.08.07 / Add
Function setTonguesForms()
	Armor  armFind
	Int    nFormID
	Int    nEndFormID
	String szModName
	Int    nIdx       = 0
	
	If (EQTONGUESCRon || EQTONGUEon) && !HTOOLSon
		maTongues = new Armor[10]
	Elseif !EQTONGUESCRon && !EQTONGUEon && HTOOLSon
		maTongues = new Armor[16]
	Elseif (EQTONGUESCRon || EQTONGUEon) && HTOOLSon
		maTongues = new Armor[26]
	Else
		Return
	Endif
	
	If EQTONGUESCRon
		; linga1armor "Tongue 1" [ARMO:01003DE6]
		; linga10armor "Tongue 10" [ARMO:01003DEF]
		nIdx       = 0
		nFormID    = 0x3DE6
		nEndFormID = 0x3DEF
		szModName  = "Tongueswcript.esp"
	Elseif EQTONGUEon
		; lingaa1armor "Tongue 1" [ARMO:01000D6C]
		; lingaa10armor "Tongue 10" [ARMO:01000D75]
		nIdx       = 0
		nFormID    = 0xD6C
		nEndFormID = 0xD75
		szModName  = "Tongues.esp"
	Endif
	
	If EQTONGUESCRon || EQTONGUEon
		While (nFormID <= nEndFormID)
			armFind = GetFormFromFile(nFormID, szModName) As Armor
			
			If armFind
				maTongues[nIdx] = armFind
				nIdx += 1
			Endif
			
			nFormID += 1
		EndWhile
	Endif
	
	If HTOOLSon
		; TongueA1 "Tongue A1" [ARMO:01003902]
		; TongueE16 "Tongue E16" [ARMO:01003951]
		nFormID    = 0x3902
		nEndFormID = 0x3911
		szModName  = "HTools.esp"
		
		While (nFormID <= nEndFormID)
			armFind = GetFormFromFile(nFormID, szModName) As Armor
			
			If armFind
				maTongues[nIdx] = armFind
				nIdx += 1
			Endif
			
			nFormID += 1
		EndWhile
	Endif
Endfunction
; 2015.08.07 / Add

; 2015.07.26 / Add
Function setTieupDeviceForms()
	Int    nIdx
	Int    nCnt
	Int    nMax
	String szMod
	Int    nYokeIdx      = 1
	Int    nArmBinderIdx = 1
	Int    nSlot30Idx    = 0
	Int    nSlot44Idx    = 0
	Int    nSlot45Idx    = 0
	Int    nSlot49Idx    = 0
	Int    nSlot53Idx    = 0
	Int    nSlot55Idx    = 0
	Int    nSlot59Idx    = 0
	Int    nSlot61Idx    = 0
	
	; Check Addon
	If !Zazon
		Return
	Endif
	
	maTieupDevices    = new Armor[100] 
	; ZaZAPECocoonWebbing01 [ARMO:02006436]
	maTieupDevices[0] = GetFormFromFile(0x6436, "ZaZAnimationPack.esm") as Armor
	; ZaZAPECocoonSuit01 [ARMO:02005960]
	maTieupDevices[1] = GetFormFromFile(0x5960, "ZaZAnimationPack.esm") as Armor
	; ZaZAPECocoonSuit02 [ARMO:02005EC5]
	maTieupDevices[2] = GetFormFromFile(0x5EC5, "ZaZAnimationPack.esm") as Armor
	; ZaZAPECocoonSuit03 [ARMO:02006438]
	maTieupDevices[3] = GetFormFromFile(0x6438, "ZaZAnimationPack.esm") as Armor
	; ZaZAPECocoonSpool01 [ARMO:02005EC6] (Not using)
	maTieupDevices[4] = GetFormFromFile(0x5EC6, "ZaZAnimationPack.esm") as Armor
	
	nIdx  = 5
	
	; zbfWristLeatherBinds [ARMO:02001002]
	nCnt  = 0x1002
	nMax  = 0x1003
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
		maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
		nSlot59Idx += 1
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfGagLogBit01 [ARMO:02002001]
	nCnt  = 0x2001
	nMax  = 0x2011
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
		maTieupSlot44[nSlot44Idx] = maTieupDevices[nIdx]
		nSlot44Idx += 1
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfCuffsSimpleBrown [ARMO:02003001]
	nCnt  = 0x3001
	nMax  = 0x3009
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx] = GetFormFromFile(nCnt, szMod) as Armor
		
		If (nCnt == 0x3003) || (nCnt == 0x3004)
			maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
			nSlot45Idx += 1
		Else
			maTieupSlot53[nSlot53Idx] = maTieupDevices[nIdx]
			maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
			nSlot53Idx += 1
			nSlot59Idx += 1
		Endif
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfAnkleLeatherBinds [ARMO:02004001]
	nCnt  = 0x4001
	nMax  = 0x4002
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
		maTieupSlot53[nSlot53Idx] = maTieupDevices[nIdx]
		nSlot53Idx += 1
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfBlindEyeMask01 [ARMO:02005001]
	nCnt  = 0x5001
	nMax  = 0x5003
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx] = GetFormFromFile(nCnt, szMod) as Armor
		
		If (nCnt == 0x5001)
			maTieupSlot55[nSlot55Idx] = maTieupDevices[nIdx]
			nSlot55Idx += 1
		Elseif (nCnt == 0x5002)
			maTieupSlot30[nSlot30Idx] = maTieupDevices[nIdx]
			nSlot30Idx += 1
		Else
			maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
			nSlot45Idx += 1
		Endif
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfHoodDark [ARMO:02005006]
	nCnt  = 0x5006
	nMax  = 0x5012
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx] = GetFormFromFile(nCnt, szMod) as Armor
		
		If (nCnt == 0x5006) || (nCnt == 0x5007)
			maTieupSlot30[nSlot30Idx] = maTieupDevices[nIdx]
			nSlot30Idx += 1
		Elseif (nCnt == 0x5008) || (nCnt == 0x5009) || (nCnt == 0x500A)
			maTieupSlot49[nSlot49Idx] = maTieupDevices[nIdx]
			nSlot49Idx += 1
		Elseif (nCnt == 0x500C) || (nCnt == 0x500D) || (nCnt == 0x500E) || (nCnt == 0x5012)
			maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
			nSlot45Idx += 1
		Else
			maTieupSlot55[nSlot55Idx] = maTieupDevices[nIdx]
			nSlot55Idx += 1
		Endif
		
		nCnt += 1
		nIdx += 1
	EndWhile
	
	; zbfCuffsGSB "zbf Cuffs GSB" [ARMO:02005D91]
	nCnt  = 0x5D91
	szMod = "ZaZAnimationPack.esm"
	maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
	maTieupSlot53[nSlot53Idx] = maTieupDevices[nIdx]
	maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
	nSlot53Idx += 1
	nSlot59Idx += 1
	nIdx += 1
	
	; zbfYokeWood01 "zbf Yoke Wood 01" [ARMO:02021BB9]
	nCnt  = 0x21BB9
	szMod = "ZaZAnimationPack.esm"
	maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
	maTieupYokes[nYokeIdx]    = maTieupDevices[nIdx]
	maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
	maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
	nYokeIdx   += 1
	nSlot45Idx += 1
	nSlot59Idx += 1
	nIdx       += 1
	
	; zbfWristArmbinder01 "zbf Wrist Armbinder 01" [ARMO:02023143]
	nCnt  = 0x23143
	szMod = "ZaZAnimationPack.esm"
	maTieupDevices[nIdx]             = GetFormFromFile(nCnt, szMod) as Armor
	maTieupArmBinders[nArmBinderIdx] = maTieupDevices[nIdx]
	maTieupSlot59[nSlot59Idx]        = maTieupDevices[nIdx]
	nArmBinderIdx += 1
	nSlot59Idx    += 1
	nIdx          += 1
	
	; zbfYokeWood02 "zbf Yoke Wood 02" [ARMO:02023147]
	nCnt  = 0x23147
	nMax  = 0x23148
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
		maTieupYokes[nYokeIdx]    = maTieupDevices[nIdx]
		maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
		maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
		
		nYokeIdx   += 1
		nSlot45Idx += 1
		nSlot59Idx += 1
		nCnt       += 1
		nIdx       += 1
	EndWhile
	
	; zbfYokeMetal01 "zbf Yoke Metal 01" [ARMO:0202314C]
	nCnt  = 0x2314C
	nMax  = 0x2314D
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx]      = GetFormFromFile(nCnt, szMod) as Armor
		maTieupYokes[nYokeIdx]    = maTieupDevices[nIdx]
		maTieupSlot45[nSlot45Idx] = maTieupDevices[nIdx]
		maTieupSlot59[nSlot59Idx] = maTieupDevices[nIdx]
		
		nYokeIdx   += 1
		nSlot45Idx += 1
		nSlot59Idx += 1
		nCnt       += 1
		nIdx       += 1
	EndWhile
	
	; ZaZAPEF201ALeakyPussyDrops "ZaZ F2 01ALeakyPussyDrops" [ARMO:02026D5D]
	nCnt  = 0x26D5D
	nMax  = 0x26D64
	szMod = "ZaZAnimationPack.esm"
	While nCnt <= nMax
		maTieupDevices[nIdx] = GetFormFromFile(nCnt, szMod) as Armor
		maTieupSlot61[nSlot61Idx] = maTieupDevices[nIdx]
		nSlot61Idx += 1
		
		nCnt += 1
		nIdx += 1
	EndWhile
Endfunction
; 2015.07.26 / Add

; 2015.09.06 / Add
Function setLeftForDeadLocations()
	Int nIdx = 0
	
	maLeftForDeadCells = new Int[32]
	maLeftForDeadPosX  = new Float[32]
	maLeftForDeadPosY  = new Float[32]
	maLeftForDeadPosZ  = new Float[32]
	
	; TrevasWatch01 "Treva's Watch" [CELL:00015200]
	maLeftForDeadCells[nIdx] = 0x00015200
	maLeftForDeadPosX[nIdx]  = 2791.691162
	maLeftForDeadPosY[nIdx]  = -377.810699
	maLeftForDeadPosZ[nIdx]  = 904.907471
	nIdx += 1
	; FaldarsTooth01 "Faldar's Tooth" [CELL:00015286]
	maLeftForDeadCells[nIdx] = 0x00015286
	maLeftForDeadPosX[nIdx]  = 1567.974487
	maLeftForDeadPosY[nIdx]  = -3817.542480
	maLeftForDeadPosZ[nIdx]  = -928.000000
	nIdx += 1
	; NorthwatchKeep01 "Northwatch Keep" [CELL:00015235]
	maLeftForDeadCells[nIdx] = 0x00015235
	maLeftForDeadPosX[nIdx]  = 938.656250
	maLeftForDeadPosY[nIdx]  = -4194.829590
	maLeftForDeadPosZ[nIdx]  = -476.131378
	nIdx += 1
	; NorthwatchKeep01 "Northwatch Keep" [CELL:00015235]
	maLeftForDeadCells[nIdx] = 0x00015235
	maLeftForDeadPosX[nIdx]  = -66.715637
	maLeftForDeadPosY[nIdx]  = -6438.454102
	maLeftForDeadPosZ[nIdx]  = -430.727844
	nIdx += 1
	; FortGreymoor02 "Fort Greymoor Prison" [CELL:000352C7]
	maLeftForDeadCells[nIdx] = 0x000352C7
	maLeftForDeadPosX[nIdx]  = 1947.733643
	maLeftForDeadPosY[nIdx]  = 3066.457275
	maLeftForDeadPosZ[nIdx]  = 272.788452
	nIdx += 1
	; FortAmol02 "Fort Amol Prison" [CELL:00034955]
	maLeftForDeadCells[nIdx] = 0x00034955
	maLeftForDeadPosX[nIdx]  = 1135.667480
	maLeftForDeadPosY[nIdx]  = 836.229675
	maLeftForDeadPosZ[nIdx]  = -512.000000
	nIdx += 1
	; SightlessPit01 "Sightless Pit" [CELL:00035299]
	maLeftForDeadCells[nIdx] = 0x00035299
	maLeftForDeadPosX[nIdx]  = 840.718445
	maLeftForDeadPosY[nIdx]  = 428.326874
	maLeftForDeadPosZ[nIdx]  = 835.110168
	nIdx += 1
	; FortDunstad02 "Fort Dunstad Prison" [CELL:00052390]
	maLeftForDeadCells[nIdx] = 0x00052390
	maLeftForDeadPosX[nIdx]  = -1102.614502
	maLeftForDeadPosY[nIdx]  = -1258.060669
	maLeftForDeadPosZ[nIdx]  = 2624.000000
	nIdx += 1
	; FortGreenwall02 "Fort Greenwall Prison" [CELL:0005B88B]
	maLeftForDeadCells[nIdx] = 0x0005B88B
	maLeftForDeadPosX[nIdx]  = 3062.422607
	maLeftForDeadPosY[nIdx]  = 1083.420776
	maLeftForDeadPosZ[nIdx]  = -780.218323
	nIdx += 1
	; FortSungard03 "Fort Sungard Oubliette" [CELL:0001AB5F]
	maLeftForDeadCells[nIdx] = 0x0001AB5F
	maLeftForDeadPosX[nIdx]  = 1004.352051
	maLeftForDeadPosY[nIdx]  = -835.150818
	maLeftForDeadPosZ[nIdx]  = -2066.953369
	nIdx += 1
	; FortSungard03 "Fort Sungard Oubliette" [CELL:0001AB5F]
	maLeftForDeadCells[nIdx] = 0x0001AB5F
	maLeftForDeadPosX[nIdx]  = 1666.919556
	maLeftForDeadPosY[nIdx]  = -1101.005859
	maLeftForDeadPosZ[nIdx]  = -937.323547
	nIdx += 1
	; BloodletThrone01 "Bloodlet Throne" [CELL:00016EA1]
	maLeftForDeadCells[nIdx] = 0x00016EA1
	maLeftForDeadPosX[nIdx]  = -2515.448486
	maLeftForDeadPosY[nIdx]  = 2433.110840
	maLeftForDeadPosZ[nIdx]  = 669.026001
	nIdx += 1
	; FortKastav01 "Fort Kastav Prison" [CELL:00015279]
	maLeftForDeadCells[nIdx] = 0x00015279
	maLeftForDeadPosX[nIdx]  = 3402.310059
	maLeftForDeadPosY[nIdx]  = -2743.286377
	maLeftForDeadPosZ[nIdx]  = -850.264343
	nIdx += 1
	; FortHraggstad02 "Fort Hraggstad Prison" [CELL:0003016A]
	maLeftForDeadCells[nIdx] = 0x0003016A
	maLeftForDeadPosX[nIdx]  = -669.566040
	maLeftForDeadPosY[nIdx]  = -831.401978
	maLeftForDeadPosZ[nIdx]  = 32.978062
	nIdx += 1
	; BrokenHelmHollow01 "Broken Helm Hollow" [CELL:000152B0]
	maLeftForDeadCells[nIdx] = 0x000152B0
	maLeftForDeadPosX[nIdx]  = -1355.334717
	maLeftForDeadPosY[nIdx]  = 2234.418457
	maLeftForDeadPosZ[nIdx]  = 91.447472
	nIdx += 1
	; BrokenFangCave01 "Broken Fang Cave" [CELL:000152B1]
	maLeftForDeadCells[nIdx] = 0x000152B1
	maLeftForDeadPosX[nIdx]  = 348.414612
	maLeftForDeadPosY[nIdx]  = 2464.463379
	maLeftForDeadPosZ[nIdx]  = -72.209427
	nIdx += 1
	; DruadachRedoubt01 "Druadach Redoubt Cave" [CELL:0004401B]
	maLeftForDeadCells[nIdx] = 0x0004401B
	maLeftForDeadPosX[nIdx]  = 424.292908
	maLeftForDeadPosY[nIdx]  = 4383.427734
	maLeftForDeadPosZ[nIdx]  = 8068.962891
	nIdx += 1
	; DarkwaterCavernOrigin [CELL:0002C997]
	maLeftForDeadCells[nIdx] = 0x0002C997
	maLeftForDeadPosX[nIdx]  = 104755.773438
	maLeftForDeadPosY[nIdx]  = -51109.492188
	maLeftForDeadPosZ[nIdx]  = 8068.962891
	nIdx += 1
	; MarasEyePond01 "Mara's Eye Den" [CELL:000DBF12]
	maLeftForDeadCells[nIdx] = 0x000DBF12
	maLeftForDeadPosX[nIdx]  = 2769.439941
	maLeftForDeadPosY[nIdx]  = 2698.103271
	maLeftForDeadPosZ[nIdx]  = -818.450439
	nIdx += 1
	; FortNeugrad02 "Fort Neugrad Prison" [CELL:0001CE8A]
	maLeftForDeadCells[nIdx] = 0x0001CE8A
	maLeftForDeadPosX[nIdx]  = -1123.911133
	maLeftForDeadPosY[nIdx]  = 8.033907
	maLeftForDeadPosZ[nIdx]  = -818.450439
	nIdx += 1
	; FortNeugrad02 "Fort Neugrad Prison" [CELL:0001CE8A]
	maLeftForDeadCells[nIdx] = 0x0001CE8A
	maLeftForDeadPosX[nIdx]  = -2825.585205
	maLeftForDeadPosY[nIdx]  = -1378.311768
	maLeftForDeadPosZ[nIdx]  = -1459.766113
	nIdx += 1
	; BrokenTowerRedoubt02 "Broken Tower Redoubt" [CELL:0007284E]
	maLeftForDeadCells[nIdx] = 0x0007284E
	maLeftForDeadPosX[nIdx]  = -2014.184692
	maLeftForDeadPosY[nIdx]  = -2429.204590
	maLeftForDeadPosZ[nIdx]  = 2249.101318
	nIdx += 1
	; RannveigsFast01 "Rannveig's Fast" [CELL:00015229]
	maLeftForDeadCells[nIdx] = 0x00015229
	maLeftForDeadPosX[nIdx]  = 1975.875854
	maLeftForDeadPosY[nIdx]  = 8903.516602
	maLeftForDeadPosZ[nIdx]  = -341.034485
	nIdx += 1
	; 2015.09.12 / Add
	; PilgrimsTrenchExterior [CELL:00008E4B]
	maLeftForDeadCells[nIdx] = 0x00008E4B
	maLeftForDeadPosX[nIdx]  = 83111.484375
	maLeftForDeadPosY[nIdx]  = 115727.671875
	maLeftForDeadPosZ[nIdx]  = -12121.759766
	nIdx += 1
	; ShrineofAzuraExterior03 [CELL:00008F5C]
	maLeftForDeadCells[nIdx] = 0x00008F5C
	maLeftForDeadPosX[nIdx]  = 109104.210938
	maLeftForDeadPosY[nIdx]  = 79258.828125
	maLeftForDeadPosZ[nIdx]  = 6172.492188
	nIdx += 1
	; MarkarthAttackStart02 [CELL:000075A9]
	maLeftForDeadCells[nIdx] = 0x000075A9
	maLeftForDeadPosX[nIdx]  = -159389.234375
	maLeftForDeadPosY[nIdx]  = 3721.472656
	maLeftForDeadPosZ[nIdx]  = -4694.936035
	nIdx += 1
	; MarkarthMainGate [CELL:000075AD]
	maLeftForDeadCells[nIdx] = 0x000075AD
	maLeftForDeadPosX[nIdx]  = -172552.906250
	maLeftForDeadPosY[nIdx]  = 3491.821289
	maLeftForDeadPosZ[nIdx]  = -4110.775391
	nIdx += 1
	; GoldenglowEstateExterior01 [CELL:0000BCF7]
	maLeftForDeadCells[nIdx] = 0x0000BCF7
	maLeftForDeadPosX[nIdx]  = 148112.203125
	maLeftForDeadPosY[nIdx]  = -100203.953125
	maLeftForDeadPosZ[nIdx]  = 10593.755859
	nIdx += 1
	; IlinaltasDeep01 "Ilinalta's Deep" [CELL:00015258]
	maLeftForDeadCells[nIdx] = 0x00015258
	maLeftForDeadPosX[nIdx]  = 1327.344116
	maLeftForDeadPosY[nIdx]  = 2818.562012
	maLeftForDeadPosZ[nIdx]  = -185.506866
	nIdx += 1
	; Ilinalta Lake [CELL:00009B99]
	maLeftForDeadCells[nIdx] = 0x00009B99
	maLeftForDeadPosX[nIdx]  = -29054.132813
	maLeftForDeadPosY[nIdx]  = -60714.761719
	maLeftForDeadPosZ[nIdx]  = 14.808793
	nIdx += 1
	; ShriekwindBastion01 "Shriekwind Bastion" [CELL:000A1A61]
	maLeftForDeadCells[nIdx] = 0x000A1A61
	maLeftForDeadPosX[nIdx]  = 71.013695
	maLeftForDeadPosY[nIdx]  = 70.031250
	maLeftForDeadPosZ[nIdx]  = -708.999756
	nIdx += 1
	; Altar near LakeView [CELL:00009BB5]
	maLeftForDeadCells[nIdx] = 0x00009BB5
	maLeftForDeadPosX[nIdx]  = -9743.228516
	maLeftForDeadPosY[nIdx]  = -65207.281250
	maLeftForDeadPosZ[nIdx]  = 1247.161865
	nIdx += 1
	; 2015.09.12 / Add
	; 
;	maLeftForDeadCells[nIdx] = 0x
;	maLeftForDeadPosX[nIdx]  = 
;	maLeftForDeadPosY[nIdx]  = 
;	maLeftForDeadPosZ[nIdx]  = 
;	nIdx += 1
	
Endfunction
; 2015.09.06 / Add

Function OnOffFeature(String Feature, Bool On = False)
	If (McmConfig.ModStatus == "$Enabled")
		If (Feature == "PlayerAgg")
			If On
				OnOffPlayerAggressor = True
				MiscQuests[2].Start() ; PlayerActionQst
				McmConfig.OnOffPagg = "$Enabled"
				ActionQst.Install()
				ActionQst.Configure()
				If !OnOffPerk ; PerkOnOff
					Player.AddPerk(DefeatAssaultPRK)
					McmConfig.Addperk = "$Enabled"
					OnOffPerk = True
				Endif
			Else
				If (ActionQst.GetState() == "Carrying")
					Notification("$You need to empty your bag before you can disable this feature.")
				Else					
					ActionQst.GoToState("Inactive")
					ActionQst.UnregisterForAllKeys()
					MiscQuests[2].Stop() ; PlayerActionQst
					If OnOffPerk
						Player.RemovePerk(DefeatAssaultPRK)
						McmConfig.Addperk = "$Disabled"
						OnOffPerk = False
					Endif
					McmConfig.OnOffPagg = "$Disabled"
					OnOffPlayerAggressor = False
				Endif
			Endif
		Elseif (Feature == "PlayerVic")
			If On
				OnOffPlayerVictim = True
				; 2015.07.20 / Add / Stop PlayerQuest before starting
				MiscQuests[0].Stop() ; Player quest
				; 2015.07.20 / Add / Stop PlayerQuest before starting
				MiscQuests[0].Start() ; Player quest
				; 2015.08.29 / Add / Stop PlayerQuest before starting
				MiscQuests[1].Stop() ; PAQst
				; 2015.08.29 / Add / Stop PlayerQuest before starting
				MiscQuests[1].Start() ; PAQst
				McmConfig.OnOffPvic = "$Enabled"
				PlayerScr.Install()
				PlayerScr.Configure()
				PostAssaultscr.Install()
				PostAssaultscr.Configure()
				If (McmConfig.OnOffNVN == "$Disabled")
					Int i
					While (i < 5)
						PlayerSLMonitor[i].GoToState("PlayerVictim")
						i += 1
					EndWhile
				Else
					Int i
					While (i < 5)
						PlayerSLMonitor[i].GoToState("Inactive")
						i += 1
					EndWhile
				Endif
			Else
				If !Player.HasKeywordString("DefeatActive")
					PlayerScr.GoToState("Inactive")
					; 2015.07.20 / Del / Not stop for captive addon
;					MiscQuests[0].Stop() ; Player quest
					; 2015.07.20 / Del / Not stop for captive addon
					MiscQuests[1].Stop() ; PAQst
					McmConfig.OnOffPvic = "$Disabled"
					OnOffPlayerVictim = False
				Else
					Notification("$You are currently defeated, you need to wait for the scene to end or use Clean up function before you can disable this feature.")
				Endif
			Endif
		Else
			If On
				OnOffNVN = True
				McmConfig.OnOffNVN = "$Enabled"
				MiscQuests[4].Start() ; NPCsRefreshQst
				NPCsRefreshQstScr.Refresh()
				If (McmConfig.OnOffPvic == "$Enabled")
					Int i
					While (i < 5)
						PlayerSLMonitor[i].GoToState("Inactive")
						i += 1
					EndWhile
				Endif
			Else
				If MiscQuests[4].IsRunning() ; NPCsRefreshQst
					MiscQuests[4].Stop() ; NPCsRefreshQst
				EndIf
				If MiscQuests[3].IsRunning() ; NPCsQst
					MiscQuests[3].Stop()
				Endif
				If (McmConfig.OnOffPvic == "$Enabled")
					Int i
					While (i < 5)
						PlayerSLMonitor[i].GoToState("PlayerVictim")
						i += 1
					EndWhile
				Endif
				McmConfig.OnOffNVN = "$Disabled"
				OnOffNVN = False
			Endif
		Endif
	Else
		Notification("$The mod is not installed.")
	Endif
EndFunction

Function Cleanup(String Type = "")
	If (Type == "")
		If (McmConfig.OnOffPvic == "$Enabled")
			PlayerScr.Clean()
		Endif
		If (McmConfig.OnOffPagg == "$Enabled")
			ActionQst.Clean()
			ActionQst.Hkrefresh()
		Endif
		Cell CurC = Player.GetParentCell()
		Actor NPCs		
		Int NumRefs = CurC.GetNumRefs(62)
		Form Gag = MiscFormLists[0].GetAt(1) ; MiscStuffList
		Form Cuffs = MiscFormLists[0].GetAt(2)
		Form Yoke = MiscFormLists[0].GetAt(3)
		Form Armbinder = MiscFormLists[0].GetAt(4)
		While (NumRefs > 0)
			NumRefs -= 1
			NPCs = (CurC.GetNthRef(NumRefs, 62) As Actor)
			If NPCs
				Log("NPC detected for cleaning - "+NPCs.GetActorBase().GetName())
				RemoveStates(NPCs, False)
				If !NPCs.IsInFaction(TieUpFaction)
					Calm(NPCs, Enter = False)
					Int i = MiscSpells.Length
					While (i > 0)
						i -= 1
						If NPCs.HasSpell(MiscSpells[i])
							NPCs.DispelSpell(MiscSpells[i])
						Endif
					EndWhile
					i = DefeatFactions.Length
					While (i > 0)
						i -= 1
						If NPCs.IsInFaction(DefeatFactions[i])
							NPCs.RemoveFromFaction(DefeatFactions[i])
						Endif
					EndWhile
					i = MiscPackages.Length
					While (i > 0)
						i -= 1
						If (NPCs.GetCurrentPackage() == MiscPackages[i])
							ActorUtil.RemovePackageOverride(NPCs, MiscPackages[i])
						Endif
					EndWhile
					; 2015.07.19 / Add
					DefeatPlayAnimation(NPCs, "Stand")
					setRapedFaceAnimation(NPCs, Enter = false)
					; 2015.07.19 / Add
				Endif
				; 2015.07.14 / Del
				; 2015.07.12 / Add
;				removeRyonaEffects(NPCs)
				; 2015.07.12 / Add
				; 2015.07.14 / Del
			Endif
		EndWhile
		Int i = NVNOnHitScr.Length
		While (i > 0)
			i -= 1
			NVNOnHitScr[i].Configure()
		EndWhile
		i = NVNActionScr.Length
		While (i > 0)
			i -= 1
			NVNActionScr[i].Configure()
		EndWhile
		HKActionTargetScr.Configure()
		If (Player.GetItemCount(MiscFormLists[0].GetAt(0) As Form) > 0) ; MiscStuff/Sack
			If (ActionQst.GetState() != "Carrying")
				ActionQst.GoToState("Carrying")
			Endif
		Endif
	Elseif (Type == "Clean tie up")
		Cell PlayerCell = Player.GetParentCell()
		Int i
		While (i < 50)
			If (TieUpSlots[i] && (TieUpSlots[i].GetParentCell() != PlayerCell))
				TieUp(TieUpSlots[i], Enter = False)
			Endif
			If (TieUpSlotsAliases[i].GetReference() && (TieUpSlotsAliases[i].GetReference() As Actor).GetParentCell() != PlayerCell)
				TieUp((TieUpSlotsAliases[i].GetReference() As Actor), Enter = False)
			Endif
			i += 1
		EndWhile
	Elseif (Type == "Clean knockout")
		Cell PlayerCell = Player.GetParentCell()
		Int i
		While (i < 30)
			If (KnockoutSlots[i] && (KnockoutSlots[i].GetParentCell() != Player.GetParentCell()))
				Knockout(KnockoutSlots[i], Enter = False)
			Endif
			If (KnockoutSlotsAliases[i].GetReference() && (KnockoutSlotsAliases[i].GetReference() As Actor).GetParentCell() != PlayerCell)
				Knockout((KnockoutSlotsAliases[i].GetReference() As Actor), Enter = False)
			Endif
			i += 1
		EndWhile
	Endif
	Notification("$Defeat Cleaned up")
EndFunction

Function Hkrefresh()
	UnregisterForAllKeys()
	RegisterForKey(HotKeyInts[0]) ; Option key
	; 2015.09.06 / Add
	RegisterForKey(HotKeyInts[5])
	; 2015.09.06 / Add
EndFunction
Event OnKeyDown(Int KeyCode)
	If (KeyCode == HotKeyInts[0]) ; Option key
		If !IsInMenuMode()
			; 2015.09.05 / Mod / using getActorSelected()
			Actor Target = getActorSelected()
			; 2015.09.05 / Mod / using getActorSelected()
			
			If ((Player.HasKeyWordString("SexLabActive")) && UIEon)
				SLController(Player)
			Elseif ((Target && Target.HasKeyWordString("SexLabActive")) && UIEon)
				SLController(Target)
;/ ==============================================================
; ==============================================================
; ==============================================================
; ========================= Tests ==============================
			Elseif Input.IsKeyPressed(46) ; C - 
				If Target

				Else
;					SetPlayerAiDriven(False)
;					EnablePlayerControls()
;					DefeatPlayAnimation(Player, "Stand")
				Endif
			Elseif Input.IsKeyPressed(47) ; V - Tests
				If Target
					CalmSPL.Cast(Player, Target)
				Else
					Update()
				Endif
			Elseif Input.IsKeyPressed(48) ; B - Tests
				If Target
;					Target.ForceActorValue("Health", 1)
;					SendAnimationEvent(Target, "GetUpBegin")
;					Wait(1.0)
;					SendAnimationEvent(Target, "IdleForceDefaultState")
				Else

				Endif
			Elseif Input.IsKeyPressed(156) ; numpad enter
				MenuOne()
; ========================= Tests ==============================
; ==============================================================
; ==============================================================
; ==============================================================/;
			Else
				OptionMenu()
			Endif
		Endif
	; 2015.09.06 / Add
	Elseif (KeyCode == HotKeyInts[5])
		onClickHotKeyCleanupSelected()
; DEBUG
saveDebugStr("KeyCode is "+(KeyCode as String))
; DEBUG
	; 2015.09.06 / Add
	Endif
EndEvent

Function MenuOne()
    String[] MenuOptions = New String[7]
	MenuOptions[0] = "Second menu"
	MenuOptions[1] = "Menu 1"
	MenuOptions[2] = "Menu 2"
	MenuOptions[3] = "Menu 3"
	MenuOptions[4] = "Menu 4"
	MenuOptions[5] = "Menu 5"
	MenuOptions[6] = "Menu 6"
	Int Selected = WheelMenu(MenuOptions)
	If (Selected == 0)
		MenuTwo()
	Elseif (Selected == 1)
		Debug.Notification("you choose 1")
	Elseif (Selected == 2)
		Debug.Notification("you choose 2")
	Elseif (Selected == 3)
		Debug.Notification("you choose 3")
	Elseif (Selected == 4)
		Debug.Notification("you choose 4")
	Elseif (Selected == 5)
		Debug.Notification("you choose 5")
	Elseif (Selected == 6)
		Debug.Notification("you choose 6")
	Elseif (Selected == 7)
		Debug.Notification("you choose 7")
	Endif
EndFunction
Function MenuTwo()
	String[] MenuOptions = New String[4]
	MenuOptions[0] = "Second menu 0"
	MenuOptions[1] = "Second menu 1"
	MenuOptions[2] = "Second menu 2"
	MenuOptions[3] = "Second menu 3"
	Int Selected = WheelMenu(MenuOptions)
	If (Selected == 0)
		Debug.Notification("you choose Second menu 0")
	Elseif (Selected == 1)
		Debug.Notification("you choose Second menu 1")
	Elseif (Selected == 2)
		Debug.Notification("you choose Second menu 2")
	Elseif (Selected == 3)
		Debug.Notification("you choose Second menu 3")
	Else
		MenuOne() ; if escape is pressed it will return to the main menu.
	Endif
EndFunction
Int Function WheelMenu(String[] Options)
	UIWheelMenu WheelMenu = (UIExtensions.GetMenu("UIWheelMenu", True) as UIWheelMenu)
	Int i
	Int L = Options.Length
	While (i < L)
		WheelMenu.SetPropertyIndexString("optionText", i, Options[i])
		WheelMenu.SetPropertyIndexString("optionLabelText", i, Options[i])
		WheelMenu.SetPropertyIndexBool("optionEnabled", i, True)
		i += 1
	EndWhile
	Return WheelMenu.OpenMenu()
EndFunction

Function OptionMenu()
	Int Button = 10
	Bool InMenu = True
	Message OptionMessage = MiscMessages[0] ; DefeatOptionMess
	While InMenu
		If (Button == 10)
			Button = OptionMessage.Show()
			If (Button == 1) ; Clean up menu
				Button = MiscMessages[1].Show() ; DefeatOptionCleanMess
				If (Button == 0)		; Clean up
					Cleanup()
				Elseif (Button == 1)	; Clean tie up
					Cleanup("Clean tie up")
				Elseif (Button == 2)	; Clean knockout
					Cleanup("Clean knockout")
				Else
					Button = 10
				Endif
			Elseif (Button == 2) ; Display Struggle Bar
				If !Player.HasKeyWordString("DefeatActive")
					DisplayBar()
				Else
					Notification("$You can't do this.")
				Endif
			Elseif (Button == 3) ; Enable Player Aggressor
				OnOffFeature("PlayerAgg", True)
			Elseif (Button == 4) ; Disable Player Aggressor
				OnOffFeature("PlayerAgg")
			Elseif (Button == 5) ; Enable Player Victim
				OnOffFeature("PlayerVic", True)
			Elseif (Button == 6) ; Disable Player Victim
				OnOffFeature("PlayerVic")
			Elseif (Button == 7) ; Enable NPC vs NPC
				OnOffFeature("", True)
			Elseif (Button == 8) ; Disable NPC vs NPC
				OnOffFeature("")
			Endif
		Else
			InMenu = False
		Endif
	EndWhile
EndFunction

Function SLController(Actor Target)
	sslThreadController Controller = SexLab.GetActorController(Target)
	If Input.IsKeyPressed(HotKeyInts[1]) ; Modifier key
		UIExtensions.InitMenu("UIListMenu")
;		UIExtensions.SetMenuPropertyStringA("UIListMenu", "appendEntries", ControllerOptions)
		Int MenuOptions = ControllerOptions.Length
		Int MenuTags = ControllerTags.Length
		Int MenuEntries = (MenuOptions + MenuTags)
		UIExtensions.SetMenuPropertyInt("UIListMenu", "totalEntries", MenuEntries)
		Int n = MenuOptions
		Int i = 0
		While (i < n)
			UIExtensions.SetMenuPropertyIndexString("UIListMenu", "entryName", i, ControllerOptions[i])
			UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryId", i, i)
			i += 1
		EndWhile
		UIExtensions.SetMenuPropertyIndexBool("UIListMenu", "hasChildren", 4, True)
		n = (MenuTags + MenuOptions)
		i = MenuOptions
		While (i < n)
			UIExtensions.SetMenuPropertyIndexString("UIListMenu", "entryName", i, (ControllerTags[i - MenuOptions]))
			UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryId", i, i)
			UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryParent", i, 4)
			i += 1
		EndWhile
		UIExtensions.OpenMenu("UIListMenu")
		Int Selected = UIExtensions.GetMenuResultInt("UIListMenu")
		If (Selected != -1)
			If (Selected == 0)				; Animation stage - Forward
				Controller.AdvanceStage()
			Elseif (Selected == 1)			; Animation stage - Backward
				Controller.AdvanceStage(True)
			Elseif (Selected == 2) 			; Disable current animation
				sslBaseAnimation Slot = SexLab.GetAnimationByName(Controller.Animation.Name)
				If Controller.VictimRef
					If Slot.HasTag("Aggressive")
						Slot.ToggleTag("Aggressive")
						Notification("$Current animation disabled.")
					Else
						Notification("$Current animation already disabled.")
					Endif
				Else
					If Slot.Enabled
						Slot.Enabled = False
						Notification("$Current animation disabled.")
					Else
						Notification("$Current animation already disabled.")
					Endif
				Endif
			Elseif (Selected == 3)			; "Coitus interruptus
				If ((Target == Controller.VictimRef) || (Controller.Creatures > 0) || (SexLab.GetGender(Target) == 1))
					Notification("$Can't be used on a sex victim, a female character/NPC or a creature.")
				Elseif (Controller.GetState() != "Ending")
					sslBaseAnimation[] NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females), "Boobjob,Blowjob", "Vaginal,Anal", RequireAll = False)
					If (NewAnims.length != 0)
						Controller.SetAnimations(NewAnims)
						Controller.ChangeAnimation()
						Controller.GoToStage(Controller.Animation.StageCount)
					Else
						Notification("$No animations available for this tag.")
					Endif
				Endif
			Else
				sslBaseAnimation[] NewAnims
				If !Controller.HasCreature
					NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females), ControllerTags[Selected - MenuOptions], RequireAll = False)
				Else
					NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females + Controller.Creatures), ControllerTags[Selected - MenuOptions], RequireAll = False)
				Endif
				If (NewAnims.length != 0)
					Controller.SetAnimations(NewAnims)
					Controller.ChangeAnimation()
				Else
					Notification("$No animations available for this tag.")
				Endif
			Endif
		Endif
	Else
		Int Anims = Controller.Animations.Length
		UIExtensions.InitMenu("UIListMenu")
		UIExtensions.SetMenuPropertyInt("UIListMenu", "totalEntries", Anims)
		Int i
		While (i < Anims)
			UIExtensions.SetMenuPropertyIndexString("UIListMenu", "entryName", i, Controller.Animations[i].Name)
			UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryId", i, i)
			i += 1
		EndWhile
		UIExtensions.OpenMenu("UIListMenu")
		Int Selected = UIExtensions.GetMenuResultInt("UIListMenu")
		If (Selected != -1)
			Controller.SetAnimation(Selected)
		Endif
	Endif
;	UIListMenu ListMenu = UIExtensions.GetMenu("UIListMenu") as UIListMenu
;	If Input.IsKeyPressed(HotKeyInts[1]) ; Modifier key
;		ListMenu.AddEntryItem("$Animation stage - Forward")
;		ListMenu.AddEntryItem("$Animation stage - Backward")
;		ListMenu.AddEntryItem("$Disable current animation")
;		ListMenu.AddEntryItem("Coitus interruptus")
;		ListMenu.AddEntryItem("$Change current scene tag", entryHasChildren = True)
;		String[] Tags = New String[24]
;		Tags[0] = "Foreplay"
;		Tags[1] = "Kissing"
;		Tags[2] = "Hugging"
;		Tags[3] = "Sex"
;		Tags[4] = "Vaginal"
;		Tags[5] = "Anal"
;		Tags[6] = "Oral"
;		Tags[7] = "Aggressive"
;		Tags[8] = "Straight"
;		Tags[9] = "Lesbian"
;		Tags[10] = "Missionary"
;		Tags[11] = "Cowgirl"
;		Tags[12] = "Doggy,Doggy Style,DoggyStyle"
;		Tags[13] = "Blowjob"
;		Tags[14] = "Boobjob"
;		Tags[15] = "Handjob"
;		Tags[16] = "Footjob"
;		Tags[17] = "Standing"
;		Tags[18] = "Laying"
;		Tags[19] = "Sideways"
;		Tags[20] = "Arrok"
;		Tags[21] = "AP"
;		Tags[22] = "Bleagh"
;		Tags[23] = "Zyn"
;		Int n = (Tags.Length + 5)
;		Int i = 5
;		While (i < n)
;			ListMenu.AddEntryItem(Tags[i - 5], 4)
;			i += 1
;		EndWhile
;		ListMenu.OpenMenu()
;		Int Selected = ListMenu.GetResultInt()
;		If (Selected != -1)
;			If (Selected == 0)				; Animation stage - Forward
;				Controller.AdvanceStage()
;			Elseif (Selected == 1)			; Animation stage - Backward
;				Controller.AdvanceStage(True)
;			Elseif (Selected == 2) 			; Disable current animation
;				sslBaseAnimation Slot = SexLab.GetAnimationByName(Controller.Animation.Name)
;				If Controller.VictimRef
;					If Slot.HasTag("Aggressive")
;						Slot.ToggleTag("Aggressive")
;						Notification("$Current animation disabled.")
;					Else
;						Notification("$Current animation already disabled.")
;					Endif
;				Else
;					If Slot.HasTag("LeadIn")
;						Slot.ToggleTag("LeadIn")
;						Notification("$Current animation disabled.")
;					Else
;						Notification("$Current animation already disabled.")
;					Endif
;				Endif
;			Elseif (Selected == 3)			; "Coitus interruptus
;				If ((Target == Controller.VictimRef) || (Controller.Creatures > 0) || (SexLab.GetGender(Target) == 1))
;					Notification("$Can't be used on a sex victim, a female character/NPC or a creature.")
;				Elseif (Controller.GetState() != "Ending")
;					sslBaseAnimation[] NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females), "Boobjob,Blowjob", "Vaginal,Anal", RequireAll = False)
;					If (NewAnims.length != 0)
;						Controller.SetAnimations(NewAnims)
;						Controller.ChangeAnimation()
;						Controller.GoToStage(Controller.Animation.StageCount)
;					Else
;						Notification("$No animations available for this tag.")
;					Endif
;				Endif
;			Else
;				sslBaseAnimation[] NewAnims
;				If !Controller.HasCreature
;					NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females), Tags[Selected - 5], RequireAll = False)
;				Else
;					NewAnims = SexLab.GetAnimationsByTags((Controller.Males + Controller.Females + Controller.Creatures), Tags[Selected - 5], RequireAll = False)
;				Endif
;				If (NewAnims.length != 0)
;					Controller.SetAnimations(NewAnims)
;					Controller.ChangeAnimation()
;				Else
;					Notification("$No animations available for this tag.")
;				Endif
;			Endif
;		Endif
;	Else 													; Choose animation
;		Int Anims = Controller.Animations.Length
;		Int i
;		While (i < Anims)
;			ListMenu.AddEntryItem(Controller.Animations[i].Name)
;			i += 1
;		EndWhile
;		ListMenu.OpenMenu()
;		Int Selected = ListMenu.GetResultInt()
;		If (Selected != -1)
;			Controller.SetAnimation(Selected)
;		Endif
;	Endif
EndFunction

Actor[] Involved
Actor Property AWitness Auto Hidden
Event RapeScene(string EventName, string argString, Float argNum, form sender)
	Actor Victim = SexLab.HookVictim(argString)
;	Log("RapeScene - Victim -"+Victim+" / Victim.HasMagicEffectWithKeyword(DefeatActive) - "+Victim.HasMagicEffectWithKeyword(DefeatActive)+" / EventName - "+EventName+" / argString - "+argString)
	If (Victim && Victim.HasKeyWordString("DefeatActive"))
		Involved = SexLab.HookActors(argString)
		If (Involved.Find(Player) != -1)
			If ((Victim == Player) && McmConfig.WitnessPvic)
				Int i 
				While (i < Involved.Length)
					If (Involved[i] != Victim)
						MiscSpells[4].Cast(Involved[i], Victim) ; SexCrimeSPL
					Endif
					i += 1
				EndWhile
			Elseif ((Victim != Player) && McmConfig.WitnessPagg)
				Int i 
				While (i < Involved.Length)
					If (Involved[i] != Victim)
						MiscSpells[4].Cast(Involved[i], Victim) ; SexCrimeSPL
					Endif
					i += 1
				EndWhile
			Endif
		Elseif McmConfig.WitnessNVN
			Int i 
			While (i < Involved.Length)
				If (Involved[i] != Victim)
					MiscSpells[4].Cast(Involved[i], Victim) ; SexCrimeSPL
				Endif
				i += 1
			EndWhile
		Endif
	Endif
EndEvent
Event EndRapeScene(string EventName, string argString, Float argNum, form sender)
	Actor Victim = SexLab.HookVictim(argString)
	If (Victim && Victim.HasMagicEffect(MiscMagicEffects[3])) ; SexCrimeEFF
		Victim.DispelSpell(MiscSpells[4])
		AWitness = None
	Endif
EndEvent

Function DisplayBar()
	StruggleBar.Percent = 50.0
	StruggleBar.Alpha = 100.0
	Wait(5.0)
	StruggleBar.Alpha = 0
	StruggleBar.Percent = 0.0
EndFunction

Function CheckOutfitSlots()
	Int i = 0
	While (i < 32)
		Form Equipped = Player.GetWornForm(Armor.GetMaskForSlot(i + 30))
		If Equipped
			Notification("Slot "+(i + 30)+" -> "+Equipped.GetName())
		Endif
		i += 1
	EndWhile
EndFunction

; ===============================================================================||


Bool Function IsEnabled(String Feature = "")
	If (Feature == "Player as Aggressor")
		Return (McmConfig.OnOffPagg == "$Enabled")
	Elseif (Feature == "Player as Victim")
		Return (McmConfig.OnOffPvic == "$Enabled")
	Elseif (Feature == "NPC vs NPC")
		Return (McmConfig.OnOffNVN == "$Enabled")
	Else
		Return (McmConfig.ModStatus == "$Enabled")
	Endif
EndFunction

Function AddCalmList(Actor Aggressor, Actor Victim)
	Faction[] Factions = Aggressor.GetFactions(0, 100)
	Int i = Factions.Length
	While (i > 0)
		i -= 1
		Factions[i].SetAlly(DefeatFactions[0], True, True) ; DefeatFaction
	EndWhile
	Victim.StopCombatAlarm()
EndFunction

Bool Function IsFollower(Actor Target)
	Return (Target.IsInFaction(FollowerFactions[0]) || Target.IsInFaction(FollowerFactions[1]) || Target.isPlayerTeammate()) ; Current follower/hireling
EndFunction

Bool Function StartScene(Actor AggressorA = None, Actor AggressorB = None, Actor AggressorC = None, Actor AggressorD = None, Actor AggressorE = None,	\ 
	Bool CustomSettings = False,	String ForcedScene = "",	Bool OnlySet = False,			String Scenario = "",	Bool AllowStaydown = True,	\ 
	Bool AllowResist = True,		Bool AllowRob = True,		Bool AllowRelation = False,		Bool AllowWitness = False,	Bool AllowCommentary = False)
;	This function can start an assault scene on the player at any time with a lot of custom options.
;	/!\ If CustomSettings is set to True all default settings are used for the scene then each setting can be specified.
;	/!\ If CustomSettings stay to False, MCM settings are used.
;	- IsCreature : Specifies if the scene involve creatures or not.																					Default : False
;	- OnlySet : If True, the scene will only use specified actors AggressorA to AggressorE, if False Defeat will look for other aggressors.			Default : False
;	- Scenario : Specified the scenario for the scene.																								Default : MCM setting
;		available scenarios: "$All Down", "$Original and "$No Transition" (The $ need to be here.)														
;	- ForcedScene : Specifies a post assault scenario for the end of the scene.																		Default : MCM setting
;		available scenarios: "Left for dead", "Defeated", "End" OR the name of a custom event.
;	- AllowStaydown : Specifies if the player should stay on the ground between each turn or have a chance to run away.								Default : True
;	- AllowResist : Specifies if the player can resist before and between turns in the scene.														Default : True
;	- AllowRob : Specidifes if the player can be robbed before the post assault scenario.															Default : True
;	- AllowRelation : Specifies if the relationship with aggressor should matter or not.															Default : False
;	- AllowWitness : Specifies if witnesses should act if there is some.																			Default : False
;	- AllowCommentary : Specifies if aggressors are able to comment before sexual assaults.		 													Default : False	
	If OnOffPlayerVictim
		If AggressorA
			PlayerScr.GetAggressors()[0] = AggressorA
			PlayerScr.TheAggressors[0].ForceRefIfEmpty(AggressorA)
		Endif
		If AggressorB	
			PlayerScr.GetAggressors()[1] = AggressorB
			PlayerScr.TheAggressors[1].ForceRefIfEmpty(AggressorB)
		Endif
		If AggressorC
			PlayerScr.GetAggressors()[2] = AggressorC
			PlayerScr.TheAggressors[2].ForceRefIfEmpty(AggressorC)
		Endif
		If AggressorD
			PlayerScr.GetAggressors()[3] = AggressorD
			PlayerScr.TheAggressors[3].ForceRefIfEmpty(AggressorD)
		Endif
		If AggressorE
			PlayerScr.GetAggressors()[4] = AggressorE
			PlayerScr.TheAggressors[4].ForceRefIfEmpty(AggressorE)
		Endif
		If CustomSettings
			PlayerScr.CustomScene("ForcedScene", IsForcedScene = ForcedScene)
			PlayerScr.CustomScene("AllowStaydown", AllowStaydown)
			PlayerScr.CustomScene("AllowResist", AllowResist)
			PlayerScr.CustomScene("AllowRob", AllowRob)
			PlayerScr.CustomScene("AllowRelation", AllowRelation)
			PlayerScr.CustomScene("AllowWitness", AllowWitness)
			PlayerScr.CustomScene("AllowCommentary", AllowCommentary)
			If !OnlySet
				PlayerScr.Detect.Start()
			Endif
		Else
			PlayerScr.Detect.Start()
		Endif
		PlayerScr.TheKnockDown(AggressorA, Scenario)
		PlayerScr.Detect.Stop()
		Return True
	Else
		Return False
	Endif
EndFunction

Int Property HasBeenRapedBy Auto Hidden Conditional
Int Property FollowerHasBeenRapedBy Auto Hidden Conditional
Int Property NVNHasBeenRapedBy Auto Hidden Conditional

Actor[] Property LastSceneAggressors Auto Hidden
Actor[] Property LastSceneAccomplices Auto Hidden
Actor[] Property LastSceneFollowers Auto Hidden
Actor Property LastSceneTheLast Auto Hidden
Bool Property LastSceneRaped Auto Hidden Conditional
Bool Property LastSceneRobbed Auto Hidden Conditional
Int Property InSceneRapesHowManyBy Auto Hidden Conditional
Bool Property NoPostAssault Auto Hidden

FormList Property FacList Auto
String Property TheEvilFaction Auto Hidden Conditional
String Function IsEvilFaction(Actor Aggressor)
	String EvilFaction = ""
	Faction[] Factions = Aggressor.GetFactions(0, 100)
	Int i = Factions.Length
	While (i > 0)
		i -= 1
		If FacList.HasForm(Factions[i])
			Int Slot = FacList.Find(Factions[i])
			If (Slot == 0)
				EvilFaction = "Bandit"
			Elseif (Slot == 1)
				EvilFaction = "Forsworn"
			Elseif (Slot == 2)
				EvilFaction = "Silver Hand"
			Elseif (Slot == 3)
				EvilFaction = "Thalmor"
			Elseif (Slot == 4)
				EvilFaction = "Vampire"
			Elseif (Slot == 5)
				EvilFaction = "Warlock"
			Elseif (Slot == 6)
				EvilFaction = "Necromancer"
			Elseif (Slot == 7)
				EvilFaction = "Bloodkin"
			Else
				EvilFaction = "Evil"
			Endif
		Endif
	EndWhile
	If Aggressor.IsGuard()
		EvilFaction = "Guard"
	Endif
	Return EvilFaction
EndFunction

Bool Function IsSameFaction(Actor Target, Actor Aggressor)
	Faction[] AggressorFactions = Aggressor.GetFactions(0, 100)
	Faction[] TargetFactions = Target.GetFactions(0, 100)
	Int i = TargetFactions.Length
	While (i > 0)
		i -= 1
		If (AggressorFactions.Find(TargetFactions[i]) != -1)
;			Log("Target - "+Target+" / "+Target.GetLeveledActorBase().GetName()+" is same faction as "+Aggressor+" / "+Aggressor.GetLeveledActorBase().GetName())
			Return True
		Endif
	EndWhile
	Return False
EndFunction

Bool Function IsBadRelation(Actor Aggressor, Actor Victim, Bool PlayerVictim = True) ; Return True if Aggressor has a bad relationshop with Victim
	If PlayerVictim
		If ((TheEvilFaction != "") && (TheEvilFaction != "Guard"))
			Return True
;		Elseif (SARon && (DefeatUtil.DGetSLAroused().GetActorArousal(Aggressor) > 70.0))
;			Return True
		Elseif (McmConfig.MoralityPvic && ((Aggressor.GetActorValue("Morality") > 2) || (Aggressor.GetRelationshipRank(Victim) > 0)))
			Return False
		Endif
	Else
		String EvilFaction = IsEvilFaction(Aggressor)
		If ((EvilFaction != "") && (EvilFaction != "Guard"))
			Return True
;		Elseif (SARon && (DefeatUtil.DGetSLAroused().GetActorArousal(Aggressor) > 70.0))
;			Return True
		Elseif (McmConfig.MoralityNVN && ((Aggressor.GetActorValue("Morality") > 2) || (Aggressor.GetRelationshipRank(Victim) > 0)))
			Return False
		Endif
	Endif
	Return True
EndFunction

Int Function HowMany(String Option)
	Int i
	Int n
	If (Option == "Followers")
		While (i < 5)
			If LastSceneFollowers[i]
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Accomplices")
		While (i < 5)
			If LastSceneAccomplices[i]
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Aggressors")
		While (i < 5)
			If LastSceneAggressors[i]
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Aggressors Male")
		While (i < 5)
			If LastSceneAggressors[i] && (SexLab.GetGender(LastSceneAggressors[i]) == 0)
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Aggressors Female")
		While (i < 5)
			If LastSceneAggressors[i] && (SexLab.GetGender(LastSceneAggressors[i]) == 1)
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Followers Male")
		While (i < 5)
			If LastSceneFollowers[i] && (SexLab.GetGender(LastSceneFollowers[i]) == 0)
				n += 1
			Endif
			i += 1
		EndWhile
	Elseif (Option == "Followers Female")
		While (i < 5)
			If LastSceneFollowers[i] && (SexLab.GetGender(LastSceneFollowers[i]) == 1)
				n += 1
			Endif
			i += 1
		EndWhile
	Endif
	Return n
EndFunction

Function GetStrippedItems(Actor Target) ; Get every items that have been stripped from the player and put them in actor a inventory. Need to be in the same cell as the dropped items
	PlayerScr.RecoverStuff(Target)
EndFunction

Int Function HasBeenRapedBy(Actor Victim, Actor Aggressor) ; Return the number of time the Victim has been raped by this Aggressor
	Return GetIntValue(Aggressor, "RapedBy"+Victim)
EndFunction

Bool Function IsArmed(Actor Target) ; Return True if the Target is armed
	Return (Target.GetEquippedWeapon() || Target.GetEquippedWeapon(True) || Target.GetEquippedShield())
EndFunction

Bool Function IsClothed(Actor Target, Bool IsPlayer = True) ; Return true if the target wears an armor
	Return Target.GetWornForm(0x00000004)
EndFunction

Bool Function IsSexualAssaulter(Actor Aggressor, Actor Victim, Bool PlayerVictim = False, Bool IsFollower = False) ; Check if the aggressor wants to rape their victim
	Return (SexCombination(Aggressor, Victim, PlayerVictim) && SexInterest(Aggressor, PlayerVictim, IsFollower))
EndFunction
Bool Function SexInterest(Actor Target, Bool PlayerVictim, Bool IsFollower)
	If Target.HasSpell(SatisfiedSPL)
		Return False
	Endif
;	If SARon
;		If PlayerVictim
;			Return (RandomInt(1, 100) <= (McmConfig.PvicRaped + (DefeatUtil.DGetSLAroused().GetActorArousal(Target) * (McmConfig.ArousalSARPvic / 100))))
;		Else
;			If !IsFollower
;				Return (RandomInt(1, 100) <= (McmConfig.NVNRaped + (DefeatUtil.DGetSLAroused().GetActorArousal(Target) * (McmConfig.ArousalSARNVN / 100))))
;			Else
;				Return (RandomInt(1, 100) <= (McmConfig.NVNRapedFollower + (DefeatUtil.DGetSLAroused().GetActorArousal(Target) * (McmConfig.ArousalSARFollower / 100))))
;			Endif
;		Endif
;	Else
		If PlayerVictim
			Return (RandomInt(1, 100) <= McmConfig.PvicRaped)
		Else
			If !IsFollower
				Return (RandomInt(1, 100) <= McmConfig.NVNRaped)
			Else
				Return (RandomInt(1, 100) <= McmConfig.NVNRapedFollower)
			Endif
		Endif
;	Endif
EndFunction
Bool Function SexCombination(Actor Aggressor, Actor Victim, Bool PlayerVictim)
;	Log("SexCombination - Victim - "+Victim+" / PlayerVictim - "+PlayerVictim+" / Aggressor.HasKeyWordString(ActorTypeCreature) - "+Aggressor.HasKeyWordString("ActorTypeCreature"))
	If PlayerVictim
		If Aggressor.HasKeyWordString("ActorTypeNPC")
			Bool AggressorMale = (SexLab.GetGender(Aggressor) == 0)
			Bool VictimFemale = (SexLab.GetGender(Victim) == 1)
			; 2015.07.25 / Add
			If (Victim == Player)
				VictimFemale = (Player.GetActorBase().GetSex() == 1)
			Endif
			; 2015.07.25 / Add
			If !McmConfig.SexualityPvic
				Return (McmConfig.MaleHunterPvic && AggressorMale) || (McmConfig.FemaleHunterPvic && !AggressorMale)
			Else
				If (AggressorMale && VictimFemale) 			; Male on Female
					Return SexLab.Stats.IsStraight(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (!AggressorMale && VictimFemale) 	; Female on Female
					Return SexLab.Stats.IsGay(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (AggressorMale && !VictimFemale) 	; Female on Male
					Return SexLab.Stats.IsStraight(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (!AggressorMale && VictimFemale) 	; Male on Male
					Return SexLab.Stats.IsGay(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Endif
			Endif
		Elseif Aggressor.HasKeyWordString("ActorTypeCreature")
			If (McmConfig.HuntCrea && (Aggressor.GetFlyingState() < 1))
				Return SexLab.AllowedCreature(Aggressor.GetLeveledActorBase().GetRace())
			Endif
		; 2015.07.20 / Add
		Elseif Aggressor.HasKeyWordString("ActorTypeDwarven") && (SexLab.GetGender(Victim) == 1)
			Return True
		; 2015.07.20 / Add
		Endif
	Else
		Bool VictimFemale = (SexLab.GetGender(Victim) == 1)
		If Aggressor.HasKeyWordString("ActorTypeNPC")
			Bool AggressorMale = (SexLab.GetGender(Aggressor) == 0)
			If !McmConfig.SexualityNVN
				Return ((McmConfig.MaleOnGal && VictimFemale && AggressorMale) || (McmConfig.GalOnGal && VictimFemale && !AggressorMale) || (McmConfig.MaleOnMale && !VictimFemale && AggressorMale) || (McmConfig.GalOnMale && !VictimFemale && !AggressorMale))
			Else
				If (AggressorMale && VictimFemale) 			; Male on Female
					Return SexLab.Stats.IsStraight(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (!AggressorMale && VictimFemale) 	; Female on Female
					Return SexLab.Stats.IsGay(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (AggressorMale && !VictimFemale) 	; Female on Male
					Return SexLab.Stats.IsStraight(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Elseif (!AggressorMale && VictimFemale) 	; Male on Male
					Return SexLab.Stats.IsGay(Aggressor) || SexLab.Stats.IsBisexual(Aggressor)
				Endif
			Endif
		Elseif Aggressor.HasKeyWordString("ActorTypeCreature")
			If (Aggressor.GetFlyingState() < 1)
				If ((VictimFemale && McmConfig.CreaOnFemale) || (!VictimFemale && McmConfig.CreaOnMale))
					Return SexLab.AllowedCreature(Aggressor.GetLeveledActorBase().GetRace())
				Endif 
			Endif
		; 2015.07.20 / Add
		Elseif Aggressor.HasKeyWordString("ActorTypeDwarven") && (SexLab.GetGender(Victim) == 1)
			Return True
		; 2015.07.20 / Add
		Endif
	Endif
	Return False
EndFunction

Function StartRobbingScene(Actor Victim, Actor Aggressor, String RobWay = "", Float Value = -1.0)
;	Launch a scene where actor Aggressor will perform a rob on Victim actor.
;	RobWay - Will determine what the aggressor will rob, valid values are "Value", "Gold" and "Gold & Items".
;	Value - Everything above it will be robbed by the aggressor.
;	If no values are specified default MCM settings will applies.
	If !MiscQuests[5].IsRunning()
		NoPostAssault = True
		PlayerScr.StartRobbingScene(Victim, Aggressor, RobWay, Value)
	Endif
EndFunction

; =================================================== SURRENDER Functions
Int Property QSTStage Auto Hidden Conditional
Bool Property IsThereWitness Auto Hidden Conditional			; Is there a witness?
Bool Property IsThereSexAggressor Auto Hidden Conditional		; Is there a potential sexual aggressor in the group?
Bool Property IsThereCollateralVictim Auto Hidden Conditional	; Is there a potential follower sexual victim in the group?
Bool Property Armed Auto Hidden Conditional						; Has the player a weapon of any kind in their hand?
Bool Property Clothed Auto Hidden Conditional					; Is the player naked?
Bool Property FollowerClothed Auto Hidden Conditional			; Is the follower naked?
Bool Property BadRelation Auto Hidden Conditional				; Is the aggressor has a bad relation with the player?
Bool Property AllowedFaction Auto Hidden Conditional			; Is the aggressor amoung one of the evil factions?
GlobalVariable Property BribeAmount Auto
Bool Property WantGold Auto Hidden Conditional
Int Property HowManyPartners Auto Hidden Conditional
Int Property HowManyAggressors Auto Hidden Conditional
Int Property HowManyAggressorsMale Auto Hidden Conditional
Int Property HowManyAggressorsFemale Auto Hidden Conditional
Int Property HowManyPartnersMale Auto Hidden Conditional
Int Property HowManyPartnersFemale Auto Hidden Conditional
Function SurrenderData(Actor Victim, Actor Aggressor)
;	Log("Get dialogue data begin "+GetCurrentRealTime())
	LastSceneAggressors = PlayerScr.GetAggressors()
	LastSceneAccomplices = PlayerScr.GetAccomplices()
	LastSceneFollowers = PlayerScr.GetFollowers()
	WantGold = False
	BribeAmount.SetValue(Aggressor.GetBribeAmount())
	Armed = IsArmed(Victim)
	Clothed = IsClothed(Victim)
	FollowerClothed = IsClothed(Victim)
	AllowedFaction = (IsEvilFaction(Aggressor) != "")
	BadRelation = IsBadRelation(Aggressor, Victim)
	IsThereWitness = PlayerScr.GetWitness()
	HasBeenRapedBy = HasBeenRapedBy(Victim, Aggressor)
	HowManyAggressors = HowMany("Aggressors")
	PlayerScr.NumAgg = HowManyAggressors
	HowManyPartners = HowMany("Followers")
	Actor SexAggressor
	SexAggressor = IsSexualTension(Aggressor, Victim, True)
	If SexAggressor
		PlayerScr.AliasTheNext.ForceRefTo(SexAggressor)
		IsThereSexAggressor = True
	Else
		PlayerScr.AliasTheNext.Clear()
	Endif
	PlayerScr.SetSexualAssault(IsThereSexAggressor)
	SexAggressor = IsSexualTension(Aggressor, None, False)
	If SexAggressor
		PlayerScr.CollaAgg.ForceRefTo(Aggressor)
		PlayerScr.CollaVic.ForceRefTo(SexAggressor)
		FollowerClothed = IsClothed(PlayerScr.CollaVic.GetReference() As Actor)
		IsThereCollateralVictim = True
	Else
		PlayerScr.CollaAgg.Clear()
		PlayerScr.CollaAgg.Clear()
	Endif
;	Log("SURRENDER IsThereSexAggressor - "+IsThereSexAggressor)
;	If IsThereSexAggressor
;		Log("SURRENDER AliasTheNext alias - "+(PlayerScr.AliasTheNext.Getreference() As Actor).GetLeveledActorBase().GetName())
;	Endif
;	Log("SURRENDER IsThereCollateralVictim - "+IsThereCollateralVictim)
;	If IsThereCollateralVictim
;		Log("SURRENDER CollaVic alias - "+(PlayerScr.CollaVic.Getreference() As Actor).GetLeveledActorBase().GetName()+" // CollaAgg - "+(PlayerScr.CollaAgg.Getreference() As Actor).GetLeveledActorBase().GetName())
;	Endif
;	Log("SURRENDER BribeAmount - "+BribeAmount.Value)
;	Log("SURRENDER IsThereWitness - "+IsThereWitness)
;	Log("SURRENDER Armed - "+Armed)
;	Log("SURRENDER Clothed - "+Clothed)
;	Log("SURRENDER FollowerClothed - "+FollowerClothed)
;	Log("SURRENDER BadRelation - "+BadRelation)
;	Log("SURRENDER AllowedFaction - "+AllowedFaction+" / TheEvilFaction - "+TheEvilFaction)
;	Log("SURRENDER HowManyAggressors - "+HowManyAggressors)
;	Log("SURRENDER HowManyPartners - "+HowManyPartners)
;	Log("SURRENDER HasBeenRapedBy - "+HasBeenRapedBy)
;	Log("SURRENDER Get dialogue data ends "+GetCurrentRealTime())
EndFunction
Actor Function IsSexualTension(Actor Aggressor, Actor Victim = None, Bool PlayerVictim) ; SURRENDER Is there at least one aggressor that want to sexual assault?
	Int i
	If PlayerVictim
		While (i < 5)
			If LastSceneAggressors[i]
				If IsSexualAssaulter(LastSceneAggressors[i], Player, PlayerVictim)
					Return LastSceneAggressors[i]
				Endif
			Endif
			i += 1
		EndWhile
	Else
		While (i < 5)
			If LastSceneFollowers[i]
				If IsSexualAssaulter(Aggressor, LastSceneFollowers[i], PlayerVictim)
					Return LastSceneFollowers[i]
				Endif
			Endif
			i += 1
		EndWhile
	Endif
	Return None
EndFunction

; =================================================== YIELD functions
Bool Property YieldIsClothed Auto Hidden Conditional
Bool Property YieldBadRelation Auto Hidden Conditional
Int Property YieldHasBeenRapedBy Auto Hidden Conditional
Function YieldData(Actor Aggressor, Actor Victim)
	YieldIsClothed = IsClothed(Victim, False)
	YieldHasBeenRapedBy = HasBeenRapedBy(Victim, Aggressor)
	YieldBadRelation = IsBadRelation(Aggressor, Victim, False)
;	Log("YIELD YieldHasBeenRapedBy - "+YieldHasBeenRapedBy)
;	Log("YIELD YieldIsClothed - "+YieldIsClothed)
;	Log("YIELD YieldBadRelation - "+YieldBadRelation)
EndFunction

; =================================================== STATES
Float Property StateDuration Auto Hidden
Actor Property Perpetrator Auto Hidden

Spell Property CalmSPL Auto							; 
Spell Property TrueCalmSPL Auto						; Calm
Faction Property CalmFaction Auto					;
Spell Property SatisfiedSPL Auto					; Satisfied
Spell Property KnockDownSPL Auto					; Knockdown
Spell Property TraumaSPL Auto						; Trauma
Spell Property ExhaustedSPL Auto					; Exhausted
Spell Property SurrenderSPL Auto					; Surrender
Spell Property YieldSPL Auto						; Yield
Spell Property EscapeSPL Auto						; Escape
Package Property EscapePack Auto					;
Faction Property TieUpFaction Auto 					; Tie up
Actor[] TieUpSlots 									;
ReferenceAlias[] Property TieUpSlotsAliases Auto 	;
Faction Property GaggedFaction Auto 				;
Bool Property TiedPermanent Auto Hidden Conditional ;
Faction Property KnockoutFaction Auto 				; Knockout
Actor[] KnockoutSlots 								;
ReferenceAlias[] Property KnockoutSlotsAliases Auto ;

String Function VictimState(Actor Target) 
	; Return the state the target is currently in as a string.
	If Target.IsDead()
		Return "Dead"
	Elseif Target.HasKeyWordString("SexLabActive")
		Return "Sex"
	Elseif Target.IsBleedingOut()
		Return "Bleedout"
	Elseif (Target.GetSleepState() == 3)
		Return "Sleeping"
	Elseif Target.IsInFaction(TieUpFaction)
		Return "Tied"		
	Else
		Return GetStringValue(Target, "DefeatState")
	Endif
EndFunction

Bool Function Tied(Actor Target) ; Check if the Target is tied
	If Zazon
		Return Target.WornHasKeyword(Keyword.GetKeyword("zbfWornWrist"))
	Else
		Return False
	Endif
EndFunction

Function RemoveStates(Actor Target, Bool NoCalm = True)
	Knockdown(Target, UnCalm = NoCalm, Enter = False)
	Trauma(Target, UnCalm = NoCalm, Enter = False)
	Exhausted(Target, UnCalm = NoCalm, Enter = False)
	Surrender(Target, UnCalm = NoCalm, Enter = False)
	Yield(Target, UnCalm = NoCalm, Enter = False)
	Escape(Target, UnCalm = NoCalm, Enter = False)
EndFunction

Bool Function Calm(Actor Target, Bool Enter = True)
	If Enter
		If !Target.IsInFaction(CalmFaction)
			Target.AddSpell(TrueCalmSPL)
			Target.AddToFaction(CalmFaction)
			Target.StopCombat()
			Target.StopCombatAlarm()
			ActorUtil.AddPackageOverride(Target, DoNothing, 100, 1)
			Target.EvaluatePackage()
			Return True
		Else
			Target.StopCombatAlarm()
		Endif
	Else
		If Target.HasSpell(TrueCalmSPL)
			Target.RemoveFromFaction(CalmFaction)
			ActorUtil.RemovePackageOverride(Target, DoNothing)
			Target.EvaluatePackage()
			Target.RemoveSpell(TrueCalmSPL)
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function SetSatisfied(Actor Target = None, Float Duration = 0.0, String Type = "", Bool Satisfied = True)
	If Satisfied
		If Target
			If !Target.HasSpell(SatisfiedSPL)
				If (Duration > 0.0)
					StateDuration = Duration
				Else
					If (Type == "Player Victim")
						StateDuration = McmConfig.SatisfiedPvic
					Elseif (Type == "Follower")
						StateDuration = McmConfig.SatisfiedFollower
					Elseif (Type == "NPC")
						StateDuration = McmConfig.SatisfiedNVN
					Endif
				Endif
				Target.AddSpell(SatisfiedSPL)
				Return True
			Endif
		Endif
	Else
		If Target
			If Target.HasSpell(SatisfiedSPL)
				Target.RemoveSpell(SatisfiedSPL)
			Endif
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function Knockdown(Actor Target, Actor Aggressor = None, Float Duration = 0.0, String Type = "", Bool UnCalm = True, Bool IsBleedout = False, Bool Enter = True) 
	; Stun a target during a MCM setting amount of time or the specified duration, the victim get back up if Stun is False.
	If Enter
		; 2015.07.03 / Add
		Bool isDowned = False
		
		If Target.HasSpell(TraumaSPL) || Target.HasSpell(ExhaustedSPL) || Target.IsInFaction(TieUpFaction)
			isDowned = True
		Endif
		; 2015.07.03 / Add
		
		If !Target.HasSpell(KnockDownSPL)
			Trauma(Target, UnCalm = False, Enter = False)
			; 2015.07.04 / Del
;			TieUp(Target, UnCalm = False, Enter = False)
			; 2015.07.04 / Del
			Exhausted(Target, UnCalm = False, Enter = False)
			Surrender(Target, UnCalm = False, Enter = False)
			Escape(Target, UnCalm = False, Enter = False)
			Calm(Target)
			Target.SetRestrained()
			Target.SetDontMove()
			If (Duration > 0.0)
				StateDuration = Duration
			Else
				If (Type == "Player Aggressor")
					StateDuration = McmConfig.KDTimePagg
				Elseif (Type == "Follower")
					StateDuration = McmConfig.KDTimeNVN
				Elseif (Type == "NPC")
					StateDuration = McmConfig.KDTimeNVN
				Endif
			Endif
			; 2015.07.11 / Add
			If Target == PreCaptiveVictim
				StateDuration = 8880.0
			Endif
			; 2015.07.11 / Add
			Perpetrator = Aggressor
			SetStringValue(Target, "DefeatState", "Knockdown")
			SetStringValue(Target, "DefeatType", Type)
			Target.AddSpell(KnockDownSPL)
			; 2015.07.03 / Mod
			If !IsBleedout && !isDowned
			; 2015.07.03 / Mod
				DefeatPlayAnimation(Target, "Bleedout")
			Else
				Target.SetNoBleedoutRecovery(True)
			Endif
			Return True
		Elseif Target.HasSpell(KnockDownSPL)
			SendAnimationEvent(Target, GetStringValue(Target, "DefeatStateAnim"))
		Endif
	Else
		; 2015.07.04 / Mod / NOT recover when tied up
		If Target.HasSpell(KnockDownSPL) && !Target.IsInFaction(TieUpFaction)
			If UnCalm
				If !Target.GetWornForm(0x00000004)
					Redress(Target)
				Endif
				DefeatPlayAnimation(Target, "Stand")
				Calm(Target, False)
			Endif
			Target.SetRestrained(False)
			Target.SetDontMove(False)
			UnsetStringValue(Target, "DefeatState")
			UnSetStringValue(Target, "DefeatType")
			Target.SetNoBleedoutRecovery(False)
			If Target.Is3DLoaded()
				MiscSpells[5].Cast(Target, Target) ; ImmunitySPL
			Endif
			Target.RemoveSpell(KnockDownSPL)
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function Trauma(Actor Target, Actor Aggressor = None, Float Duration = 0.0, String Type = "", Bool UnCalm = True, Bool Enter = True)
	; Make a NPC enters in a trauma state, if the duration is not specified the default NPC vs NPC mcm value will applies.
	If Enter
		If !Target.HasSpell(TraumaSPL)
			Knockdown(Target, UnCalm = False, Enter = False)
			TieUp(Target, UnCalm = False, Enter = False)
			Exhausted(Target, UnCalm = False, Enter = False)
			Surrender(Target, UnCalm = False, Enter = False)
			Escape(Target, UnCalm = False, Enter = False)
			Calm(Target)
			Target.SetRestrained()
			Target.SetDontMove()
			If (Duration > 0.0)
				StateDuration = Duration
			Else
				If (Type == "Follower")
					StateDuration = McmConfig.NVNTraumaCvic
				Elseif (Type == "Player Aggressor")
					StateDuration = McmConfig.TraumaPagg
				Elseif (Type == "NPC")
					StateDuration = McmConfig.NVNTrauma
				Endif
				; 2015.07.11 / Add
				If Target == PreCaptiveVictim
					StateDuration = 8880.0
				Endif
				; 2015.07.11 / Add
			Endif
			Perpetrator = Aggressor
			SetStringValue(Target, "DefeatState", "Trauma")
			SetStringValue(Target, "DefeatType", Type)
			SetStringValue(Target, "DefeatStateAnim", "IdleWounded_03")
			Target.AddSpell(TraumaSPL)
			Target.EvaluatePackage()
			DefeatPlayAnimation(Target, "Trauma Lie")
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target)
;			setRyonaEffects(Target, Aggressor, Enter = true)
			; 2015.07.12 / Add
			Return True
		Elseif Target.HasSpell(TraumaSPL)
			SendAnimationEvent(Target, GetStringValue(Target, "DefeatStateAnim"))
		Endif
	Else
		; 2015.07.04 / Mod / NOT recover when tied up
		If Target.HasSpell(TraumaSPL) && !Target.IsInFaction(TieUpFaction)
			UnsetStringValue(Target, "DefeatStateAnim")
			If UnCalm
				If !Target.GetWornForm(0x00000004)
					Bool OptionRedress
					String Option = GetStringValue(Target, "DefeatType")
					If Option == "Player Victim"
						OptionRedress = McmConfig.bRedressPvic
					Elseif Option == "Follower"
						OptionRedress = McmConfig.bRedressFollower
					Elseif (Option == "Player Aggressor")
						OptionRedress = McmConfig.bRedressPagg
					Elseif (Option == "NPC")
						OptionRedress = McmConfig.bRedressNVN
					Endif
					If OptionRedress
						Redress(Target)
					Endif
				Endif
				DefeatPlayAnimation(Target, "Trauma Stand")
				Calm(Target, False)
			Endif
			Target.SetRestrained(False)
			Target.SetDontMove(False)
			UnsetStringValue(Target, "DefeatState")
			UnSetStringValue(Target, "DefeatType")
			Target.RemoveSpell(TraumaSPL)
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target, Enter = false)
;			setRyonaEffects(Target, Aggressor, Enter = false)
			; 2015.07.12 / Add
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function Exhausted(Actor Target, Actor Aggressor = None, Float Duration = 0.0, String Type = "", Bool UnCalm = True, Bool Enter = True)
	; Make a NPC enters in a exhausted state, if the duration is not specified the default NPC vs NPC mcm value will applies.
	If Enter
		If !Target.HasSpell(ExhaustedSPL)
			Knockdown(Target, UnCalm = False, Enter = False)
			TieUp(Target, UnCalm = False, Enter = False)
			Trauma(Target, UnCalm = False, Enter = False)
			Surrender(Target, UnCalm = False, Enter = False)
			Escape(Target, UnCalm = False, Enter = False)
			Calm(Target)
			Target.SetRestrained()
			Target.SetDontMove()
			If (Duration > 0.0)
				StateDuration = Duration
			Else
				If (Type == "Follower")
					StateDuration = McmConfig.NVNExhaustedCvic
				Elseif (Type == "Player Aggressor")
					StateDuration = McmConfig.ExhaustedPagg
				Elseif (Type == "NPC")
					StateDuration = McmConfig.NVNExhausted
				Endif
			Endif
			; 2015.07.11 / Add
			If Target == PreCaptiveVictim
				StateDuration = 8880.0
			Endif
			; 2015.07.11 / Add
			Perpetrator = Aggressor
			SetStringValue(Target, "DefeatState", "Exhausted")
			SetStringValue(Target, "DefeatType", Type)
			Target.AddSpell(ExhaustedSPL)
			DefeatPlayAnimation(Target, "Exhausted Lie")
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target)
;			setRyonaEffects(Target, Aggressor, Enter = true)
			; 2015.07.12 / Add
			Return True
		Elseif Target.HasSpell(ExhaustedSPL)
			SendAnimationEvent(Target, GetStringValue(Target, "DefeatStateAnim"))
		Endif
	Else
		; 2015.07.04 / Mod / NOT recover when tied up
		If Target.HasSpell(ExhaustedSPL) && !Target.IsInFaction(TieUpFaction)
			UnsetStringValue(Target, "DefeatStateAnim")
			If UnCalm
				If !Target.GetWornForm(0x00000004)
					Bool OptionRedress
					String Option = GetStringValue(Target, "DefeatType")
					If Option == "Player Victim"
						OptionRedress = McmConfig.bRedressPvic
					Elseif Option == "Follower"
						OptionRedress = McmConfig.bRedressFollower
					Elseif (Option == "Player Aggressor")
						OptionRedress = McmConfig.bRedressPagg
					Elseif (Option == "NPC")
						OptionRedress = McmConfig.bRedressNVN
					Endif
					If OptionRedress
						Redress(Target)
					Endif
				Endif
				; 2015.07.08 / Mod
;				DefeatPlayAnimation(Target, "Stand")
				DefeatPlayAnimation(Target, "Trauma Stand")
				; 2015.07.08 / Mod
				Calm(Target, False)
			Endif
			Target.SetRestrained(False)
			Target.SetDontMove(False)
			UnsetStringValue(Target, "DefeatState")
			UnSetStringValue(Target, "DefeatType")
			Target.RemoveSpell(ExhaustedSPL)
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target, Enter = false)
;			setRyonaEffects(Target, Aggressor, Enter = false)
			; 2015.07.12 / Add
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function Surrender(Actor Target, Actor Aggressor = None, Bool UnCalm = True, Bool Enter = True) 
	If Enter
		If !Target.HasSpell(SurrenderSPL)
			Calm(Target)
			Perpetrator = Aggressor
			Target.AddSpell(SurrenderSPL)
			DefeatPlayAnimation(Target, "Surrender")
			SetStringValue(Target, "DefeatState", "Surrender")
			Return True
		Elseif Target.HasSpell(SurrenderSPL)
			DefeatPlayAnimation(Target, "Surrender")
		Endif
	Else
		If Target.HasSpell(SurrenderSPL)
			If UnCalm
				Calm(Target, False)
			Endif
			UnsetStringValue(Target, "DefeatState")
			If Target.Is3DLoaded()
				MiscSpells[5].Cast(Target, Target) ; ImmunitySPL
			Endif
			Target.RemoveSpell(SurrenderSPL)
			Return True
		Endif
	Endif
	Return False
EndFunction

; 2015.06.27 / Add
Function SurrenderALL()
	LastSceneFollowers = PlayerScr.GetFollowers()
	
	Int i
	While (i < 5)
		Actor Reference = LastSceneFollowers[i]
		If Reference
			String TheState = VictimState(Reference)
			If (TheState == "") ; The follower is doing well
				Surrender(Reference)
			Endif
		Endif
		i += 1
	EndWhile
EndFunction
; 2015.06.27 / Add

; 2015.07.02 / Add
Bool Function Collateral(Actor Aggressor = None, Actor Victim = None)
	If (McmConfig.CollateralAssault && !PlayerScr.MiscScenes[3].IsPlaying())
		Actor[] CollateralActors = New Actor[2]
		
		If (Aggressor && Victim)
			CollateralActors[0] = Aggressor
			CollateralActors[1] = Victim
		Else
			PlayerScr.SetAggressors()
			PlayerScr.SetFollowers()
			CollateralActors = PlayerScr.CollateralGetActors(CollateralActors)
		Endif
		
		If (CollateralActors[0] && CollateralActors[1])
			CollateralActors[0].SetFactionRank(DefeatFactions[1], 3) ; AggFaction / Set the aggressor as collateral aggressor
			CollateralActors[1].SetFactionRank(DefeatFactions[0], 3) ; DefeatFaction / Set follower as collateral victim
			FollowerHasBeenRapedBy = HasBeenRapedBy(CollateralActors[1], CollateralActors[0])
			PlayerScr.CollateralStart(CollateralActors[0], CollateralActors[1])
			Return True
		Endif
	Endif
	
	Return False
EndFunction
; 2015.07.02 / Add

Bool Function Yield(Actor Target, Actor Aggressor = None, Bool UnCalm = True, Bool Enter = True) 
	; Make the target yield until the player leave his line of sight.
	If Enter
		If !Target.HasSpell(YieldSPL)
			Calm(Target)
			Perpetrator = Aggressor
			Target.AddSpell(YieldSPL)
			DefeatPlayAnimation(Target, "Surrender")
			SetStringValue(Target, "DefeatState", "Yield")
			YieldData(Aggressor, Target)
			Return True
		Elseif Target.HasSpell(YieldSPL)
			DefeatPlayAnimation(Target, "Surrender")
		Endif
	Else
		If Target.HasSpell(YieldSPL)
			If Target.IsInDialogueWithPlayer()
				DisablePlayerControls()
				EnablePlayerControls()
			Endif
			If UnCalm
				If !Target.GetWornForm(0x00000004)
					Redress(Target)
				Endif
			;	DefeatPlayAnimation(Target, "Stand")
				Calm(Target, False)
			Endif
			UnsetStringValue(Target, "DefeatState")
			If Target.Is3DLoaded()
				MiscSpells[5].Cast(Target, Target) ; ImmunitySPL
			Endif
			Target.RemoveSpell(YieldSPL)
			Return True
		Endif
	Endif
	Return False
EndFunction

Bool Function Escape(Actor Target, Actor EscapeFrom = None, Float Duration = 0.0, String Type = "", Bool UnCalm = True, Bool Enter = True)
	; Make the Target flee for the MCM duration
	If Enter
		If !Target.HasSpell(EscapeSPL)
			Calm(Target)
			If (Duration > 0.0)
				StateDuration = Duration
			Else
				If (Type == "Follower")
					StateDuration = McmConfig.EscapeCvic
				Elseif (Type == "Player Aggressor")
					StateDuration = McmConfig.EscapePagg
				Elseif (Type == "NPC")
					StateDuration = McmConfig.EscapeNPC
				Endif
			Endif
			SetStringValue(Target, "DefeatState", "Escape")
			SetStringValue(Target, "DefeatType", Type)
			Perpetrator = EscapeFrom
			ActorUtil.AddPackageOverride(Target, EscapePack, 100, 1)
			Target.AddSpell(EscapeSPL)
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target)
;			setRyonaEffects(Target, EscapeFrom, Enter = true)
			; 2015.07.12 / Add
			Return True
		Elseif Target.HasSpell(EscapeSPL)
			Target.EvaluatePackage()
		Endif
	Else
		If Target.HasSpell(EscapeSPL)
			If UnCalm
				Calm(Target, False)
				If !Target.GetWornForm(0x00000004)
					Bool OptionRedress
					String Option = GetStringValue(Target, "DefeatType")
					If Option == "Follower"
						OptionRedress = McmConfig.bRedressFollower
					Elseif (Option == "Player Aggressor")
						OptionRedress = McmConfig.bRedressPagg
					Elseif (Option == "NPC")
						OptionRedress = McmConfig.bRedressNVN
					Endif
					If OptionRedress
						Redress(Target)
					Endif
				Endif
			Endif
			UnsetStringValue(Target, "DefeatState")
			UnSetStringValue(Target, "DefeatType")
			ActorUtil.RemovePackageOverride(Target, EscapePack)
			Target.EvaluatePackage()
			Target.RemoveSpell(EscapeSPL)
			; 2015.07.12 / Add
;			setRapedFaceAnimation(Target, Enter = false)
;			setRyonaEffects(Target, EscapeFrom, Enter = false)
			; 2015.07.12 / Add
			Return True
		Endif
	Endif
	Return False
EndFunction


Bool Function TieUp(Actor Target, Actor Aggressor = None, Float Duration = 0.0, Bool DoAnimation = False, Bool UnCalm = True, Bool Enter = True)
;	Tie up a NPC, the duration can be specified, if not it will use the MCM setting
;	the tying up animation can be disabled to make it instant, if so the aggressor need to be specified as well
;	or this will be ignored. Untie the Target if Tied is False, do nothing if the Target isn't tied.
	; 2015.07.30 / Add
	Bool  enableWeb      = McmConfig.mEnableTieupWeb
	Bool  isSpiderRace   = isSpider(Aggressor)
	Bool  enableFuro     = McmConfig.mEnableTieupFuro
	Bool  isTentacleUser = isTentacleUser(Aggressor)
	
	If isSpiderRace && !enableWeb
		Return False
	Elseif isTentacleUser && !enableFuro
		Return False
	Endif
	; 2015.07.30 / Add
	
	If Enter
		If !Target.IsInFaction(TieUpFaction)
			Int i = TieUpSlots.Find(None)
			If (i != -1)
				TieUpSlots[i] = Target
				TieUpSlotsAliases[i].ForceRefIfEmpty(Target)
				; 2015.07.14 / Del
;				RemoveStates(Target, False)
				; 2015.07.14 / Del
				Calm(Target)
				Target.SetRestrained()
				Target.SetDontMove()
				If (Duration > 0.0)
					StateDuration = Duration
				Else
					StateDuration = McmConfig.TiedTime
				Endif
				Perpetrator = Aggressor
				SetStringValue(Target, "DefeatState", "Tied")
				Target.SetFactionRank(TieUpFaction, i)
				If (DoAnimation && Aggressor)
					SendAnimationEvent(Aggressor, "DefeatTyingUpAnim")
					Wait(3.0)
				Endif
				(TieUpSlotsAliases[i] As DefeatStateMonitoringScr).Enter(Target)
				Log("NPC "+Target.GetActorBase().GetName()+" / Slot "+Target.GetFactionRank(TieUpFaction)+" Enters in a tie up state // TieUpSlots - "+TieUpSlots)
				; 2015.07.20 / Add
				DefeatStateMonitoringScr scrSlot = (TieUpSlotsAliases[i] As DefeatStateMonitoringScr)
				Int   nRand                      = RandomInt(0, 2)
				Bool  enableYoke                 = McmConfig.mEnableTieupYoke
				Bool  enableArmbinder            = McmConfig.mEnableTieupArmBinder
				Bool  enableGag                  = McmConfig.mEnableTieupGag
				; 2015.07.26 / Add
				Bool  enableExDev                = McmConfig.mEnableTieupExt
				Bool  enableExHood               = McmConfig.mEnableTieupHood
				Armor armDevice
				Int   nRandWeb                   = RandomInt(0, 2)
				; 2015.07.26 / Add
				
				; 2015.07.26 / Add
				If !Zazon
					enableWeb  = False
					; 2015.07.30 / Add
					enableFuro = False
					; 2015.07.30 / Add
				Endif
				
				If isSpiderRace && enableWeb && (nRandWeb == 0)
					; ZaZAPECocoonSuit01 [ARMO:02005960]
					armDevice = maTieupDevices[1]
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "ZazAPC223")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				Elseif isSpiderRace && enableWeb && (nRandWeb == 1)
					; ZaZAPECocoonSuit02 [ARMO:02005EC5]
					armDevice = maTieupDevices[2]
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "ZazAPC224")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				Elseif isSpiderRace && enableWeb && (nRandWeb == 2)
					; ZaZAPECocoonSuit03 [ARMO:02006438]
					armDevice = maTieupDevices[3]
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "ZazAPC225")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				Elseif isSpiderRace && enableWeb && (nRandWeb == 3)
					; ZaZAPECocoonWebbing01 [ARMO:02006436]
					armDevice = maTieupDevices[4]
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "ZazAPC226")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				; 2015.07.30 / Add
				Elseif isTentacleUser && enableFuro
					; No device
				; 2015.07.30 / Add
				; 2015.07.26 / Add
				; 2015.07.26 / Mod / If -> Elseif
				Elseif (nRand == 0) && enableYoke
					armDevice = MiscFormLists[0].GetAt(3) As Armor
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "DefeatTieUpYoke")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				Elseif (nRand == 1) && enableArmbinder
					armDevice = MiscFormLists[0].GetAt(4) As Armor
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "DefeatTieUpArmbinder")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				; 2015.07.26 / Add
				Else
					armDevice = MiscFormLists[0].GetAt(2) As Armor
					ActionQst.ChangeDevice(Target, scrSlot, armDevice, "DefeatTieUpEnter")
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				; 2015.07.26 / Add
				Endif
				
				; 2015.07.26 / Add
				If isSpiderRace && enableWeb
					armDevice = maTieupDevices[0]
					Target.AddItem(armDevice, 1)
					Target.EquipItem(armDevice)
				; 2015.07.30 / Add
				Elseif isTentacleUser && enableFuro
					addTieupDevices(Target, "extend61")
				; 2015.07.30 / Add
				Elseif enableExDev
					If enableExHood
						addTieupDevices(Target, "extend30")
					Endif
					
					addTieupDevices(Target, "extend44")
					addTieupDevices(Target, "extend45")
					addTieupDevices(Target, "extend49")
					addTieupDevices(Target, "extend53")
					addTieupDevices(Target, "extend55")
					addTieupDevices(Target, "extend59")
					addTieupDevices(Target, "extend61")
				; 2015.07.26 / Add
				; 2015.07.26 / Mod / If -> Elseif
				Elseif (RandomInt(0, 1) == 0) && enableGag
					scrSlot.Gag()
				Endif
				; 2015.07.20 / Add
				
				; 2015.07.03 / Add
				Int    Selected
				Int    nZazIndex
				String ThePose      = ""
				String StrugglePose = ""
				
				; 2015.07.26 / Mod / Adding Spider handling
				If isSpiderRace && enableWeb
					Int nWebIdx  = RandomInt(221, 232)
					ThePose      = "ZazAPC"+(nWebIdx as String)
					StrugglePose = "ZazAPC"+(nWebIdx as String)
				Elseif isTentacleUser && enableFuro
					ThePose      = "ZazAPFSA001"
					StrugglePose = "ZazAPFSA001"
				Else
					; 2015.07.14 / Mod / Using getTieupPose()
					String[] aPoses = getTieupPose(Target)
					ThePose         = aPoses[0]
					StrugglePose    = aPoses[1]
					; 2015.07.14 / Mod / Using getTieupPose()
				Endif
				; 2015.07.26 / Mod / Adding Spider handling
				
				If (ThePose != "" && StrugglePose != "")
;					Notification("The pose is "+ThePose+"("+(Selected as string)+").")
					(TieUpSlotsAliases[i] As DefeatStateMonitoringScr).ChangeTiePose(ThePose, StrugglePose)
				Endif
				; 2015.07.03 / Add
				; 2015.07.12 / Add
				setRapedFaceAnimation(Target)
				; 2015.07.12 / Add
			Else
				Notification("$No more slots available for tie up")
			Endif
			Return True
		Elseif Target.IsInFaction(TieUpFaction)
			Calm(Target)
		Endif
	Else
		If Target.IsInFaction(TieUpFaction)
			If (DoAnimation && Aggressor)
				SendAnimationEvent(Aggressor, "BoundStandingCutNPC")
				wait(1.0)
			Endif
			Int i = Target.GetFactionRank(TieUpFaction)
			TieUpSlots[i] = None
			(TieUpSlotsAliases[i] As DefeatStateMonitoringScr).RegisterAnimEvent(False)
			TieUpSlotsAliases[i].Clear()
			; 2015.07.26 / Mod
;			Form Gag = MiscFormLists[0].GetAt(1) ; MiscStuffList/Gag
;			If (Target.GetItemCount(Gag) > 0)
;				Target.RemoveItem(Gag)
;			Endif
;			If Target.IsInFaction(GaggedFaction)
;				Target.RemoveFromFaction(GaggedFaction)
;			Endif
;			Int LimitLoop = 5
;			Form Cuffs = MiscFormLists[0].GetAt(2) ; MiscStuffList/Cuffs
;			While ((Target.GetItemCount(Cuffs) > 0) && (LimitLoop > 0))
;				Target.RemoveItem(Cuffs)
;				LimitLoop -= 1
;			EndWhile
;			LimitLoop = 5
;			Form Yoke = MiscFormLists[0].GetAt(3) ; MiscStuffList/Yoke
;			While ((Target.GetItemCount(Yoke) > 0) && (LimitLoop > 0))
;				Target.RemoveItem(Yoke)
;				LimitLoop -= 1
;			EndWhile
;			LimitLoop = 5
;			Form Armbinder = MiscFormLists[0].GetAt(4) ; MiscStuffList/Armbinder
;			While ((Target.GetItemCount(Armbinder) > 0) && (LimitLoop > 0))
;				Target.RemoveItem(Armbinder)
;				LimitLoop -= 1
;			EndWhile
			removeTieupDevices(Target)
			; 2015.07.26 / Mod
			
;			Form WearedItem = Target.GetWornForm(0x00004000)
;			If (WearedItem && WearedItem.HasKeyWordString("DefeatWornGag"))
;				Target.RemoveFromFaction(GaggedFaction)
;				Target.RemoveItem(WearedItem)
;			Endif
;			WearedItem = Target.GetWornForm(0x20000000)
;			If (WearedItem && WearedItem.HasKeyWordString("DefeatWornDevice"))
;				Target.RemoveItem(WearedItem)
;			Endif
			If UnCalm
				DefeatPlayAnimation(Target, "Untie")
				Calm(Target, False)
			Endif
			Target.SetRestrained(False)
			Target.SetDontMove(False)
			UnsetStringValue(Target, "DefeatState")
			UnsetStringValue(Target, "DefeatStateAnim")
			Log("NPC "+Target.GetActorBase().GetName()+" / Slot "+i+" Exit of a tie up state // TieUpSlots - "+TieUpSlots)
			Target.RemoveFromFaction(TieUpFaction)
			Redress(Target)
			; 2015.07.12 / Add
			setRapedFaceAnimation(Target, Enter = false)
			; 2015.07.12 / Add
			Return True
		Endif
	Endif
	Return False
EndFunction

; 2015.07.26 / Add
Function addTieupDevices(Actor actTarget, String szType)
	If (szType == "web") && Zazon
		Int  nDevIdx   = RandomInt(1, 3)
		Form frmDev    = maTieupDevices[nDevIdx] as Form
		Form frmWeb    = maTieupDevices[0] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
		
		If frmWeb
			actTarget.AddItem(frmWeb, 1)
			actTarget.EquipItem(frmWeb, True)
		Endif
	Elseif (szType == "default")
		Int  nDevIdx         = RandomInt(2, 4)
		Form frmDev          = MiscFormLists[0].GetAt(nDevIdx)
		Form frmGag          = MiscFormLists[0].GetAt(1)
		Bool enableYoke      = McmConfig.mEnableTieupYoke
		Bool enableArmbinder = McmConfig.mEnableTieupArmBinder
		Bool enableGag       = McmConfig.mEnableTieupGag
		
		If !enableYoke && (nDevIdx == 3)
			frmDev = MiscFormLists[0].GetAt(2)
		Elseif !enableArmbinder && (nDevIdx == 4)
			frmDev = MiscFormLists[0].GetAt(2)
		Endif
		
		actTarget.AddItem(frmDev, 1)
		actTarget.EquipItem(frmDev, True)
		
		If (RandomInt(0, 1) == 0) && enableGag
			actTarget.AddItem(frmGag, 1)
			actTarget.EquipItem(frmGag, True)
		Endif
	Elseif (szType == "extend") && Zazon
		Int  nDevMax   = maTieupDevices.Find(None) - 1
		Int  nDevIdx   = RandomInt(5, nDevMax)
		Form frmDev    = maTieupDevices[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend30") && Zazon
		Int  nDevMax   = maTieupSlot30.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot30[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend44") && Zazon
		Int  nDevMax   = maTieupSlot44.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot44[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend45") && Zazon
		Int  nDevMax   = maTieupSlot45.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot45[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend49") && Zazon
		Int  nDevMax   = maTieupSlot49.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot49[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend53") && Zazon
		Int  nDevMax   = maTieupSlot53.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot53[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend55") && Zazon
		Int  nDevMax   = maTieupSlot55.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot55[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend59") && Zazon
		Int  nDevMax   = maTieupSlot59.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot59[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Elseif (szType == "extend61") && Zazon
		Int  nDevMax   = maTieupSlot61.Find(None)
		Int  nDevIdx   = RandomInt(0, nDevMax)
		Form frmDev    = maTieupSlot61[nDevIdx] as Form
		
		If frmDev
			actTarget.AddItem(frmDev, 1)
			actTarget.EquipItem(frmDev, True)
		Endif
	Endif
EndFunction

Function setTieupPose(Actor actTarget, String szType)
	If (szType == "web") && Zazon
		String szPose = "ZazAPC"+(RandomInt(221, 232) as String)
		SetStringValue(actTarget, "DefeatStateAnim", szPose)
		SendAnimationEvent(actTarget, szPose)
	; 2015.07.30 / Add
	Elseif (szType == "furo") && Zazon
		String szPose = "ZazAPFSA001"
		SetStringValue(actTarget, "DefeatStateAnim", szPose)
		SendAnimationEvent(actTarget, szPose)
	; 2015.07.30 / Add
	Elseif (szType == "default")
		String[] aPoses = getTieupPose(actTarget)
		SetStringValue(actTarget, "DefeatStateAnim", aPoses[0])
		SendAnimationEvent(actTarget, aPoses[0])
	Endif
EndFunction

Function removeTieupDevices(Actor actTarget)
	Form frmDev
	Int  nDevIdx
	Int  nLimitLoop
	
	; Cuffs, Yoke, Armbinder, Gag
	nDevIdx = 5
	
	While (nDevIdx > 1)
		nDevIdx -= 1
		
		nLimitLoop = 5
		frmDev    = MiscFormLists[0].GetAt(nDevIdx)
		
		If frmDev
			While ((actTarget.GetItemCount(frmDev) > 0) && (nLimitLoop > 0))
				actTarget.RemoveItem(frmDev)
				nLimitLoop -= 1
			EndWhile
		Endif
	EndWhile
	
	; Extended devices
;	nDevIdx = maTieupDevices.Length
	nDevIdx = maTieupDevices.Find(None)
	
	While (nDevIdx > 0)
		nDevIdx -= 1
		
		nLimitLoop = 5
		frmDev    = maTieupDevices[nDevIdx] as Form
		
		If frmDev
			While ((actTarget.GetItemCount(frmDev) > 0) && (nLimitLoop > 0))
				actTarget.RemoveItem(frmDev)
				nLimitLoop -= 1
			EndWhile
		Endif
	EndWhile
EndFunction
; 2015.07.26 / Add

Bool Function Knockout(Actor Target, Actor Aggressor = None, Float Duration = 0.0, Bool UnCalm = True, Bool Enter = True)
	; knock uncnonscious the target, do nothing if the target is already unconscious
	If Enter
		If (!Target.IsInFaction(KnockoutFaction))
			Int i = KnockoutSlots.Find(None)
			If (i != -1)
				; 2015.07.14 / Del
;				RemoveStates(Target, False)
				; 2015.07.14 / Del
				TieUp(Target, UnCalm = False, Enter = False)
				Calm(Target)
				If (Duration > 0.0)
					StateDuration = Duration
				Else
					StateDuration = McmConfig.KOTime
				Endif
				Perpetrator = Aggressor
				SetStringValue(Target, "DefeatState", "Knockout")
				KnockoutSlots[i] = Target
				KnockoutSlotsAliases[i].ForceRefIfEmpty(Target)
				(KnockoutSlotsAliases[i] As DefeatStateMonitoringScr).Enter(Target)
				Target.SetFactionRank(KnockoutFaction, i)
				Target.ModActorValue("Paralysis", 1)
				If !Target.IsUnconscious()
					Target.SetUnconscious()
					Target.PushActorAway(Target, 0.0001)
				Endif
				Log("NPC "+Target.GetActorBase().GetName()+" / Slot "+Target.GetFactionRank(KnockoutFaction)+" enters knock out // KnockoutSlots - "+KnockoutSlots)
				Return True
			Else
				Notification("$No more slots available for knock out")
			Endif
		Else
			Calm(Target)
			If !Target.IsUnconscious()
				Target.SetUnconscious()
			Endif
		Endif
	Else
		If (Target.IsInFaction(KnockoutFaction) || Target.IsUnconscious())
			Int i = Target.GetFactionRank(KnockoutFaction)
			KnockoutSlots[i] = None
			(KnockoutSlotsAliases[i] As DefeatStateMonitoringScr).RegisterAnimEvent(False)
			KnockoutSlotsAliases[i].Clear()
			Log("NPC "+Target.GetActorBase().GetName()+" / Slot "+i+" exit knock out // KnockoutSlots - "+KnockoutSlots)
			Target.RemoveFromFaction(KnockoutFaction)
			Target.ForceActorValue("Paralysis", 0)
			Target.Setunconscious(False)
			Target.QueueNiNodeUpdate()
			UnsetStringValue(Target, "DefeatState")
			If UnCalm
				Calm(Target, False)
			Endif
			Return True
		Endif
	Endif
	Return False
EndFunction

Function Weakenings(Actor Target, String Type = "", Float Duration = 0.0, Bool RemoveSpl = False)
	; To apply weakenings effect on the target.
	If !RemoveSpl
		If (Type == "Player Victim")
			If (Duration == 0.0)
				StateDuration = McmConfig.DebuffDuration
			Endif
		Elseif (Type == "Player Aggressor")
			If (Duration == 0.0)
				StateDuration = McmConfig.DebuffDurationPagg
			Endif
			If McmConfig.VicAnimosity
				Target.SetRelationshipRank(Player, -4)
			Endif
		Elseif (Type == "NPC")
			If (Duration == 0.0)
				StateDuration = McmConfig.DebuffDurationNVN
			Endif
		Elseif (Type == "Follower")
			If (Duration == 0.0)
				StateDuration = McmConfig.DebuffDurationNVNCvic
			Endif
		Else
			If (Duration == 0.0)
				StateDuration = McmConfig.DebuffDurationNVN
			Endif
		Endif
		If !Target.HasSpell(MiscSpells[0]) ; Debuffspl
			Target.AddSpell(MiscSpells[0], False)
		Endif
	Else
		If Target.HasSpell(MiscSpells[0])
			Target.RemoveSpell(MiscSpells[0])
		Endif
	Endif
EndFunction

Function DefeatPlayAnimation(Actor Target, String AnimType) ; Play an animation depending of the situation of the player.
	If (!Target.IsDead() && Target.Is3DLoaded())
		If (AnimType == "Bleedout")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					If DDon
						If Target.IsInFaction(DefeatFactions[2])
							Target.RemoveFromFaction(DefeatFactions[2])
						Endif
					Endif
					SendAnimationEvent(Target, "ZapArmbBleedoutIdle")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZapYokeBleedoutIdle")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZapWriBleedoutIdle")
				Else
					SendAnimationEvent(Target, "BleedoutStart")
				Endif
			Else
				SendAnimationEvent(Target, "BleedoutStart")
			Endif
		Elseif (AnimType == "Surrender")
			Form Links = Target.GetWornForm(0x20000000)		
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					If DDon
						If Target.IsInFaction(DefeatFactions[2])
							Target.RemoveFromFaction(DefeatFactions[2])
						Endif
					Endif
					SendAnimationEvent(Target, "ZapArmbPose06")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZapYokePose06")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZapWriPose06")
				Endif
			Else
				SendAnimationEvent(Target, "IdleSurrender")
			Endif
		Elseif (AnimType == "Submission")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					If DDon
						If Target.IsInFaction(DefeatFactions[2])
							Target.RemoveFromFaction(DefeatFactions[2])
						Endif
					Endif
					SendAnimationEvent(Target, "ZapArmbPose06")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZapYokePose06")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZapWriPose06")
				Endif
			Else
				SendAnimationEvent(Target, "DefeatAllFour")
			Endif
		Elseif (AnimType == "Sit")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					SendAnimationEvent(Target, "ZapArmbPose07")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZapYokePose07")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZapWriPose07")
				Endif
			Else
				SendAnimationEvent(Target, "IdleWounded_03") 	; Vanilla injured sit stance
			Endif
		Elseif (AnimType == "Lie")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					SetStringValue(Target, "DefeatStateAnim", "ZapArmbPose14")
					SendAnimationEvent(Target, "ZapArmbPose14")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SetStringValue(Target, "DefeatStateAnim", "ZapYokePose15")
					SendAnimationEvent(Target, "ZapYokePose15")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SetStringValue(Target, "DefeatStateAnim", "ZapWriPose14")
					SendAnimationEvent(Target, "ZapWriPose14")
				Endif
			Else
				; 2015.07.16 / Mod
				Int i
				
				If McmConfig.mEnableExHalosPoses
					i = RandomInt(8, 8)
				Else
					i = RandomInt(0, 2)
				Endif
				; 2015.07.16 / Mod
				If (i == 0)
					SetStringValue(Target, "DefeatStateAnim", "DefeatEstrusExhaustedBack")
					SendAnimationEvent(Target, "DefeatEstrusExhaustedBack")
				Elseif (i == 1)
					SetStringValue(Target, "DefeatStateAnim", "DefeatEstrusExhaustedFront")
					SendAnimationEvent(Target, "DefeatEstrusExhaustedFront")
				; 2015.07.16 / Mod
				Elseif (i == 8)
					String szPose = getRandomLiePose()
					SetStringValue(Target, "DefeatStateAnim", szPose)
					SendAnimationEvent(Target, szPose) 
				; 2015.07.16 / Mod
				Else
					SetStringValue(Target, "DefeatStateAnim", "IdleWounded_02")
					SendAnimationEvent(Target, "IdleWounded_02") ; Vanilla injured lying down stance
				Endif
			Endif
		Elseif (AnimType == "Trauma Lie")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					SetStringValue(Target, "DefeatStateAnim", "ZapArmbPose14")
					SendAnimationEvent(Target, "ZapArmbPose14")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SetStringValue(Target, "DefeatStateAnim", "ZapYokePose15")
					SendAnimationEvent(Target, "ZapYokePose15")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SetStringValue(Target, "DefeatStateAnim", "ZapWriPose14")
					SendAnimationEvent(Target, "ZapWriPose14")
				Endif
			Else
				; 2015.07.16 / Mod
				Int i
				
				If McmConfig.mEnableExHalosPoses
					i = RandomInt(8, 8)
				Else
					i = RandomInt(0, 3)
				Endif
				; 2015.07.16 / Mod
				If (i == 0)
					SetStringValue(Target, "DefeatStateAnim", "DefeatEstrusTrauma")
					SendAnimationEvent(Target, "DefeatEstrusTrauma")
				Elseif (i == 1)
					SetStringValue(Target, "DefeatStateAnim", "DefeatTraumaEnter")
					SendAnimationEvent(Target, "DefeatTraumaEnter")
				; 2015.07.08 / Add
				Elseif (i == 2)
					SetStringValue(Target, "DefeatStateAnim", "IdleChildCryingStart")
					SendAnimationEvent(Target, "IdleChildCryingStart")
				; 2015.07.08 / Add
				; 2015.07.16 / Mod
				Elseif (i == 8)
					String szPose = getRandomLiePose()
					SetStringValue(Target, "DefeatStateAnim", szPose)
					SendAnimationEvent(Target, szPose) 
				; 2015.07.16 / Mod
				Else
					SetStringValue(Target, "DefeatStateAnim", "IdleWounded_02")
					SendAnimationEvent(Target, "IdleWounded_02") 
				Endif
			Endif
		Elseif (AnimType == "Trauma Stand")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					If DDon
						Target.AddToFaction(DefeatFactions[2])
					Endif
					SendAnimationEvent(Target, "ZazAPOA005")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZazAPOA007")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZazAPOA001")
				Endif
			Else
				SendAnimationEvent(Target, "DefeatTraumaExit")
			Endif
		Elseif (AnimType == "Exhausted Lie")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					SetStringValue(Target, "DefeatStateAnim", "ZapArmbPose14")
					SendAnimationEvent(Target, "ZapArmbPose14")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SetStringValue(Target, "DefeatStateAnim", "ZapYokePose15")
					SendAnimationEvent(Target, "ZapYokePose15")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SetStringValue(Target, "DefeatStateAnim", "ZapWriPose14")
					SendAnimationEvent(Target, "ZapWriPose14")
				Endif
			Else
				; 2015.07.16 / Mod
				Int i
				
				If McmConfig.mEnableExHalosPoses
					i = RandomInt(8, 8)
				Else
					i = RandomInt(0, 1)
				Endif
				
				If (i == 0)
;				If (RandomInt(0, 1) == 0)
				; 2015.07.16 / Mod
					SetStringValue(Target, "DefeatStateAnim", "DefeatEstrusExhaustedBack")
					SendAnimationEvent(Target, "DefeatEstrusExhaustedBack")
				; 2015.07.16 / Mod
				Elseif (i == 8)
					String szPose = getRandomLiePose()
					SetStringValue(Target, "DefeatStateAnim", szPose)
					SendAnimationEvent(Target, szPose) 
				; 2015.07.16 / Mod
				Else
					SetStringValue(Target, "DefeatStateAnim", "DefeatEstrusExhaustedFront")
					SendAnimationEvent(Target, "DefeatEstrusExhaustedFront")
				Endif
			Endif
		Elseif (AnimType == "Stand")
			Form Links = Target.GetWornForm(0x20000000)
			If (Links && Zazon)
				If Links.HasKeyWordString("zbfAnimHandsArmbinder")
					If DDon
						Target.AddToFaction(DefeatFactions[2])
					Endif
					SendAnimationEvent(Target, "ZazAPOA005")
				Elseif Links.HasKeyWordString("zbfAnimHandsYoke")
					SendAnimationEvent(Target, "ZazAPOA007")
				Elseif Links.HasKeyWordString("zbfAnimHandsWrists")
					SendAnimationEvent(Target, "ZazAPOA001")
				Endif
			Else
				If Target.GetAnimationVariableBool("IsBleedingOut")
					SendAnimationEvent(Target, "BleedoutStop")
				Else
					SendAnimationEvent(Target, "DefeatWounded02Exit") ; Fast Get up from vanilla IdleWounded_02 anim
				Endif
				CoverSelf(Target)
			Endif
		Elseif (AnimType == "Untie")
			SendAnimationEvent(Target, "DefeatTieUpExit")
		Endif
	Endif
EndFunction

Function CoverSelf(Actor Target)
	If !Target.GetWornForm(0x00000004)
		Wait(1.0)
		If (Target.GetLeveledActorBase().GetSex() == 1)
			SendAnimationEvent(Target, "DefeatZaZCoverSelfF")
		Else
			SendAnimationEvent(Target, "DefeatZaZCoverSelfM")
		Endif
	Endif
EndFunction
Function Redress(Actor Target)
	If Target.Is3DLoaded()
		Form Rags = (MiscFormLists[0].GetAt(6) As Form) ; MiscStuff/Rags
		Target.AddItem(Rags, 1)
		Target.EquipItem(Rags)
		Target.UnequipItem(Rags)
		Target.RemoveItem(Rags, 1)
	Endif
EndFunction

Actor StruggleVictim
Actor StruggleAggressor
Bool StruggleIsCreature
String StruggleScenario
String StruggleVictimClass
String StruggleAggressorClass
Int StruggleStrafeL
Int StruggleStrafeR
Bool StruggleLeftRight = True
Float StruggleFillDifficulty = 0.0
Float StruggleFillThreshold = 0.0
Int StruggleResistTime = 0
Function StruggleSceneTrigger(Actor Aggressor, Actor Victim, String Scenario, Bool IsCreature = False)
	StruggleIsCreature = IsCreature
	StruggleScenario = Scenario
	StruggleVictim = Victim
	StruggleAggressor = Aggressor
	GoToState("StruggleScene")
EndFunction
Function StruggleBar(Bool Display = True)
	If Display
		If ((McmConfig.QTEHKType == "$Attack") || UsingGamepad())
			StruggleStrafeL = Input.GetMappedKey("Left Attack/Block")
			StruggleStrafeR = Input.GetMappedKey("Right Attack/Block")
		Else
			StruggleStrafeL = Input.GetMappedKey("Strafe Left")
			StruggleStrafeR = Input.GetMappedKey("Strafe Right")
		Endif
		RegisterForKey(StruggleStrafeL)
		RegisterForKey(StruggleStrafeR)
		StruggleBar.Alpha = 100.0
	Else
		UnregisterForKey(StruggleStrafeL)
		UnregisterForKey(StruggleStrafeR)
		StruggleBar.Alpha = 0.0
		StruggleBar.Percent = 0.0
		StruggleFillDifficulty = 0.0
	EndIf
EndFunction
Function StruggleAnim(Actor Victim, Actor Aggressor, Bool Animate = True)
	If !StruggleIsCreature
		If Animate
			If (Aggressor != Player)
	 			ActorUtil.AddPackageOverride(Aggressor, DoNothing, 100, 1)
				Aggressor.EvaluatePackage()
				Aggressor.SetRestrained()
				Aggressor.SetDontMove(True)
			Else
				SetPlayerAiDriven()
			Endif
			MiscReferences[0].MoveTo(Aggressor) ; PosRef
			Float AngleZ = Victim.GetAngleZ()
			Aggressor.MoveTo(Victim, 0.0 * Math.Sin(AngleZ), 0.0 * Math.Cos(AngleZ))
			Victim.SetVehicle(MiscReferences[0]) ; PosRef
			Aggressor.SetVehicle(MiscReferences[0]) ; PosRef
			SendAnimationEvent(Victim, "DefeatArrokResistVicS2")
			SendAnimationEvent(Aggressor, "DefeatArrokResistAggS2")
		Else
			Victim.SetVehicle(None)
			Aggressor.SetVehicle(None)
			If (Aggressor != Player)
				Aggressor.SetRestrained(False)
				Aggressor.SetDontMove(False)
				ActorUtil.RemovePackageOverride(Aggressor, DoNothing)
			Else
				SetPlayerAiDriven(False)
			Endif
			SendAnimationEvent(Aggressor, "IdleForceDefaultState")
		Endif
	Endif
EndFunction
Function StruggleChances(Actor Aggressor, Actor Victim, Bool Weakened, Bool PhyStrength)
	StruggleFillThreshold = ((Victim.GetLevel() - Aggressor.GetLevel()) + (StruggleClassChance(Victim, True) - StruggleClassChance(Aggressor)))
;	Log("StruggleFillThreshold before - "+StruggleFillThreshold)
	StruggleFillThreshold = (StruggleFillThreshold / 10)
	If (StruggleFillThreshold < 2.0)
		StruggleFillThreshold = 2.0
	Elseif (StruggleFillThreshold > 10.0)
		StruggleFillThreshold = 10.0
	Endif
	If Weakened
		StruggleFillThreshold -= 1.0
	Endif
	If PhyStrength
		StruggleFillThreshold -= 0.5
	Endif
;	Log("StruggleFillThreshold after -> "+StruggleFillThreshold+" // Already raped? - "+Weakened+" / Female weakness? - 0.5"+PhyStrength)
	StruggleFillThreshold = (StruggleFillThreshold / 100)
;	Log("StruggleFillThreshold / 100 -> "+StruggleFillThreshold)
EndFunction
Float Function StruggleClassChance(Actor Target, Bool Victim = False) ; Return the two strongest skill values of the agressor.
	Float[] Skills
	If !Victim
		Skills = New float[9]
		Skills[0] = Target.GetActorValue("OneHanded")
		Skills[1] = Target.GetActorValue("TwoHanded")
		Skills[2] = Target.GetActorValue("Marksman")
		Skills[3] = Target.GetActorValue("Pickpocket")
		Skills[4] = Target.GetActorValue("Destruction")
		Skills[5] = Target.GetActorValue("Alteration")
		Skills[6] = (Skills[0] + Skills[1])
		Skills[7] = (Skills[2] + Skills[3])
		Skills[8] = (Skills[4] + Skills[5])
;		Log("StruggleClassChance Agg Skills - "+Skills)
		If ((Skills[6] > Skills[7]) && (Skills[6] > Skills[8]))
			StruggleAggressorClass = "Warrior"
;			Log("StruggleClassChance Agg return Warrior "+Skills[6])
			Return Skills[6]
		Elseif ((Skills[7] > Skills[6]) && (Skills[7] > Skills[8]))
			StruggleAggressorClass = "Rogue"
;			Log("StruggleClassChance Agg return Rogue "+Skills[7])
			Return Skills[7]
		Else
			StruggleAggressorClass = "Mage"
;			Log("StruggleClassChance Agg return Mage "+Skills[8])
			Return Skills[8]
		Endif
	Else
		Skills = New float[11]
		Skills[0] = (Target.GetActorValue("LightArmor") / 1.2)
		Skills[1] = Target.GetActorValue("Block")
		Skills[2] = (Target.GetActorValue("Sneak") / 1.6)
		Skills[3] = (Target.GetActorValue("Alchemy") / 1.6)
		Skills[4] = Target.GetActorValue("Illusion")
		Skills[5] = Target.GetActorValue("Restoration")
		Skills[6] = (Target.GetActorValue("HeavyArmor") / 1.2)
		Skills[7] = Target.GetActorValue("Conjuration")
		Skills[8] = (Skills[0] + Skills[1] + Skills[6])
		Skills[9] = (Skills[2] + Skills[3])
		Skills[10] = (Skills[4] + Skills[5] + Skills[7])
;		Log("StruggleClassChance Def Skills - "+Skills)
		If (Skills[0] > Skills[1])
			Skills[8] - Skills[1]
		Else
			Skills[8] - Skills[0]
		Endif
		If (Skills[4] > Skills[7])
			Skills[10] = (Skills[10] - Skills[7])
		Else
			Skills[10] = (Skills[10] - Skills[4])
		Endif
;		Log("StruggleClassChance Skills after reduction - "+Skills)
		If ((Skills[8] > Skills[9]) && (Skills[8] > Skills[10]))
			StruggleVictimClass = "Warrior"
;			Log("StruggleClassChance Def return Warrior "+Skills[8])
			Return Skills[6]
		Elseif ((Skills[9] > Skills[8]) && (Skills[9] > Skills[10]))
			StruggleVictimClass = "Rogue"
;			Log("StruggleClassChance Def return Rogue "+Skills[9])
			Return Skills[7]
		Else
			StruggleVictimClass = "Mage"
;			Log("StruggleClassChance Def return Mage "+Skills[10])
			Return Skills[8]
		Endif
	Endif
EndFunction
State StruggleScene
;	Event OnHit(ObjectReference akAggressor, Form akSrc, Projectile akProjectile, Bool abPowerAttack, Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked)
;		AddCalmList(akAggressor As Actor, StruggleVictim)
;	EndEvent
	Event OnBeginState()
		StruggleChances(StruggleAggressor, StruggleVictim, StruggleVictim.HasSpell(MiscSpells[0]), ((StruggleVictim.GetLeveledActorBase().GetSex() == 1) && (StruggleAggressor.GetLeveledActorBase().GetSex() == 0))) ; DebuffSPL
		StruggleAnim(StruggleVictim, StruggleAggressor)
		StruggleBar()
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnUpdate()
		If (StruggleBar.Percent >= 1.0)
			GoToState("")
			StruggleAnim(StruggleVictim, StruggleAggressor, False)
			If (StruggleScenario == "Player Aggressor")
				ActionQst.TheRape(StruggleVictim, StruggleAggressor, None, True)
			Elseif (StruggleScenario == "Player Victim")
				StruggleSuccess(StruggleVictim, StruggleAggressor)
			Endif
			Return
		Elseif (StruggleResistTime == 4)
			GoToState("")
			SendAnimationEvent(StruggleVictim, "IdleWounded_02")
			StruggleAnim(StruggleVictim, StruggleAggressor, False)
			Wait(0.5)
			If (StruggleScenario == "Player Aggressor")
				StruggleSuccess(StruggleVictim, StruggleAggressor)
			Elseif (StruggleScenario == "Player Victim")
				PlayerScr.PreDownRape()
			Endif
			Return
		Endif
		StruggleResistTime += 1
		SoundToPlay[8].Play(StruggleVictim) ; Rescue
		RegisterForSingleUpdate(1.0)
	EndEvent
	Event OnKeyDown(Int KeyCode)
		If ((KeyCode == StruggleStrafeL) && StruggleLeftRight)
			StruggleLeftRight = False
			StruggleFillDifficulty += StruggleFillThreshold
			StruggleBar.Percent = (StruggleFillDifficulty)
		Elseif ((KeyCode == StruggleStrafeR) && !StruggleLeftRight)
			StruggleLeftRight = True
			StruggleFillDifficulty += StruggleFillThreshold
			StruggleBar.Percent = (StruggleFillDifficulty)
		Endif
	EndEvent
	Event OnEndState()
		StruggleBar(False)
		StruggleResistTime = 0
	EndEvent
EndState
Function StruggleSuccess(Actor Victim, Actor Aggressor)
	If (StruggleVictimClass == "Warrior")
		If Victim.GetEquippedShield()
			SoundToPlay[4].Play(Victim) ; Bash shield
		Else
			SoundToPlay[5].Play(Victim) ; Bash weapon
		Endif
	Elseif (StruggleVictimClass == "Rogue")
		int Rand = RandomInt(1, 4)
		If (Rand == 1)
			ResistSpells[9].Cast(Victim, Aggressor) ; ResistAlchemySpell
			SoundToPlay[2].Play(Victim) ; Alchemy
		Elseif (Rand == 2)
			ResistSpells[8].Cast(Victim, Aggressor) ; ResistSneakSpell
			Aggressor.Say(TopicToSay[12], Victim) ; Caugh
		Else
			SoundToPlay[0].Play(Victim) ; Sneak
			ResistSpells[0].Cast(Victim, Aggressor) ; ResistArcherySpell
		Endif
	Else
		int Rand = RandomInt(1, 12)
		If (Rand == 1)
			ResistSpells[1].Cast(Victim, Victim) ; ResistDestructionFireSpell
		Elseif (Rand == 2)
			ResistSpells[2].Cast(Victim, Victim) ; ResistDestructionFrostSpell
		Elseif (Rand == 3)
			ResistSpells[3].Cast(Victim, Victim) ; ResistDestructionShockSpell
		Elseif (Rand == 4)
			ResistSpells[4].Cast(Victim, Aggressor) ; ResistConjurationFireSpell
		Elseif (Rand == 5)		
			ResistSpells[5].Cast(Victim, Aggressor) ; ResistConjurationFrostSpell
		Elseif (Rand == 6)
			ResistSpells[6].Cast(Victim, Aggressor) ; ResistConjurationShockSpell
		Else
			ResistSpells[7].Cast(Victim, Aggressor) ; ResistAlterationSpell
			SoundToPlay[3].Play(Victim) ; Tele push
		Endif
	Endif
	Victim.PushActorAway(Aggressor, 5.0)
	Victim.Say(TopicToSay[11], Aggressor) ; PickPocketCombat
	DefeatPlayAnimation(Victim, "Stand")
	If (StruggleScenario == "Player Victim")
		PlayerScr.Restored()
	Endif
EndFunction
; 2015.07.14 / Add
string[] Function getTieupPose(Actor actTarget)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	String[] aRet
	Int      nRand
	Int      nZazIndex
	String   ThePose      = ""
	String   StrugglePose = ""
	Cell     celCur       = actTarget.GetParentCell()
	Bool     isIndoor     = celCur.IsInterior()
	Bool     enableExPose = McmConfig.mEnableExZazPoses
	; 2015.07.20 / Add
	Form     frmCuffs     = MiscFormLists[0].GetAt(2)
	Form     frmYoke      = MiscFormLists[0].GetAt(3)
	Form     frmArmBinder = MiscFormLists[0].GetAt(4)
	String   szStyle      = "Wri"
	; 2015.07.20 / Add
	; 2015.07.26 / Add
	Int      nDevIdx
	Bool     isYokeEquipped      = False
	Bool     isArmBinderEquipped = False
	; 2015.07.26 / Add
	; 2015.08.02 / Add
	Armor    armDevice
	; 2015.08.02 / Add
	
	; 2015.07.26 / Add
	;-------------------------------------------------------
	; Check yoke device
	;-------------------------------------------------------
	nDevIdx = maTieupYokes.Length
	
	While (nDevIdx > 0) && !isYokeEquipped
		nDevIdx -= 1
		
		armDevice = maTieupYokes[nDevIdx]
		
		If armDevice && actTarget.IsEquipped(armDevice)
			isYokeEquipped = True
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Check armbinder device
	;-------------------------------------------------------
	nDevIdx = maTieupArmBinders.Length
	
	While (nDevIdx > 0) && !isArmBinderEquipped
		nDevIdx -= 1
		
		armDevice = maTieupYokes[nDevIdx]
		
		If armDevice && actTarget.IsEquipped(armDevice)
			isArmBinderEquipped = True
		Endif
	EndWhile
	; 2015.07.26 / Add
	
	; 2015.07.20 / Add
	;-------------------------------------------------------
	; Check current device
	;-------------------------------------------------------
	If (actTarget.GetItemCount(frmCuffs) > 0)
		szStyle      = "Wri"
	; 2015.07.26 / Mod / Using isYokeEquipped
	Elseif isYokeEquipped
		szStyle      = "Yoke"
	; 2015.07.26 / Mod / Using isArmBinderEquipped
	Elseif isArmBinderEquipped
		szStyle      = "Armb"
		enableExPose = False
	Endif
	; 2015.07.20 / Add
	
	;-------------------------------------------------------
	; Set random number
	;-------------------------------------------------------
	if isArmBinderEquipped
		nRand = RandomInt(0, 6)
	Elseif Zazon && ZazRon && isIndoor && enableExPose
		nRand = RandomInt(0, 20)
	Elseif !Zazon && ZazRon && isIndoor && enableExPose
		nRand = RandomInt(18, 20)
	Elseif Zazon && !ZazRon && isIndoor && enableExPose
		nRand = RandomInt(0, 18)
		
		If (nRand >= 18)
			nRand = 20
		Endif
	Elseif Zazon
		nRand = RandomInt(0, 7)
		
		If (nRand >= 7)
			nRand = 20
		Endif
	Else
		nRand = 20
	Endif
	
	;-------------------------------------------------------
	; Choose poses
	;-------------------------------------------------------
	If (nRand <= 0)
		ThePose = "Zap"+szStyle+"Pose01" ; Legs spread
		StrugglePose = "Zap"+szStyle+"Struggle01"
	Elseif (nRand <= 1)
		ThePose = "Zap"+szStyle+"Pose04" ; Standing bend over, legs spread
		StrugglePose = "Zap"+szStyle+"Struggle03"
	Elseif (nRand <= 2)
		nZazIndex = RandomInt(5,9)
		ThePose = "Zap"+szStyle+"Pose0"+(nZazIndex as string) ; Wrist Bound Poses
		StrugglePose = "Zap"+szStyle+"Struggle0"+(nZazIndex as string)
	Elseif (nRand <= 3)
		nZazIndex = RandomInt(10,15)
		ThePose = "Zap"+szStyle+"Pose"+(nZazIndex as string) ; Wrist Bound Poses
		StrugglePose = "Zap"+szStyle+"Struggle"+(nZazIndex as string)
;				Elseif (nRand <= 2)
;					ThePose = "ZapWriPose05" ; Standing, legs spread
;					StrugglePose = "ZapWriStruggle05"
;				Elseif (nRand <= 3)
;					ThePose = "ZapWriPose06" ; Standing on knees
;					StrugglePose = "ZapWriStruggle06"
;				Elseif (nRand <= 4)
;					ThePose = "ZapWriPose07" ; Standing on knees, legs spread
;					StrugglePose = "ZapWriStruggle07"
;				Elseif (nRand <= 5)
;					ThePose = "ZapWriPose08" ; Standing on knees, bent over
;					StrugglePose = "ZapWriStruggle08"
;				Elseif (nRand <= 6)
;					ThePose = "ZapWriPose09" ; Sitting squat
;					StrugglePose = "ZapWriStruggle09"
;				Elseif (nRand <= 7)
;					ThePose = "ZapWriPose10" ; Sitting squat, legs spread
;					StrugglePose = "ZapWriStruggle10"
;				Elseif (nRand <= 8)
;					ThePose = "ZapWriPose11" ; Hogtie
;					StrugglePose = "ZapWriStruggle11"
;				Elseif (nRand <= 9)
;					ThePose = "ZapWriPose12" ; Hogtie, legs spread
;					StrugglePose = "ZapWriStruggle12"
;				Elseif (nRand <= 10)
;					ThePose = "ZapWriPose13" ; Hogtie, lie on side
;					StrugglePose = "ZapWriStruggle13"
;				Elseif (nRand <= 11)
;					ThePose = "ZapWriPose14" ; Lie on side, sleeping position
;					StrugglePose = "ZapWriStruggle14"
;				Elseif (nRand <= 12)
;					ThePose = "ZapWriPose15" ; Lie on stomach, not sleeping
;					StrugglePose = "ZapWriStruggle15"
	Elseif (nRand <= 4)
		nZazIndex = RandomInt(1,3)
		ThePose = "Zap"+szStyle+"Horny0"+(nZazIndex as string) ; Horny, crouching
		StrugglePose = "Zap"+szStyle+"Horny0"+(nZazIndex as string)
;				Elseif (nRand <= 13)
;					ThePose = "ZapWriHorny01" ; Horny, crouching, legs grinding
;					StrugglePose = "ZapWriHorny01"
;				Elseif (nRand <= 14)
;					ThePose = "ZapWriHorny02" ; Horny, crouching, legs grinding
;					StrugglePose = "ZapWriHorny02"
;				Elseif (nRand <= 15)
;					ThePose = "ZapWriHorny03" ; Rubbing crotch in the air
;					StrugglePose = "ZapWriHorny03"
	Elseif (nRand <= 5)
		ThePose = "Zap"+szStyle+"BleedoutIdle" ; 
		StrugglePose = "Zap"+szStyle+"BleedoutIdle"
	Elseif (nRand <= 6)
		ThePose = "Zap"+szStyle+"Turn01" ; 
		StrugglePose = "Zap"+szStyle+"Turn01"
	Elseif (nRand <= 7)
		nZazIndex = RandomInt(1,9)
		ThePose = "ZazAPC00"+(nZazIndex as string) ; Bound Poses/Idles 001-50
		StrugglePose = "ZazAPC00"+(nZazIndex as string)
	Elseif (nRand <= 8)
		nZazIndex = RandomInt(10,20)
		ThePose = "ZazAPC0"+(nZazIndex as string) ; Bound Poses/Idles 001-50
		StrugglePose = "ZazAPC0"+(nZazIndex as string)
	Elseif (nRand <= 9)
		nZazIndex = RandomInt(51,58)
		ThePose = "ZazAPC0"+(nZazIndex as string) ; Bound Poses/Idles II 51-100
		StrugglePose = "ZazAPC0"+(nZazIndex as string)
	Elseif (nRand <= 10)
		nZazIndex = RandomInt(1,9)
		ThePose = "ZazAPCAO00"+(nZazIndex as string) ; SOLO IDLES With AO--- 001 to 500
		StrugglePose = "ZazAPCAO00"+(nZazIndex as string)
	Elseif (nRand <= 11)
		nZazIndex = RandomInt(10,25)
		ThePose = "ZazAPCAO0"+(nZazIndex as string) ; SOLO IDLES With AO--- 001 to 500
		StrugglePose = "ZazAPCAO0"+(nZazIndex as string)
	Elseif (nRand <= 12)
		nZazIndex = RandomInt(51,55)
		ThePose = "ZazAPCAO0"+(nZazIndex as string) ; ZaZ SpecialBinds AOs
		StrugglePose = "ZazAPCAO0"+(nZazIndex as string)
	Elseif (nRand <= 13)
		nZazIndex = RandomInt(201,205)
		ThePose = "ZazAPCAO"+(nZazIndex as string) ; Torture Pole 201-210
		StrugglePose = "ZazAPCAO"+(nZazIndex as string)
	Elseif (nRand <= 14)
		nZazIndex = RandomInt(211,212)
		ThePose = "ZazAPCAO"+(nZazIndex as string) ; Torture Rack 211-215
		StrugglePose = "ZazAPCAO"+(nZazIndex as string)
	Elseif (nRand <= 15)
		nZazIndex = RandomInt(251,252)
		ThePose = "ZazAPCAO"+(nZazIndex as string) ; Crux 251-260
		StrugglePose = "ZazAPCAO"+(nZazIndex as string)
	Elseif (nRand <= 16)
		nZazIndex = RandomInt(261,263)
		ThePose = "ZazAPCAO"+(nZazIndex as string) ; The Wheel 261-265
		StrugglePose = "ZazAPCAO"+(nZazIndex as string)
	Elseif (nRand <= 17)
		nZazIndex = RandomInt(301,315)
		ThePose = "ZazAPCAO"+(nZazIndex as string) ; ZaZ Chained Multiple Animated Objects
		StrugglePose = "ZazAPCAO"+(nZazIndex as string)
	Elseif (nRand <= 18)
		nZazIndex = RandomInt(1,9)
		ThePose = "ZazRb00"+(nZazIndex as string) ; Animobjects
		StrugglePose = "ZazRb00"+(nZazIndex as string)
	Elseif (nRand <= 19)
		nZazIndex = RandomInt(10,15)
		ThePose = "ZazRb0"+(nZazIndex as string) ; Animobjects
		StrugglePose = "ZazRb0"+(nZazIndex as string)
	Else
		ThePose = "DefeatTieUpIdle" ; 
		StrugglePose = "DefeatZapWriStruggle06"
	Endif
	
	;-------------------------------------------------------
	; Set return value
	;-------------------------------------------------------
	aRet    = New String[2]
	aRet[0] = ThePose
	aRet[1] = StrugglePose
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aRet
EndFunction
; 2015.07.14 / Add
; 2015.07.16 / Add
Bool gIsPlayingRandomLiePose = False

Function showRandomLiePose(Actor actTarget)
	String szPose
	Int    nLoop  = 8
	
	If gIsPlayingRandomLiePose
		Return
	Else
		SetPlayerAiDriven()
		gIsPlayingRandomLiePose = True
	Endif
	
	While (nLoop > 0)
		nLoop -= 1
		
		szPose = getRandomLiePose()
		Notification("The pose is "+szPose+".")
		SetStringValue(actTarget, "DefeatStateAnim", szPose)
		SendAnimationEvent(actTarget, szPose)
		
		wait(3.5)
	EndWhile
	
	SendAnimationEvent(actTarget, "IdleForceDefaultState")
	gIsPlayingRandomLiePose = False
	SetPlayerAiDriven(False)
EndFunction

string Function getRandomLiePose()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	String[] aPoses
	Int      nRand
	Int      nIdx         = 0
	Bool     enableExPose = McmConfig.mEnableExHalosPoses
	
	;-------------------------------------------------------
	; Pose
	;-------------------------------------------------------
	aPoses       = New String[128]
	aPoses[nIdx] = "DefeatEstrusTrauma"
	nIdx += 1
	aPoses[nIdx] = "DefeatTraumaEnter"
	nIdx += 1
	aPoses[nIdx] = "IdleChildCryingStart"
	nIdx += 1
	aPoses[nIdx] = "DefeatEstrusExhaustedFront"
	nIdx += 1
	aPoses[nIdx] = "DefeatEstrusExhaustedBack"
	nIdx += 1
	aPoses[nIdx] = "IdleWounded_02"
	nIdx += 1
	aPoses[nIdx] = "PUP3Lay"+(RandomInt(2,5) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Lay"+(RandomInt(8,11) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Lay"+(RandomInt(13,15) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Lay"+(RandomInt(17,25) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Lay"+(RandomInt(17,25) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Sit6"
	nIdx += 1
	aPoses[nIdx] = "PUP3Sit"+(RandomInt(9,11) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Sit"+(RandomInt(21,26) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Kneel"+(RandomInt(1,9) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Kneel"+(RandomInt(12,14) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Kneel"+(RandomInt(16,21) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Kneel"+(RandomInt(16,21) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP3Kneel"+(RandomInt(23,25) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay"+(RandomInt(1,10) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay13"
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay"+(RandomInt(17,18) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay"+(RandomInt(20,21) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay"+(RandomInt(23,24) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Lay"+(RandomInt(26,27) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit4"
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit"+(RandomInt(6,10) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit12"
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit17"
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit"+(RandomInt(19,20) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit"+(RandomInt(22,23) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Sit"+(RandomInt(22,23) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Kneel"+(RandomInt(3,4) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Kneel"+(RandomInt(12,13) as String)
	nIdx += 1
	aPoses[nIdx] = "PUP5Kneel15"
	nIdx += 1
	aPoses[nIdx] = "PUP5Kneel22"
	nIdx += 1
	aPoses[nIdx] = "PUPEX2"
	nIdx += 1
	aPoses[nIdx] = "PUPEX13"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(15,18) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(20,21) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(24,25) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX32"
	nIdx += 1
	aPoses[nIdx] = "PUPEX36"
	nIdx += 1
	aPoses[nIdx] = "PUPEX44"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(52,53) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(55,56) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX61"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(67,69) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(71,72) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX78"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(81,82) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX85"
	nIdx += 1
	aPoses[nIdx] = "PUPEX87"
	nIdx += 1
	aPoses[nIdx] = "PUPEX98"
	nIdx += 1
	aPoses[nIdx] = "PUPEX101"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(103,104) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX108"
	nIdx += 1
	aPoses[nIdx] = "PUPEX110"
	nIdx += 1
	aPoses[nIdx] = "PUPEX123"
	nIdx += 1
	aPoses[nIdx] = "PUPEX133"
	nIdx += 1
	aPoses[nIdx] = "PUPEX135"
	nIdx += 1
	aPoses[nIdx] = "PUPEX139"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(141,142) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(146,148) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX150"
	nIdx += 1
	aPoses[nIdx] = "PUPEX166"
	nIdx += 1
	aPoses[nIdx] = "PUPEX179"
	nIdx += 1
	aPoses[nIdx] = "PUPEX192"
	nIdx += 1
	aPoses[nIdx] = "PUPEX211"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(213,214) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX229"
	nIdx += 1
	aPoses[nIdx] = "PUPEX239"
	nIdx += 1
	aPoses[nIdx] = "PUPEX250"
	nIdx += 1
	aPoses[nIdx] = "PUPEX254"
	nIdx += 1
	aPoses[nIdx] = "PUPEX261"
	nIdx += 1
	aPoses[nIdx] = "PUPEX268"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(271,272) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX288"
	nIdx += 1
	aPoses[nIdx] = "PUPEX292"
	nIdx += 1
	aPoses[nIdx] = "PUPEX298"
	nIdx += 1
	aPoses[nIdx] = "PUPEX"+(RandomInt(313,314) as String)
	nIdx += 1
	aPoses[nIdx] = "PUPEX324"
	nIdx += 1
	aPoses[nIdx] = "PPEX5Lay"+(RandomInt(2,6) as String)
	nIdx += 1
	aPoses[nIdx] = "DPose4"
	nIdx += 1
	aPoses[nIdx] = "DPose"+(RandomInt(11,14) as String)
	nIdx += 1
	aPoses[nIdx] = "DPose34"
	nIdx += 1
	aPoses[nIdx] = "CST9"
	nIdx += 1
	aPoses[nIdx] = "CST"+(RandomInt(60,63) as String)
	nIdx += 1
	aPoses[nIdx] = "CUS"+(RandomInt(18,20) as String)
	nIdx += 1
	aPoses[nIdx] = "CUS22"
	nIdx += 1
	aPoses[nIdx] = "CUS"+(RandomInt(26,27) as String)
	nIdx += 1
	aPoses[nIdx] = "CUS"+(RandomInt(30,31) as String)
	nIdx += 1
	aPoses[nIdx] = "CUS"+(RandomInt(26,27) as String)
	nIdx += 1
	aPoses[nIdx] = "CUS34"
	nIdx += 1
	aPoses[nIdx] = "CUS42"
	nIdx += 1
	aPoses[nIdx] = "CUS43"
	nIdx += 1
	aPoses[nIdx] = "CUS45"
	nIdx += 1
	aPoses[nIdx] = "EXT1"
	nIdx += 1
	aPoses[nIdx] = "EXT"+(RandomInt(3,4) as String)
	nIdx += 1
	aPoses[nIdx] = "EXT11"
	nIdx += 1
	aPoses[nIdx] = "EXT20"
	nIdx += 1
	aPoses[nIdx] = "EXT50"
	nIdx += 1
	aPoses[nIdx] = "HObP9"
	nIdx += 1
	aPoses[nIdx] = "HObP14"
	nIdx += 1
	aPoses[nIdx] = "HObP18"
	nIdx += 1
	aPoses[nIdx] = "CUT6"
	nIdx += 1
	aPoses[nIdx] = "CUT9"
	nIdx += 1
	aPoses[nIdx] = "CUT74"
	nIdx += 1
	aPoses[nIdx] = "CSM"+(RandomInt(52,54) as String)
	nIdx += 1
	aPoses[nIdx] = "CSM"+(RandomInt(76,80) as String)
	nIdx += 1
	aPoses[nIdx] = "CSS20"
	nIdx += 1
	aPoses[nIdx] = "CSS"+(RandomInt(66,67) as String)
	nIdx += 1
	aPoses[nIdx] = "H6P16"
	nIdx += 1
	aPoses[nIdx] = "H6P20"
	nIdx += 1
	aPoses[nIdx] = "H6P23"
	nIdx += 1
	aPoses[nIdx] = "H7P13"
	nIdx += 1
	aPoses[nIdx] = "H7P78"
	nIdx += 1
	aPoses[nIdx] = "H8P62"
	nIdx += 1
	aPoses[nIdx] = "H8P"+(RandomInt(80,81) as String)
	nIdx += 1
	aPoses[nIdx] = "H9P1"
	nIdx += 1
	aPoses[nIdx] = "H9P64"
	nIdx += 1
	aPoses[nIdx] = "H9P77"
	nIdx += 1
	aPoses[nIdx] = "H10P74"
	nIdx += 1
	aPoses[nIdx] = "H10P81"
	nIdx += 1
	aPoses[nIdx] = "H10P29"
	nIdx += 1
	aPoses[nIdx] = "H10P71"
	nIdx += 1
	aPoses[nIdx] = "H11P6"
	nIdx += 1
	aPoses[nIdx] = "H11P11"
	
	;-------------------------------------------------------
	; Set random number
	;-------------------------------------------------------
	if Haloson && enableExPose
		nRand = RandomInt(0, 127)
	Else
		nRand = RandomInt(0, 5)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aPoses[nRand]
EndFunction
; 2015.07.16 / Add
; 2015.07.09 / Add
string[] Function getFGTripWandererQuestName()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	string[] aQuests = new string[24]

	;-------------------------------------------------------
	; Set Quest name
	;-------------------------------------------------------
	aQuests[0]  = "FGTWandererQuest"
	aQuests[1]  = "FGTWandererQuestDUPLICATE001"
	aQuests[2]  = "FGTWandererQuestDUPLICATE002"
	aQuests[3]  = "FGTWandererQuestDUPLICATE003"
	aQuests[4]  = "FGTWandererQuestDUPLICATE004"
	aQuests[5]  = "FGTWandererQuestDUPLICATE005"
	aQuests[6]  = "FGTWandererQuestDUPLICATE006"
	aQuests[7]  = "FGTWandererQuestDUPLICATE007"
	aQuests[8]  = "FGTWandererQuestDUPLICATE008"
	aQuests[9]  = "FGTWandererQuestDUPLICATE009"
	aQuests[10] = "FGTWandererQuestDUPLICATE010"
	aQuests[11] = "FGTWandererQuestDUPLICATE011"
	aQuests[12] = "FGTWandererQuestDUPLICATE012"
	aQuests[13] = "FGTWandererQuestDUPLICATE013"
	aQuests[14] = "FGTWandererQuestDUPLICATE014"
	aQuests[15] = "FGTWandererQuestDUPLICATE015"
	aQuests[16] = "FGTWandererQuestDUPLICATE016"
	aQuests[17] = "FGTWandererQuestDUPLICATE017"
	aQuests[18] = "FGTWandererQuestDUPLICATE018"
	aQuests[19] = "FGTWandererQuestDUPLICATE019"
	aQuests[20] = "FGTWandererQuestDUPLICATE020"
	aQuests[21] = "FGTWandererQuestDUPLICATE021"
	aQuests[22] = "FGTWandererQuestDUPLICATE022"
	aQuests[23] = "FGTWandererQuestDUPLICATE023"
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aQuests
EndFunction

Int[] Function getFGTripWandererQuestFormID()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[] aQuests = new Int[24]

	;-------------------------------------------------------
	; Set Quest name
	;-------------------------------------------------------
	aQuests[0]  = 0x3321
	aQuests[1]  = 0xFAE0
	aQuests[2]  = 0xFAE1
	aQuests[3]  = 0xFAE2
	aQuests[4]  = 0xFAE3
	aQuests[5]  = 0xFAE4
	aQuests[6]  = 0xFAE5
	aQuests[7]  = 0xFAE6
	aQuests[8]  = 0xFAE7
	aQuests[9]  = 0xFAE8
	aQuests[10] = 0xFAE9
	aQuests[11] = 0xFAEA
	aQuests[12] = 0xFAEB
	aQuests[13] = 0xFAEC
	aQuests[14] = 0xFAED
	aQuests[15] = 0xFAEE
	aQuests[16] = 0xFAEF
	aQuests[17] = 0xFAF0
	aQuests[18] = 0xFAF1
	aQuests[19] = 0xFAF2
	aQuests[20] = 0xFAF3
	aQuests[21] = 0xFAF4
	aQuests[22] = 0xFAF5
	aQuests[23] = 0xFAF6
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aQuests
EndFunction

Int[] Function getAFTweakFollowerAliaseID()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[] aAliaseIDs = new Int[64]
	Int   nIdx
	Int   nAliasID

	;-------------------------------------------------------
	; Set Alias ID
	;-------------------------------------------------------
	nIdx     = 0
	nAliasID = 8
	While nIdx < 32
		aAliaseIDs[nIdx] = nAliasID
		
		nAliasID += 1
		nIdx     += 1
	EndWhile
	; For AFT Boost
	nIdx     = 32
	nAliasID = 48
	While nIdx < aAliaseIDs.Length
		aAliaseIDs[nIdx] = nAliasID
		
		nAliasID += 1
		nIdx     += 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aAliaseIDs
EndFunction

; 2015.07.14 / Add
Int[] Function getEFFrameworkFollowerAliaseID()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[] aAliaseIDs = new Int[100]
	Int   nIdx
	Int   nAliasID

	;-------------------------------------------------------
	; Set Alias ID
	;-------------------------------------------------------
	nIdx     = 0
	nAliasID = 1
	While nIdx < aAliaseIDs.Length
		aAliaseIDs[nIdx] = nAliasID
		
		nAliasID += 1
		nIdx     += 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aAliaseIDs
EndFunction

Int[] Function getFLPackageFollowerAliaseID()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[] aAliaseIDs = new Int[108]
	Int   nIdx
	Int   nAliasID

	;-------------------------------------------------------
	; Set Alias ID
	;-------------------------------------------------------
	nIdx     = 0
	nAliasID = 1
	While nIdx < aAliaseIDs.Length
		aAliaseIDs[nIdx] = nAliasID
		
		nAliasID += 1
		nIdx     += 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aAliaseIDs
EndFunction
; 2015.07.14 / Add

; 2015.07.15 / Add
Int[] Function getJbNPCMapNPCsAliaseID()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[] aAliaseIDs = new Int[41]
	Int   nIdx
	Int   nAliasID

	;-------------------------------------------------------
	; Set Alias ID
	;-------------------------------------------------------
	nIdx     = 0
	nAliasID = 1
	While nIdx < aAliaseIDs.Length
		aAliaseIDs[nIdx] = nAliasID
		
		nAliasID += 1
		nIdx     += 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aAliaseIDs
EndFunction
; 2015.07.15 / Add

ReferenceAlias[] Function getRefAliasesFromAddon(string szAddon = "", string szOption = "")
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	ReferenceAlias[] aRet
	
	;-------------------------------------------------------
	; Get ReferenceAlias array from other mods
	;-------------------------------------------------------
	If (FGTon && szAddon == "FGT" && szOption == "Wanderer")
		ReferenceAlias refEach
		string[]       aNames    = getFGTripWandererQuestName()
		Int[]          aIDs      = getFGTripWandererQuestFormID()
		Int            nCnt      = aNames.Length
		Int            nActorCnt = 0
		
		aRet = new ReferenceAlias[24]
		
		While nCnt > 0
			nCnt -= 1
			
			refEach = getAliasFromQuest(aNames[nCnt], "Actor") as ReferenceAlias
			
			If refEach
				aRet[nActorCnt] = refEach
				nActorCnt += 1
			Endif
		EndWhile
	Elseif (AFTon && szAddon == "AFT" && szOption == "Follower")
		ReferenceAlias refEach
		Quest          qstAddon
		Int[]          aIDs      = getAFTweakFollowerAliaseID()
		Int            nCnt      = aIDs.Length
		Int            nActorCnt = 0
		
		aRet     = new ReferenceAlias[64]
		qstAddon = mqstAFTweakFollowerQuest
		
		While nCnt > 0
			nCnt -= 1
			
			refEach = qstAddon.GetAlias(aIDs[nCnt]) as ReferenceAlias
			
			If refEach
				aRet[nActorCnt] = refEach
				nActorCnt += 1
			Endif
		EndWhile
	; 2015.07.14 / Add
	Elseif (EFFon && szAddon == "EFF" && szOption == "Follower")
		ReferenceAlias refEach
		Quest          qstAddon
		Int[]          aIDs      = getEFFrameworkFollowerAliaseID()
		Int            nCnt      = aIDs.Length
		Int            nActorCnt = 0
		
		aRet     = new ReferenceAlias[100]
		qstAddon = mqstEFFrameworkFollowerQuest
		
		While nCnt > 0
			nCnt -= 1
			
			refEach = qstAddon.GetAlias(aIDs[nCnt]) as ReferenceAlias
			
			If refEach
				aRet[nActorCnt] = refEach
				nActorCnt += 1
			Endif
		EndWhile
	Elseif (FLPon && szAddon == "FLP" && szOption == "Follower")
		ReferenceAlias refEach
		Quest          qstAddon
		Int[]          aIDs      = getFLPackageFollowerAliaseID()
		Int            nCnt      = aIDs.Length
		Int            nActorCnt = 0
		
		aRet     = new ReferenceAlias[108]
		qstAddon = mqstFLPackageFollowerQuest
		
		While nCnt > 0
			nCnt -= 1
			
			refEach = qstAddon.GetAlias(aIDs[nCnt]) as ReferenceAlias
			
			If refEach
				aRet[nActorCnt] = refEach
				nActorCnt += 1
			Endif
		EndWhile
	; 2015.07.14 / Add
	; 2015.07.15 / Add
	Elseif (jbNPCMapon && szAddon == "jbNPCMap" && szOption == "Follower")
		ReferenceAlias refEach
		Quest          qstAddon
		Int[]          aIDs      = getJbNPCMapNPCsAliaseID()
		Int            nCnt      = aIDs.Length
		Int            nActorCnt = 0
		
		aRet     = new ReferenceAlias[108]
		qstAddon = mqstJbNPCMapQuest
		
		While nCnt > 0
			nCnt -= 1
			
			refEach = qstAddon.GetAlias(aIDs[nCnt]) as ReferenceAlias
			
			If refEach
				aRet[nActorCnt] = refEach
				nActorCnt += 1
			Endif
		EndWhile
	; 2015.07.15 / Add
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aRet
EndFunction

Quest[] Function getQuestsFromAddon(string szAddon = "", string szOption = "")
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Quest[] aRet
	
	;-------------------------------------------------------
	; Get ReferenceAlias array from other mods
	;-------------------------------------------------------
	If (FGTon && StringUtil.Find(szAddon, "FGTWandererQuest") != -1)
		Int[] aIDs    = getFGTripWandererQuestFormID()
		Int   nCnt    = aIDs.Length
		Int   nQstCnt = 0
		
		aRet = new Quest[24]
		
		While nCnt > 0
			nCnt -= 1
			
			aRet[nQstCnt] = GetFormFromFile(aIDs[nCnt], "FGT.esp") as Quest
			
			nQstCnt += 1
		EndWhile
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aRet
EndFunction

Alias Function getAliasFromQuest(string szAddon = "", string szOption = "")
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Alias refRet = None
	
	;-------------------------------------------------------
	; Get ReferenceAlias array from other mods
	;-------------------------------------------------------
	If (FGTon && StringUtil.Find(szAddon, "FGTWandererQuest") != -1 && szOption == "Actor")
		string[] aNames = getFGTripWandererQuestName()
		Int[]    aIDs   = getFGTripWandererQuestFormID()
		Int      nCnt   = aNames.Length
		
		While nCnt > 0
			nCnt -= 1
			
			If (szAddon == aNames[nCnt])
;				Quest qstAddon = GetFormFromFile(aIDs[nCnt], "FGT.esp") as Quest
				Quest qstAddon = maFGTripWandererQuests[nCnt]
				
				If qstAddon
					refRet = qstAddon.GetAlias(0)
				Endif
				
				Return refRet
			Endif
		EndWhile
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return refRet
EndFunction

Bool Function isValidCaptiveAggressor(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool  isValid        = True
	Int   nFactCnt
	Float nMinSearch     = McmConfig.mnCaptiveMinAggSearchDist
	; 2015.07.27 / Add
	Bool  enableAnyone   = McmConfig.mEnableCaptiveAnyone
	; 2015.07.27 / Add
	; 2015.07.30 / Add
	Bool  enableCreature = McmConfig.mEnableCaptiveCrAgg
	Bool  enableFemale   = McmConfig.mEnableCaptiveFemaleAgg
	Bool  isHuman        = actFind.HasKeywordString("ActorTypeNPC")
	; 2015.07.30 / Add
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	; 2015.07.30 / Mod / Adding the condition, !enableFemale
	Elseif !enableFemale && (SexLab.GetGender(actFind) == 1)
		isValid = False
	; 2015.07.30 / Add
	Elseif !enableCreature && (SexLab.GetGender(actFind) == 2)
		isValid = False
	; 2015.07.30 / Add
	; 2015.07.17 / Add
	Elseif (actFind == Player)
		isValid = False
	; 2015.07.17 / Add
	Elseif (actFind == PreCaptiveVictim)
		isValid = False
	; 2015.07.27 / Mod / Adding the condition, !enableAnyone
	Elseif actFind.IsPlayerTeammate() && !enableAnyone
		isValid = False
	Elseif (actFind.GetDistance(Player) < nMinSearch)
		isValid = False
	Endif
	
	;-------------------------------------------------------
	; Faction Check
	;-------------------------------------------------------
	; 2015.07.27 / Mod / Adding the condition, !enableAnyone
	If isValid && isHuman && !enableAnyone
		nFactCnt = CaptiveFactions.Length
		isValid  = False
		
		While nFactCnt > 0
			nFactCnt -= 1
			
			If actFind.IsInFaction(CaptiveFactions[nFactCnt])
				isValid = True
			Endif
		EndWhile
	; 2015.07.27 / Mod / Adding the condition, !enableAnyone
	Elseif isValid && !enableAnyone
		nFactCnt = NonCaptiveFactions.Length
		
		While nFactCnt > 0
			nFactCnt -= 1
			
			If actFind.IsInFaction(NonCaptiveFactions[nFactCnt])
				isValid = False
			Endif
		EndWhile
	EndIf
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Bool Function isValidCaptiveVoice(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool      isValid = True
	VoiceType vocFind = None
	Int       nIdx    = -1
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If actFind
		vocFind = actFind.GetActorBase().GetVoiceType()
	Endif
	
	If vocFind
		nIdx = maCaptiveExcludeVoices.Find(vocFind)
	Endif
	
	If (nIdx >= 0)
		isValid = False
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Bool Function isValidCaptiveVictim(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool  isValid    = True
	Float nMinSearch = McmConfig.mnCaptiveMinAggSearchDist
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	Elseif (SexLab.GetGender(actFind) != 1)
		isValid = False
	; 2015.07.17 / Add
	Elseif (actFind == Player)
		isValid = False
	; 2015.07.17 / Add
	Elseif (actFind == PreCaptiveVictim)
		isValid = False
	Elseif actFind.IsPlayerTeammate()
		isValid = False
	Elseif (actFind.GetDistance(Player) < nMinSearch)
		isValid = False
	; 2015.07.18 / Add
	Elseif !isValidCaptiveVoice(actFind)
		isValid = False
	; 2015.07.18 / Add
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

; 2015.07.17 / Add
Function onClickShowCaptiveList()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	int    nSelected
	Actor  actFind
	Actor  actEach
	String szName
	String szMsg
	Int    nLen      = maInternalNpcList.Length
	int    nIdx      = 0
	Bool   isExist   = False
	
	;-------------------------------------------------------
	; Init Menu
	;-------------------------------------------------------
	UIExtensions.InitMenu("UIListMenu")
	UIExtensions.SetMenuPropertyInt("UIListMenu", "totalEntries", nLen)
	
	;-------------------------------------------------------
	; Create Menu
	;-------------------------------------------------------
	While (nIdx < nLen)
		actEach = maInternalNpcList[nIdx]
		
		If actEach
			szName = actEach.GetActorBase().GetName()
			
			If (szName && szName != "")
				UIExtensions.SetMenuPropertyIndexString("UIListMenu", "entryName", nIdx, szName)
				UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryId", nIdx, nIdx)
				isExist = True
			Endif
		Endif
		
		nIdx += 1
	EndWhile
	
	If !isExist
		nIdx   = 0
		szName = "No NPC"
		UIExtensions.SetMenuPropertyIndexString("UIListMenu", "entryName", nIdx, szName)
		UIExtensions.SetMenuPropertyIndexInt("UIListMenu", "entryId", nIdx, nIdx)
	Endif
	
	;-------------------------------------------------------
	; Create Menu
	;-------------------------------------------------------
	UIExtensions.OpenMenu("UIListMenu")
	
	;-------------------------------------------------------
	; Delete selected
	;-------------------------------------------------------
	nSelected = UIExtensions.GetMenuResultInt("UIListMenu")
	
	If (isExist && nSelected != -1)
		actFind = maInternalNpcList[nSelected]
		maInternalNpcList[nSelected] = None
		
		szMsg = actFind.GetActorBase().GetName()
		szMsg = szMsg+" is deleted from captive list."
		Notification(szMsg)
	Endif
EndFunction

Function onClickHotKeyCaptiveList()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actFind
	Int       nIdx
	Int       nSearchCnt = 8
	Bool      isFound    = False
	Bool      isValid
	String    szMsg
	
	;-------------------------------------------------------
	; Check settings
	;-------------------------------------------------------
	If !McmConfig.mIsCaptiveUseInternal
		Return
	Endif
	
	;-------------------------------------------------------
	; Search Aggressor Loop
	;-------------------------------------------------------
	While (!isFound && nSearchCnt > 0)
		nSearchCnt -= 1
		
		; 2015.09.05 / Mod / using getActorSelected()
		actFind = getActorSelected()
		; 2015.09.05 / Mod / using getActorSelected()
		
		isValid = canAddCaptiveList(actFind)
		nIdx    = maInternalNpcList.Find(actFind)
		
		If isValid && (nIdx < 0)
			nIdx = maInternalNpcList.Find(None)
			
			If (nIdx < 0)
				nIdx = RandomInt(0, (maInternalNpcList.Length - 1))
			Endif
			
			maInternalNpcList[nIdx] = actFind
			isFound                 = True
			
			szMsg = actFind.GetActorBase().GetName()
			szMsg = szMsg+" is added to captive list."
			Notification(szMsg)
		Elseif (nIdx >= 0)
			maInternalNpcList[nIdx] = None
			isFound                 = True
			
			szMsg = actFind.GetActorBase().GetName()
			szMsg = szMsg+" is deleted from captive list."
			Notification(szMsg)
		Elseif (!isValid && actFind != Player)
			isFound = True
			
			szMsg = "Cannot add to captive list."
			Notification(szMsg)
		EndIf
	EndWhile
	
	onClickShowCaptiveList()
EndFunction
; 2015.07.17 / Add

; 2015.07.15 / Add
Bool Function canAddCaptiveList(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool isValid = True
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	Elseif (SexLab.GetGender(actFind) != 1)
		isValid = False
	; 2015.07.17 / Add
	Elseif (actFind == Player)
		isValid = False
	; 2015.07.17 / Add
	Elseif (actFind == PreCaptiveVictim)
		isValid = False
	Elseif actFind.IsPlayerTeammate()
		isValid = False
	Elseif !actFind.GetActorBase().IsUnique()
		isValid = False
	; 2015.07.18 / Add
	Elseif !isValidCaptiveVoice(actFind)
		isValid = False
	; 2015.07.18 / Add
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Function addCaptiveList()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actFind
	Int       nIdx
	Int       nSearchCnt = 8
	Float     nMaxSearch = 8880.0
	
	;-------------------------------------------------------
	; Search Aggressor Loop
	;-------------------------------------------------------
	While nSearchCnt > 0
		nSearchCnt -= 1
		
		actFind = FindRandomActorFromRef(Player, nMaxSearch)
		
		If canAddCaptiveList(actFind) && (maInternalNpcList.Find(actFind) < 0)
			nIdx = maInternalNpcList.Find(None)
			
			If (nIdx < 0)
				nIdx = RandomInt(0, (maInternalNpcList.Length - 1))
			Endif
			
			maInternalNpcList[nIdx] = actFind
;			Notification(actFind.GetActorBase().GetName()+" is added to captive list.")
;		Else
;			Notification(actFind.GetActorBase().GetName()+" is invalid for captive.")
		EndIf
	EndWhile
EndFunction
; 2015.07.15 / Add

; 2015.07.24 / Add
ActorBase Function getCaptiveAggressor()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	ActorBase   abRet
	ActorBase[] aList
	Bool        enableTPO  = McmConfig.mEnableCaptiveTPO
	Location    locCur     = None
	Int         nLen
	Int         nIdx
	
	;-------------------------------------------------------
	; Check location TPO
	;-------------------------------------------------------
	If enableTPO
		locCur = Player.GetCurrentLocation()
	Endif
	
	; LocTypeBanditCamp [KYWD:000130DF]
	; LocTypeDragonPriestLair [KYWD:000130E1]
	; LocTypeDragonLair [KYWD:000130E0]
	; LocTypeDraugrCrypt [KYWD:000130E2]
	; LocSetNordicRuin [KYWD:000130F2]
	; LocTypeCemetery [KYWD:0001CD58]
	; LocSetDwarvenRuin [KYWD:000130F0]
	; LocTypeDwarvenAutomatons [KYWD:000130E3]
	; LocTypeWarlockLair [KYWD:000130EC]
	; LocTypeVampireLair [KYWD:000130EB]
	; LocTypeHouse [KYWD:0001CB85]
	; LocTypePlayerHouse [KYWD:000FC1A3]
	; LocTypeInn [KYWD:0001CB87]
	; LocTypeDwelling [KYWD:000130DC]
	; LocTypeStore [KYWD:0001CB86]
	; LocTypeFalmerHive [KYWD:000130E4]
	; LocTypeWerewolfLair [KYWD:000130ED]
	; LocTypeForswornCamp [KYWD:000130EE]
	; LocTypeHagravenNest [KYWD:000130E6]
	; LocTypeGiantCamp [KYWD:000130E5]
	; LocTypeAnimalDen [KYWD:000130DE]
	; LocTypeOrcStronghold [KYWD:000130E9]
	; ActorBase[] Property maCaptiveBandits Auto Hidden
	; ActorBase[] Property maCaptiveThieves Auto Hidden
	; ActorBase[] Property maCaptiveForsworns Auto Hidden
	; ActorBase[] Property maCaptiveThalmors Auto Hidden
	; ActorBase[] Property maCaptiveVampires Auto Hidden
	; ActorBase[] Property maCaptiveWarlocks Auto Hidden
	; ActorBase[] Property maCaptiveDraugrs Auto Hidden
	; ActorBase[] Property maCaptiveUndeads Auto Hidden
	; ActorBase[] Property maCaptiveFalmers Auto Hidden
	; ActorBase[] Property maCaptiveDwarvens Auto Hidden
	; ActorBase[] Property maCaptiveAnimals Auto Hidden
	; ActorBase[] Property maCaptiveWerewolves Auto Hidden
	; ActorBase[] Property maCaptiveGiants Auto Hidden
	; ActorBase[] Property maCaptiveOrcs Auto Hidden
	If !locCur
		aList = maCaptiveBandits
	Elseif locCur.HasKeyWordString("LocTypeBanditCamp")
		aList = maCaptiveBandits
	Elseif locCur.HasKeyWordString("LocTypeDragonPriestLair")
		aList = maCaptiveDraugrs
	Elseif locCur.HasKeyWordString("LocTypeDragonLair")
		aList = maCaptiveDraugrs
	Elseif locCur.HasKeyWordString("LocTypeDraugrCrypt")
		aList = maCaptiveDraugrs
	Elseif locCur.HasKeyWordString("LocSetNordicRuin")
		aList = maCaptiveDraugrs
	Elseif locCur.HasKeyWordString("LocTypeCemetery")
		aList = maCaptiveUndeads
	Elseif locCur.HasKeyWordString("LocSetDwarvenRuin")
		aList = maCaptiveDwarvens
	Elseif locCur.HasKeyWordString("LocTypeDwarvenAutomatons")
		aList = maCaptiveDwarvens
	Elseif locCur.HasKeyWordString("LocTypeWarlockLair")
		aList = maCaptiveWarlocks
	Elseif locCur.HasKeyWordString("LocTypeVampireLair")
		aList = maCaptiveVampires
	Elseif locCur.HasKeyWordString("LocTypeFalmerHive")
		aList = maCaptiveFalmers
	Elseif locCur.HasKeyWordString("LocTypeWerewolfLair")
		aList = maCaptiveWerewolves
	Elseif locCur.HasKeyWordString("LocTypeForswornCamp")
		aList = maCaptiveForsworns
	Elseif locCur.HasKeyWordString("LocTypeHagravenNest")
		aList = maCaptiveForsworns
	Elseif locCur.HasKeyWordString("LocTypeGiantCamp")
		aList = maCaptiveGiants
	Elseif locCur.HasKeyWordString("LocTypeAnimalDen")
		aList = maCaptiveAnimals
	Elseif locCur.HasKeyWordString("LocTypeOrcStronghold")
		aList = maCaptiveOrcs
	Elseif locCur.HasKeyWordString("LocTypePlayerHouse")
		aList = maCaptiveThieves
	Elseif locCur.HasKeyWordString("LocTypeHouse")
		aList = maCaptiveThieves
	Elseif locCur.HasKeyWordString("LocTypeInn")
		aList = maCaptiveThieves
	Elseif locCur.HasKeyWordString("LocTypeDwelling")
		aList = maCaptiveThieves
	Elseif locCur.HasKeyWordString("LocTypeStore")
		aList = maCaptiveThieves
	Else
		aList = maCaptiveBandits
	Endif
	
	;-------------------------------------------------------
	; Choose one
	;-------------------------------------------------------
	nLen  = aList.Length - 1
	nIdx  = RandomInt(0, nLen)
	abRet = aList[nIdx]
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return abRet
EndFunction
; 2015.07.24 / Add

; 2015.07.18 / Add
Actor Function createCaptiveAggressor()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actRet
	Actor     actFind
	; 2015.07.24 / Add
	ActorBase abAggressor
	; 2015.07.24 / Add
	Float     nMaxSearch = 8880.0
	; 2015.08.08 / Add
	ObjectReference  orPop
	sslThreadLibrary scrLib
	; 2015.08.08 / Add
	
	;-------------------------------------------------------
	; Choose one
	;-------------------------------------------------------
	; 2015.07.24 / Add
	abAggressor = getCaptiveAggressor()
	; 2015.07.24 / Add
	
	;-------------------------------------------------------
	; Get Random Place
	;-------------------------------------------------------
	actFind = FindRandomActorFromRef(Player, nMaxSearch)
	
	; 2015.08.08 / Add
	If !actFind || (actFind == Player) || IsFollower(actFind)
		orPop = scrLib.FindBed(Player, Radius = nMaxSearch)
	Endif
	; 2015.08.08 / Add
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	; 2015.07.24 / Mod / Using abAggressor
	; 2015.08.08 / Mod
	If orPop
		actRet = orPop.PlaceActorAtMe(abAggressor, aiLevelMod = 3)
	Else
		actRet = actFind.PlaceActorAtMe(abAggressor, aiLevelMod = 3)
	Endif
	; 2015.08.08 / Mod
	
	;-------------------------------------------------------
	; Calm
	;-------------------------------------------------------
;	Calm(actRet)
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actRet
EndFunction

Actor Function createCaptiveVictim()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor actRet
	Actor actFind
	Int   nLen
	Int   nIdx
	Float nMaxSearch = 8880.0
	
	;-------------------------------------------------------
	; Choose one
	;-------------------------------------------------------
	nLen = maCaptiveVictims.Length
	nIdx = RandomInt(0, nLen)
	
	;-------------------------------------------------------
	; Get Random Place
	;-------------------------------------------------------
	actFind = FindRandomActorFromRef(Player, nMaxSearch)
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	actRet = actFind.PlaceActorAtMe(maCaptiveVictims[nIdx])
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actRet
EndFunction
; 2015.07.18 / Add

; 2015.08.02 / Add
Actor[] Function getCaptiveVictims(Int nJoinNum = 1)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	ReferenceAlias   refActor
	Actor            actFind
	Int              nIndex
	Int              nStartIndex
	Int              nEndIndex
	Bool             isAdded
	ReferenceAlias[] aWanderers
	ReferenceAlias[] aAmazingFollwers
	ReferenceAlias[] aEEFwFollwers
	ReferenceAlias[] aFLPkgFollwers
	ReferenceAlias[] aJbNPCMapNPCs
	Int              nActors
	Int              nValidActors
	Actor[]          aVictims1
	Actor[]          aVictims2
	Actor[]          aVictims3
	Actor[]          aJoinVictims = new Actor[5]
	Int              nJoinMembers = 0
	
	;-------------------------------------------------------
	; Reset the number of victims
	;-------------------------------------------------------
	If (nJoinNum > aJoinVictims.Length) || (nJoinNum < 1)
		nJoinNum = aJoinVictims.Length
	Endif
	
	;-------------------------------------------------------
	; Get Captive Victims List
	;-------------------------------------------------------
	; FGT 24 + AFT 64 + EFF 100 + FLP 108 + jbNPCMap 41 + Internal 40
	aVictims1 = new Actor[128]
	aVictims2 = new Actor[128]
	aVictims3 = new Actor[128]
	; From FGT
	If McmConfig.mIsCaptiveUseFGT
		aWanderers = getRefAliasesFromAddon("FGT", "Wanderer")
		nActors    = aWanderers.Length
		
		While nActors > 0
			nActors -= 1
			refActor = aWanderers[nActors]
			actFind  = refActor.GetReference() As Actor
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (FGT"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	; From AFT
	If McmConfig.mIsCaptiveUseAFT
		aAmazingFollwers = getRefAliasesFromAddon("AFT", "Follower")
		nActors          = aAmazingFollwers.Length
		
		While nActors > 0
			nActors -= 1
			refActor = aAmazingFollwers[nActors]
			actFind  = refActor.GetReference() As Actor
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (AFT"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	; From EFF
	If McmConfig.mIsCaptiveUseEFF
		aEEFwFollwers = getRefAliasesFromAddon("EFF", "Follower")
		nActors       = aEEFwFollwers.Length
		
		While nActors > 0
			nActors -= 1
			refActor = aEEFwFollwers[nActors]
			actFind  = refActor.GetReference() As Actor
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (EFF"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	; From FLP
	If McmConfig.mIsCaptiveUseFLP
		aFLPkgFollwers = getRefAliasesFromAddon("FLP", "Follower")
		nActors        = aFLPkgFollwers.Length
		
		While nActors > 0
			nActors -= 1
			refActor = aFLPkgFollwers[nActors]
			actFind  = refActor.GetReference() As Actor
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (FLP"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	; From jbNPCMap
	If McmConfig.mIsCaptiveUseJbNPCMap
		aJbNPCMapNPCs = getRefAliasesFromAddon("jbNPCMap", "Follower")
		nActors       = aJbNPCMapNPCs.Length
		
		While nActors > 0
			nActors -= 1
			refActor = aJbNPCMapNPCs[nActors]
			actFind  = refActor.GetReference() As Actor
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (JbNPCMap"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	; From Internal List
	If McmConfig.mIsCaptiveUseInternal
		nActors = maInternalNpcList.Length
		
		While nActors > 0
			nActors -= 1
			actFind  = maInternalNpcList[nActors]
			If isValidCaptiveVictim(actFind)
;				Notification(actFind.GetActorBase().GetName()+" is detected. (DefeatInternal"+(nActors as string)+")")
				If (nValidActors < 128)
					aVictims1[nValidActors] = actFind
				Elseif (nValidActors < 256)
					aVictims2[nValidActors - 128] = actFind
				Elseif (nValidActors < 384)
					aVictims3[nValidActors - 256] = actFind
				Endif
				nValidActors += 1
			Endif
		EndWhile
	Endif
	
	;-------------------------------------------------------
	; Choose Victims
	;-------------------------------------------------------
	If (nValidActors > 0)
		nStartIndex  = 0
		nEndIndex    = nValidActors - 1
		
		nActors      =  nJoinNum * 2
		isAdded      =  False
		
		While (nActors > 0) && (nJoinMembers <= nJoinNum)
			nActors -= 1
			
			nIndex = RandomInt(nStartIndex, nEndIndex)
			
			If (nIndex < 128)
				actFind = aVictims1[nIndex]
			Elseif (nIndex < 256)
				actFind = aVictims2[nIndex - 128]
			Elseif (nIndex < 384)
				actFind = aVictims3[nIndex - 256]
			Endif
			
			isAdded = (aJoinVictims.Find(actFind) >= 0)
			
			If actFind && !actFind.IsDead() && !isAdded
				aJoinVictims[nJoinMembers] = actFind
				nJoinMembers += 1
			Elseif McmConfig.mEnableCaptiveForceCreateActor
				actFind = createCaptiveVictim()
				aJoinVictims[nJoinMembers] = actFind
				nJoinMembers += 1
			Endif
		EndWhile
	Else
		Return aJoinVictims
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aJoinVictims
EndFunction
; 2015.08.02 / Add

; 2015.08.04 / Add
Function cleanCaptiveVictims()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor   actFind
	Int     nActors
	Cell    celActor
	Cell    celPlayer
	Bool    isNear
	Actor[] aVictims  = new Actor[1]
	
	;-------------------------------------------------------
	; Get RapeClub Members
	;-------------------------------------------------------
	aVictims[0] = PreCaptiveVictim
	celPlayer   = Player.GetParentCell()
	
	nActors = aVictims.Length
	
	While (nActors > 0)
		nActors -= 1
		
		actFind   = aVictims[nActors]
		celActor  = actFind.GetParentCell()
		isNear    = (celPlayer == celActor)
		
		If actFind && !isNear
			RemoveStates(actFind)
			cleanupDefeatStatus(actFind)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction

Bool Function doCaptiveDefeat(Actor[] aAggressors, Actor[] aVictims, Int nAggLen = 0, Int nVicLen = 0, Float nAggWait = 0.0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int   nAggIdx
	Int   nVicIdx
	Actor actEach
	Actor actAgg
	Actor actVic
	Actor actMainAgg   = None
	Actor actMainVic   = None
	Float nAggWaitMin  = McmConfig.mnCaptiveMinAggWait
	Float nAggWaitMax  = McmConfig.mnCaptiveMaxAggWait
	Float nAggInterval = RandomFloat(0.8, 3.5)
	Float nDownTime    = 60.0 * 30.0
	Cell  celPlayer
	Cell  celActor
	
	;-------------------------------------------------------
	; Reset wait time
	;-------------------------------------------------------
	If (nAggWait == 0.0)
		nAggWait = RandomFloat(nAggWaitMin, nAggWaitMax)
	Endif
	
	;-------------------------------------------------------
	; Reset number of members
	;-------------------------------------------------------
	If (nAggLen > aAggressors.Length) || (nAggLen <= 0)
		nAggLen = aAggressors.Length
	Endif
	
	If (nVicLen > aVictims.Length) || (nVicLen <= 0)
		nVicLen = aVictims.Length
	Endif
	
	;-------------------------------------------------------
	; Gathering Aggressors
	;-------------------------------------------------------
	nAggIdx = nAggLen
	
	While (nAggIdx > 0)
		nAggIdx -= 1
		
		actEach = aAggressors[nAggIdx]
		Calm(actEach)
		
		If actEach && !actMainAgg
			actMainAgg = actEach
			celPlayer  = Player.GetParentCell()
			celActor   = actEach.GetParentCell()
			
			If (celActor != celPlayer)
				; 2015.09.03 / Mod / Adding x and y offset
				actEach.MoveTo(Player, 8.0, 8.0)
			Endif
		Elseif actEach
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(actMainAgg, 8.0, 8.0)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Check aggressors
	;-------------------------------------------------------
	If !actMainAgg
		Return False
	Endif
	
	;-------------------------------------------------------
	; Gathering Victims
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	While (nVicIdx > 0)
		nVicIdx -= 1
		
		actEach = aVictims[nVicIdx]
		Calm(actEach)
		
		If actEach && !actMainVic
			actMainVic = actEach
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(actMainAgg, 8.0, 8.0)
		Elseif actEach
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(actMainVic, 8.0, 8.0)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Check victims
	;-------------------------------------------------------
	If !actMainVic
		Return False
	Endif
	
	;-------------------------------------------------------
	; Wait
	;-------------------------------------------------------
	Notification(actMainVic.GetActorBase().GetName()+" is held captive.")
	Wait(3.5)
	
	;-------------------------------------------------------
	; Strip victims
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	While (nVicIdx > 0)
		nVicIdx -= 1
		
		actEach = aVictims[nVicIdx]
		
		If actEach
			TieUp(actEach, actMainAgg, Duration = nDownTime)
			Strip(actEach)
			Strip(actEach)
			Strip(actEach)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Wait
	;-------------------------------------------------------
	Wait(nAggWait)
	
	;-------------------------------------------------------
	; Cleanup previous victim and reset
	;-------------------------------------------------------
	cleanCaptiveVictims()
	PreCaptiveVictim = actMainVic
		
	;-------------------------------------------------------
	; Start "Defeat"
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	While (nVicIdx > 0)
		nVicIdx -= 1
		
		actVic = aVictims[nVicIdx]
		actAgg = aAggressors[nVicIdx]
		
		If actVic && actAgg
			Wait(nAggInterval)
			
			If !actAgg.IsDead() && !actVic.IsDead()
				MiscSpells[3].Cast(actAgg, actVic)
				actVic.Say(TopicToSay[3], actVic)
			Endif
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return True
EndFunction
; 2015.08.04 / Add

Function startCaptive()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	ReferenceAlias   refActor
	Actor            actVictim
	Actor            actAggressor
	Actor            actFind
	Int              nIndex
	Int              nStartIndex
	Int              nEndIndex
	Cell             celCur
	; 2015.07.24 / Add
	Location         locCur
	; 2015.07.24 / Add
	Actor[]          aVictims
	Int              nActors
	Int              nValidActors   = 0
	Float            nMaxSearch     = McmConfig.mnCaptiveMaxAggSearchDist
	Int              nSearchCnt     = McmConfig.mnCaptiveAggSearchNum
	Int              nCaptRatio     = McmConfig.mnCaptiveRatio
	Float            nAggWaitMin    = McmConfig.mnCaptiveMinAggWait
	Float            nAggWaitMax    = McmConfig.mnCaptiveMaxAggWait
	Float            nAggWait       = RandomFloat(nAggWaitMin, nAggWaitMax)
	Float            nDownTime      = nAggWait + 8.0
	; 2015.07.17 / Add
	Bool             isFound        = False
	; 2015.07.17 / Add
	; 2015.07.25 / Add
	Bool             enableWherever = McmConfig.mEnableCaptiveWherever
	; 2015.07.25 / Add
	; 2015.08.04 / Add
	Actor[] aAggressors
	; 2015.08.04 / Add
	
	;-------------------------------------------------------
	; Addon check
	;-------------------------------------------------------
	; 2015.07.15 / Mod / Adding the condition
	If !FGTon && !AFTon && !EFFon && !FLPon && !jbNPCMapon && !McmConfig.mIsCaptiveUseInternal
;		Notification("FGT, AFT, EFF, FLP, jbNPCMap are not installed.")
		Return
	Elseif (RandomInt(1, 100) > nCaptRatio)
		; 2015.07.17 / Add
		addCaptiveList()
		; 2015.07.17 / Add
;		Notification("A captive is avoided. ("+(nCaptRatio as String)+"%)")
		Return
	Endif
	
	;-------------------------------------------------------
	; Check location TPO
	;-------------------------------------------------------
	celCur = Player.GetParentCell()
	; 2015.07.24 / Add
	locCur = Player.GetCurrentLocation()
	; 2015.07.24 / Add
	
	; 2015.07.25 / Mod / Add the condition, !enableWherever
	If !celCur.IsInterior() && !enableWherever
		; 2015.07.15 / Add
		addCaptiveList()
		; 2015.07.15 / Add
		; To avoid an outdoor captive
;		Notification("Here is not interior.")
		Return
	; 2015.07.24 / Mod / Add the condition, celCur.GetActorOwner()
	; 2015.07.25 / Mod / Add the condition, !enableWherever
	Elseif (celCur.GetFactionOwner() || celCur.GetActorOwner()) && !enableWherever
		; 2015.07.15 / Add
		addCaptiveList()
		; 2015.07.15 / Add
		; To avoid a house captive
;		Notification("Here is owned by some faction.")
		Return
	; 2015.07.24 / Add
	; LocTypeHouse [KYWD:0001CB85]
	; LocTypeInn [KYWD:0001CB87]
	; LocTypeDwelling [KYWD:000130DC]
	; LocTypeStore [KYWD:0001CB86]
	; 2015.07.25 / Mod / Adding the condition, !enableWherever
	; 2015.08.02 / Mod
	Elseif locCur.HasKeyWordString("LocTypeHouse") && !enableWherever
;		Notification("Here is a house.")
		addCaptiveList()
		Return
	; 2015.07.24 / Add
	; 2015.08.02 / Add
	Elseif locCur.HasKeyWordString("LocTypePlayerHouse") && !enableWherever
		addCaptiveList()
		Return
	Elseif locCur.HasKeyWordString("LocTypeInn") && !enableWherever
		addCaptiveList()
		Return
	Elseif locCur.HasKeyWordString("LocTypeDwelling") && !enableWherever
		addCaptiveList()
		Return
	Elseif locCur.HasKeyWordString("LocTypeStore") && !enableWherever
		addCaptiveList()
		Return
	; 2015.08.02 / Add
	; 2015.07.30 / Add
	Elseif (maNoCaptiveLocations.Find(locCur) >= 0)
;		Notification("Forbidden Place")
		Return
	; 2015.07.30 / Add
	; 2015.07.25 / Add
	Elseif enableWherever
		addCaptiveList()
	; 2015.07.25 / Add
	Endif
	
	;-------------------------------------------------------
	; Get Captive Victims List
	;-------------------------------------------------------
	aVictims  = getCaptiveVictims()
	actVictim = aVictims[0]
	
	;-------------------------------------------------------
	; Check Victim
	;-------------------------------------------------------
	If !actVictim
;		Notification("No victims.")
		Return
	Endif
	
	;-------------------------------------------------------
	; Search Aggressor Loop
	;-------------------------------------------------------
	; 2015.07.17 / Mod / Adding a while condition, !isFound
	While (!isFound && nSearchCnt > 0)
		nSearchCnt -= 1
		
		actFind = FindRandomActorFromRef(Player, nMaxSearch)
		
		; 2015.07.13 / Mod / Using isValidCaptiveAggressor()
		If isValidCaptiveAggressor(actFind)
			actAggressor = actFind
			; 2015.07.17 / Add
			isFound      = True
			; 2015.07.17 / Add
;			Notification(actFind.GetActorBase().GetName()+" is found.")
		Else
			actAggressor = None
;			Notification(actFind.GetActorBase().GetName()+" is not choosed.")
		EndIf
	EndWhile
	
	; 2015.07.18 / Add
	;-------------------------------------------------------
	; Force create Aggressor
	;-------------------------------------------------------
	If !isFound && McmConfig.mEnableCaptiveForceCreateActor
		actAggressor = createCaptiveAggressor()
	EndIf
	; 2015.07.18 / Add
	
	;-------------------------------------------------------
	; Start "Defeat"
	;-------------------------------------------------------
	If actAggressor
		; 2015.08.04 / Mod
		aAggressors    = new Actor[1]
		aAggressors[0] = actAggressor
		aVictims       = new Actor[1]
		aVictims[0]    = actVictim
		
		doCaptiveDefeat(aAggressors, aVictims)
		; 2015.08.04 / Mod
	EndIf
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction

; 2015.08.02 / Add
Bool Function canAddRapeClubList(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool      isValid    = True
	Bool      isExcluded = False
	VoiceType vocFind
	
	;-------------------------------------------------------
	; Get VoiceType
	;-------------------------------------------------------
	If actFind
		vocFind    = actFind.GetVoiceType()
		isExcluded = (maRapeClubExcludeVoices.Find(vocFind) >= 0)
	Endif
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	; 2015.08.03 / Add
	Elseif !actFind.HasKeyWordString("ActorTypeNPC")
		isValid = False
	Elseif actFind.HasKeyWordString("ActorisChild")
		isValid = False
	; 2015.08.03 / Add
	; 2015.08.05 / Add
	Elseif isExcluded
		isValid = False
	; 2015.08.05 / Add
	Elseif (SexLab.GetGender(actFind) != 0)
		isValid = False
	Elseif (actFind == Player)
		isValid = False
	Elseif actFind.IsPlayerTeammate()
		isValid = False
	Elseif !actFind.GetActorBase().IsUnique()
		isValid = False
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Function addRapeClubList()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor actFind
	Int   nIdx
	Int   nEndIdx
	Bool  isAdded
	Int   nSearchCnt = 8
	Float nMaxSearch = 8880.0
	
	;-------------------------------------------------------
	; Search Aggressor Loop
	;-------------------------------------------------------
	While nSearchCnt > 0
		nSearchCnt -= 1
		
		actFind = FindRandomActorFromRef(Player, nMaxSearch)
		isAdded = (maRapeClubMembers.Find(actFind) >= 0)
		
		If canAddRapeClubList(actFind) && !isAdded
			nIdx = maRapeClubMembers.Find(None)
			
			If (nIdx < 0)
				nEndIdx = maRapeClubMembers.Length - 1
				nIdx    = RandomInt(0, nEndIdx)
			Endif
			
			maRapeClubMembers[nIdx] = actFind
;			Notification(actFind.GetActorBase().GetName()+" is added to the rape club.")
;		Else
;			Notification(actFind.GetActorBase().GetName()+" is invalid for the rape club.")
		EndIf
	EndWhile
EndFunction

Bool Function isValidRapeClubVictim(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool  isValid    = True
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	Elseif (SexLab.GetGender(actFind) != 1)
		isValid = False
	Elseif (actFind == Player)
		isValid = False
	Elseif actFind.IsPlayerTeammate()
		isValid = False
	Elseif !isValidCaptiveVoice(actFind)
		isValid = False
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Bool Function isValidRapeClubLocation()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool     isValid        = False
	Location locCur         = Player.GetCurrentLocation()
	Bool     enableHouse    = McmConfig.mEnableRapeClubLocHouse
	Bool     enableDwelling = McmConfig.mEnableRapeClubLocInn
	Bool     enableInn      = McmConfig.mEnableRapeClubLocDwelling
	Bool     enableStore    = McmConfig.mEnableRapeClubLocStore
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If (maNoCaptiveLocations.Find(locCur) >= 0)
		isValid = False
	Elseif locCur.HasKeyWordString("LocTypePlayerHouse")
		isValid = False
	Elseif locCur.HasKeyWordString("LocTypeHouse") && enableHouse
		isValid = True
	Elseif locCur.HasKeyWordString("LocTypeInn") && enableInn
		isValid = True
	Elseif locCur.HasKeyWordString("LocTypeDwelling") && enableDwelling
		isValid = True
	Elseif locCur.HasKeyWordString("LocTypeStore") && enableStore
		isValid = True
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Bool Function doRapeClubDefeat(Actor[] aMembers, Actor[] aVictims, Int nMemLen = 0, Int nVicLen = 0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int     nAggIdx
	Int     nVicIdx
	Actor   actEach
	Actor   actAgg
	Actor   actVic
	Actor   actMainAgg   = None
	Actor   actMainVic   = None
	Float   nAggWait     = 3.5
	Float   nAggInterval = RandomFloat(3.5, 8.0)
	Float   nDownTime    = 60.0 * 30.0
	Cell    celPlayer
	Cell    celActor
	String  szVicType    = "NPC"
	Actor[] aExcludes    = new Actor[40]
	Int     nExcIdx      = 0
	; 2015.08.07 / Add
	Int     nRapeLimit   = McmConfig.mnRapeClubRapingLimit
	; 2015.08.07 / Add
	; 2015.08.31 / Add
	Int     nPvicChance  = McmConfig.mnRapeClubPvicChance
	Bool    enablePvic   = False
	; 2015.08.31 / Add
	
	;-------------------------------------------------------
	; Reset number of members
	;-------------------------------------------------------
	If (nMemLen > aMembers.Length) || (nMemLen <= 0)
		nMemLen = aMembers.Length
	Endif
	
	If (nVicLen > aVictims.Length) || (nVicLen <= 0)
		nVicLen = aVictims.Length
	Endif
	
	;-------------------------------------------------------
	; Gathering Victims
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	; 2015.08.22 / Mod / Adding the condition, !actMainVic
	While (nVicIdx > 0) && !actMainVic
		nVicIdx -= 1
		
		actEach = aVictims[nVicIdx]
		
		If actEach && !actMainVic
			actMainVic = actEach
			celPlayer  = Player.GetParentCell()
			celActor   = actEach.GetParentCell()
			
			If (celActor != celPlayer)
				; 2015.09.03 / Mod / Adding x and y offset
				actEach.MoveTo(Player, 8.0, 8.0)
			Endif
		; 2015.08.22 / Del
;		Elseif actEach
;			actEach.MoveTo(actMainVic, 8.0, 8.0)
		; 2015.08.22 / Del
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Check victims
	;-------------------------------------------------------
	If !actMainVic
;		Notification("No main victim.")
		Return False
	Endif
	
	;-------------------------------------------------------
	; Gathering Members
	;-------------------------------------------------------
	nAggIdx = nMemLen
	
	While (nAggIdx > 0)
		nAggIdx -= 1
		
		actEach = aMembers[nAggIdx]
		Calm(actEach)
		
		If actEach && !actMainAgg
			actMainAgg = actEach
			; 2015.08.05 / Add
			actEach.EquipItem(marmRapeClubHood, True, True)
			; 2015.08.05 / Add
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(actMainVic, 8.0, 8.0)
		; 2015.08.22 / Add
		Elseif actEach && aVictims[nAggIdx]
			actEach.EquipItem(marmRapeClubHood, True, True)
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(aVictims[nAggIdx], 8.0, 8.0)
		; 2015.08.22 / Add
		Elseif actEach
			; 2015.08.05 / Add
			actEach.EquipItem(marmRapeClubHood, True, True)
			; 2015.08.05 / Add
			; 2015.09.03 / Mod / Adding x and y offset
			actEach.MoveTo(actMainAgg, 8.0, 8.0)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Check members
	;-------------------------------------------------------
	If !actMainAgg
;		Notification("No main member.")
		Return False
	Endif
	
	;-------------------------------------------------------
	; Wait
	;-------------------------------------------------------
	Notification("Rape Club starts.")
	Wait(nAggWait)
	
	;-------------------------------------------------------
	; Tieup victims
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	While (nVicIdx > 0)
		nVicIdx -= 1
		
		actEach = aVictims[nVicIdx]
		
		If actEach
			TieUp(actEach, actMainAgg, Duration = nDownTime)
			Strip(actEach)
			Strip(actEach)
			Strip(actEach)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Start Player "Defeat"
	;-------------------------------------------------------
	If (RandomInt(1, 100) < nPvicChance)
		enablePvic = True
	Endif
	
	nAggIdx = nMemLen - 1
	
	If enablePvic && aMembers[nAggIdx]
		actAgg = aMembers[nAggIdx]
		
		; 2015.09.02 / Add
		nVicIdx = 5
		
		While (nVicIdx > 0)
			nVicIdx -= 1
			
			actEach = aVictims[nVicIdx]
			
			If actEach
				PlayerScr.GetFollowers()[nVicIdx] = actEach
				PlayerScr.TheFollowers[nVicIdx].ForceRefIfEmpty(actEach)
			Endif
		EndWhile
		; 2015.09.02 / Add
		
		; 2015.09.02 / Mod / Adding 4 aggressors
		StartScene(					\
			actAgg,					\
			aMembers[0],			\
			aMembers[1],			\
			aMembers[2],			\
			aMembers[3],			\
			Scenario = "$Original"	)
		
		aExcludes[nExcIdx] = Player
		nExcIdx += 1
	Endif
	
	;-------------------------------------------------------
	; Start "Defeat"
	;-------------------------------------------------------
	nVicIdx = nVicLen
	
	; 2015.08.07 / Mod / Adding the condition, (nExcIdx < nRapeLimit)
	While (nVicIdx > 0) && (nExcIdx < nRapeLimit)
		nVicIdx -= 1
		
		actVic = aVictims[nVicIdx]
		actAgg = aMembers[nVicIdx]
		
		If actVic && actAgg
;			Wait(nAggInterval)
			
			If !actAgg.IsDead() && !actVic.IsDead()
				; 2015.08.31 / Mod
				If enablePvic
					actVic.Say(TopicToSay[3], actVic)
					PlayerScr.CollateralRape(actVic, actAgg)
				Else
					actVic.Say(TopicToSay[3], actVic)
					MiscSpells[3].Cast(actAgg, actVic)
				Endif
				; 2015.08.31 / Mod
				
				aExcludes[nExcIdx] = actVic
				nExcIdx += 1
			Endif
		Endif
	EndWhile
	
	; 2015.08.04 / Add
	;-------------------------------------------------------
	; Start "Collateral"
	;-------------------------------------------------------
	nAggIdx = nMemLen
	
	; 2015.08.07 / Mod / Adding the condition, (nExcIdx < nRapeLimit)
	While (nAggIdx > 0) && (nExcIdx < nRapeLimit)
		nAggIdx -= 1
		
		actAgg = aMembers[nAggIdx]
		
		If !actAgg.HasKeyWordString("DefeatActive")
			actVic = getCollaVictim(actAgg, aExcludes)
		Else
			actVic = None
		Endif
		
		If actVic && actAgg
;			Wait(nAggInterval)
			
			; 2015.08.05 / Add
			If IsFollower(actVic)
				szVicType = "Follower"
			; 2015.08.23 / Add
			Else
				szVicType = "NPC"
			; 2015.08.23 / Add
			Endif
			; 2015.08.05 / Add
			
			; 2015.08.31 / Add
			If !actAgg.IsDead() && !actVic.IsDead()
				; 2015.08.31 / Mod
				If enablePvic
					actVic.Say(TopicToSay[3], actVic)
					PlayerScr.CollateralRape(actVic, actAgg)
				Else
					actVic.Say(TopicToSay[3], actVic)
					Knockdown(actVic, actAgg, nDownTime, szVicType)
					MiscSpells[3].Cast(actAgg, actVic)
				Endif
				; 2015.08.31 / Mod
				
				aExcludes[nExcIdx] = actVic
				nExcIdx += 1
			Endif
		Endif
	EndWhile
	; 2015.08.04 / Add
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return True
EndFunction

; 2015.08.04 / Add
Bool Function isValidCollaVictim(Actor actFind)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool  isValid    = True
	
	;-------------------------------------------------------
	; Actor Check
	;-------------------------------------------------------
	If !actFind
		isValid = False
	Elseif actFind.IsDead()
		isValid = False
	Elseif (SexLab.GetGender(actFind) != 1)
		isValid = False
	Elseif (actFind == Player)
		isValid = False
	Elseif !isValidCaptiveVoice(actFind)
		isValid = False
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isValid
EndFunction

Actor Function getCollaVictim(Actor actAggressor, Actor[] aExcludes)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor   actFind
	Int     nSearchCnt = 8
	Float   nMaxSearch = 8880.0
	Bool    isExcluded
	
	;-------------------------------------------------------
	; Search RapeClub Victims Loop
	;-------------------------------------------------------
	While (nSearchCnt > 0)
		nSearchCnt -= 1
		
		actFind    = FindRandomActorFromRef(actAggressor, nMaxSearch)
		isExcluded = (aExcludes.Find(actFind) >= 0)
		
		If isValidCollaVictim(actFind) && !isExcluded
			Return actFind
		EndIf
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return None
EndFunction
; 2015.08.04 / Add

; 2015.08.05 / Add
Function cleanupDefeatStatus(Actor actTarget)
	Calm(actTarget, Enter = False)
	
	Int nIdx = MiscSpells.Length
	While (nIdx > 0)
		nIdx -= 1
		If actTarget.HasSpell(MiscSpells[nIdx])
			actTarget.DispelSpell(MiscSpells[nIdx])
		Endif
	EndWhile
	
	nIdx = DefeatFactions.Length
	While (nIdx > 0)
		nIdx -= 1
		If actTarget.IsInFaction(DefeatFactions[nIdx])
			actTarget.RemoveFromFaction(DefeatFactions[nIdx])
		Endif
	EndWhile
	
	nIdx = MiscPackages.Length
	While (nIdx > 0)
		nIdx -= 1
		If (actTarget.GetCurrentPackage() == MiscPackages[nIdx])
			ActorUtil.RemovePackageOverride(actTarget, MiscPackages[nIdx])
		Endif
	EndWhile
	
	; 2015.09.01 / Add
	RemoveStates(actTarget, NoCalm = True)
	RemoveStates(actTarget, NoCalm = True)
	; 2015.09.01 / Add
	; 2015.09.03 / Add
	SendAnimationEvent(actTarget, "IdleForceDefaultState")
	
	If actTarget.Is3DLoaded()
		SendAnimationEvent(actTarget, "BleedoutStop")
	Endif
	; 2015.09.03 / Add
EndFunction
; 2015.08.05 / Add

; 2015.08.24 / Add
Bool Function isJaxonzPluginInstalled()
	Bool   isInstalled = False
	String szPlugin    = "JaxonzConsolePlugIn"
	Int    nVer
	
	nVer = SKSE.GetPluginVersion(szPlugin)
	
	If (nVer > 0)
		isInstalled = True
	Endif
	
	Return isInstalled
EndFunction

; 2015.09.05 / Add
Actor Function getActorSelected(	\
	Bool enableGrabbed    = True, 	\
	Bool enableCrosshair  = True, 	\
	Bool enableConsole    = True,	\
	Bool enableNearPlayer = True,	\
	Bool disableDead      = True,	\
	Bool onlySexActive    = False	\
)
	Actor actFind    = None
	Float nMaxSearch = 170.0
	Int   nSkseVer   = SKSE.GetScriptVersionRelease()
	
	; Console selected
	If !actFind && enableConsole && (nSkseVer > 47)
		actFind = GetCurrentConsoleRef() as Actor
	Elseif !actFind && enableConsole && isJaxonzPluginInstalled()
		actFind = JaxonzConsolePlugIn.GetCurrentConsoleRef() as Actor
	Endif
	
	If actFind && !actFind.GetActorBase()
		actFind = None
	Elseif actFind && actFind.IsDead() && disableDead
		actFind = None
	Elseif actFind && !actFind.HasKeyWordString("SexLabActive") && onlySexActive
		actFind = None
	Endif
	
	; Grabbed
	If !actFind && enableGrabbed
		actFind = GetPlayerGrabbedRef() as Actor
	Endif
	
	If actFind && !actFind.GetActorBase()
		actFind = None
	Elseif actFind && actFind.IsDead() && disableDead
		actFind = None
	Elseif actFind && !actFind.HasKeyWordString("SexLabActive") && onlySexActive
		actFind = None
	Endif
	
	; Crosshair
	If !actFind && enableCrosshair
		actFind = GetCurrentCrosshairRef() as Actor
	Endif
	
	If actFind && !actFind.GetActorBase()
		actFind = None
	Elseif actFind && actFind.IsDead() && disableDead
		actFind = None
	Elseif actFind && !actFind.HasKeyWordString("SexLabActive") && onlySexActive
		actFind = None
	Endif
	
	; Near player
	If !actFind && enableNearPlayer
		actFind = FindRandomActorFromRef(Player, nMaxSearch)
	Endif
	
	If actFind && !actFind.GetActorBase()
		actFind = None
	Elseif actFind && actFind.IsDead() && disableDead
		actFind = None
	Elseif actFind && !actFind.HasKeyWordString("SexLabActive") && onlySexActive
		actFind = None
	Endif
	
	Return actFind
EndFunction
; 2015.09.05 / Add

Function onClickHotKeyCleanupSelected()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actFind
	Int       nSearchCnt = 8
	String    szMsg      = ""
	Bool      isFound    = False
	
	;-------------------------------------------------------
	; Search Loop
	;-------------------------------------------------------
	While (!isFound && nSearchCnt > 0)
		nSearchCnt -= 1
		
		; 2015.09.05 / Mod / using getActorSelected()
		actFind = getActorSelected(enableNearPlayer = False)
		; 2015.09.05 / Mod / using getActorSelected()
		
		If actFind && (actFind != Player)
			cleanupDefeatStatus(actFind)
			
			szMsg = actFind.GetLeveledActorBase().GetName() \
				  + " is cleaned up."
			Notification(szMsg)
			
			isFound = True
		; 2015.09.05 / Add
		Elseif actFind && (actFind == Player)
			If (McmConfig.OnOffPvic == "$Enabled")
				PlayerScr.Clean()
			Endif
			
			If (McmConfig.OnOffPagg == "$Enabled")
				ActionQst.Clean()
				ActionQst.Hkrefresh()
			Endif
			
			szMsg = "Player is cleaned up."
			Notification(szMsg)
			
			isFound = True
		; 2015.09.05 / Add
		EndIf
	EndWhile
EndFunction
; 2015.08.24 / Add

; 2015.08.03 / Add
Function cleanRapeClubMembers()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor   actFind
	Int     nActors
	
	;-------------------------------------------------------
	; Get RapeClub Members
	;-------------------------------------------------------
	nActors = maRapeClubMembers.Length
	
	While (nActors > 0)
		nActors -= 1
		
		actFind = maRapeClubMembers[nActors]
		
		; 2015.08.04 / Mod / Adding actFind.IsEquipped(marmRapeClubHood)
		If actFind && actFind.IsEquipped(marmRapeClubHood)
			actFind.UnequipItem(marmRapeClubHood, True, True)
			actFind.RemoveItem(marmRapeClubHood, 1, True)
			; 2015.08.05 / Add
			cleanupDefeatStatus(actFind)
			; 2015.08.05 / Add
		; 2015.08.05 / Add
		Elseif actFind
			cleanupDefeatStatus(actFind)
		; 2015.08.05 / Add
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction
; 2015.08.03 / Add

Actor[] Function getRapeClubJoinMembers(Int nJoinNum = 3)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor   actFind
	Int     nIndex
	Int     nStartIndex
	Int     nEndIndex
	Int     nActors
	Bool    isAdded
	Actor[] aMembers        = new Actor[40]
	Actor[] aJoinMembers    = new Actor[40]
	Int     nValidActors    = 0
	Int     nJoinMembers    = 0
	
	;-------------------------------------------------------
	; Get RapeClub Members
	;-------------------------------------------------------
	nActors = maRapeClubMembers.Length
	
	While (nActors > 0)
		nActors -= 1
		
		actFind = maRapeClubMembers[nActors]
		
		; 2015.08.03 / Mod / Using canAddRapeClubList()
		If canAddRapeClubList(actFind)
			aMembers[nValidActors] = actFind
			nValidActors += 1
		; 2015.08.03 / Add
		Else
			maRapeClubMembers[nActors] = None
		; 2015.08.03 / Add
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Choose Members
	;-------------------------------------------------------
	If (nValidActors > 0)
		nStartIndex  = 0
		nEndIndex    = nValidActors - 1
		
		nActors  =  nJoinNum * 2
		isAdded  =  False
		
		While (nActors > 0) && (nJoinMembers <= nJoinNum)
			nActors -= 1
			
			nIndex  = RandomInt(nStartIndex, nEndIndex)
			actFind = aMembers[nIndex]
			isAdded = (aJoinMembers.Find(actFind) >= 0)
			
			If actFind && !actFind.IsDead() && !isAdded
				aJoinMembers[nJoinMembers] = actFind
				nJoinMembers += 1
			Endif
		EndWhile
	Else
;		Notification("No rape club members.")
		Return aJoinMembers
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aJoinMembers
EndFunction

Bool Function startRapeClub()
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor   actFind
	Bool    isAdded
	Bool    isSuccess
	Int     nRapeClubChance = McmConfig.mnRapeClubChance
	Bool    enableRapeClub  = True
	Bool    enableCaptive   = McmConfig.mEnableRapeClubCaptive
	Int     nSearchCnt      = 8
	Float   nMaxSearch      = 8880.0
	Actor[] aJoinMembers    = new Actor[40]
	; 2015.08.18 / Mod / 3 -> 8
	Actor[] aVictims        = new Actor[8]
	Int     nVictims        = 0
	Int     nJoinMembers    = 0
	Int     nJoinNum        = RandomInt(1, 3)
	Int     nCaptiveNum     = RandomInt(1, 2)
	; 2015.08.18 / Add
	Cell    celCur         = Player.GetParentCell()
	; 2015.08.18 / Add
	; 2015.08.22 / Add
	Float   nDownTime      = 60.0 * 30.0
	Bool    isMember
	Bool    isHuman
	Bool    isPlayer
	; 2015.08.22 / Add
	
	;-------------------------------------------------------
	; Check settings
	;-------------------------------------------------------
	If !enableRapeClub
		Return False
	Elseif (RandomInt(1, 100) > nRapeClubChance)
		cleanRapeClubMembers()
		addRapeClubList()
		Return False
	Endif
	
	;-------------------------------------------------------
	; Check location
	;-------------------------------------------------------
	If !isValidRapeClubLocation()
;		Notification("Invalid rape club location.")
		cleanRapeClubMembers()
		addRapeClubList()
		Return False
	Endif
	
	;-------------------------------------------------------
	; Adding Rape Club members
	;-------------------------------------------------------
	addRapeClubList()
	
	;-------------------------------------------------------
	; Search RapeClub Victims Loop
	;-------------------------------------------------------
	isAdded = False
	; 2015.08.18 / Add
	nSearchCnt = celCur.GetNumRefs(62)
	; 2015.08.18 / Add
	
	While (nVictims < aVictims.Length) && (nSearchCnt > 0)
		nSearchCnt -= 1
		
		; 2015.08.18 / Mod / Using GetNthRef() to search
;		actFind  = FindRandomActorFromRef(Player, nMaxSearch)
		actFind  = celCur.GetNthRef(nSearchCnt, 62) as Actor
		isAdded  = (aVictims.Find(actFind) >= 0)
		; 2015.08.22 / Add
		isHuman  = actFind.HasKeyWordString("ActorTypeNPC")
		isMember = (maRapeClubMembers.Find(actFind) >= 0)
		isPlayer = (actFind == Player)
		; 2015.08.22 / Add
		
		If isValidRapeClubVictim(actFind) && !isAdded
			aVictims[nVictims] = actFind
			nVictims += 1
		; 2015.08.22 / Add
		Elseif !isPlayer && isHuman && !isMember && !isAdded
			TieUp(actFind, Duration = nDownTime)
		; 2015.08.22 / Add
		EndIf
	EndWhile
	
	;-------------------------------------------------------
	; Get Victims from Captive List
	;-------------------------------------------------------
	If (nVictims < 1) && enableCaptive
		aVictims = getCaptiveVictims(nCaptiveNum)
		nVictims = aVictims.Find(None)
		
		If (nVictims < 0)
			nVictims = aVictims.Length
		Endif
	Endif
	
	;-------------------------------------------------------
	; Check RapeClub Victims
	;-------------------------------------------------------
	If (nVictims < 1)
;		Notification("No rape club victims.")
		Return False
	Endif
	
	;-------------------------------------------------------
	; Get RapeClub Members
	;-------------------------------------------------------
	nJoinNum += nVictims
	aJoinMembers = getRapeClubJoinMembers(nJoinNum)
	nJoinMembers = aJoinMembers.Find(None)
	
	If (nJoinMembers < 0)
		nJoinMembers = aJoinMembers.Length
	Endif
	
	;-------------------------------------------------------
	; Start "Defeat"
	;-------------------------------------------------------
	isSuccess = doRapeClubDefeat(aJoinMembers, aVictims, nJoinMembers, nVictims)
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isSuccess
EndFunction
; 2015.08.02 / Add

Function Strip(Actor actStripper)
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[1], Armor.GetMaskForSlot(McmConfig.SSNVN[0] As Int))
		Return
	Endif
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[2], Armor.GetMaskForSlot(McmConfig.SSNVN[1] As Int))
		Return
	Endif
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[3], Armor.GetMaskForSlot(McmConfig.SSNVN[2] As Int))
		Return
	Endif
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[4], Armor.GetMaskForSlot(McmConfig.SSNVN[3] As Int))
		Return
	Endif
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[5], Armor.GetMaskForSlot(McmConfig.SSNVN[4] As Int))
		Return
	Endif
	
	Weapon Equipped = actStripper.GetEquippedWeapon()
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[0], 0, Equipped)
		Return
	Endif
	
	Equipped = actStripper.GetEquippedWeapon(True)
	
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[0], 0, Equipped)
		Return
	Endif
	
	Armor Shield = actStripper.GetEquippedShield()
	If !PieceToStrip(actStripper, McmConfig.SSNVNSet[0], 0, Shield)
		Return
	Endif
	
	Wait(0.8)
EndFunction

Bool Function PieceToStrip(Actor actStripper, String Way, Int Slot, Form Weapons = None)
	Form  Equipped
	Actor actStealer
	
	If Weapons
		Equipped = Weapons
	Else
		Equipped = actStripper.GetWornForm(Slot)
	Endif
	
	If canStrip(Equipped) && (Way == "$UNEQUIP")
		actStripper.UnequipItem(Equipped, True, True)
	Elseif canStrip(Equipped) && (Way == "$STRIP")
		actStripper.UnequipItem(Equipped, False, True)
		actStripper.DropObject(Equipped)
	Elseif canStrip(Equipped) && (Way == "$STEAL")
		actStealer = FindRandomActorFromRef(actStripper, 800.0)
		actStripper.UnequipItem(Equipped, False, True)
		actStripper.RemoveItem(Equipped, 1, True, actStealer)
	Endif
	
	Return True
EndFunction

; 2015.07.26 / Add
Bool Function canStrip(Form frmEquipped)
	Bool canStrip = True
	Int  nDevIdx  = maTieupDevices.Find(frmEquipped as Armor)
	
	If !frmEquipped
		canStrip = False
	Elseif frmEquipped.HasKeyWordString("SexLabNoStrip")
		canStrip = False
	Elseif frmEquipped.HasKeyWordString("DefeatWornDevice")
		canStrip = False
	Elseif (nDevIdx >= 0)
		canStrip = False
	Endif
	
	Return canStrip
EndFunction
; 2015.07.26 / Add

Function setRapedFaceAnimation(Actor actVictim, Bool Enter = true)
	If Enter && McmConfig.mIsRapedPhoneme
		; 2015.07.13 / Mod / Adding 2 expressions and randomized
		; 2015.08.07 / Mod / Changing the end number, 2 -> 3
		Int  nRand = RandomInt(0, 2)
		; 2015.08.08 / Add
		Int  nTogueRand       = RandomInt(1, 100)
		Int  nTogueRatio      = McmConfig.mnTongueEquipChance
		Bool canEquipTongue   = (nTogueRand <= nTogueRatio)
		Int  nMouthOpen       = 100
		Int  nPhonemeCnt      = 0
		
;		If !actVictim.HasKeyWordString("SexLabActive") && (actVictim != Player)
;			canEquipTongue = False
;		Endif
		
		If !canEquipTongue
			removeTongues(actVictim)
		Endif
		
		If !EQTONGUESCRon && !EQTONGUEon && HTOOLSon
			nMouthOpen = 62
		Endif
		; 2015.08.08 / Add
		
;		MfgConsoleFunc.ResetPhonemeModifier(actVictim)
		
		If (nRand <= 0)
			actVictim.SetExpressionOverride(3,100)
			MfgConsoleFunc.SetModifier(actVictim,0,0)
			MfgConsoleFunc.SetModifier(actVictim,1,0)
			MfgConsoleFunc.SetModifier(actVictim,2,50)
			MfgConsoleFunc.SetModifier(actVictim,3,50)
			MfgConsoleFunc.SetModifier(actVictim,4,50)
			MfgConsoleFunc.SetModifier(actVictim,5,50)
			MfgConsoleFunc.SetModifier(actVictim,8,50)
			MfgConsoleFunc.SetModifier(actVictim,12,30)
			MfgConsoleFunc.SetModifier(actVictim,13,30)
			
			If canEquipTongue
				MfgConsoleFunc.SetPhoneme(actVictim,0,nMouthOpen)
				MfgConsoleFunc.SetPhoneme(actVictim,6,nMouthOpen)
			Else
				MfgConsoleFunc.SetPhoneme(actVictim,1,10)
				MfgConsoleFunc.SetPhoneme(actVictim,2,100)
				MfgConsoleFunc.SetPhoneme(actVictim,6,0)
				MfgConsoleFunc.SetPhoneme(actVictim,7,50)
				MfgConsoleFunc.SetPhoneme(actVictim,8,0)
			Endif
		Elseif (nRand <= 1)
			actVictim.SetExpressionOverride(3,80)
			MfgConsoleFunc.SetModifier(actVictim,0,44)
			MfgConsoleFunc.SetModifier(actVictim,1,44)
			MfgConsoleFunc.SetModifier(actVictim,2,50)
			MfgConsoleFunc.SetModifier(actVictim,3,50)
			MfgConsoleFunc.SetModifier(actVictim,4,50)
			MfgConsoleFunc.SetModifier(actVictim,5,50)
			MfgConsoleFunc.SetModifier(actVictim,8,50)
			MfgConsoleFunc.SetModifier(actVictim,12,30)
			MfgConsoleFunc.SetModifier(actVictim,13,30)
			
			If canEquipTongue
				MfgConsoleFunc.SetPhoneme(actVictim,0,nMouthOpen)
				MfgConsoleFunc.SetPhoneme(actVictim,6,nMouthOpen)
			Else
				MfgConsoleFunc.SetPhoneme(actVictim,1,10)
				MfgConsoleFunc.SetPhoneme(actVictim,2,0)
				MfgConsoleFunc.SetPhoneme(actVictim,6,80)
				MfgConsoleFunc.SetPhoneme(actVictim,7,50)
				MfgConsoleFunc.SetPhoneme(actVictim,8,0)
			Endif
		Elseif McmConfig.mEnableRandomFace
			; 2015.07.15 / Add
			; Fear
			actVictim.SetExpressionOverride(1,  RandomInt(0, 100))
			actVictim.SetExpressionOverride(9,  RandomInt(0, 100))
			; Sad
			actVictim.SetExpressionOverride( 3, RandomInt(80, 100))
			actVictim.SetExpressionOverride(11, RandomInt(80, 100))
			; Blink Left/Right
			MfgConsoleFunc.SetModifier(actVictim,  0, RandomInt(0, 100))
			MfgConsoleFunc.SetModifier(actVictim,  1, RandomInt(0, 100))
			; Brow Down Left/Right
			MfgConsoleFunc.SetModifier(actVictim,  2, RandomInt(44, 80))
			MfgConsoleFunc.SetModifier(actVictim,  3, RandomInt(44, 80))
			; Brow In Left/Right
			MfgConsoleFunc.SetModifier(actVictim,  4, RandomInt(44, 80))
			MfgConsoleFunc.SetModifier(actVictim,  5, RandomInt(44, 80))
			; Look Down/Left/Right/Up
			MfgConsoleFunc.SetModifier(actVictim,  RandomInt(8, 11), RandomInt(0, 100))
			; Squint Left/Right
			MfgConsoleFunc.SetModifier(actVictim, 12, RandomInt(0, 100))
			MfgConsoleFunc.SetModifier(actVictim, 13, RandomInt(0, 100))
			; Phoneme
			If canEquipTongue
				MfgConsoleFunc.SetPhoneme(actVictim,0,nMouthOpen)
				MfgConsoleFunc.SetPhoneme(actVictim,6,nMouthOpen)
			Else
				nPhonemeCnt = 0
				
				While (nPhonemeCnt < 16)
					MfgConsoleFunc.SetPhoneme(actVictim, nPhonemeCnt, RandomInt(0, 8))
					
					nPhonemeCnt += 1
				EndWhile
			Endif
			; 2015.07.15 / Add
		Else
			actVictim.SetExpressionOverride(11,100)
			MfgConsoleFunc.SetModifier(actVictim,0,100)
			MfgConsoleFunc.SetModifier(actVictim,1,100)
			MfgConsoleFunc.SetModifier(actVictim,2,50)
			MfgConsoleFunc.SetModifier(actVictim,3,50)
			MfgConsoleFunc.SetModifier(actVictim,4,50)
			MfgConsoleFunc.SetModifier(actVictim,5,50)
			MfgConsoleFunc.SetModifier(actVictim,8,50)
			MfgConsoleFunc.SetModifier(actVictim,12,30)
			MfgConsoleFunc.SetModifier(actVictim,13,30)
			
			If canEquipTongue
				MfgConsoleFunc.SetPhoneme(actVictim,0,nMouthOpen)
				MfgConsoleFunc.SetPhoneme(actVictim,6,nMouthOpen)
			Else
				MfgConsoleFunc.SetPhoneme(actVictim,1,10)
				MfgConsoleFunc.SetPhoneme(actVictim,2,0)
				MfgConsoleFunc.SetPhoneme(actVictim,6,0)
				MfgConsoleFunc.SetPhoneme(actVictim,7,50)
				MfgConsoleFunc.SetPhoneme(actVictim,8,88)
			Endif
		Endif
		
		; 2015.08.08 / Add
		; DEBUG
;		If canEquipTongue
;			removeTongues(actVictim)
;			addTongue(actVictim)
		; DEBUG
		If canEquipTongue && !isTongueEquipped(actVictim)
			addTongue(actVictim)
		Endif
		; 2015.08.08 / Add
	Else
		MfgConsoleFunc.ResetPhonemeModifier(actVictim)
		
		; 2015.08.07 / Add / For the tongue
		removeTongues(actVictim)
		; 2015.08.07 / Add / For the tongue
	Endif
EndFunction

; 2015.07.15 / Mod / Add 5th argument, nColor
Int Function getEffectMapID(String szName, String szTxtr, String szSect, String szArea, Int nColor = -1)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int nMap
	
	;-------------------------------------------------------
	; Setup Map
	;-------------------------------------------------------
	nMap = JMap.object()
	JValue.retain(nMap)
	JMap.setStr(nMap, "name", szName)
	JMap.setStr(nMap, "texture", szTxtr)
	JMap.setStr(nMap, "section", szSect)
	JMap.setStr(nMap, "area", szArea)
	
	; 2015.07.15 / Add
	If nColor > 0x0000000
		JMap.setInt(nMap, "color", nColor)
	Endif
	; 2015.07.15 / Add
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return nMap
EndFunction

; 2015.07.13 / Mod / Deleting 3rd argument, nLevel
Int[] Function getRyonaMapID(Actor actVictim, Actor actAggressor = None)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int[]    aRet       = New Int[8]
	String[] aNames     = New String[22]
	String[] aTextures  = New String[22]
	String[] aSections  = New String[22]
	String[] aAreas     = New String[22]
	Int      nIdx       = 0
	Int      nTears     = 1
	Int      nEffects   = 1
	Int      nCuts      = 1
	Int      nScars     = 1
	Int      nSob       = 1
	Int      nDirt      = 1
	Int      nMax       = 0
	Bool     isCreature = False
	Bool     isDaedra   = False
	; 2015.07.22 / Add
	Bool     isVampire  = False
	; 2015.07.22 / Add
	; 2015.07.15 / Add
	Int      nTearLv    = 3
	Int      nAftEffLv  = 3
	Int      nDirtLv    = 3
	Int      nCutsLv    = 3
	Int      nScarsLv   = 3
	; 2015.07.22 / Add
	Int      nVampBittenLv = 1
	Int      nSweatLv      = 1
	; 2015.07.22 / Add
	Bool     isSyncOK   = False
	Int      nLoopCnt   = 3
	; 2015.07.15 / Add1
	; 2015.07.23 / Add
	Int      nMapIdx    = 0
	; 2015.07.23 / Add
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !STTon || !McmConfig.mEnableRyona
		nMapIdx = aRet.Length
		While (nMapIdx > 0)
			nMapIdx -= 1
			
			aRet[nMapIdx] = 0
		EndWhile
		
		Return aRet
	Endif
	
	;-------------------------------------------------------
	; Set Map Data
	;-------------------------------------------------------
	aNames[nIdx]    = "battered"
	aTextures[nIdx] = "After Effects\\face_battered.dds"
	aSections[nIdx] = "After Effects"
	aAreas[nIdx]    = "Face"
	nIdx += 1
	aNames[nIdx]    = "After Effects "+(nEffects as String)
	aTextures[nIdx] = "After Effects\\after_effects_"+(nEffects as String)+".dds"
	aSections[nIdx] = "After Effects"
	aAreas[nIdx]    = "Body"
	nEffects += 1
	nIdx     += 1
	aNames[nIdx]    = "After Effects "+(nEffects as String)
	aTextures[nIdx] = "After Effects\\after_effects_"+(nEffects as String)+".dds"
	aSections[nIdx] = "After Effects"
	aAreas[nIdx]    = "Body"
	nEffects += 1
	nIdx     += 1
	aNames[nIdx]    = "After Effects "+(nEffects as String)
	aTextures[nIdx] = "After Effects\\after_effects_"+(nEffects as String)+".dds"
	aSections[nIdx] = "After Effects"
	aAreas[nIdx]    = "Body"
	nEffects += 1
	nIdx     += 1
	aNames[nIdx]    = "After Effects "+(nEffects as String)
	aTextures[nIdx] = "After Effects\\after_effects_"+(nEffects as String)+".dds"
	aSections[nIdx] = "After Effects"
	aAreas[nIdx]    = "Body"
	nEffects += 1
	nIdx     += 1
	aNames[nIdx]    = "Cuts "+(nCuts as String)
	aTextures[nIdx] = "After Effects\\cuts_"+(nCuts as String)+".dds"
	aSections[nIdx] = "Cuts"
	aAreas[nIdx]    = "Body"
	nCuts += 1
	nIdx  += 1
	aNames[nIdx]    = "Cuts "+(nCuts as String)
	aTextures[nIdx] = "After Effects\\cuts_"+(nCuts as String)+".dds"
	aSections[nIdx] = "Cuts"
	aAreas[nIdx]    = "Body"
	nCuts += 1
	nIdx  += 1
	aNames[nIdx]    = "Cuts "+(nCuts as String)
	aTextures[nIdx] = "After Effects\\cuts_"+(nCuts as String)+".dds"
	aSections[nIdx] = "Cuts"
	aAreas[nIdx]    = "Body"
	nCuts += 1
	nIdx  += 1
	aNames[nIdx]    = "Scars "+(nScars as String)
	aTextures[nIdx] = "Scars Dirt\\scarred_"+(nScars as String)+".dds"
	aSections[nIdx] = "Scars"
	aAreas[nIdx]    = "Body"
	nScars += 1
	nIdx   += 1
	aNames[nIdx]    = "Scars "+(nScars as String)
	aTextures[nIdx] = "Scars Dirt\\scarred_"+(nScars as String)+".dds"
	aSections[nIdx] = "Scars"
	aAreas[nIdx]    = "Body"
	nScars += 1
	nIdx   += 1
	aNames[nIdx]    = "Scars "+(nScars as String)
	aTextures[nIdx] = "Scars Dirt\\scarred_"+(nScars as String)+".dds"
	aSections[nIdx] = "Scars"
	aAreas[nIdx]    = "Body"
	nScars += 1
	nIdx   += 1
	aNames[nIdx]    = "Tears "+(nTears as String)
	aTextures[nIdx] = "Sob Tears\\tears_"+(nTears as String)+".dds"
	aSections[nIdx] = "Tears"
	aAreas[nIdx]    = "Face"
	nTears += 1
	nIdx   += 1
	aNames[nIdx]    = "Tears "+(nTears as String)
	aTextures[nIdx] = "Sob Tears\\tears_"+(nTears as String)+".dds"
	aSections[nIdx] = "Tears"
	aAreas[nIdx]    = "Face"
	nTears += 1
	nIdx   += 1
	aNames[nIdx]    = "Tears "+(nTears as String)
	aTextures[nIdx] = "Sob Tears\\tears_"+(nTears as String)+".dds"
	aSections[nIdx] = "Tears"
	aAreas[nIdx]    = "Face"
	nTears += 1
	nIdx   += 1
	; 2015.07.13 / Add
	aNames[nIdx]    = "Tears "+(nSob as String)
	aTextures[nIdx] = "Sob Tears\\sob_"+(nSob as String)+".dds"
	aSections[nIdx] = "Tears"
	aAreas[nIdx]    = "Face"
	nSob += 1
	nIdx   += 1
	aNames[nIdx]    = "Tears "+(nSob as String)
	aTextures[nIdx] = "Sob Tears\\sob_"+(nSob as String)+".dds"
	aSections[nIdx] = "Tears"
	aAreas[nIdx]    = "Face"
	nSob += 1
	nIdx   += 1
	aNames[nIdx]    = "Dirt "+(nDirt as String)
	aTextures[nIdx] = "Scars Dirt\\dirt_"+(nDirt as String)+".dds"
	aSections[nIdx] = "Dirt"
	aAreas[nIdx]    = "Body"
	nDirt += 1
	nIdx  += 1
	aNames[nIdx]    = "Dirt "+(nDirt as String)
	aTextures[nIdx] = "Scars Dirt\\dirt_"+(nDirt as String)+".dds"
	aSections[nIdx] = "Dirt"
	aAreas[nIdx]    = "Body"
	nDirt += 1
	nIdx  += 1
	aNames[nIdx]    = "Dirt "+(nDirt as String)
	aTextures[nIdx] = "Scars Dirt\\dirt_"+(nDirt as String)+".dds"
	aSections[nIdx] = "Dirt"
	aAreas[nIdx]    = "Body"
	nDirt += 1
	nIdx  += 1
	; 2015.07.13 / Add
	; 2015.07.22 / Add
	aNames[nIdx]    = "VampireBitten 1"
	aTextures[nIdx] = "Bitten Sweat\\vamp_bitten_1.dds"
	aSections[nIdx] = "Bitten"
	aAreas[nIdx]    = "Face"
	nIdx  += 1
	aNames[nIdx]    = "SweatFace 1"
	aTextures[nIdx] = "Bitten Sweat\\sweat_face_1.dds"
	aSections[nIdx] = "Sweat"
	aAreas[nIdx]    = "Face"
	nIdx  += 1
	aNames[nIdx]    = "SweatBody 1"
	aTextures[nIdx] = "Bitten Sweat\\sweat_body_1.dds"
	aSections[nIdx] = "Sweat"
	aAreas[nIdx]    = "Body"
	nIdx  += 1
	; 2015.07.22 / Add
	
	;-------------------------------------------------------
	; Clear previous effects
	;-------------------------------------------------------
	removeRyonaEffects(actVictim)
	
	;-------------------------------------------------------
	; Check aggressor
	;-------------------------------------------------------
	If actAggressor && actAggressor.HasKeyWordString("ActorTypeCreature")
		isCreature = True
	Endif
	
	If actAggressor && actAggressor.HasKeyWordString("ActorTypeDaedra")
		isDaedra = True
	Endif
	
	If actAggressor && actAggressor.HasKeyWordString("Vampire")
		isVampire = True
	Endif
	
	; 2015.07.15 / Add
	;-------------------------------------------------------
	; Randomize Level
	;-------------------------------------------------------
	If McmConfig.mEnableRandomRyona
		nTearLv       = RandomInt(0, McmConfig.mnRyonaTearLevel)
		nAftEffLv     = RandomInt(0, McmConfig.mnRyonaAfterEffectLevel)
		nDirtLv       = RandomInt(0, McmConfig.mnRyonaDirtLevel)
		nCutsLv       = RandomInt(0, McmConfig.mnRyonaCutsLevel)
		nScarsLv      = RandomInt(0, McmConfig.mnRyonaScarsLevel)
		nVampBittenLv = RandomInt(0, McmConfig.mnRyonaVampBittenLevel)
		nSweatLv      = RandomInt(0, McmConfig.mnRyonaSweatLevel)
	Else
		nTearLv       = McmConfig.mnRyonaTearLevel
		nAftEffLv     = McmConfig.mnRyonaAfterEffectLevel
		nDirtLv       = McmConfig.mnRyonaDirtLevel
		nCutsLv       = McmConfig.mnRyonaCutsLevel
		nScarsLv      = McmConfig.mnRyonaScarsLevel
		nVampBittenLv = McmConfig.mnRyonaVampBittenLevel
		nSweatLv      = McmConfig.mnRyonaSweatLevel
	Endif
	; 2015.07.15 / Add
	
	;-------------------------------------------------------
	; Set Return Value
	;-------------------------------------------------------
	; Get MapIDs and add effects
	nMax = 5
	If (nTearLv > 0) && (nTearLv <= nMax)
		nIdx = 10 + nTearLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nTearLv > nMax)
		nIdx = 0
		; 2015.07.15 / Mod / Adding color(dark red)
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx], 0x880000)
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	
	nMax = 4
	If (nAftEffLv > 0) && (nAftEffLv <= nMax)
		nIdx = 0 + nAftEffLv
		; 2015.07.15 / Mod / Adding color(dark red)
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx], 0x880000)
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nAftEffLv > nMax)
		nIdx = 0 + nMax
		; 2015.07.15 / Mod / Adding color(dark red)
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx], 0x880000)
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	
	nMax = 3
	If (nDirtLv > 0) && (nDirtLv <= nMax)
		nIdx = 15 + nDirtLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nDirtLv > nMax)
		nIdx = 15 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	
	nMax = 3
	If (nCutsLv > 0) && (nCutsLv <= nMax) && isCreature
		nIdx = 4 + nCutsLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx], 0x880000)
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nCutsLv > nMax) && actAggressor && isCreature
		nIdx = 4 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx], 0x880000)
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	
	nMax = 3
	If (nScarsLv > 0) && (nScarsLv <= nMax) && isDaedra
		nIdx = 7 + nScarsLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nScarsLv > nMax) && actAggressor && isDaedra
		nIdx = 7 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	; 2015.07.22 / Add
	nMax = 1
	If (nVampBittenLv > 0) && (nVampBittenLv <= nMax) && isVampire
		nIdx = 18 + nVampBittenLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nVampBittenLv > nMax) && actAggressor && isVampire
		nIdx = 18 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	
	nMax = 1
	If (nSweatLv > 0) && (nSweatLv <= nMax)
		nIdx = 19 + nSweatLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
		
		nMapIdx += 1
		
		nIdx = 20 + nSweatLv
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Elseif (nSweatLv > nMax)
		nIdx = 19 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
		
		nMapIdx += 1
		
		nIdx = 20 + nMax
		aRet[nMapIdx] = getEffectMapID(aNames[nIdx], aTextures[nIdx], aSections[nIdx], aAreas[nIdx])
		SlaveTats.add_tattoo(actVictim, aRet[nMapIdx], -1)
	Endif
	nMapIdx += 1
	; 2015.07.22 / Add
	
	; 2015.07.15 / Mod
	;-------------------------------------------------------
	; Apply Ryona effects
	;-------------------------------------------------------
;	While (!isSyncOK && nLoopCnt > 0)
;		nLoopCnt -= 1
;		
;		Wait(0.8)
;		isSyncOK = SlaveTats.synchronize_tattoos(actVictim, True)
;	EndWhile
	
	; 2015.09.05 / Mod
	isSyncOK = SlaveTats.synchronize_tattoos(actVictim, True)
	; 2015.07.15 / Mod
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aRet
EndFunction

; 2015.07.13 / Add
Function releaseRyonaMapIDs(Actor actVictim, Int[] aMaps)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Int  nIdx
	; 2015.07.15 / Add
	Bool isSyncOK   = False
	Int  nLoopCnt   = 3
	; 2015.07.15 / Add
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	; 2015.08.07 / Mod / Adding the condition, !McmConfig.mEnableRyonaAutoRemove
	If !STTon || !McmConfig.mEnableRyonaAutoRemove
		Return
	Endif
	
	;-------------------------------------------------------
	; Release MapIDs
	;-------------------------------------------------------
	nIdx = aMaps.Length
	While nIdx > 0
		nIdx -= 1
		; 2015.07.14 / Mod / Only releasing MapID > 0
		If aMaps[nIdx] > 0
			; 2015.07.31 / Mod / Using remove_tattoos()
;			JValue.release(aMaps[nIdx])
			SlaveTats.remove_tattoos(actVictim, aMaps[nIdx], silent = True)
		Endif
		; 2015.07.14 / Mod / Only releasing MapID > 0
	EndWhile
	
	; 2015.07.15 / Mod
	;-------------------------------------------------------
	; Remove Ryona effects
	;-------------------------------------------------------
;	While (!isSyncOK && nLoopCnt > 0)
;		nLoopCnt -= 1
;		
;		Wait(0.8)
;		isSyncOK = SlaveTats.synchronize_tattoos(actVictim, True)
;	EndWhile
	
	; 2015.09.05 / Mod
	isSyncOK = SlaveTats.synchronize_tattoos(actVictim, True)
	; 2015.07.15 / Mod
EndFunction
; 2015.07.13 / Add

Function removeRyonaEffects(Actor actVictim)
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !STTon
		Return
	Endif
	
	;-------------------------------------------------------
	; Force Removing
	;-------------------------------------------------------
	If McmConfig.mEnableRyona
		SlaveTats.remove_tattoos(actVictim, 0, silent = True)
	Endif
EndFunction
; 2015.07.09 / Add

; 2015.07.16 / Add
Bool Function syncRyonaEffects(Actor actVictim)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool isOK
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !STTon || !McmConfig.mEnableRyona
		Return False
	Endif
	
	;-------------------------------------------------------
	; Force Removing
	;-------------------------------------------------------
	isOK = SlaveTats.synchronize_tattoos(actVictim, True)
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isOK
EndFunction
; 2015.07.16 / Add

; 2015.07.19 / Add
Bool Function doDwarvenRape(Actor actAggressor, Actor actVictim, Float nDuration = 300.0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool   isRaped   = True
	Int    nRand     = RandomInt(2, 3)
	Int    nEffect   = 1
	Int    nPattern  = 0
	Float  nInterval = 3.0
	Float  nWaitTime = nDuration
	Bool   isRaping
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !Estruson
		Return False
	Endif
	
	;-------------------------------------------------------
	; Set Effect
	;-------------------------------------------------------
	If (actVictim == Player)
		nEffect = 2
	Endif
	
	;-------------------------------------------------------
	; Set Animation Pattern (Etc-1 is Dwarven Horse)
	;-------------------------------------------------------
	If (nRand == 2)
		nPattern = 1
	Endif
	
	;-------------------------------------------------------
	; Calling Estrus Effect API
	;-------------------------------------------------------
	If !actAggressor.IsDead() && !actVictim.IsDead()
		zzEstrusUtil.EstrusEffectAPI(actVictim, EffectType = nEffect, AnimType = nRand, AnimPattern = nPattern)
	Else
		isRaped = False
	Endif
	
	;-------------------------------------------------------
	; Estrus Animation Timer
	;-------------------------------------------------------
	isRaping = isRaped
	
	; 2015.07.22 / Add
	Wait(40.0)
	; 2015.07.22 / Add
	
	While isRaping && (nWaitTime > 0.0)
		Wait(nInterval)
		
		isRaping = isEstrusRaping(actVictim)
		
		If (nWaitTime == nDuration)
			isRaped = isRaping
		Endif
		
		nWaitTime -= nInterval
	EndWhile
	
	;-------------------------------------------------------
	; Force stop animation
	;-------------------------------------------------------
	If (nWaitTime <= 0.0)
		zzEstrusUtil.EstrusEffectStopAPI(actVictim)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isRaped
EndFunction

Bool Function doTentacleRape(Actor actAggressor, Actor actVictim, Float nDuration = 300.0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool   isRaped   = True
	Int    nRand     = RandomInt(1, 2)
	Int    nEffect   = 1
	Int    nPattern  = 0
	Float  nInterval = 3.0
	Float  nWaitTime = nDuration
	Bool   isRaping
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !Estruson
		Return False
	Endif
	
	;-------------------------------------------------------
	; Set Effect
	;-------------------------------------------------------
	If (actVictim == Player)
		nEffect = RandomInt(2, 3)
	Elseif RandomInt(0, 1) == 0
		nEffect = 3
	Endif
	
	;-------------------------------------------------------
	; Set Animation Pattern (Etc-2 is Tentacle Slime)
	;-------------------------------------------------------
	If (nRand == 2)
		nPattern = 2
	Endif
	
	;-------------------------------------------------------
	; Calling Estrus Effect API
	;-------------------------------------------------------
	If !actAggressor.IsDead() && !actVictim.IsDead()
		zzEstrusUtil.EstrusEffectAPI(actVictim, EffectType = nEffect, AnimType = nRand, AnimPattern = nPattern)
	Else
		isRaped = False
	Endif
	
	;-------------------------------------------------------
	; Estrus Animation Timer
	;-------------------------------------------------------
	isRaping = isRaped
	
	; 2015.07.22 / Add
	Wait(40.0)
	; 2015.07.22 / Add
	
	While isRaping && (nWaitTime > 0.0)
		Wait(nInterval)
		
		isRaping = isEstrusRaping(actVictim)
		
		If (nWaitTime == nDuration)
			isRaped = isRaping
		Endif
		
		nWaitTime -= nInterval
	EndWhile
	
	;-------------------------------------------------------
	; Force stop animation
	;-------------------------------------------------------
	If (nWaitTime <= 0.0)
		zzEstrusUtil.EstrusEffectStopAPI(actVictim)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isRaped
EndFunction

Bool Function doEstrusUndress(Actor actAggressor, Actor actVictim, Float nDuration = 300.0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool   isRaped   = True
	Int    nRand     = 0
	Int    nEffect   = 3
	Int    nPattern  = 0
	Float  nInterval = 3.0
	Float  nWaitTime = nDuration
	Bool   isRaping
	
	;-------------------------------------------------------
	; Check Addon
	;-------------------------------------------------------
	If !Estruson
		Return False
	Endif
	
	;-------------------------------------------------------
	; Calling Estrus Effect API
	;-------------------------------------------------------
	If !actAggressor.IsDead() && !actVictim.IsDead()
		zzEstrusUtil.EstrusEffectAPI(actVictim, EffectType = nEffect, AnimType = nRand, AnimPattern = nPattern)
	Else
		isRaped = False
	Endif
	
	;-------------------------------------------------------
	; Estrus Animation Timer
	;-------------------------------------------------------
	isRaping = isRaped
	
	; 2015.07.22 / Add
	Wait(40.0)
	; 2015.07.22 / Add
	
	While isRaping && (nWaitTime > 0.0)
		Wait(nInterval)
		
		isRaping = isEstrusRaping(actVictim)
		
		If (nWaitTime == nDuration)
			isRaped = isRaping
		Endif
		
		nWaitTime -= nInterval
	EndWhile
	
	;-------------------------------------------------------
	; Force stop animation
	;-------------------------------------------------------
	If (nWaitTime <= 0.0)
		zzEstrusUtil.EstrusEffectStopAPI(actVictim)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isRaped
EndFunction

Bool Function isEstrusRaping(Actor actVictim)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Bool isPlaying = False
	
	;-------------------------------------------------------
	; Check Estrus Token
	;-------------------------------------------------------
;	If (actVictim.getItemCount(moEstrusToken) > 0)
;		isPlaying = True
	If actVictim.HasMagicEffectWithKeyword(mkwEstrusEffect)
		isPlaying = True
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isPlaying
EndFunction
; 2015.07.19 / Add

; 2015.07.30 / Add
Bool Function isTentacleUser(Actor actTarget)
	Race   racCreature
	string szRace
	Bool   isSpecifiedRace = False
	
	If actTarget
		racCreature = actTarget.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
	Endif
	
	If StringUtil.Find(szRace, "Lurker") != -1
		isSpecifiedRace = True
	Elseif StringUtil.Find(szRace, "Seeker") != -1
		isSpecifiedRace = True
	Endif
	
	Return isSpecifiedRace
EndFunction
; 2015.07.30 / Add

; 2015.07.25 / Add
Bool Function isSpider(Actor actTarget)
	Race   racCreature
	string szRace
	Bool   isSpecifiedRace = False
	
	If actTarget
		racCreature = actTarget.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
	Endif
	
	If StringUtil.Find(szRace, "Spider") != -1
		isSpecifiedRace = True
	Endif
	
	Return isSpecifiedRace
EndFunction

Bool Function isSpriggan(Actor actTarget)
	Race   racCreature
	string szRace
	Bool   isSpecifiedRace = False
	
	If actTarget
		racCreature = actTarget.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
	Endif
	
	If StringUtil.Find(szRace, "Spriggan") != -1
		isSpecifiedRace = True
	Endif
	
	Return isSpecifiedRace
EndFunction

Actor Function summonSprigganRaper(Actor actCaster)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor        actRet
	ActorBase    abFind
	Faction[]    aCurFactions
	Int          nFactIdx
	Int          nActorIdx
	Int          nActorLen
	Int          nRate      = McmConfig.mnSummonSppriganRate
	Int          nRand      = RandomInt(1, 100)
	
	;-------------------------------------------------------
	; Check Ratio
	;-------------------------------------------------------
	If (nRand > nRate) || !isSpriggan(actCaster)
		Return None
	Endif
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	nActorLen = maCaptiveAnimals.Length - 1
	nActorIdx = RandomInt(0, nActorLen)
	abFind    = maCaptiveAnimals[nActorIdx]
	actRet    = actCaster.PlaceActorAtMe(abFind)
	
	;-------------------------------------------------------
	; Setup Actor
	;-------------------------------------------------------
	If actRet
		; Remove current Factions
		aCurFactions = actRet.GetFactions(0, 100)
		nFactIdx     = aCurFactions.Length
		
		While nFactIdx > 0
			nFactIdx -= 1
			
			actRet.RemoveFromFaction(aCurFactions[nFactIdx])
		EndWhile
		
		; Add to the Spriggan Faction
		actRet.AddToFaction(mfctSpriggan)
		
		; Play summon FX
		actRet.AddSpell(msplGhostNew)
		actRet.SetAlpha(0.8)
		actRet.PlaceAtMe(mactvSummonFX)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actRet
EndFunction
; 2015.07.25 / Add

; 2015.07.26 / Add
Bool Function isAtronachFlame(Actor actTarget)
	Race   racCreature
	string szRace
	Bool   isSpecifiedRace = False
	
	If actTarget
		racCreature = actTarget.GetLeveledActorBase().GetRace()
		szRace      = MiscUtil.GetRaceEditorID(racCreature)
	Endif
	
	If StringUtil.Find(szRace, "AtronachFlame") != -1
		isSpecifiedRace = True
	Endif
	
	Return isSpecifiedRace
EndFunction

Actor Function summonFlamingRaper(Actor actCaster)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor        actRet
	ActorBase    abFind
	Faction[]    aCurFactions
	Int          nFactIdx
	Int          nActorIdx
	Int          nActorLen
	Int          nRate      = McmConfig.mnSummonAtronachRate
	Int          nRand      = RandomInt(1, 100)
	
	;-------------------------------------------------------
	; Check Ratio
	;-------------------------------------------------------
	If (nRand > nRate) || !isAtronachFlame(actCaster)
		Return None
	Endif
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	nActorLen = maFlamingRapers.Length - 1
	nActorIdx = RandomInt(0, nActorLen)
	abFind    = maFlamingRapers[nActorIdx]
	actRet    = actCaster.PlaceActorAtMe(abFind)
	
	;-------------------------------------------------------
	; Setup Actor
	;-------------------------------------------------------
	If actRet
		; Remove current Factions
		aCurFactions = actRet.GetFactions(0, 100)
		nFactIdx     = aCurFactions.Length
		
		While nFactIdx > 0
			nFactIdx -= 1
			
			actRet.RemoveFromFaction(aCurFactions[nFactIdx])
		EndWhile
		
		; Add to the Spriggan Faction
		actRet.AddToFaction(mfctDaedra)
		
		; Play summon FX
		actRet.SetAlpha(0.44)
		actRet.AddSpell(msplFireWolf)
		actRet.PlaceAtMe(mactvSummonFX)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actRet
EndFunction
; 2015.07.26 / Add

; 2015.07.22 / Add
Actor Function summonDwarvenRaper(Actor actCaster)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor        actRet
	Actor        actFind
	Faction[]    aCurFactions
	Form         frmEquipped
	Int[]        aStripSlots
	Int          nFactIdx
	Int          nEquipIdx
	Float        nMaxSearch = 8880.0
	Int          nRate      = McmConfig.mnSummonDwarvenRate
	Int          nRand      = RandomInt(1, 100)
	; 2015.09.06 / Add
	Int          nActorIdx
	Int          nActorMax
	; 2015.09.06 / Add
	
	;-------------------------------------------------------
	; Check Ratio
	;-------------------------------------------------------
	; 2015.09.13 / Mod
	If (nRand > nRate)
		Return None
	Elseif !actCaster.HasKeyWordString("ActorTypeDwarven")
		Return None
	; 2015.09.13 / Add
	Elseif !actCaster.IsInFaction(mfctDwarven)
		Return None
	; 2015.09.13 / Add
	Endif
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	; 2015.09.06 / Add
	If SICon
		nActorMax = maSicDwarvenRapers.Length - 1
		nActorIdx = RandomInt(0, nActorMax)
		mabDwarvenRaper = maSicDwarvenRapers[nActorIdx]
	Endif
	; 2015.09.06 / Add
	actFind = FindRandomActorFromRef(actCaster, nMaxSearch)
	actRet  = actFind.PlaceActorAtMe(mabDwarvenRaper, aiLevelMod = 1)
	
	;-------------------------------------------------------
	; Setup Actor
	;-------------------------------------------------------
	; 2015.09.06 / Add
	If actRet && SICon
		; Moving to the caster
		actRet.MoveTo(actCaster)
		
		; Play summon FX
		actRet.PlaceAtMe(mactvSummonFX)
	; 2015.09.06 / Add
	; 2015.09.06 / Mod / If -> Elseif
	Elseif actRet
		aStripSlots     = new Int[7]
		aStripSlots[0]  = 32
		aStripSlots[1]  = 37
		aStripSlots[2]  = 33
		aStripSlots[3]  = 30
		aStripSlots[4]  = 31
		aStripSlots[5]  = 42
		aStripSlots[6]  = 43
		
		; Remove current Factions
		aCurFactions = actRet.GetFactions(0, 100)
		nFactIdx     = aCurFactions.Length
		
		While nFactIdx > 0
			nFactIdx -= 1
			
			actRet.RemoveFromFaction(aCurFactions[nFactIdx])
		EndWhile
		
		; Add to the Dwarven Faction
		actRet.AddToFaction(mfctDwarven)
		
		; Change NPC properties
		actRet.GetActorBase().SetVoiceType(mvocDwarven)
;		actRet.GetActorBase().SetName(McmConfig.mszDwarvenRaper)
		
		; Unequip and remove armors
		nEquipIdx = aStripSlots.Length
		
		While nEquipIdx > 0
			nEquipIdx -= 1
			
			frmEquipped = actRet.GetWornForm(aStripSlots[nEquipIdx])
			actRet.UnequipItem(frmEquipped, True, True)
			actRet.RemoveItem(frmEquipped, 1, True)
		EndWhile
		
		actRet.RemoveAllItems()
		
		; Add and equip Dwarven Armors
		nEquipIdx = maDwarvenArmors.Length
		
		While nEquipIdx > 0
			nEquipIdx -= 1
			
			actRet.AddItem(maDwarvenArmors[nEquipIdx], 1)
			actRet.EquipItem(maDwarvenArmors[nEquipIdx], True, True)
		EndWhile
		
		; Set Health
		actRet.SetAV("Health", 80.0)
		
		; Stop Combat
;		Calm(actRet)
		
		; Moving to the caster
		actRet.MoveTo(actCaster)
		
		; Play summon FX
		actRet.SetAlpha(0.8)
		actRet.PlaceAtMe(mactvSummonFX)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return actRet
EndFunction
; 2015.07.22 / Add

; 2015.07.25 / Add
Actor[] Function addAggressor(Actor actAggressor)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actFind
	ActorBase abAggressor
	Actor[]   aRet       = new Actor[3]
	Int       nAddNum    = McmConfig.mnReinforceMaxAdds
	Float     nMaxSearch = 8880.0
	Int       nRate      = McmConfig.mnReinforceRatio
	Int       nRand      = RandomInt(1, 100)
	
	;-------------------------------------------------------
	; Check conditions
	;-------------------------------------------------------
	If (nRand > nRate)
		Return None
	Elseif actAggressor.IsDead()
		Return None
	Elseif actAggressor.GetActorBase().IsUnique()
		Return None
	Endif
	
	;-------------------------------------------------------
	; Create NPC
	;-------------------------------------------------------
	While (nAddNum > 0)
		nAddNum -= 1
		
		actFind       = FindRandomActorFromRef(actAggressor, nMaxSearch)
;		abAggressor   = actAggressor.GetLeveledActorBase()
		abAggressor   = actAggressor.GetActorBase()
		aRet[nAddNum] = actFind.PlaceActorAtMe(abAggressor)
		Notification(aRet[nAddNum].GetLeveledActorBase().GetName()+" appears.")
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aRet
EndFunction
; 2015.07.25 / Add

; 2015.07.21 / Add
Function forceResetAnimation(Actor actVictim, Int nRetry = 1, Float nInterval = 3.0)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	String szCurPose
	
	;-------------------------------------------------------
	; Check arguments
	;-------------------------------------------------------
	If (nRetry <= 0)
		nRetry = 8
	Endif
	
	If (nInterval <= 0.0)
		nInterval = 0.8
	Endif
	
	;-------------------------------------------------------
	; Reset Loop
	;-------------------------------------------------------
	szCurPose = GetStringValue(actVictim, "DefeatStateAnim")
	
	While (nRetry > 0)
		Wait(nInterval)
		
		SendAnimationEvent(actVictim, szCurPose)
		
		nRetry -= 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction
; 2015.07.21 / Add

; 2015.07.28 / Add
Actor[] Function findRapers(Actor actAggressor, Actor actVictim, Bool isGangbangRape = True)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Actor     actFind
	VoiceType vocMainAgg
	VoiceType vocFind
	; 2015.08.01 / Mod / 4 -> 3
	Actor[]   aFound             = new Actor[3]
	Float     nMaxDistance       = McmConfig.NVN3wayAutoFollower
	Bool      isHuman            = False
	Int       nRetry             = 8
	Bool      canJoin            = True
	Int       nFoundIdx          = 0
	Bool      isSameVoice        = True
	Bool      isValidVoice       = True
	Bool      isFollower         = False
	Bool      isAdded            = False
	Bool      isEnemy            = False
	Bool      isFemaleVic        = False
	Bool      isFemaleFind       = False
	Bool      isTeammate         = False
	Bool      enableTeammateRape = McmConfig.mEnableTeammateRape
	; 2015.09.14 / Add
	Bool      nGangbangChance
	; 2015.09.14 / Add
	
	;-------------------------------------------------------
	; Check max distance
	;-------------------------------------------------------
	If (nMaxDistance <= 0.0)
		nMaxDistance = 1700.0
	Endif
	
	;-------------------------------------------------------
	; Check main aggressor
	;-------------------------------------------------------
	If actAggressor && actAggressor.HasKeyWordString("ActorTypeNPC")
		isHuman = True
	Endif
	
	If actAggressor
		vocMainAgg = actAggressor.GetVoiceType()
	Endif
	
	If actVictim
		isFollower  = IsFollower(actVictim)
		isFemaleVic = (SexLab.GetGender(actVictim) == 1)
	Endif
	
	; 2015.09.14 / Add
	If (actVictim == Player)
		isFollower = True
	Endif
	; 2015.09.14 / Add
	
	; 2015.09.14 / Add
	;-------------------------------------------------------
	; Set Gangbang Chance
	;-------------------------------------------------------
	If isHuman && (actVictim == Player)
		nGangbangChance = McmConfig.ThreesomeChance
	Elseif !isHuman && (actVictim == Player)
		nGangbangChance = McmConfig.GbCrChancePvic
	Elseif isHuman && (actVictim != Player)
		nGangbangChance = McmConfig.GbChanceNVN
	Elseif !isHuman && (actVictim != Player)
		nGangbangChance = McmConfig.GbCrChanceNVN
	Endif
	; 2015.09.14 / Add
	
	;-------------------------------------------------------
	; Check settings
	;-------------------------------------------------------
	If !actAggressor || !actVictim
		Return aFound
	; 2015.09.14 / Mod / Changing the condition, using nGangbangChance
;	Elseif (nGangbangChance <= 0.0)
	Elseif (RandomFloat(1.0, 100.0) > nGangbangChance)
		Return aFound
	Endif
	
	;-------------------------------------------------------
	; Search
	;-------------------------------------------------------
	While (nRetry > 0) && (nFoundIdx < aFound.Length)
		; Find the new raper
		actFind = FindRandomActorFromRef(actVictim, nMaxDistance)
		
		; Check VoiceType
		If actFind
			vocFind      = actFind.GetVoiceType()
			isSameVoice  = (vocMainAgg == vocFind)
			isValidVoice = (MiscVoicetypes.Find(vocMainAgg) >= 0)
			isAdded      = (aFound.Find(actFind) >= 0)
			isEnemy      = (actFind.getFactionReaction(actAggressor) < 2)
			isFemaleFind = (SexLab.GetGender(actFind) == 1)
			isTeammate   = (IsFollower(actFind) && isFollower)
		Else
			isSameVoice  = False
			isValidVoice = False
			isAdded      = False
			isEnemy      = False
			isFemaleFind = False
			isTeammate   = False
		Endif
		
		; Check conditions
		canJoin = True
		
		If !actFind || actFind.IsDead()
			canJoin = False
		Elseif isAdded
			canJoin = False
		; 2015.09.15 / Del
;		Elseif IsDefeatActive(actFind)
;			canJoin = False
		; 2015.09.15 / Del
		Elseif actFind.HasKeyWordString("SexLabActive")
			canJoin = False
		; 2015.09.06 / Add
		Elseif (PlayerScr.GetTheNext() == actFind)
			canJoin = False
		; 2015.09.06 / Add
		Elseif actFind.HasSpell(MiscSpells[3])
			canJoin = False
		; 2015.07.30 / Mod / Adding (actFind == actVictim)
		Elseif (actFind == Player) || (actFind == actAggressor) || (actFind == actVictim)
			canJoin = False
		Elseif isGangbangRape && isHuman && !actFind.HasKeyWordString("ActorTypeNPC")
			canJoin = False
		Elseif isGangbangRape && !isHuman && actFind.HasKeyWordString("ActorTypeNPC")
			canJoin = False
		Elseif isGangbangRape && !isHuman && !isValidVoice
			canJoin = False
		Elseif isGangbangRape && !isHuman && !isSameVoice
			canJoin = False
		; 2015.08.02 / Add
		Elseif isGangbangRape && isHuman && isTeammate && enableTeammateRape
			canJoin = True
		; 2015.08.02 / Add
		; 2015.08.02 / Mod / Deleting the condition, isGangbangRape
		Elseif isHuman && isEnemy
			canJoin = False
		; 2015.08.02 / Mod / Deleting the condition, isGangbangRape
		Elseif isHuman && !IsSexualAssaulter(actFind, actVictim, IsFollower = isFollower)
			canJoin = False
		Endif
		
		; Set to rapers array
		If canJoin
			aFound[nFoundIdx] = actFind
			nFoundIdx += 1
		Endif
		
		; Break
		; 2015.09.15 / Del / For Human 4P
;		If canJoin && isHuman
;			nRetry = 0
		; 2015.09.15 / Mod / Elseif -> If
		If isGangbangRape && !isHuman && !isValidVoice
			nRetry = 0
		Endif
		
		nRetry -= 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return aFound
EndFunction

Function waitSexEnd(Actor actVictim)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Float nAnimationWait    = 0.0
	Float nEndTimerInterval = 5.0
	; 2015.07.31 / Mod / Always true for animations randomizing
;	Bool  enableRapeSpell   = McmConfig.mEnableReplaceRapeSpell
	Bool  enableRapeSpell   = True
	
	;-------------------------------------------------------
	; Set waiting time
	;-------------------------------------------------------
	; Defeat durations for each stage
	nAnimationWait += 30.0
	nAnimationWait += 25.0
	nAnimationWait += 20.0
	nAnimationWait += 15.0
	nAnimationWait += 10.0
	nAnimationWait += 5.0
	
	; Rapespell duration
	If enableRapeSpell
		nAnimationWait += 260.0
	Endif
	
	;-------------------------------------------------------
	; Waiting Loop
	;-------------------------------------------------------
	While actVictim.HasKeyWordString("SexLabActive") && (nAnimationWait > 0.0)
		Wait(nEndTimerInterval)
		
		nAnimationWait -= nEndTimerInterval
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction
; 2015.07.28 / Add

; 2015.08.01 / Add
Function randomizeSex(sslThreadController oThread, Actor actVictim, Actor[] aActors)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Float nRand            = RandomFloat(1.0, 100.0)
	Float nChangeAnimation = McmConfig.mnRandAnimChangeChance
	Float nBackwardStage   = McmConfig.mnRandAnimBackwordChance
	Float nChangeInterval  = 2.6
	Int   nStage           = oThread.Stage
	Bool  isBegin          = (oThread.Stage <= 2)
	Bool  isLeadIn         = oThread.Animation.HasTag("LeadIn")
	Bool  enableOffset     = McmConfig.mEnableRandAnimOffset
	Int   nActorIdx        = aActors.Length
	Float nVicValue        = 0.0
	Float nAggValue        = 0.0
	Float nDamageRatio     = 0.8
	Float nDamage
	Float nTotal
	Float nOffset
	Actor actFind
	Bool  isVictim
	
	;-------------------------------------------------------
	; Get ActorValues of actors
	;-------------------------------------------------------
	While (nActorIdx > 0)
		nActorIdx -= 1
		
		actFind  = aActors[nActorIdx]
		isVictim = (actFind == actVictim)
		
		If actFind && isVictim && enableOffset
			nVicValue += actVictim.GetActorValue("Stamina")
			nDamage = nVicValue * nDamageRatio
			actVictim.DamageAV("Stamina", nDamage)
		Elseif actFind && !isVictim && enableOffset
			nAggValue += actFind.GetActorValue("Stamina")
			nDamage = nAggValue * nDamageRatio
			actFind.DamageAV("Stamina", nDamage)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Set offset
	;-------------------------------------------------------
	If enableOffset && (nAggValue > 0.0) && (nVicValue > 0.0)
		nTotal  = nAggValue + nVicValue
		nOffset = (nAggValue - nVicValue) / nTotal
		
		nBackwardStage   += (8.0 * nOffset)
		nChangeAnimation += (8.0 * nOffset)
	Endif
	
;	Notification("backward: "+(nBackwardStage as String)+" %")
;	Notification("change: "+(nChangeAnimation as String)+" %")
	
	;-------------------------------------------------------
	; Backward stage
	;-------------------------------------------------------
	If (nRand < nBackwardStage) && !isBegin && !isLeadIn
		Wait(nChangeInterval)
		oThread.advanceStage(true)
	Endif
	
	;-------------------------------------------------------
	; Change sex animation
	;-------------------------------------------------------
	If (nRand < nChangeAnimation) && !isBegin && !isLeadIn
		Wait(nChangeInterval)
		oThread.changeAnimation()
	Endif
EndFunction
; 2015.08.01 / Add

; 2015.08.07 / Add
Armor Function addTongue(Actor actTarget)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Armor armFind
	Int   nIdx
	Int   nEnd
	Int   nMouthOpen
	
	;-------------------------------------------------------
	; Choose tongue
	;-------------------------------------------------------
	nEnd    = maTongues.Length - 1
	nIdx    = RandomInt(0, nEnd)
	armFind = maTongues[nIdx]
	
	;-------------------------------------------------------
	; Choose the mouth size
	;-------------------------------------------------------
	If !EQTONGUESCRon && !EQTONGUEon && HTOOLSon
		nMouthOpen = 62
	Else
		nMouthOpen = 100
	Endif
	
	;-------------------------------------------------------
	; Add tongue
	;-------------------------------------------------------
	If armFind
		MfgConsoleFunc.SetPhoneme(actTarget, 0, nMouthOpen)
		MfgConsoleFunc.SetPhoneme(actTarget, 6, nMouthOpen)
		
		actTarget.AddItem(armFind, 1)
		actTarget.EquipItem(armFind, True, True)
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return armFind
EndFunction

Function removeTongues(Actor actTarget)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Armor armTongue
	Bool  isEquipped
	Int   nTongueIdx  = maTongues.Length
	Int   nPhonemeCnt = 0
	
	;-------------------------------------------------------
	; Remove tongue
	;-------------------------------------------------------
	While (nTongueIdx > 0)
		nTongueIdx -= 1
		
		armTongue  = maTongues[nTongueIdx]
		isEquipped = actTarget.IsEquipped(armTongue)
		
		If actTarget.IsEquipped(armTongue)
			actTarget.UnequipItem(armTongue, True, True)
			actTarget.RemoveItem(armTongue, 1, True)
		Endif
	EndWhile
	
	;-------------------------------------------------------
	; Close Mouth
	;-------------------------------------------------------
	While (nPhonemeCnt < 16)
		MfgConsoleFunc.SetPhoneme(actTarget, nPhonemeCnt, 0)
		
		nPhonemeCnt += 1
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return
EndFunction

Bool Function isTongueEquipped(Actor actTarget)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	Armor armTongue
	Bool  isEquipped = False
	Int   nTongueIdx = maTongues.Length
	
	;-------------------------------------------------------
	; Remove tongue
	;-------------------------------------------------------
	While !isEquipped && (nTongueIdx > 0)
		nTongueIdx -= 1
		
		armTongue  = maTongues[nTongueIdx]
		isEquipped = actTarget.IsEquipped(armTongue)
	EndWhile
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return isEquipped
EndFunction

Function startWeakenAnimation(Actor actTarget)
	Int nRand = RandomInt(1, 100)
	
	If Zazon && (nRand <= 80)
		SendAnimationEvent(actTarget, "ZazWoodenHorse01_Exit")
	Else
		SendAnimationEvent(actTarget, "BleedoutStart")
	Endif
EndFunction
; 2015.08.07 / Add
; 2015.09.01 / Add
sslThreadModel Function setupSexAnimThread(	\
	Actor  actVic, 							\
	Actor  actAgg, 							\
	Bool   disableRapeSpell = False,		\
	Bool   enablePlayerJoin = False,		\
	String szAnimType       = ""			\
)
	;-------------------------------------------------------
	; Init Variables
	;-------------------------------------------------------
	sslThreadModel     Make
	sslBaseAnimation[] Anims
	Actor[] Positions
	Actor[] aGangbangRapers
	Actor   TheAdd
	Actor   actEach
	String  Tag
	Int     nIdx
	Int     NumFemales
	Bool    IsTied
	Int     nRaperIdx
	Bool    isHumanEach
	Bool    isDwarven
	Bool    isHumanAgg
	Bool    enableRapeSpell
	Spell   splRape         = msplRapeAlt
	bool[]  aStripSlots     = new bool[33]
	bool[]  aTiedStripSlots = new bool[33]
	
	;-------------------------------------------------------
	; Check Arguments
	;-------------------------------------------------------
	If !actVic || !actAgg
		Return None
	Else
		isHumanAgg = actAgg.HasKeyWordString("ActorTypeNPC")
	Endif
	
	If disableRapeSpell
		enableRapeSpell = False
	Else
		enableRapeSpell = McmConfig.mEnableReplaceRapeSpell
	Endif
	
	;-------------------------------------------------------
	; Init tiedup slots (for Spider Web)
	;-------------------------------------------------------
	If !isHumanAgg
		nIdx = aTiedStripSlots.Length
		
		While (nIdx > 0)
			nIdx -= 1
			
			aTiedStripSlots[nIdx] = True
		EndWhile
		
		aTiedStripSlots[61 - 30] = False
		aTiedStripSlots[48 - 30] = False
	Endif
	
	;-------------------------------------------------------
	; Setup
	;-------------------------------------------------------
	If splRape && enableRapeSpell
		splRape.Cast(actAgg, actVic)
		Make = None
	Else
		Make = SexLab.NewThread()
		
		If isHumanAgg && enablePlayerJoin
			TheAdd = Player
		Else
			aGangbangRapers = findRapers(actAgg, actVic, True)
			TheAdd          = aGangbangRapers[0]
		Endif
		
		If isHumanAgg
			aGangbangRapers    = new Actor[1]
			aGangbangRapers[0] = TheAdd
			
			Positions  = sslUtility.MakeActorArray(actVic, actAgg, TheAdd)
			NumFemales = SexLab.FemaleCount(Positions)
			Positions  = SexLab.SortActors(Positions)
			Tag        = SexLab.MakeAnimationGenderTag(Positions)
			Anims      = SexLab.GetAnimationsByTags(3, Tag)
			
			Make.AddActors(Positions, actVic)
		Endif
		
		If isHumanAgg && TheAdd
			If (Anims.Length == 0)
				If (NumFemales == 2) && (SexLab.GetGender(actVic) == 0)
					; 2 female aggressors on male
					Anims    = new sslBaseAnimation[2]
					Anims[0] = SexLab.GetAnimationByName("Arrok Tricycle")
					Anims[1] = SexLab.GetAnimationByName("Zyn FemDom")
				Else
					Anims    = new sslBaseAnimation[3]
					Anims[0] = SexLab.GetAnimationByName("Arrok Devils Threeway")
					Anims[1] = SexLab.GetAnimationByName("Zyn Double Penetration")
					Anims[2] = SexLab.GetAnimationByName("DI Forced Threesome")
				Endif
			Endif
		Elseif isHumanAgg && !TheAdd
			IsTied = Tied(actVic)
			
			If (szAnimType == "Blowjob")
				Anims = SexLab.GetAnimationsByTags(2, "Blowjob,MF", "Vaginal,Anal,69")
				
				If (Anims.length == 0)
					Anims    = new sslBaseAnimation[2]
					Anims[0] = SexLab.GetAnimationByName("Arrok Blowjob")
					Anims[1] = SexLab.GetAnimationByName("DI Blowjob")
				Endif
			Elseif (McmConfig.ReverseR && (NumFemales == 1) && (SexLab.GetGender(actAgg) == 1))
				Positions = SexLab.SortActors(Positions)
				If !IsTied
					Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
				Else
					If Tied(actAgg)
						Anims = SexLab.GetAnimationsByTags(2, "SubSub")
					Else
						Anims = SexLab.GetAnimationsByTags(2, "DomSub")
					Endif
				Endif
				If (Anims.length == 0)
					Anims = SexLab.GetAnimationsByTags(2, "Cowgirl", "Bound,Pillory")
					If (Anims.length == 0)
						Anims    = new sslBaseAnimation[1]
						Anims[0] = SexLab.GetAnimationByName("Arrok Cowgirl")
					Endif
				Endif
			Elseif (McmConfig.ReverseRf && (NumFemales == 2))
				Positions = SexLab.SortActors(Positions)
				If !IsTied
					Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
				Else
					If Tied(actAgg)
						Anims = SexLab.GetAnimationsByTags(2, "Lesbian,SubSub")
					Else
						Anims = SexLab.GetAnimationsByTags(2, "Lesbian,DomSub")
					Endif
				Endif
				If (Anims.length == 0)
					Anims = SexLab.GetAnimationsByTags(2, "Lesbian", "Bound,Pillory")
					If (Anims.length == 0)
						Anims    = new sslBaseAnimation[1]
						Anims[0] = SexLab.GetAnimationByName("Arrok Lesbian")
					Endif
				Endif
			Else
				If !IsTied
					Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
				Else
					If Tied(actAgg)
						Anims = SexLab.GetAnimationsByTags(2, "SubSub")
					Else
						Anims = SexLab.GetAnimationsByTags(2, "DomSub")
					Endif
				Endif
				If (Anims.length == 0)
					Anims = SexLab.GetAnimationsByTags(2, "Aggressive", "Bound,Pillory")
				Endif
			Endif
		Elseif !isHumanAgg && TheAdd
			Make.AddActor(actVic, isVictim = True)
			Make.AddActor(actAgg)
			
			nRaperIdx = aGangbangRapers.Length
			
			While (nRaperIdx > 0)
				nRaperIdx -= 1
				
				actEach = aGangbangRapers[nRaperIdx]
				
				If actEach
					Make.AddActor(actEach)
				Endif
			EndWhile
		Else
			Make.AddActor(actVic, isVictim = True)
			Make.AddActor(actAgg)
		Endif
		
		If isHumanAgg && !McmConfig.mDisableRapeAnimRestriction && (szAnimType != "Consensual")
			Make.SetAnimations(Anims)
		Endif
		
		Make.DisableUndressAnimation(actVic)
		Make.DisableRagdollEnd(actAgg)
		
		If (actVic == Player) && SexLabConfig.RagdollEnd && McmConfig.mEnablePcRapedAnimation
			Make.DisableRagdollEnd(actVic)
		Endif
		
		If !isHumanAgg && actVic.IsInFaction(TieUpFaction)
			Make.SetStrip(actVic, aTiedStripSlots)
		Endif
		
		If isHumanAgg && actAgg.IsInFaction(mfctDwarven)
			Make.SetStrip(actAgg, aStripSlots)
		Endif
		
		nRaperIdx = aGangbangRapers.Length
		
		While (nRaperIdx > 0)
			nRaperIdx -= 1
			
			actEach     = aGangbangRapers[nRaperIdx]
			isHumanEach = False
			isDwarven   = False
			
			If actEach
				Make.DisableRagdollEnd(actEach)
				isHumanEach = actEach.HasKeyWordString("ActorTypeNPC")
				isDwarven   = actEach.IsInFaction(mfctDwarven)
			Endif
			
			If isHumanEach && isDwarven
				Make.SetStrip(actEach, aStripSlots)
			Endif
		EndWhile
	Endif
	
	;-------------------------------------------------------
	; Return
	;-------------------------------------------------------
	Return Make
EndFunction
; 2015.09.01 / Add
; 2015.09.05 / Add
Bool Function isNaked(Actor actTarget)
	; ArmorCuirass [KYWD:0006C0EC]
	Keyword kwdCuirass = Keyword.GetKeyword("ArmorCuirass")
	; ClothingBody [KYWD:000A8657]
	Keyword kwdCloth   = Keyword.GetKeyword("ClothingBody")
	; Slot 32 - Body
	Form    frmBody    = actTarget.GetWornForm(0x00000004)
	
;	If actTarget.WornHasKeyword(kwdCuirass)
;		Return False
;	Elseif actTarget.WornHasKeyword(kwdCloth)
;		Return False
	If frmBody && (frmBody.GetName() != "")
		Return False
	Endif
	
	Return True
EndFunction

String[] gaDebug
Bool     gEnablePrintDebugStr = False
Bool     gEnableSaveDebugInfo = False

Function saveCurrentPosition(Actor actTarget)
	Cell celCur = actTarget.GetParentCell()
	
	gaDebug    = new String[5]
	gaDebug[0] = celCur.GetName()
	; 2015.09.07 / Add
	gaDebug[1] = "FormID = " + (celCur.GetFormID() as String)
	; 2015.09.07 / Add
	gaDebug[2] = "x = " + (actTarget.GetPositionX() as String)
	gaDebug[3] = "y = " + (actTarget.GetPositionY() as String)
	gaDebug[4] = "z = " + (actTarget.GetPositionZ() as String)
	
	exportDebugInfo()
	
	If gEnablePrintDebugStr
		; 2015.09.07 / Mod
		Notification(gaDebug[0]+" "+gaDebug[1]+" "+gaDebug[2]+" "+gaDebug[3]+" "+gaDebug[4])
	Endif
	
	gaDebug    = None
	
	Return
EndFunction

Function saveDebugStr(String szStr)
	If !gEnableSaveDebugInfo
		Return
	Endif
	
	If (szStr != "")
		gaDebug    = new String[1]
		gaDebug[0] = szStr
		exportDebugInfo()
	Endif
	
	If gEnablePrintDebugStr
		Notification(szStr)
	Endif
	
	gaDebug    = None
	
	Return
EndFunction

Function exportDebugInfo()
	String szFile = "../Defeat/DebugExtPatch.json"
	
	If !gEnableSaveDebugInfo
		Return
	Endif
	
	If (gaDebug.Length > 0)
		McmConfig.ExportStringArray(szFile, "Debug", gaDebug)
	Endif
	
	JsonUtil.Save(szFile, False)
	
	Return
EndFunction

Function doDebugTest()
;	showRandomLiePose(Player)
	
	If gEnableSaveDebugInfo
		Actor actTarget =					\
			getActorSelected(				\
				enableNearPlayer = False,	\
				disableDead      = False	)
		
		If !actTarget
			actTarget = Player
		EndIf
		
		saveCurrentPosition(actTarget)
	Endif
	
;	ExAnimationRegister oAnimReg
;	sslBaseAnimation    oAnim
;	String szAnim = "NecroMissionary"
;	
;	oAnim = oAnimReg.GetAnimationByName(szAnim)
;	
;	saveDebugStr("Animation name is "+oAnim.Name+".")
	
	; 1->Attack, 2->Death, 3->Flee
;	Int nIdx = RandomInt(1, 3)
;	Player.Say(TopicToSay[nIdx], Player)

;	; 0x080801->Death, 0x080802->Flee
;	Int    nIdx     = RandomInt(0x080801, 0x080802)
;	String szMaster = "SexLabDefeat.esp"
;	Sound sndVoice  = GetFormFromFile(nIdx, szMaster) as Sound
;	If sndVoice
;		sndVoice.Play(Player)
;	Else
;		saveDebugStr("Sound is NONE. "+(nIdx as String)+" of "+szMaster)
;	Endif
	
	Return
EndFunction
; 2015.09.05 / Add

; ------------------------------------------------------------------------------
; End of Script
; ------------------------------------------------------------------------------
